SystemOrganization addCategory: #'Mondrian-Core'!
SystemOrganization addCategory: #'Mondrian-Shapes'!
SystemOrganization addCategory: #'Mondrian-Events'!
SystemOrganization addCategory: #'Mondrian-Morphic'!
SystemOrganization addCategory: #'Mondrian-Tests'!
SystemOrganization addCategory: #'Mondrian-Layouts'!
SystemOrganization addCategory: #'Mondrian-Normalizers'!
SystemOrganization addCategory: #'Mondrian-ComplexShape'!
SystemOrganization addCategory: #'Mondrian-Example'!
SystemOrganization addCategory: #'Mondrian-Easel'!
SystemOrganization addCategory: #'Mondrian-Animation'!
SystemOrganization addCategory: #'Mondrian-Interaction'!
SystemOrganization addCategory: #'Mondrian-Visitor'!
SystemOrganization addCategory: #'Mondrian-Util'!
SystemOrganization addCategory: #'Mondrian-Legend'!

NullCanvas subclass: #CountingNullCanvas
	instanceVariableNames: 'numberOfRectangles numberOfLines numberOfImages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!CountingNullCanvas methodsFor: 'accessing' stamp: 'Alexandre Bergel 7/14/2010 08:45'!
clipRect
	^1@1 extent: 100000@100000! !

!CountingNullCanvas methodsFor: 'drawing-rectangles' stamp: 'Alexandre Bergel 6/7/2010 19:09'!
frameAndFillRectangle: bounds fillColor: c borderWidth: width borderColor: cc
	numberOfRectangles := numberOfRectangles + 1.
! !

!CountingNullCanvas methodsFor: 'initialization' stamp: 'Alexandre Bergel 6/7/2010 18:40'!
initialize 
	super initialize .
	numberOfRectangles := 0.
	numberOfLines := 0.
	numberOfImages := 0! !

!CountingNullCanvas methodsFor: 'drawing' stamp: 'Alexandre Bergel 6/7/2010 18:35'!
line: fromPoint to: toPoint width: width color: color
	numberOfLines := numberOfLines + 1.! !

!CountingNullCanvas methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/7/2010 18:41'!
numberOfImages
	^ numberOfImages! !

!CountingNullCanvas methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/7/2010 18:36'!
numberOfLines
	^ numberOfLines! !

!CountingNullCanvas methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/7/2010 18:36'!
numberOfRectangles
	^ numberOfRectangles! !

!CountingNullCanvas methodsFor: 'drawing-images' stamp: 'Alexandre Bergel 6/7/2010 18:43'!
paintImage: cacheForm at: position
	numberOfImages := numberOfImages + 1.
! !

Morph subclass: #MOCanvas
	instanceVariableNames: 'currentPosition lastClickPosition lastClickTimestamp root announcer lastEnteredGraphElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Morphic'!

!MOCanvas commentStamp: 'Alexandre.Bergel 2/2/2009 11:05' prior: 0!
Comment by Alexandre Bergel (Feb 2, 2009)

A MOCanvas is the graphical component embedded in a MOBrowser. Figures and nodes are displayed in it.

Instance Variables
	announce:		<Announcer>
	currentElement:		<Object>
	currentPosition:		<Object>
	graph:		<Object>
	lastClickPosition:		<Object>
	lastClickTimestamp:		<Object>
	selected:		<Object>

announce
	- Instance of Announcer. The reference must be obtained from the view

currentElement
	- xxxxx

currentPosition
	- xxxxx

graph
	- xxxxx

lastClickPosition
	- xxxxx

lastClickTimestamp
	- xxxxx

selected
	- xxxxx
!

!MOCanvas class methodsFor: 'instance-creation' stamp: 'Alexandre.Bergel 4/15/2009 13:07'!
on: aMORoot
	^ self new root: aMORoot! !

!MOCanvas class methodsFor: 'instance-creation' stamp: 'Alexandre.Bergel 4/15/2009 13:07'!
openOn: aMORoot
	^ (self on: aMORoot) openInHand! !

!MOCanvas methodsFor: 'announce' stamp: 'Alexandre Bergel 6/17/2010 15:05'!
announce: anAnnouncement
"Transcript show: anAnnouncement printString; cr.
"	anAnnouncement element isNil ifFalse: [
		anAnnouncement element announcer announce: anAnnouncement ].
	self announcer announce: anAnnouncement.! !

!MOCanvas methodsFor: 'announce' stamp: 'Alexandre.Bergel 8/9/2009 16:09'!
announcer

	^ announcer ifNil: [announcer := MOAnnouncer new].! !

!MOCanvas methodsFor: 'error management' stamp: 'Alexandre.Bergel 9/25/2009 19:53'!
disableErrorFlag
	Smalltalk removeKey: #MondrianError ifAbsent: []! !

!MOCanvas methodsFor: 'drawing' stamp: 'Alexandre Bergel 8/13/2010 18:25'!
drawOn: aCanvas 

	 self root displayOn: (aCanvas copyOffset: self bounds origin) 
	
"	[ self root displayOn: (aCanvas copyOffset: self bounds origin) ]
		on: Error do: [:ex | self raiseError: ex ].
"

"	
	| canvas |
	canvas := (aCanvas copyOffset: self bounds origin) asBalloonCanvas
		aaLevel: 4;
		yourself.
	canvas transformBy: IdentityTransform new during:[:cc|
		self root displayOn: canvas 
	]
"! !

!MOCanvas methodsFor: 'export' stamp: 'AlexandreBergel 9/13/2010 14:55'!
exportAsBMP
	^ self exportWith: BMPReadWriter extension: '.bmp'! !

!MOCanvas methodsFor: 'export' stamp: 'AlexandreBergel 9/13/2010 14:55'!
exportAsGIF
	^ self exportWith: GIFReadWriter extension: '.gif'! !

!MOCanvas methodsFor: 'export' stamp: 'AlexandreBergel 9/13/2010 14:55'!
exportAsJPEG
	^ self exportWith: JPEGReadWriter extension: '.jpeg'! !

!MOCanvas methodsFor: 'export' stamp: 'AlexandreBergel 9/13/2010 14:55'!
exportAsPNG
	^ self exportWith: PNGReadWriter extension: '.png'! !

!MOCanvas methodsFor: '*Mondrian-Visitor-public-export' stamp: 'Alexandre Bergel 7/4/2010 19:54'!
exportAsXML
	| xmlFileName stream |
	xmlFileName := UIManager default request: 'Enter a file name' initialAnswer: 'graph.xml'.
	stream := FileStream fileNamed: xmlFileName.
	self exportAsXMLOn: stream.
	stream close.! !

!MOCanvas methodsFor: '*Mondrian-Visitor-public-export' stamp: 'Alexandre Bergel 7/4/2010 19:31'!
exportAsXMLOn: stream
	| visitor |
	visitor := MOXMLVisitor stream: stream.
	visitor writePreamble.
	self root acceptVisitor: visitor.
	visitor writeTail! !

!MOCanvas methodsFor: 'export' stamp: 'AlexandreBergel 9/13/2010 14:56'!
exportWith: imageWriterClass extension: fileExtension
	| fName directoryName |
	fName := UIManager default 
				request:'Please enter the name' translated initialAnswer: self externalName, fileExtension.
	fName isEmptyOrNil ifTrue:[^self].
	directoryName := UIManager default chooseDirectory: 'Choose a directory to store the image'.
	directoryName ifNil: [ ^ self ].
	"PNGReadWriter"
	imageWriterClass 
		putForm: self imageForm 
		onFileNamed: (directoryName pathName, FileDirectory pathNameDelimiter asString ,fName).! !

!MOCanvas methodsFor: 'morph' stamp: 'AlexandreBergel 9/13/2010 14:26'!
externalName
	^ 'Mondrian-', Date today yyyymmdd, '-', Time now hhmm24! !

!MOCanvas methodsFor: 'event handling' stamp: 'Alexandre Bergel 4/26/2010 10:15'!
handleMouseOver: anEvent
	anEvent wasHandled ifTrue:[ ^ self ]. "not interested"
	(anEvent hand hasSubmorphs) ifTrue:[ ^ self ].

	anEvent hand newKeyboardFocus: self.
	self mouseOver: anEvent 
! !

!MOCanvas methodsFor: 'event handling' stamp: 'lr 10/11/2006 22:06'!
handlesKeyboard: anEvent
	^ true! !

!MOCanvas methodsFor: 'event handling' stamp: 'Alexandre.Bergel 2/3/2009 13:53'!
handlesMouseDown: anEvent
	^ true! !

!MOCanvas methodsFor: 'event handling' stamp: 'lr 10/11/2006 22:08'!
handlesMouseOver: anEvent
	^ true! !

!MOCanvas methodsFor: 'initialization' stamp: 'Alexandre.Bergel 2/22/2009 22:10'!
initialize
	super initialize.
	currentPosition := 0@0! !

!MOCanvas methodsFor: 'initialization' stamp: 'Alexandre.Bergel 8/9/2009 16:08'!
initializeHanders
	"The canvas need to listen at zoom and drag event. This is necessary to make the canvas grow"
	"The root announcer is used for this"

	| rootAnnouncer |
	self root ifNil: [self error: 'The root must be set before calling this method'].
	self root announcer ifNil: [self error: 'the root announcer must not be nil'].
	
	rootAnnouncer := self root announcer.
	rootAnnouncer on: MOZoomEvent do: [:ann | 
		ann isZoomIncrease
			ifTrue: [self extent: (self extent * 1.1)]]! !

!MOCanvas methodsFor: 'event handling' stamp: 'Alexandre Bergel 4/26/2010 10:16'!
keyDown: anEvent
	| element |

	element := self root elementAt: anEvent position.
	element ifNotNil: [
			self announce: (MOKeyDown event: anEvent on: element).
			anEvent wasHandled: true.
			^ self ].
	
	self announce: (MOKeyDown event: anEvent on: self root).
	anEvent wasHandled: true.
! !

!MOCanvas methodsFor: 'event handling' stamp: 'Alexandre Bergel 4/2/2010 09:29'!
keyStroke: anEvent

	self root hasSelection ifFalse: [ ^ self ].

"	self root selections do: [:each |
			(MOKeyPressed event: anEvent on: each) dispatch.].
"	anEvent wasHandled: true
! !

!MOCanvas methodsFor: 'event handling' stamp: 'Alexandre.Bergel 8/6/2009 11:36'!
keyUp: anEvent

	| element |

	element := self root elementAt: anEvent position.
	element ifNotNil: [
			self announce: (MOKeyUp event: anEvent on: element).
			anEvent wasHandled: true.
			^ self ].
	self announce: (MOKeyUp event: anEvent on: self root).
	anEvent wasHandled: true.


"	self root hasSelection ifTrue: [
		self root selections do: [:each |
			(MOKeyUp event: anEvent on: each) dispatch.].
		anEvent wasHandled: true
	]
"! !

!MOCanvas methodsFor: 'event handling' stamp: 'AlexandreBergel 9/6/2010 09:14'!
mouseDown: anEvent 
	| element |
	"anEvent wasHandled ifTrue: [ ^ self ]."
		"not interested"

	element := self root elementAt: anEvent position.
	lastEnteredGraphElement := nil.
	element ifNil: [ ^ self ].
	self announce: (MOMouseDown 
			event: anEvent
			on: element).
	anEvent wasHandled: true
! !

!MOCanvas methodsFor: 'event handling' stamp: 'AlexandreBergel 9/6/2010 18:28'!
mouseOver: anEvent 

	"not interested if already handled"
	| lastMousePosition step dragEvent elementUnderTheMouse |
	anEvent wasHandled ifTrue: [ ^ self ].

	lastMousePosition := currentPosition.
	currentPosition := anEvent position - self bounds origin.
	
	((currentPosition = lastMousePosition) and: [anEvent anyButtonPressed not])
		ifTrue: [ anEvent wasHandled: true. ^ self ].
	
	
	"Check whether we are dragging a figure"
	(anEvent anyButtonPressed and: [ lastEnteredGraphElement notNil ]) ifTrue: 
		[ step := currentPosition - lastMousePosition.

		"We need to enlarge the canvas is necessary. 
			We assume here that only the lower bounds is interesting. 
			This might not be true all the time, but this could be fixed later on. 	
			We enlarge the canvas if currentPosition is close to the canvas boundary"
		"This should be done as an event that is received, and not here"
		"(self bounds containsPoint: currentPosition) 
			ifFalse: [ self extent: self extent + (step * 3) ]."
		
		step ~= (0 @ 0) ifTrue: 
			[ dragEvent := (MOMouseDrag event: anEvent on: lastEnteredGraphElement) step: step.
			  self announce: dragEvent.
			  "Do we really need to send the event to the root?"
			  "self root announce: dragEvent" ].
		anEvent wasHandled: true.
		^ self ].

	"We also need to take care of emitting leaving and entering events. A question one may ask, is why do we have to deal with entering and leaving in this mouseOver: method? The answer is the fact that figures are not morphes. The mouseOver: is invoked for entering the MOCanvas."
	elementUnderTheMouse := self root elementAt: currentPosition.

	elementUnderTheMouse ~~ lastEnteredGraphElement 
		ifTrue: [ lastEnteredGraphElement 
						ifNotNil: [ lastEnteredGraphElement resetMetricCaches.
								  self announce: 
												(MOMouseLeave event: anEvent on: lastEnteredGraphElement) ].
		  			elementUnderTheMouse 
						ifNotNil: [ 
							elementUnderTheMouse resetMetricCaches.
							self announce: (MOMouseEnter event: anEvent on: elementUnderTheMouse) ].
		  			lastEnteredGraphElement := elementUnderTheMouse ]
		ifFalse: [ self announce: (MOMouseMove event: anEvent on: elementUnderTheMouse) ].
	
	anEvent wasHandled: true! !

!MOCanvas methodsFor: 'event handling' stamp: 'AlexandreBergel 9/6/2010 09:09'!
mouseUp: anEvent 
	| element selectionEvent |

	element := self root elementAt: anEvent position.

	(lastClickPosition = anEvent position and: 
		[ lastClickTimestamp notNil and: [ lastClickTimestamp + 300 > Time millisecondClockValue ] ]) 
				ifTrue: [ ^ self announce: (MOMouseDouble event: anEvent on: element) ].
	lastClickPosition := anEvent position.
	lastClickTimestamp := Time millisecondClockValue.

	anEvent wasHandled: true.
	
	"If the lastEnteredGraphElement is not selected, then we select it since a mouse button is pressed"
	(lastEnteredGraphElement isNil not and: [
		(lastEnteredGraphElement class ~~ MORoot and: [ lastEnteredGraphElement isNotSelected ])]) ifTrue: [
		selectionEvent := MOElementSelection event: anEvent on: lastEnteredGraphElement.
		anEvent commandKeyPressed ifTrue: [ selectionEvent setAsMultiple ].
	  self announce: selectionEvent.
	  anEvent wasHandled: true.
	  ^ self  ].

	"We simply send MOMouseUp"
	element ifNotNilDo: [:el | el announce: (MOMouseUp event: anEvent on: el) ]! !

!MOCanvas methodsFor: 'printing' stamp: 'Alexandre Bergel 6/6/2010 20:03'!
printOn: stream
	stream nextPutAll: 'MOCanvas<'.
	stream nextPutAll: self bounds printString.
	stream nextPutAll: '>'.! !

!MOCanvas methodsFor: 'error management' stamp: 'Alexandre Bergel 12/17/2009 00:36'!
raiseError: error
	| v |
	v := Smalltalk at: #MondrianError ifAbsentPut: [ true ].
	v ifFalse: [ ^ self ].
	self inform: error printString.
	Smalltalk at: #MondrianError put: false! !

!MOCanvas methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 20:32'!
root
	^ root! !

!MOCanvas methodsFor: 'accessing' stamp: 'Alexandre Bergel 2/25/2010 10:09'!
root: aMORoot 
	root := aMORoot applyLayout.
	aMORoot canvas: self.
	"self extent: aMORoot bounds extent"
	self updateBounds! !

!MOCanvas methodsFor: 'event handling' stamp: 'AlexandreBergel 9/14/2010 13:53'!
selected: anElement 
	self root deselectAll.
	anElement isNil
		ifFalse: [ anElement select ].
	self changed! !

!MOCanvas methodsFor: 'announce' stamp: 'Alexandre.Bergel 8/9/2009 16:12'!
signalWindowSwitch
	"This method is called when the window in which I am embedded is moved to the back or to the front"
	
	"nil is provided since no mouse event is accessible (hooks need to be inserted into the Morphic framework, which is not trivial). However, the morphic mouse event is irrelevent here"
	lastEnteredGraphElement 
		ifNotNil: [ self announce: (MOMouseLeave event: nil on: lastEnteredGraphElement) ].
	lastEnteredGraphElement := nil.! !

!MOCanvas methodsFor: 'action' stamp: 'Alexandre Bergel 6/20/2010 23:40'!
stopAllProcesses
	self root allNodesDo: [ :n | n interaction stopProcesses ].
	(Process allInstances select: [:p | p name = 'mondrian process' ])
		do: #terminate.! !

!MOCanvas methodsFor: 'action' stamp: 'AlexandreBergel 9/6/2010 18:35'!
updateBounds

	"Scroll pane comes with its own bag of mysteries and tricks. "
	| scrollPane scrollPaneExtent |
	(owner isNil or: [ owner owner isNil]) 
		ifTrue: [ self extent: root bounds extent. ^ self ].
	

	scrollPane := owner owner.
	scrollPaneExtent := scrollPane bounds extent.

	scrollPane resizeScrollBars; resizeScroller; hideOrShowScrollBars.	
	scrollPane  vSetScrollDelta ; hSetScrollDelta.
	 self extent: root bounds extent.  
	

! !

MOCanvas subclass: #MOPopupViewCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Morphic'!

!CompiledMethod methodsFor: '*mondrian-literals' stamp: 'Alexandre Bergel 4/26/2010 11:25'!
classReferences
	^ ((self allLiterals select: [:l | l isKindOf: Association ]) collect: #value) copyWithout: self methodClass
	! !

!CompiledMethod methodsFor: '*mondrian-literals' stamp: 'Alexandre Bergel 5/10/2010 18:58'!
numberOfLinesOfCode
	(self propertyValueAt: #numberOfLinesOfCode)
			ifNil: [ self propertyValueAt: #numberOfLinesOfCode put: self getSource lineCount ].

	^ self propertyValueAt: #numberOfLinesOfCode ! !

!Behavior methodsFor: '*mondrian-accessing' stamp: 'Alexandre Bergel 4/21/2010 21:13'!
numberOfAttributes
	^ self instVarNames size! !

!MenuIcons class methodsFor: '*Mondrian-Easel' stamp: 'Alexandre Bergel 6/19/2010 19:21'!
mondrian
^ Icons
		at: #mondrian ifAbsentPut: [((ColorForm
	extent: 16@16
	depth: 4
	fromArray: #( 2863311530 2863311530 2863311530 2863311530 2863267840 43690 2863268113 286304938 2863268113 286304938 2862940433 286304938 2860646673 286304938 2855600128 43690 2684398250 2258283178 2688592544 170 2688592544 2004316330 2688592544 2004316330 2688592544 2004316330 2688592544 2004316330 2688592544 2004316330 2684398240 170)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.0 0.686 0.28200000000000003) #(0.059000000000000004 0.059000000000000004 0.059000000000000004) #(0.28500000000000003 0.28500000000000003 0.28500000000000003) #(0.34500000000000003 0.427 0.964) #(0.423 0.423 0.423) #(0.603 0.603 0.603) #(0.729 0.125 0.117) #(0.745 0.745 0.745) #(0.78 0.78 0.78) #(0.843 0.843 0.843) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  ))]! !

!MenuIcons class methodsFor: '*Mondrian-Easel' stamp: 'tg 9/3/2010 08:43'!
mondrianZoomIn
^ Icons
		at: #mondrianZoomIn ifAbsentPut: [(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1648246334 3040821055 3879681855 3879681855 3040821055 1648246334 0 0 0 0 0 0 0 0 423443773 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 423443773 0 0 0 0 0 0 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 0 0 0 0 0 1648246334 4282400832 4282400832 4282400832 4282400832 2151694400 2151694400 4282400832 4282400832 4282400832 4282400832 1648246334 0 0 0 0 3040821055 4282400832 4282400832 4282400832 4282400832 2151694400 2151694400 4282400832 4282400832 4282400832 4282400832 3040821055 0 0 0 0 3879681855 4282400832 4282400832 2151694400 2151694400 1077952576 1077952576 2151694400 2151694400 4282400832 4282400832 3879681855 0 0 0 0 3879681855 4282400832 4282400832 2151694400 2151694400 1077952576 1077952576 2151694400 2151694400 4282400832 4282400832 3879681855 0 0 0 0 3040821055 4282400832 4282400832 4282400832 4282400832 2151694400 2151694400 4282400832 4282400832 4282400832 4282400832 3040821055 0 0 0 0 1648246334 4282400832 4282400832 4282400832 4282400832 2151694400 2151694400 4282400832 4282400832 4282400832 4282400832 1648246334 0 0 0 0 0 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 0 0 0 0 0 0 423443773 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 423443773 0 0 0 0 0 0 0 0 1648246334 3040821055 3879681855 3879681855 3040821055 1648246334 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)]! !

!MenuIcons class methodsFor: '*Mondrian-Easel' stamp: 'tg 9/3/2010 08:43'!
mondrianZoomOut
^ Icons
		at: #mondrianZoomOut ifAbsentPut: [(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1648246334 3040821055 3879681855 3879681855 3040821055 1648246334 0 0 0 0 0 0 0 0 423443773 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 423443773 0 0 0 0 0 0 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 0 0 0 0 0 1648246334 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 1648246334 0 0 0 0 3040821055 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3040821055 0 0 0 0 3879681855 4282400832 4282400832 2151694400 2151694400 2151694400 2151694400 2151694400 2151694400 4282400832 4282400832 3879681855 0 0 0 0 3879681855 4282400832 4282400832 2151694400 2151694400 2151694400 2151694400 2151694400 2151694400 4282400832 4282400832 3879681855 0 0 0 0 3040821055 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3040821055 0 0 0 0 1648246334 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 1648246334 0 0 0 0 0 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 0 0 0 0 0 0 423443773 3141484351 4282400832 4282400832 4282400832 4282400832 4282400832 4282400832 3141484351 423443773 0 0 0 0 0 0 0 0 1648246334 3040821055 3879681855 3879681855 3040821055 1648246334 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)]! !

!BlockClosure methodsFor: '*mondrian' stamp: 'simon.denier 4/18/2009 13:03'!
moValue: anArgument
	^ self value: anArgument! !

!Collection methodsFor: '*Mondrian' stamp: 'Alexandre.Bergel 8/30/2009 11:01'!
maxValue: aBlock
	"Evaluate aBlock for element of the receiver, and return the largest result."

	^self inject: Float infinity negated into: [ :max :each | max max: (aBlock value: each) ]! !

!Collection methodsFor: '*mondrian-converting' stamp: 'Alexandre.Bergel 9/17/2009 18:48'!
sortedAs: aSortBlockOrSymbol
	"Answer a SortedCollection whose elements are the elements of the 
	receiver. The sort order is defined by the argument, aSortBlock."

	| aSortedCollection aSortBlock |
	aSortedCollection := SortedCollection new: self size.
	aSortBlock := 
		aSortBlockOrSymbol isSymbol 
			ifTrue: [ [:a :b | |t1 t2|
							t1 := (a perform: aSortBlockOrSymbol).
							t2 := (b perform: aSortBlockOrSymbol).
							((t1 isKindOf: Boolean) and: [t2 isKindOf: Boolean])
								ifTrue: [ t1 ]
								ifFalse: [ t1 < t2 ] ] ]
			ifFalse: [ aSortBlockOrSymbol ].
	aSortedCollection sortBlock: aSortBlock.
	aSortedCollection addAll: self.
	^ aSortedCollection! !

HealthReportProducer subclass: #MondrianHealth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MondrianHealth class methodsFor: 'public' stamp: 'Alexandre Bergel 10/20/2009 16:11'!
produceReport
	^ self new produceReport! !

!MondrianHealth methodsFor: 'logging' stamp: 'Alexandre Bergel 4/6/2010 09:42'!
logMethodCoverage
	^ #(#(58 'September 26, 2009'))
	,#(#(58.5 'MethodCoverage'))	,#(#(58.83 'MethodCoverage'))	,#(#(58.83 'MethodCoverage'))	,#(#(60.41 'MethodCoverage'))	,#(#(60.13 'MethodCoverage'))	,#(#(60.03 'MethodCoverage'))	,#(#(60.03 'MethodCoverage'))	,#(#(60.03 'MethodCoverage'))	,#(#(60.03 'MethodCoverage'))	,#(#(60.03 'MethodCoverage'))	,#(#(60.03 'MethodCoverage'))	,#(#(60.03 'MethodCoverage'))	,#(#(60.22 'MethodCoverage'))	,#(#(55.03 'MethodCoverage'))	,#(#(55.11 'MethodCoverage'))	,#(#(52.11 'MethodCoverage'))	,#(#(55.11 'MethodCoverage'))	,#(#(56.04 'MethodCoverage'))	,#(#(55.08 'MethodCoverage'))	,#(#(55.65 'MethodCoverage'))	,#(#(55.54 'MethodCoverage'))	,#(#(54.63 'MethodCoverage'))	,#(#(54.71 'MethodCoverage'))	,#(#(54.78 'MethodCoverage'))	,#(#(54.77 'MethodCoverage'))	,#(#(54.77 'MethodCoverage'))	,#(#(60.6 'MethodCoverage'))! !

!MondrianHealth methodsFor: 'public' stamp: 'AlexandreBergel 9/14/2010 10:25'!
produceReportOn: stream
	"
	self new produceReport
	"
	self writeGeneralInfoOn: stream.
	self writeBenchmarkResultsOn: stream.
	self writeBenchmark2ResultsOn: stream.
	
	self writeBenchmark3ResultsOn: stream.
	self writeBenchmark4ResultsOn: stream.
	self writeBenchmark5ResultsOn: stream.

	self writeBenchmark6ResultsOn: stream.

	self writeBenchmark7ResultsOn: stream.

	self writeBenchmark8ResultsOn: stream.	
		
	self writeBenchmark9ResultsOn: stream.			


"	self writeCoverageInfoOn: stream.
"! !

!MondrianHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 6/7/2010 20:47'!
writeBenchmark2ResultsOn: stream
	| bench numberOfEdges results v |
	numberOfEdges := #(10 20 30 40 50 60 70 80 90 100 200 300).
	results := OrderedCollection new.
	stream
		nextPutAll: 'Benchmark ManyEdges (simple rendering of edges) :';
		cr.
	bench := MOBenchmarks new.
	self displayProgressBar:
			[ :bar | 
			numberOfEdges do:
					[ :number | 
					Transcript
						show: 'number of edges = ';
						show: number printString;
						cr.
					v := bench reportManyEdgesBenchFor: number.
					results add: v.
					stream
						nextPutAll: '  ';
						nextPutAll: number printString;
						nextPutAll: ' edges => ';
						nextPutAll: v printString;
						nextPutAll: ' ms';
						cr.
					self incrProgressBar: bar ] ]
		size: numberOfEdges size
		titled: 'ManyEdges benchmark'.
	"self openMondrianGraphOn: (numberOfEdges with: results collect: [ :v1 :v2 | v1 -> v2 ]) titled: 'ManyEdges'"! !

!MondrianHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 6/7/2010 20:52'!
writeBenchmark3ResultsOn: stream
	| bench numberOfNodes results v |
	numberOfNodes := #(5 10 15).
	results := OrderedCollection new.
	
	stream nextPutAll: 'Benchmark ManyInnerNodes :'; cr.
	bench := MOBenchmarks new.
	self displayProgressBar: [:bar | 
			numberOfNodes
				do: [:number |
						v := bench reportManyInnerNodesBenchFor: number.
						results add: v.
						stream nextPutAll: '  ';
							nextPutAll: number printString;
							nextPutAll: ' nodes => ';
							nextPutAll: v printString;
							nextPutAll: ' ms';
							cr.
						self incrProgressBar: bar]]
		 size: numberOfNodes size  titled: 'ManyInnerNodes benchmark'.

	"self openMondrianGraphOn: (numberOfNodes with: results collect: [:v1 :v2 | v1 -> v2]) titled: 'ManyNodes'.
"! !

!MondrianHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 6/7/2010 20:52'!
writeBenchmark4ResultsOn: stream
	| bench numberOfNodes results v |
	numberOfNodes := #(5 10 15).
	results := OrderedCollection new.
	
	stream nextPutAll: 'Benchmark Displaying ManyInnerNodes :'; cr.
	bench := MOBenchmarks new.
	self displayProgressBar: [:bar | 
			numberOfNodes
				do: [:number |
						v := bench reportManyDisplayingInnerNodesBenchFor: number.
						results add: v.
						stream nextPutAll: '  ';
							nextPutAll: number printString;
							nextPutAll: ' nodes => ';
							nextPutAll: v printString;
							nextPutAll: ' ms';
							cr.
						self incrProgressBar: bar]]
		 size: numberOfNodes size  titled: 'Displaying ManyInnerNodes benchmark'.

	"self openMondrianGraphOn: (numberOfNodes with: results collect: [:v1 :v2 | v1 -> v2]) titled: 'Displaying ManyNodes'.
"! !

!MondrianHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 6/7/2010 21:02'!
writeBenchmark5ResultsOn: stream
	| bench numberOfNodes results v |
	numberOfNodes := #(1 2 3 4).
	results := OrderedCollection new.
	
	stream nextPutAll: 'Benchmark Displaying ManyInnerNodesAndEdges :'; cr.
	bench := MOBenchmarks new.
	self displayProgressBar: [:bar | 
			numberOfNodes
				do: [:number |
						v := bench reportManyDisplayingInnerNodesAndEdgesBenchFor: number.
						results add: v.
						stream nextPutAll: '  ';
							nextPutAll: number printString;
							nextPutAll: ' nodes => ';
							nextPutAll: v printString;
							nextPutAll: ' ms';
							cr.
						self incrProgressBar: bar]]
		 size: numberOfNodes size  titled: 'Displaying ManyInnerNodesAndEdges benchmark'.
! !

!MondrianHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 6/10/2010 18:09'!
writeBenchmark6ResultsOn: stream
	| bench numberOfIterations results v |
	numberOfIterations := #(100 500 1000 1500 2000 2500).
	results := OrderedCollection new.
	
	stream nextPutAll: 'Benchmark Displaying elementAt :'; cr.
	bench := MOBenchmarks new.
	self displayProgressBar: [:bar | 
			numberOfIterations
				do: [:number |
						v := bench reportElementAtFor:  number.
						results add: v.
						stream nextPutAll: '  ';
							nextPutAll: number printString;
							nextPutAll: ' nodes => ';
							nextPutAll: v printString;
							nextPutAll: ' ms';
							cr.
						self incrProgressBar: bar]]
		 size: numberOfIterations size  titled: 'Benchmark Displaying elementAt :'.
! !

!MondrianHealth methodsFor: 'report producers' stamp: 'AlexandreBergel 9/6/2010 18:33'!
writeBenchmark7ResultsOn: stream
	| v numberOfNodes |

	numberOfNodes := 2000.
	stream nextPutAll: 'Benchmark many small nodes : '; cr.
	v := MOBenchmarks new reportManySmallNodesBenchFor: numberOfNodes.
	stream nextPutAll: '  ';
			nextPutAll: numberOfNodes printString;
			nextPutAll: ' nodes => ';
			nextPutAll: v printString;
			nextPutAll: ' ms';
			cr.! !

!MondrianHealth methodsFor: 'report producers' stamp: 'AlexandreBergel 9/14/2010 10:26'!
writeBenchmark8ResultsOn: stream
	| v numberOfNodes |
	numberOfNodes := 500.
	stream nextPutAll: 'Benchmark edges bounds : '; cr.
	v := MOBenchmarks new reportEdgeBounds: 500.
	stream nextPutAll: '  ';
			nextPutAll: numberOfNodes printString;
			nextPutAll: ' nodes => ';
			nextPutAll: v printString;
			nextPutAll: ' ms';
			cr.! !

!MondrianHealth methodsFor: 'report producers' stamp: 'AlexandreBergel 9/14/2010 10:26'!
writeBenchmark9ResultsOn: stream
	| v numberOfNodes |
	numberOfNodes := 20000.
	stream nextPutAll: 'Benchmark subnodes lookup : '; cr.
	v := MOBenchmarks new reportEdgeBounds: numberOfNodes.
	stream nextPutAll: '  ';
			nextPutAll: numberOfNodes printString;
			nextPutAll: ' nodes => ';
			nextPutAll: v printString;
			nextPutAll: ' ms';
			cr.! !

!MondrianHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 6/7/2010 20:46'!
writeBenchmarkResultsOn: stream
	| bench numberOfNodes results v |
	numberOfNodes := #(100 200 300 400 500 600 700 800 900 1000 1600 3200 6400).
	results := OrderedCollection new.
	
	stream nextPutAll: 'Benchmark ManyNode (simple rendering of nodes) :'; cr.
	bench := MOBenchmarks new.
	self displayProgressBar: [:bar | 
			numberOfNodes
				do: [:number |
						v := bench reportManyNodesBenchFor: number.
						results add: v.
						stream nextPutAll: '  ';
							nextPutAll: number printString;
							nextPutAll: ' nodes => ';
							nextPutAll: v printString;
							nextPutAll: ' ms';
							cr.
						self incrProgressBar: bar]]
		 size: numberOfNodes size  titled: 'ManyNodes benchmark'.

	"self openMondrianGraphOn: (numberOfNodes with: results collect: [:v1 :v2 | v1 -> v2]) titled: 'ManyNodes'.
"! !

!SequenceableCollection methodsFor: '*mondrian' stamp: 'simon.denier 4/30/2009 13:51'!
swapElement: oneElement withElement: anotherElement 
	| oneIndex anotherIndex |
	oneIndex := self indexOf: oneElement.
	anotherIndex := self indexOf: anotherElement.
	self swap: oneIndex with: anotherIndex! !

!Symbol methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:34'!
moValue: anObject 
	^ anObject perform: self! !

!Rectangle class methodsFor: '*mondrian-complexshape' stamp: 'Alexandre.Bergel 2/5/2009 18:45'!
left: x top: y width: w height: h
	^ self origin: (x@y) corner: (x + w) @ (y + h)! !

!Rectangle class methodsFor: '*mondrian-complexshape' stamp: 'lr 9/17/2006 23:07'!
origin: aPoint width: aWidth height: aHeight
	^ self origin: aPoint corner: (aPoint x + aWidth) @ (aPoint y + aHeight)! !

!Rectangle methodsFor: '*mondrian' stamp: 'lr 9/18/2006 15:38'!
corner: aPoint
	corner := aPoint! !

!Rectangle methodsFor: '*mondrian' stamp: 'Alexandre.Bergel 2/5/2009 18:47'!
extent: aPoint
	corner := origin + aPoint! !

!Rectangle methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:36'!
height: aNumber 
	corner moY: origin y + aNumber! !

!Rectangle methodsFor: '*mondrian' stamp: 'lr 9/18/2006 15:38'!
origin: aPoint
	origin := aPoint! !

!Rectangle methodsFor: '*mondrian' stamp: 'Alexandre.Bergel 2/21/2009 13:07'!
translate: aPoint
	origin := origin + aPoint.
	corner := corner + aPoint! !

!Rectangle methodsFor: '*mondrian' stamp: 'Alexandre Bergel 3/2/2010 14:15'!
translateTo: aPoint	
	| currentExtent |

	currentExtent := self extent.
	origin := aPoint.
	self extent: currentExtent! !

!Rectangle methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:35'!
width: aNumber 
	corner moX: origin x + aNumber! !

Announcer subclass: #MOAnnouncer
	instanceVariableNames: 'forwards menuItems menuMorphBlock viewRenderer ports processes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOAnnouncer methodsFor: 'convenient' stamp: 'Alexandre Bergel 12/28/2009 11:35'!
action: oneArgumentBlockactionOrSymbol

	^ oneArgumentBlockactionOrSymbol isSymbol
		ifTrue: [ self item: oneArgumentBlockactionOrSymbol asString action: oneArgumentBlockactionOrSymbol ]
		ifFalse: [ self item: 'action' action: oneArgumentBlockactionOrSymbol ]
! !

!MOAnnouncer methodsFor: 'announce' stamp: 'AlexandreBergel 9/16/2010 14:48'!
announce: ann
	ann viewRenderer: self viewRenderer.
	(self isForwarder and: [ forwards anySatisfy: [ :ev | ann isKindOf: ev ]]) ifTrue: [ 
			ann element: ann element owner. 
			^ ann element announce: ann ].
	super announce: ann! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'AlexandreBergel 9/5/2010 16:55'!
draggable
	self unsubscribeForEvent: MOMouseDrag.
	self subscribe: MOMouseDrag do: [:ann | 
		ann nodesToDrag do: [ :node |
			node translateBy: ann step bounded: true.
			node resetFormCacheUpToTheRoot ].
		
		"ann element resetFormCacheResursively."
		ann viewRenderer updateWindow ]! !

!MOAnnouncer methodsFor: 'threading' stamp: 'Alexandre Bergel 6/15/2010 09:02'!
every: milliseconds do: block
	| process |
	process := [ [ true ] 
					whileTrue: [ block value": self viewRenderer root" . (Delay forMilliseconds: milliseconds) wait ]] forkNamed: 'mondrian process'.
	self processes add: process ! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 20:16'!
forNode: aBlockOrSymbol whenClickingUpdateNode: firstClickBlock whenClickingBackUpdateNode: secondClickBlock withLayoutUpdate: aBoolean
	"enteringBlock and leavingBlock are one arg block each. The argument is the shape of the node that receive the event"

	self registerForEvent: MOMouseDown forNode: aBlockOrSymbol updateNode: firstClickBlock updateLayout: aBoolean.
! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 20:16'!
forNode: aBlockOrSymbol whenClickingUpdateNode: firstClickBlock withLayoutUpdate: aBoolean
	"enteringBlock and leavingBlock are one arg block each. The argument is the shape of the node that receive the event"

	self registerForEvent: MOMouseDown forNode: aBlockOrSymbol updateNode: firstClickBlock updateLayout: aBoolean.
! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 19:59'!
forNode: aBlockOrSymbol whenEnteringUpdateNode: enteringBlock whenLeavingUpdateNode: leavingBlock withLayoutUpdate: aBoolean

	self registerForEvent: MOMouseEnter forNode: aBlockOrSymbol updateNode: enteringBlock updateLayout: aBoolean.
	self registerForEvent: MOMouseLeave forNode: aBlockOrSymbol updateNode: leavingBlock updateLayout: aBoolean.! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 1/14/2010 16:40'!
forNodes: aBlockOrSymbol whenEnteringUpdateShapes: enteringBlock whenLeavingUpdateShapes: leavingBlock
	"enteringBlock and leavingBlock are one arg block each. The argument is the shape of the node that receive the event"

	^ self forNodes: aBlockOrSymbol whenEnteringUpdateShapes: enteringBlock whenLeavingUpdateShapes: leavingBlock withLayoutUpdate: false! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 20:13'!
forNodes: aBlockOrSymbol whenEnteringUpdateShapes: enteringBlock whenLeavingUpdateShapes: leavingBlock withLayoutUpdate: aBoolean
	"enteringBlock and leavingBlock are one arg block each. The argument is the shape of the node that receive the event"

	self registerForEvent: MOMouseEnter forNodes: aBlockOrSymbol updateShape: enteringBlock updateLayout: aBoolean.
	self registerForEvent: MOMouseLeave forNodes: aBlockOrSymbol updateShape: leavingBlock updateLayout: aBoolean.! !

!MOAnnouncer methodsFor: 'forwarder' stamp: 'AlexandreBergel 9/16/2010 14:46'!
forward
	self forwarder ! !

!MOAnnouncer methodsFor: 'forwarder' stamp: 'AlexandreBergel 9/16/2010 14:46'!
forward: anEvent
	forwards ifNil: [ forwards := OrderedCollection new ].
	forwards add: anEvent ! !

!MOAnnouncer methodsFor: 'forwarder' stamp: 'AlexandreBergel 9/16/2010 14:43'!
forwarder
	self forward: MOEvent! !

!MOAnnouncer methodsFor: 'ports and transmissions' stamp: 'AlexandreBergel 9/6/2010 18:28'!
from: interaction port: portName do: aBlock

	interaction on: MOPortEvent do: [:ann | ann portName = portName ifTrue: [ aBlock value: ann ] ].

	"self element addTransmission: transmission."
! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 12/17/2009 19:15'!
highlightWhenOver
	self highlightWhenOver: #yourself! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 12/17/2009 19:53'!
highlightWhenOver: aBlockOrSymbol

	self 
		forNodes: aBlockOrSymbol 
		whenEnteringUpdateShapes: [:shape | shape borderColor: Color red ] 
		whenLeavingUpdateShapes: [:shape | shape borderColor: Color black ]! !

!MOAnnouncer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 3/2/2010 21:29'!
initialize
	super initialize.
	isForwarder := false.
	
	ports := OrderedCollection new.! !

!MOAnnouncer methodsFor: 'forwarder' stamp: 'AlexandreBergel 9/16/2010 14:45'!
isForwarder
	^ forwards notNil! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'tg 9/29/2009 12:05'!
item: itemString action: oneArgumentBlockaction

	self menuItems add: itemString -> oneArgumentBlockaction.
	self registerMenu! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'Alexandre.Bergel 5/14/2009 00:01'!
lookFor: aEventClass
	"return the handler associated to the event class"
	^ subscriptions at: aEventClass! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'tg 9/29/2009 12:05'!
menu: aBlock
	self menuMorphBlock: aBlock! !

!MOAnnouncer methodsFor: 'accessing' stamp: 'tg 9/29/2009 11:13'!
menuItems
	^ menuItems ifNil: [menuItems := OrderedCollection new]! !

!MOAnnouncer methodsFor: 'accessing' stamp: 'tg 9/29/2009 11:59'!
menuItems: aCollection
	"aCollection has to follow the pattern {'item1' -> [:element | ... ] . 'item2' -> #selector ...}"
	menuItems := aCollection asOrderedCollection.
	self registerMenu		! !

!MOAnnouncer methodsFor: 'accessing' stamp: 'tg 9/29/2009 12:05'!
menuMorphBlock: aBlock 
	menuMorphBlock := aBlock.
	self registerMenu	! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'Alexandre Bergel 7/19/2010 11:36'!
menuMorphFor: anElement 
	| menuMorph |
	menuMorph := 
		menuMorphBlock isNil 
			ifTrue:  [ MenuMorph new ]
			ifFalse: [ menuMorphBlock moValue: anElement model ].
		
	self menuItems do: 
		[ :each | 
		menuMorph 
			add: each key
			target: each value
			selector: #moValue:
			argument: anElement model ].
	^ menuMorph 
	! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'Alexandre.Bergel 4/12/2009 19:45'!
nodraggable
	self unsubscribeForEvent: MOMouseDrag.
! !

!MOAnnouncer methodsFor: '*Mondrian-Morphic' stamp: 'jannik.laval 3/6/2009 16:26'!
popupText
	"open a popup text when the mouse enter a node"

	self popupText: [:each | each]! !

!MOAnnouncer methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 1/23/2010 11:21'!
popupText: aBlock
	^ self popupText: aBlock delay: 500! !

!MOAnnouncer methodsFor: '*Mondrian-Morphic' stamp: 'AlexandreBergel 9/6/2010 18:35'!
popupText: aBlock delay: ms
	"open a popup text when the mouse enter a node"

	self unsubscribeForEvent: MOMouseEnter.
	self unsubscribeForEvent: MOMouseLeave.
	self
		subscribe: MOMouseEnter
		do: [ :ann | 
			ann element resetMetricCaches.	"I do not understand what we need this"
			ann hasElement
				ifTrue: [ 
					[ 
					| oldPosition relativePosition |
					ActiveHand
						ifNotNil: [ :arg | 
							oldPosition := ActiveHand position.
							(Delay forMilliseconds: ms) wait.	"we compute the relative position since ActiveHand return an absolute location"
							relativePosition := ann position - oldPosition + ActiveHand position.	"We check if we are in the same node, if yes, then we evaluate the view"
							(ann root notNil and: [ (ann root elementAt: relativePosition) == ann current ])
								ifTrue: [ MOPopup show: ([ (aBlock moValue: ann modelElement) asString ] on: Error do: [ 'Error when printing' ]) asString ] ] ]
						fork ]
				ifFalse: [ MOPopup remove ]	"and: [(ann element isKindOf: MORoot) not]" ].
	self
		subscribe: MOMouseLeave
		do: [ :ann | 
			ann element resetMetricCaches.
			MOPopup remove ]! !

!MOAnnouncer methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre.Bergel 5/13/2009 23:46'!
popupView: aBlock
	self popupView: aBlock delay: 100! !

!MOAnnouncer methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 4/1/2010 14:58'!
popupView: aBlock delay: ms
	"open a popup text when the mouse enter a node"
	^ self popupView: aBlock delay: ms zoomedInBy: 1! !

!MOAnnouncer methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 7/26/2010 15:00'!
popupView: aBlock delay: ms zoomedInBy: aValue
	"open a popup text when the mouse enter a node"

	"Yeah, this method is a bit scary"
	self unsubscribeForEvent: MOMouseEnter.
	self unsubscribeForEvent: MOMouseLeave.

	self subscribe: MOMouseEnter do: 
		[:ann | 
			ann element resetMetricCaches.
			(ann hasElement)
				ifTrue: [
					[ | oldPosition view newCanvas relativePosition |
					 oldPosition := ActiveHand position.
					 (Delay forMilliseconds: ms) wait.
					
					 "we compute the relative position since ActiveHand return an absolute location"
					 relativePosition := ann position - oldPosition + ActiveHand position.
					
					 "We check if we are in the same node, if yes, then we evaluate the view"
					 (ann root notNil and: [(ann root elementAt: relativePosition) == ann current]) ifTrue: 
						[ view := MOViewRenderer new.
						  aBlock value: ann element model value: view.
						  newCanvas := MOPopup showView: view zoomedInBy: aValue.
						  ann element popup: newCanvas. ] ] fork.
					]
				ifFalse: [ann element popup ifNotNil: [:v | v delete]. MOPopup remove] ].

	self subscribe: MOMouseLeave do: 
		[:ann | 
			ann element resetMetricCaches.
			ann element removePopupIfExist. MOPopup remove ].
! !

!MOAnnouncer methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 4/1/2010 15:04'!
popupView: aBlock zoomedInBy: aValue
	self popupView: aBlock delay: 100 zoomedInBy: aValue! !

!MOAnnouncer methodsFor: 'ports and transmissions' stamp: 'Alexandre Bergel 3/2/2010 21:37'!
port: aSymbol 
	 
	^ports 
		detect: [:each | each name = aSymbol] 
		ifNone: 
			[ports 
				addLast: 
					(MOPort new
						"interaction: self;" 
						name: aSymbol; 
						yourself)]! !

!MOAnnouncer methodsFor: 'ports and transmissions' stamp: 'Alexandre Bergel 3/2/2010 21:29'!
ports 
	 
	^OrderedCollection withAll: ports! !

!MOAnnouncer methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/15/2010 12:19'!
processes
	^ processes ifNil: [ processes := OrderedCollection new ]! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/15/2010 09:21'!
refreshLayoutEvery: ms
	^ self refreshLayoutEvery: ms view: self viewRenderer ! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/15/2010 09:21'!
refreshLayoutEvery: ms view: view
	self every: ms do: [ 
		view layout doIncrementallyExecute:  view  root.  
		view updateWindow ].! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'AlexandreBergel 9/6/2010 18:28'!
registerForEvent: eventClass forNode: aBlockOrSymbol updateNode: updateBlock updateLayout: aBoolean

	| domainNode |
	self 
		on: eventClass do: [:ann | 
			"ann element = the MONode"
			ann element removeAllEdges.

			domainNode := (aBlockOrSymbol moValue: ann element model).
			ann element 
				resetMetricCachesResursively;
				resetElementsToLookupUpToTheRoot.
			
			ann viewRenderer forNodes: {domainNode} do: updateBlock.
			aBoolean
				ifTrue: 
					[ ann viewRenderer root allNodes do: #resetCache.
					  ann viewRenderer root resetElementsToDisplayCacheRecursively.
					  ann element resetCacheInEdges.					
					  ann viewRenderer updateWindow.
					  ann viewRenderer root applyLayout]
				ifFalse: [ ann viewRenderer updateWindow ]
			].
! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 20:09'!
registerForEvent: eventClass forNode: aBlockOrSymbol updateShape: updateBlock updateLayout: aBoolean

	| node domainNode |
	self 
		on: eventClass do: [:ann | 
			"ann element = the MONode"
			ann element removeAllEdges.

			domainNode := (aBlockOrSymbol moValue: ann element model).
			node := ann viewRenderer nodeForDomainValue: domainNode.
			ann element 
				resetMetricCachesResursively;
				resetElementsToLookupUpToTheRoot.
			
			node resetMetricCachesResursively. 
			node copyShapeWithoutUpdatingAndDo: updateBlock.

			aBoolean
				ifTrue: 
					[ ann viewRenderer root allNodes do: #resetCache.
					  ann viewRenderer root resetElementsToDisplayCacheRecursively.
					  ann element resetCacheInEdges.					
					  ann viewRenderer updateWindow.
					  ann viewRenderer root applyLayout]
				ifFalse: [ ann viewRenderer updateWindow ]
			].
! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'AlexandreBergel 9/6/2010 18:34'!
registerForEvent: eventClass forNodes: aBlockOrSymbol updateNode: updateBlock updateLayout: aBoolean

	| domainNodes domainNode |
	self 
		on: eventClass do: [:ann | 
			"ann element = the MONode"
			ann element removeAllEdges.

			domainNodes := (aBlockOrSymbol moValue: ann element model).
			domainNodes do: [:n | 
				n 
					resetMetricCachesResursively;
					resetElementsToLookupUpToTheRoot ].
			
			ann viewRenderer forNodes: domainNode do: updateBlock.
			aBoolean
				ifTrue: 
					[ ann viewRenderer root allNodes do: #resetCache.
					  ann viewRenderer root resetElementsToDisplayCacheRecursively.
					  ann element resetCacheInEdges.					
					  ann viewRenderer updateWindow.
					  ann viewRenderer root applyLayout]
				ifFalse: [ ann viewRenderer updateWindow ]
			].
! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'AlexandreBergel 9/1/2010 19:16'!
registerForEvent: eventClass forNodes: aBlockOrSymbol updateShape: updateBlock updateLayout: aBoolean

	| nodes domainNodes |
	self 
		on: eventClass do: [:ann | 
			"ann element = the MONode"
			ann element removeAllEdges.

			domainNodes := (aBlockOrSymbol moValue: ann element model).
			nodes := ann viewRenderer nodeForDomainValues: domainNodes.
			ann element 
				resetMetricCachesResursively;
				resetElementsToLookupUpToTheRoot.
				
			nodes do: [:node |
				node resetMetricCachesResursively. 
				node copyShapeWithoutUpdatingAndDo: updateBlock ].

			aBoolean
				ifTrue: 
					[ ann viewRenderer root allNodes do: #resetCache.
					  ann viewRenderer root resetElementsToDisplayCacheRecursively.
					  ann element resetCacheInEdges.					
					  ann viewRenderer updateWindow.
					  ann viewRenderer root applyLayout]
				ifFalse: [
					ann element 
						resetFormCacheUpToTheRoot;
						resetMetricCachesUpToTheRoot.
					ann viewRenderer updateWindow ]
			].
! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'Alexandre Bergel 7/19/2010 11:04'!
registerMenu
	self unsubscribeForEvent: MOMouseDown.
	self subscribe: MOMouseDown do: [:ann |
		ann isLeftButtonPressed ifFalse: [
			(self menuMorphFor: ann element) popUpInWorld
		].
		"Clicking on a menu should make popup disappear"
		ann element removePopupIfExist
	].
! !

!MOAnnouncer methodsFor: 'window status' stamp: 'Alexandre Bergel 2/24/2010 00:01'!
resetWindowStatus
	self setWindowStatusTo: '' forElement: viewRenderer root! !

!MOAnnouncer methodsFor: 'animation' stamp: 'Alexandre Bergel 3/1/2010 19:24'!
selectFrameFromX
	self unsubscribe: MOMouseEnter.
	self unsubscribe: MOMouseLeave.
	self on: MOMouseMove do: [:ann | 
				| pos extent framedNode frameToDisplay relativePosition |
				framedNode := ann element.
				pos := ann position.
				relativePosition := pos - framedNode absoluteBounds origin.
				extent := ann element shape boundsFor: ann element.
				frameToDisplay := (relativePosition x / extent width * framedNode numberOfFrames + 1) asInteger.
				framedNode moveToFrame: frameToDisplay ].! !

!MOAnnouncer methodsFor: 'animation' stamp: 'Alexandre Bergel 3/1/2010 16:28'!
selectFrameFromY
	self on: MOMouseMove do: [:ann | 
				| pos extent framedNode frameToDisplay relativePosition |
				framedNode := ann element.
				pos := ann position.
				relativePosition := pos - framedNode absoluteBounds origin.
				extent := ann element shape boundsFor: ann element.
				frameToDisplay := (relativePosition y / extent height * framedNode numberOfFrames + 1) asInteger.
				framedNode moveToFrame: frameToDisplay ].! !

!MOAnnouncer methodsFor: 'window status' stamp: 'tg 4/6/2010 22:50'!
setWindowStatusTo: aString forElement: element
	viewRenderer root announce: ((MOWindowStatusChanged event: nil on: element) newLabel: aString) ! !

!MOAnnouncer methodsFor: 'threading' stamp: 'Alexandre Bergel 3/15/2010 12:47'!
stopProcesses
	processes ifNil: [ ^ self ].
	self processes do: #terminate.
	processes := nil! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 12/17/2009 19:55'!
strongHighlightWhenOver: aBlockOrSymbol

	self 
		forNodes: aBlockOrSymbol 
		whenEnteringUpdateShapes: [:shape | shape fillColor: Color red ] 
		whenLeavingUpdateShapes: [:shape | shape fillColor: Color white ]! !

!MOAnnouncer methodsFor: 'threading' stamp: 'Alexandre Bergel 4/2/2010 11:27'!
toggleAllProcesses

	self processes do: [ :p |
		p isSuspended not ifTrue: [ p suspend ] ifFalse: [ p resume ] ]! !

!MOAnnouncer methodsFor: 'convenient' stamp: 'Alexandre Bergel 7/26/2010 15:00'!
unsubscribeForEvent: aEventClass
	subscriptions ifNotNil: [ :arg | subscriptions removeKey: aEventClass ifAbsent: [  ] ]! !

!MOAnnouncer methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/17/2009 18:53'!
viewRenderer
	^ viewRenderer! !

!MOAnnouncer methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/17/2009 18:53'!
viewRenderer: anObject
	viewRenderer := anObject! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 19:40'!
whenClickingUpdateNode: enteringBlock 
	^ self whenClickingUpdateNode: enteringBlock withLayoutUpdate: false! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 19:41'!
whenClickingUpdateNode: enteringBlock whenLeavingUpdateNode: leavingBlock withLayoutUpdate: aBoolean
	^ self forNode: #yourself whenClickingUpdateNode: enteringBlock  withLayoutUpdate: aBoolean! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 20:10'!
whenClickingUpdateNode: clickBlock withLayoutUpdate: aBoolean
	^ self registerForEvent: MOMouseDown forNode: #yourself updateNode: clickBlock updateLayout: aBoolean! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 20:06'!
whenClickingUpdateShape: enteringBlock 
	^ self registerForEvent: MOMouseDown forNode: #yourself updateShape: enteringBlock updateLayout: false! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/19/2010 20:06'!
whenClickingUpdateShape: enteringBlock updateLayout: aBoolean
	^ self registerForEvent: MOMouseDown forNode: #yourself updateShape: enteringBlock updateLayout: aBoolean! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 6/10/2010 18:29'!
whenEnteringUpdateNode: enteringBlock 
	^ self whenEnteringUpdateNode: enteringBlock withLayoutUpdate: false! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 1/12/2010 14:19'!
whenEnteringUpdateNode: enteringBlock whenLeavingUpdateNode: leavingBlock withLayoutUpdate: aBoolean
	^ self forNode: #yourself whenEnteringUpdateNode: enteringBlock whenLeavingUpdateNode: leavingBlock withLayoutUpdate: aBoolean! !

!MOAnnouncer methodsFor: 'convenient interaction' stamp: 'Alexandre Bergel 4/26/2010 10:53'!
whenEnteringUpdateNode: enteringBlock withLayoutUpdate: aBoolean
	^ self whenEnteringUpdateNode: enteringBlock whenLeavingUpdateNode: [:each | ] withLayoutUpdate: aBoolean! !

!MOAnnouncer methodsFor: 'window status' stamp: 'Alexandre Bergel 2/23/2010 22:31'!
windowStatus: aBlock
	^ self windowStatus: aBlock delay: 500! !

!MOAnnouncer methodsFor: 'window status' stamp: 'AlexandreBergel 9/6/2010 18:34'!
windowStatus: aBlock delay: ms

	"change the window status when the mouse enter a node"
	self unsubscribeForEvent: MOMouseEnter.
	self unsubscribeForEvent: MOMouseLeave.

	self subscribe: MOMouseEnter do: 
		[:ann | (ann hasElement and: [ ann element isNotRoot ])
				ifTrue: [ [ | oldPosition relativePosition |
							oldPosition := ActiveHand position.
					 		(Delay forMilliseconds: ms) wait.
					
					 		"we compute the relative position since ActiveHand return an absolute location"
					 		relativePosition := ann position - oldPosition + ActiveHand position.
					
					 		"We check if we are in the same node, if yes, then we evaluate the view"
					 		(ann root notNil and: [(ann root elementAt: relativePosition) == ann current]) ifTrue: 
								[ self setWindowStatusTo: ([aBlock value: ann modelElement ] on: Error do: ['Error when printing']) printString 
										forElement: ann element]] fork ]
				ifFalse: [ self resetWindowStatus ]].

	self subscribe: MOMouseLeave do: 
		[:ann | self resetWindowStatus ].
! !

Announcement subclass: #MOEvent
	instanceVariableNames: 'event element current timestamp cancelled viewRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

MOEvent subclass: #MOContentChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOContentChanged commentStamp: 'Alexandre.Bergel 3/3/2009 14:05' prior: 0!
Used when the content of a window is changed, and a redraw has to be done!

MOEvent subclass: #MOElementDeselection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

MOEvent subclass: #MOElementSelection
	instanceVariableNames: 'isMultiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOElementSelection methodsFor: 'initialization' stamp: 'AlexandreBergel 9/5/2010 16:39'!
initializeEvent: aMorphicEvent on: anElement
	super initializeEvent: aMorphicEvent on: anElement.
	isMultiple := false! !

!MOElementSelection methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2010 11:54'!
isMultiple
	^ isMultiple! !

!MOElementSelection methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2010 11:54'!
isMultiple: anObject
	isMultiple := anObject! !

!MOElementSelection methodsFor: 'testing' stamp: 'AlexandreBergel 9/5/2010 16:34'!
isUnique
	^ self isMultiple not! !

!MOElementSelection methodsFor: 'actions' stamp: 'AlexandreBergel 9/5/2010 11:54'!
setAsMultiple 
	isMultiple := true! !

!MOEvent class methodsFor: 'instance creation' stamp: 'AlexandreBergel 9/5/2010 16:38'!
event: aMorphicEvent on: anElement
	^ self new initializeEvent: aMorphicEvent on: anElement! !

!MOEvent class methodsFor: 'instance creation' stamp: 'AlexandreBergel 10/28/2009 09:57'!
initializedInstance
	"Used to create a ready-to use instance of myself"
	^ self new element: (MONode on: 10); yourself! !

!MOEvent methodsFor: 'actions' stamp: 'lr 10/11/2006 20:52'!
cancel
	cancelled := true! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/17/2009 18:42'!
current
	"Answer the element that is currently dispatching this event."

	^ current! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 22:40'!
currentInteraction
	^ self current announcement! !

!MOEvent methodsFor: 'actions' stamp: 'Alexandre.Bergel 3/29/2009 21:08'!
dispatch
	"Dispatch the receiving event trough the owner chain and the styles of every element. Immediatley stop processing when the event gets cancelled or when reaching to root."
	
	| style |	
	[ cancelled or: [ current isNil ] ] whileFalse: [
		current announce: self.
		style := current shape.
		[ cancelled or: [ style isNil ] ] whileFalse: [
			style announce: self.
			style := style next ].
		current := current owner ]! !

!MOEvent methodsFor: 'accessing' stamp: 'lr 10/11/2006 20:50'!
element
	"Answer the element that originally received this event."
	
	^ element! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 13:55'!
element: object
	"The element of an announcement may be changed when forwarding. Have a look at sender of isForwarder.
	 MOAnnouncer>>announce:"
	
	element := object! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 23:10'!
elementInteraction
	^ self element announcer! !

!MOEvent methodsFor: 'testing' stamp: 'Alexandre.Bergel 8/30/2009 13:36'!
hasElement
	^ element notNil! !

!MOEvent methodsFor: 'initialization' stamp: 'AlexandreBergel 9/5/2010 16:47'!
initialize 
	super initialize.
	self initializeEvent: nil on: nil! !

!MOEvent methodsFor: 'initialization' stamp: 'lr 11/11/2006 19:39'!
initializeEvent: aMorphicEvent on: anElement
	event := aMorphicEvent.
	element := current := anElement.
	timestamp := TimeStamp now.
	cancelled := false! !

!MOEvent methodsFor: 'testing-keyboard' stamp: 'lr 10/11/2006 21:22'!
isAltKeyPressed
	^ event commandKeyPressed! !

!MOEvent methodsFor: 'testing' stamp: 'lr 10/11/2006 20:51'!
isCancelled
	^ cancelled! !

!MOEvent methodsFor: 'testing-keyboard' stamp: 'lr 10/11/2006 21:22'!
isCtrlKeyPressed
	^ event controlKeyPressed! !

!MOEvent methodsFor: 'testing' stamp: 'lr 11/11/2006 00:54'!
isInitiator
	^ element = current! !

!MOEvent methodsFor: 'testing-keyboard' stamp: 'lr 10/11/2006 21:22'!
isShiftKeyPressed
	^ event shiftPressed! !

!MOEvent methodsFor: 'accessing' stamp: 'lr 10/18/2006 23:40'!
model
	"Answer the model object that triggered this event."
	
	^ element model! !

!MOEvent methodsFor: 'testing' stamp: 'Alexandre.Bergel 8/30/2009 13:37'!
modelElement
	^ element model! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/23/2009 17:20'!
node
	^ self element! !

!MOEvent methodsFor: 'printing' stamp: 'lr 10/8/2006 20:48'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' on: '; print: self element! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/26/2010 22:07'!
root
	"Answer the graph this event is dispatched in."
	current ifNil: [ ^ nil ].
	^ current root! !

!MOEvent methodsFor: 'morphic' stamp: 'Alexandre Bergel 12/28/2009 11:54'!
setAsNotHandled
	event wasHandled: false! !

!MOEvent methodsFor: 'accessing' stamp: 'lr 10/4/2006 09:49'!
timestamp
	"Answer the timestamp when the event was created."
	
	^ timestamp! !

!MOEvent methodsFor: 'port' stamp: 'Alexandre Bergel 3/2/2010 23:56'!
transmit: aValue onPort: portName
	self element announce: (MOPortEvent new value: aValue; portName: portName).! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/17/2009 18:55'!
viewRenderer
	^ viewRenderer! !

!MOEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/17/2009 18:55'!
viewRenderer: anObject
	viewRenderer := anObject! !

MOEvent subclass: #MOKeyEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

MOKeyEvent subclass: #MOKeyDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOKeyEvent methodsFor: 'accessing' stamp: 'lr 10/11/2006 21:19'!
character
	^ event keyCharacter! !

!MOKeyEvent methodsFor: 'printing' stamp: 'lr 10/11/2006 21:06'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' character: '; print: self character! !

MOKeyEvent subclass: #MOKeyPressed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

MOKeyEvent subclass: #MOKeyUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

MOEvent subclass: #MOMouseEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

MOMouseEvent subclass: #MOMouseDouble
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

MOMouseEvent subclass: #MOMouseDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOMouseDown commentStamp: 'Alexandre.Bergel 8/30/2009 14:01' prior: 0!
The mouseDown event occurs when the pointing device button is pressed over an element.!

MOMouseEvent subclass: #MOMouseDrag
	instanceVariableNames: 'stepAsPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOMouseDrag class methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 7/13/2010 22:54'!
step: aStep
	^ self new step: aStep! !

!MOMouseDrag methodsFor: 'accessed-computed' stamp: 'AlexandreBergel 9/5/2010 17:06'!
nodesToDrag
	| v |
	v := self element root allSelectedNodes.
	(v includes: self element)
		ifFalse: [ v add: self element ].
	^ v! !

!MOMouseDrag methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 16:02'!
step
	^ stepAsPoint! !

!MOMouseDrag methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 16:02'!
step: aPoint
	stepAsPoint := aPoint! !

!MOMouseDrag methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:50'!
stepAsPoint: anObject
	stepAsPoint := anObject! !

MOMouseEvent subclass: #MOMouseEnter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOMouseEnter commentStamp: 'Alexandre.Bergel 8/30/2009 14:02' prior: 0!
The mouseEnter event occurs when the pointing device is moved onto an element.!

!MOMouseEvent methodsFor: 'testing-mouse' stamp: 'Alexandre.Bergel 3/31/2009 20:19'!
isLeftButtonPressed
	event ifNil: [ ^ true ]. "This is used in the tests"
	^ event redButtonPressed! !

!MOMouseEvent methodsFor: 'testing-mouse' stamp: 'lr 10/11/2006 21:24'!
isMiddleButtonPressed
	^ event yellowButtonPressed! !

!MOMouseEvent methodsFor: 'testing-mouse' stamp: 'lr 10/11/2006 21:23'!
isRightButtonPressed
	^ event blueButtonPressed! !

!MOMouseEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/18/2010 15:39'!
nodeAbove
	viewRenderer ifNil: [ ^ nil ].
	self position ifNil: [ ^ nil ].
	^ viewRenderer root elementAt: self position.! !

!MOMouseEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/26/2010 22:05'!
position
	"Answer the position of the mouse event relative to the root."
	event ifNil: [ ^ 0@0].
	^ event position! !

MOMouseEvent subclass: #MOMouseLeave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOMouseLeave commentStamp: 'Alexandre.Bergel 8/30/2009 14:02' prior: 0!
The mouseLeave event occurs when the pointing device is moved away from an element.!

MOMouseEvent subclass: #MOMouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOMouseMove commentStamp: 'Alexandre.Bergel 8/30/2009 14:01' prior: 0!
The mouseMove event occurs when the pointing device is moved while it is over an element.!

MOMouseEvent subclass: #MOMouseUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOMouseUp commentStamp: 'Alexandre.Bergel 8/30/2009 14:01' prior: 0!
The mouseUp event occurs when the pointing device button is released over an element.!

MOEvent subclass: #MOPortEvent
	instanceVariableNames: 'value interaction portName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOPortEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 23:51'!
interaction
	^ interaction! !

!MOPortEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 23:51'!
interaction: anObject
	interaction := anObject! !

!MOPortEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 23:51'!
portName
	^ portName! !

!MOPortEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 23:51'!
portName: anObject
	portName := anObject! !

!MOPortEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 23:51'!
value
	^ value! !

!MOPortEvent methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 23:51'!
value: anObject
	value := anObject! !

MOEvent subclass: #MOWindowStatusChanged
	instanceVariableNames: 'newLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOWindowStatusChanged methodsFor: 'accessing' stamp: 'Alexandre Bergel 2/23/2010 23:27'!
newLabel
	^ newLabel! !

!MOWindowStatusChanged methodsFor: 'accessing' stamp: 'Alexandre Bergel 2/23/2010 23:27'!
newLabel: anObject
	newLabel := anObject! !

MOEvent subclass: #MOZoomEvent
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Events'!

!MOZoomEvent class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 3/10/2009 11:46'!
decrease
	^ self basicNew value: #decrease! !

!MOZoomEvent class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 3/10/2009 11:46'!
increase
	^ self basicNew value: #increase! !

!MOZoomEvent class methodsFor: 'instance creation' stamp: 'TestRunner 10/28/2009 09:58'!
initializedInstance
	"Used to create a ready-to use instance of myself"
	^ self increase element: (MONode on: 10); yourself! !

!MOZoomEvent class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 3/10/2009 11:45'!
new
	self error: 'please use increase or decrease for instantiating this class'! !

!MOZoomEvent methodsFor: 'testing' stamp: 'Alexandre.Bergel 3/10/2009 11:47'!
isZoomDecrease
	^ value == #decrease! !

!MOZoomEvent methodsFor: 'testing' stamp: 'Alexandre.Bergel 3/10/2009 11:47'!
isZoomIncrease
	^ value == #increase! !

!MOZoomEvent methodsFor: 'accessing' stamp: 'Alexandre.Bergel 3/10/2009 11:47'!
value: aSymbol
	value := aSymbol! !

!Color class methodsFor: '*mondrian-example' stamp: 'Alexandre.Bergel 4/20/2009 18:28'!
pink
 	^ self r: 1.0 g: 0.752899 b: 0.796118.! !

!Color class methodsFor: '*mondrian-example' stamp: 'simon.denier 7/24/2009 18:22'!
purple
 	^ self r: 0.4 g: 0.0 b: 0.6.! !

!Color class methodsFor: '*mondrian-example' stamp: 'Alexandre Bergel 7/26/2010 12:21'!
strongColors
	^(OrderedCollection new)
			add: self red;
			add: self blue;
			add: self orange;
			add: self cyan;
			add: self green;
			add: self pink;
			add: self brown;
			add: self purple;
			add: self yellow;
			add: self gray;
			yourself! !

!BalloonCanvas methodsFor: '*mondrian' stamp: 'dr 6/21/2007 16:12'!
drawArrowHead: anArray fill: fillColor borderWidth: anInteger borderColor: borderColor
     self ensuredEngine drawPolygon: anArray fill: fillColor borderWidth: anInteger borderColor: borderColor transform: transform. ! !

!BalloonCanvas methodsFor: '*mondrian' stamp: 'dr 6/21/2007 16:12'!
drawDashedPath: anArray borderWidth: borderWidth borderColor: borderColor
    | delta fromPoint toPoint c b a alpha deltaX deltaY length pointA pointB |
    pointA := anArray first.
    pointB := anArray second.

    "Kosinussatz"
    c := pointB dist: pointA.
    b := pointB y - pointA y.
    a := pointB x - pointA x.
    
    a = 0 ifTrue: [delta := 0@10]. "Special case: horizonal line"
    b = 0 ifTrue: [delta := (a sign * 10)@0]. "Special case: vertical line"
    delta ifNil: [
        alpha := (a / c) arcSin.
        deltaX := 10 * (alpha sin).
        deltaY := 10 * (alpha cos) * b sign.
        delta := deltaX @ deltaY.
    ].

    fromPoint := pointA.
    toPoint := pointA + delta.
    length := 10.
    [length <= c] whileTrue: [
        self drawPath: {fromPoint. toPoint} borderWidth: borderWidth borderColor: borderColor.
        fromPoint := toPoint + (0.5 * delta).
        toPoint :=fromPoint + delta.
        length := length + 5 + 10.
    ].

	"Add final stroke" 
    (length - 10) < c ifTrue: [self drawPath: {fromPoint. pointB} borderWidth: borderWidth borderColor: borderColor]. ! !

!BalloonCanvas methodsFor: '*mondrian' stamp: 'lr 9/21/2006 22:04'!
drawPath: anArray borderWidth: borderWidth borderColor: borderColor
	self ensuredEngine
		drawPolygon: anArray
		fill: nil
		borderWidth: borderWidth
		borderColor: borderColor
		transform: transform! !

!BalloonCanvas methodsFor: '*mondrian' stamp: 'dr 7/3/2007 11:10'!
line: startPoint to: endPoint
    self line: startPoint to: endPoint width: 1 color: Color black.! !

!BalloonCanvas methodsFor: '*mondrian' stamp: 'lr 10/7/2006 23:19'!
transform
	^ transform! !

!BlockContext methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:42'!
moValue: anArgument
	^ self value: anArgument! !

TextMorphForEditView subclass: #MOTextMorphWithShout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOTextMorphWithShout methodsFor: 'private' stamp: 'Alexandre Bergel 4/22/2010 18:01'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	Smalltalk at: #TextMorphForShoutEditor ifPresent: [:cls | ^ cls].

	^ TextMorph ! !

!MOTextMorphWithShout methodsFor: 'private' stamp: 'DavidRoethlisberger 1/26/2010 20:59'!
installEditorToReplace: priorEditor 
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."
	| stateArray |
	priorEditor isNil ifFalse: [ stateArray := priorEditor stateArray ].
	editor := self editorClass new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor isNil ifFalse: [ editor stateArrayPut: stateArray ].
	self selectionChanged.
	^ editor! !

!Point class methodsFor: '*mondrian-layouts' stamp: 'lr 9/22/2006 14:04'!
r: radius theta: angle
	^ (radius * angle cos) @ (radius * angle sin)! !

!Point methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:35'!
moX: aNumber 
	x := aNumber! !

!Point methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:37'!
moX: xNumber Y: yNumber 
	x := xNumber.
	y := yNumber! !

!Point methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:36'!
moY: aNumber 
	y := aNumber! !

!Point methodsFor: '*mondrian' stamp: 'AlexandreBergel 2/17/2009 18:09'!
translatedBy: amount 
	"Answer a new object translated by amount, which can be
	a Point or a scalar value."
	
	"For compatibility, used in layouts"

	^self + amount! !

TestCase subclass: #MOElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOElementTest methodsFor: 'as yet unclassified' stamp: 'tg 2/13/2010 15:12'!
testSelection
	| root |
	root := MORoot new.
	root addNode: (MONode on: $a).
	root nodes first select.
	self assert: root selections notEmpty.
	root nodes first deselect.	
	self assert: root selections isEmpty! !

!MOElementTest methodsFor: 'as yet unclassified' stamp: 'tg 9/14/2010 07:01'!
testSelectionOfForwarders
	| root parent child |
	root := MORoot new.
	parent := MONode on: 'parent'.
	child := MONode on: 'child'.
	child interaction forward.
	root addNode: parent.
	parent addNode: child.
	root nodes first select.
	self assert: root selections size = 1.
	self assert: root selections first = parent.
	self assert: child isSelected not.
	root nodes first deselect.	
	self assert: root selections isEmpty! !

TestCase subclass: #MONormalizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MONormalizerTest class methodsFor: 'history' stamp: 'simon.denier 7/6/2009 16:39'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testLinearNormalizer; add: #testIdentity; add: #testThreshold; add: #testIdentityWithCommand; add: #testBlockContext; add: #testIdentityModulo; add: #testGradient; yourself)); add: (#timeStamp->'6 July 2009 4:38:46 pm' asTimeStamp); add: (#failures->((Set new))); add: (#errors->((Set new))); yourself)! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 2/22/2009 20:27'!
testBlockContext
	| normalizer |

	normalizer := MONColorLinearNormalizer inContext: [:entity | #(1 2 3 4 5 6 7 8)] withCommand: [:entity | entity].
	self assert: (normalizer maximumValue: nil) = 8.
	self assert: (normalizer moValue: 1) = ( Color veryVeryLightGray).
	self assert: (normalizer moValue: 8) = Color black.! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 2/22/2009 20:29'!
testGradient
	| normalizer |

	normalizer := MONColorLinearNormalizer inContext: #(0 1 2 3 4 5 6 7 8 9 10) lowColor: Color yellow highColor: Color red.
	self assert: (normalizer maximumValue: nil) = 10.
	self assert: (normalizer moValue: 10) = Color red. 
	self assert: (normalizer moValue: 1) = (Color r: 1.0 g: 0.900012 b: 0.0).
	self assert: (normalizer moValue: 0) = (Color yellow).! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 2/22/2009 20:29'!
testIdentity
	| colorOne colorTwo normalizer |
	
	normalizer := MONIdentityNormalizer new.
	colorOne := normalizer moValue: 1.
	colorTwo := normalizer moValue: 2.
	self deny: colorOne = colorTwo.

	colorOne := normalizer moValue: 12.
	colorTwo := normalizer moValue: 12.
	self assert: colorOne = colorTwo.! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 8/30/2009 15:50'!
testIdentityModulo
	"This checks that there is no exception if there are more identities than colors"

	1 to: 150 do: [:index | MONIdentityNormalizer new moValue: index]! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 2/22/2009 20:38'!
testIdentityWithCommand
	| colorOne colorTwo normalizer |
	
	normalizer := MONIdentityNormalizer withCommand: #last.
	colorOne := normalizer moValue: 'bob'.
	colorTwo := normalizer moValue: 'tom'.
	self deny: colorOne = colorTwo.

	colorOne := normalizer moValue: 'anna'.
	colorTwo := normalizer moValue: 'maria'.
	self assert: colorOne = colorTwo.! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 2/22/2009 20:39'!
testLinearNormalizer
	| normalizer |

	normalizer := MONColorLinearNormalizer inContext: #(#Zuerich #Bern) withCommand: [:entity | entity size].
	self assert: (normalizer maximumValue: nil) = 7.
	self assert: (normalizer moValue: #Zuerich) = Color black. 
	self assert: (normalizer moValue: #Bern) = ( (Color r: 0.428 g: 0.428 b: 0.428)).
	
	normalizer := MONLinearNormalizer inContext: #('Luzern' 'Basel') withCommand: [:entity | entity size].
	self assert: (normalizer maximumValue: nil) = 6.

	normalizer := MONLinearNormalizer inContext: #('Luzern' 'Basel') withCommand: 99.
	self assert: (normalizer maximumValue: nil) = 99.! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre Bergel 7/26/2010 15:17'!
testNumberLinearNormalizer
	| normalizer |
	normalizer := MONumberLinearNormalizer inContext: (1 to: 10) withCommand: [:entity | entity * 1000 ].
	self assert: (normalizer moValue: 100) = 10.
	
	normalizer := MONumberLinearNormalizer inContext: (1 to: 100) withCommand: [:entity | entity * 1000 ].
	self assert: (normalizer moValue: 100) = 1.
	
	normalizer := MONumberLinearNormalizer inContext: (1 to: 100) withCommand: [:entity | entity ].
	self assert: (normalizer moValue: 100) = 1.
! !

!MONormalizerTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 2/22/2009 20:43'!
testThreshold
	| normalizer skyBlue |
	
	skyBlue := (Color r:  0.529361 g: 0.807838 b: 0.921621).
	normalizer := MONColorLinearNormalizer inContext: #(0 1 2 3 4 5 6 7 8 9 10) lowColor: skyBlue lowThreshold: 0.3 highColor: Color brown highThreshold: 0.7.
	self assert: (normalizer maximumValue: nil) = 10.
	self assert: (normalizer moValue: 10) = ( (Color r: 0.579 g: 0.382 b: 0.277)). 
	self assert: (normalizer moValue: 1) = ( (Color r: 0.553 g: 0.601 b: 0.608)).
	self assert: (normalizer moValue: 0) = ( (Color r: 0.551 g: 0.626 b: 0.645)).
	
"The adapted VW version. Differences with Squeak propably lay in different variable initialization. For example, brown in Squeak is different from VW
	skyBlue := (Color r:  0.529361 g: 0.807838 b: 0.921621).
	normalizer := MONColorLinearNormalizer inContext: #(0 1 2 3 4 5 6 7 8 9 10) lowColor: skyBlue lowThreshold: 0.3 highColor: Color brown highThreshold: 0.7.
	self assert: (normalizer maximumValue: nil) = 10.
	self assert: (normalizer moValue: 10) = (Color r: 0.611769 g: 0.357588 b: 0.391771). 
	self assert: (normalizer moValue: 1) = (Color r: 0.569405 g: 0.589183 b: 0.664266).
	self assert: (normalizer moValue: 0) = (Color r: 0.564644 g: 0.614943 b: 0.694543)."! !

TestCase subclass: #MOQuadTreeTest
	instanceVariableNames: 'leafQuad compositeQuad nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOQuadTreeTest class methodsFor: 'history' stamp: 'simon.denier 7/6/2009 16:39'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testLeafQuadtree; add: #testMutation; add: #testQuadtreeGeometry; add: #testCompositeQuadtree; yourself)); add: (#timeStamp->'6 July 2009 4:38:46 pm' asTimeStamp); add: (#failures->((Set new))); add: (#errors->((Set new))); yourself)! !

!MOQuadTreeTest methodsFor: 'running' stamp: 'simon.denier 6/25/2009 21:26'!
setUp

	| model |
	model := MOTestModel new.
	nodes := MOViewRenderer new nodes: model allNodes using: model shapeForNode.
	leafQuad := MOQuadTree with: (1@1 corner: 10@10).
	compositeQuad := MOQuadTree with: (0@0 corner: 40@40).
	nodes do: [:n | compositeQuad addElement: n]! !

!MOQuadTreeTest methodsFor: 'tests' stamp: 'Alexandre Bergel 4/22/2010 17:59'!
testCompositeQuadtree

	| a1 b1 b2 c3 c4 d3 |
	
	a1 := nodes first.
	b1 := nodes second.
	b2 := nodes third.
"	c1 := nodes at: 4.
	c2 := nodes at: 5."
	c3 := nodes at: 6.
	c4 := nodes at: 7.
"	d1 := nodes at: 8.
	d2 := nodes at: 9."
	d3 := nodes at: 10.
	
	self assert: compositeQuad isComposite.
	self assert: compositeQuad count = 10.
	
	self assert: ((compositeQuad findElementsAt: 11@11) includesAll: {c3. c4. d3}).
	self assert: ((compositeQuad findElementsAt: 7@1) includes: a1).
	self deny: ((compositeQuad findElementsAt: 7@1) includes: b1).
	
	self assert: ((compositeQuad findElementsIntersecting: (-1@ -1 corner: 2@3)) includesAll: {a1. b1}).
	self assert: ((compositeQuad findElementsIntersecting: (7@1 corner: 8@2)) includes: a1).
	self deny: ((compositeQuad findElementsIntersecting: (7@1 corner: 8@2)) includes: b1).
	self assert: (compositeQuad findElementsIntersecting: (20@20 corner: 25@25)) isEmpty.
	
	compositeQuad removeElement: b1.
	compositeQuad removeElement: b2.
	self deny: compositeQuad isComposite.
	self assert: compositeQuad count = 8.
	! !

!MOQuadTreeTest methodsFor: 'tests' stamp: 'Alexandre Bergel 4/22/2010 18:03'!
testLeafQuadtree

	| a1 b1 |
	self deny: leafQuad isComposite.
	self assert: leafQuad count = 0.
	
	a1 := nodes first.
	b1 := nodes second.
	
	leafQuad addElement: a1.
	leafQuad addElement: b1.
	self assert: leafQuad count = 2.
	
	self assert: ((leafQuad findElementsAt: 1@1) includesAll: (Array with: a1 with: b1)).
	self assert: ((leafQuad findElementsAt: 7@1) includes: a1).
	self deny: ((leafQuad findElementsAt: 7@1) includes: b1).
	
	self assert: ((leafQuad findElementsIntersecting: (-1@ -1 corner: 2@3)) includesAll: (Array with: a1 with: b1)).
	self assert: ((leafQuad findElementsIntersecting: (7@1 corner: 8@2)) includes: a1).
	self deny: ((leafQuad findElementsIntersecting: (7@1 corner: 8@2)) includes: b1).
	self assert: (leafQuad findElementsIntersecting: (-2@ -2 corner: -1@ -1)) isEmpty.! !

!MOQuadTreeTest methodsFor: 'tests' stamp: 'Alexandre.Bergel 8/30/2009 15:33'!
testMutation

	| a1 b1 q |
	q := MOQuadTree with: (0@0 corner: 30@30).
	self deny: q isComposite.
	
	a1 := nodes first.
	b1 := nodes second.
	q addElement: a1.
	q addElement: b1.
	q addElement: b1.
	q addElement: b1.
	q addElement: b1.
	q addElement: b1.
	q addElement: b1.
	q addElement: b1.
	self deny: q isComposite.

	q addElement: b1.
	self assert: q isComposite.

	q removeElement: a1.
	self deny: q isComposite.
! !

!MOQuadTreeTest methodsFor: 'tests' stamp: 'Alexandre Bergel 4/22/2010 18:03'!
testQuadtreeGeometry

	self assert: (leafQuad contains: 1@1).
	self assert: (leafQuad contains: 4@7).
	self assert: (leafQuad contains: 9@9).
	self deny: (leafQuad contains: 0@0).
	self deny: (leafQuad contains: 11@10).
	
	self assert: (leafQuad intersects: (1@2 corner: 4@5)).
	self assert: (leafQuad intersects: (8@9 corner: 15@20)).
	self deny: (leafQuad intersects: (8@10 corner: 15@20)).
	self deny: (leafQuad intersects: (-1@ -1 corner: 1@1)).! !

TestCase subclass: #MondrianTestCase
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

MondrianTestCase subclass: #MOAnimatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOAnimatorTest methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 3/1/2010 11:15'!
testBasic1

	| view node |
	view := MOViewRenderer new.
	node := view framedNode: (1 to: 20).
	window := view open.

	self assert: (view root totalNumberOfNodes = 2).
	self assert: (view root nodes first == node).

	self assert: (node bounds = (5@5 corner: 10@10))! !

!MOAnimatorTest methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 3/1/2010 16:41'!
testBasic2

	| view node morphicEvent |
	view := MOViewRenderer new.
	view interaction selectFrameFromX.
	view shape rectangle size: 80.
	node := view framedNode: (1 to: 20).

	window := view open.

	morphicEvent := MouseEvent new  
						setPosition: (node bounds origin + (0@0) ) asIntegerPoint.
	node announce: (MOMouseMove event: morphicEvent on: node).
	self assert: (node currentFrame = 1).


	morphicEvent := MouseEvent new  
						setPosition: (node bounds origin + (40@0) ) asIntegerPoint.
	node announce: (MOMouseMove event: morphicEvent on: node).
	self assert: (node currentFrame = 11).
! !

!MOAnimatorTest methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 3/1/2010 16:27'!
testInteraction

	| view node morphicEvent |
	view := MOViewRenderer new.
	view interaction 
			on: MOMouseMove do: [:ann | 
				| pos extent framedNode frameToDisplay relativePosition |
				framedNode := ann element.
				pos := ann position.
				relativePosition := pos - framedNode absoluteBounds origin.
				extent := ann element shape boundsFor: ann element.
				frameToDisplay := (relativePosition x / extent width * framedNode numberOfFrames + 1) asInteger.
				framedNode moveToFrame: frameToDisplay ].

	node := view framedNode: (1 to: 3) forEach: [ :value | view nodes: (1 to: value) ] .
	window := view open.

	self assert: (node currentFrame = 1).
	self assert: (node currentValue = 1).
	self assert: (node numberOfNodes = 1).
	self assert: (node bounds = ( 5@5 corner: 50@20)).

	"Frame 1"
	morphicEvent := MouseEvent new  
						setPosition: (node bounds origin ) asIntegerPoint.
	node announce: (MOMouseMove event: morphicEvent on: node).
	self assert: (node currentFrame = 1).
	self assert: (node currentValue = 1).
	self assert: (node numberOfNodes = 1).
	self assert: (node bounds = ( 5@5 corner: 50@20)).


	"Frame 2"
	morphicEvent := MouseEvent new  
						setPosition: (node bounds origin + (16@0)) asIntegerPoint.
	node announce: (MOMouseMove event: morphicEvent on: node).
	self assert: (node currentFrame = 2).
	self assert: (node currentValue = 2).
	self assert: (node numberOfNodes = 2).
	self assert: (node bounds = ( 5@5 corner: 50@20)).

	"Frame 3"
	morphicEvent := MouseEvent new  
						setPosition: (node bounds origin + (32@0) ) asIntegerPoint.
	node announce: (MOMouseMove event: morphicEvent on: node).
	self assert: (node currentFrame = 3).
	self assert: (node currentValue = 3).
	self assert: (node numberOfNodes = 3).
	self assert: (node bounds = ( 5@5 corner: 50@20)).

	"Frame 1"
	morphicEvent := MouseEvent new  
						setPosition: (node bounds origin) asIntegerPoint.
	node announce: (MOMouseMove event: morphicEvent on: node).

	self assert: (node currentFrame = 1).
	self assert: (node currentValue = 1).
	self assert: (node numberOfNodes = 1).
	self assert: (node bounds = ( 5@5 corner: 50@20)).
! !

!MOAnimatorTest methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 3/1/2010 16:42'!
testSubview

	| view node |
	view := MOViewRenderer new.
	node := view framedNode: (1 to: 3) forEach: [ :value | view nodes: (1 to: value) ] .
	window := view open.

	self assert: (node currentFrame = 1).
	self assert: (node currentValue = 1).
	self assert: (node numberOfNodes = 1).
	self assert: (node bounds = ( 5@5 corner: 50@20)).

	node nextFrame.
	self assert: (node currentFrame = 2).
	self assert: (node currentValue = 2).
	self assert: (node numberOfNodes = 2).
	self assert: (node bounds = ( 5@5 corner: 50@20)).

	node nextFrame.
	self assert: (node currentFrame = 3).
	self assert: (node currentValue = 3).
	self assert: (node numberOfNodes = 3).
	self assert: (node bounds = ( 5@5 corner: 50@20)).

	node nextFrame.
	self assert: (node currentFrame = 1).
	self assert: (node currentValue = 1).
	self assert: (node numberOfNodes = 1).
	self assert: (node bounds = ( 5@5 corner: 50@20)).
! !

MondrianTestCase subclass: #MOEaselTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOEaselTest methodsFor: 'simple checks' stamp: 'Alexandre Bergel 3/4/2010 14:16'!
testAllVariableKeys
	| easel |
	easel := MOEasel new.
	self assert: (easel allVariableKeys includes: #view)! !

!MOEaselTest methodsFor: 'testing help' stamp: 'AlexandreBergel 9/16/2010 01:31'!
testExamplesAreOkay
	| inst source view easel |
	inst := MOEaselHelp new.
	(MOEaselHelp selectors select: [ :sel | sel beginsWith: 'script']) do: [:sel |
		source := inst perform: sel.
		
		easel := MOEasel new. 
		window := easel open.
		easel setScript: source.
		easel generate.		
		window delete
	]! !

!MOEaselTest methodsFor: 'simple checks' stamp: 'Alexandre Bergel 6/26/2010 02:12'!
testOpenOn
	| easel |
	window := MOEasel openOn: #foo -> self.
	easel := window model.
	self assert: (easel allVariableKeys includes: #view).
	self assert: (easel allVariableKeys includes: #foo)! !

!MOEaselTest methodsFor: 'simple checks' stamp: 'AlexandreBergel 7/9/2010 16:29'!
testOpenWithTitle
	"This is supported only in Pharo 1.1"
	Smalltalk at: #SystemVersion ifPresent: [:cl |
			(cl current version beginsWith: 'Pharo') 
				ifTrue: [	
					(cl current perform:  #highestUpdate) <=  10517
						ifTrue: [ ^ self ] ] ].

	window := MOEasel openWithTitle: 'hello'.
	self assert: window label = 'hello'! !

!MOEaselTest methodsFor: 'resize' stamp: 'Alexandre Bergel 6/14/2010 16:56'!
testSize1
	| easel canvas scrollPanel wishedWindowBounds |
	easel := MOEasel new.
	window := easel open.
	wishedWindowBounds :=  13@182 corner: 763@562.

	"Small rendering"
	easel setScript: 'view shape rectangle width: 40; height: 30. view node: #foo'.
	easel generate.
	window doLayoutIn: wishedWindowBounds.
	canvas := window findDeeplyA: MOCanvas.
	scrollPanel := window findDeeplyA: ScrollPane.
	self assert: (canvas extent < scrollPanel extent).
	self deny: scrollPanel hIsScrollable.
	self deny: scrollPanel vIsScrollable.
	self deny: scrollPanel hIsScrollbarShowing.
	self deny: scrollPanel vIsScrollbarShowing.


	"Big rendering"
	easel setScript: 'view shape rectangle width: 40; height: 30. view nodes: (1 to: 100)'.
	easel generate.
	canvas := window findDeeplyA: MOCanvas.
	scrollPanel := window findDeeplyA: ScrollPane.
	window doLayoutIn: wishedWindowBounds.
	
"	self assert: (canvas extent y = scrollPanel extent y).
	self assert: (canvas extent x > scrollPanel extent x).
"
	self assert: scrollPanel hIsScrollable.
	self deny: scrollPanel vIsScrollable.
	self assert: scrollPanel hIsScrollbarShowing.
	self deny: scrollPanel vIsScrollbarShowing.

	"Small rendering"
	easel setScript: 'view shape rectangle width: 40; height: 30. view node: #foo'.
	easel generate.
	window doLayoutIn: wishedWindowBounds.
	canvas := window findDeeplyA: MOCanvas.
	scrollPanel := window findDeeplyA: ScrollPane.
	self assert: (canvas extent < scrollPanel extent).
	self deny: scrollPanel hIsScrollable.
	self deny: scrollPanel vIsScrollable.
	self deny: scrollPanel hIsScrollbarShowing.
	self deny: scrollPanel vIsScrollbarShowing.

! !

MondrianTestCase subclass: #MOEventHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOEventHandlerTest class methodsFor: 'history' stamp: 'simon.denier 7/6/2009 16:39'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testSubview2; add: #testOnMenuOpen; add: #testUseOnceNodes; add: #testOnDoubleClick; add: #testUseOnceForEachReloaded; add: #testMultipleAnnouncer2; add: #testEventToTheRoot2; add: #testOnUnselect; add: #testUseOnceEdges; add: #testUseOnceForEach; add: #testForwarder; add: #testMultipleAnnouncer; add: #testOnSelect; add: #testOnClick; add: #testSubview; add: #testMultiEvent; add: #testEventToTheRoot; yourself)); add: (#timeStamp->'6 July 2009 4:38:46 pm' asTimeStamp); add: (#failures->((Set new))); add: (#errors->((Set new))); yourself)! !

!MOEventHandlerTest methodsFor: 'edges' stamp: 'Alexandre Bergel 11/30/2009 23:52'!
testEdgeOnClick
	
	| boolean view |
	boolean := false.
	view := MOViewRenderer new.

	view nodes: #(1 2).

	view interaction subscribe: MOMouseDown do: [ :announcement | boolean := true].
	view edges: {1 -> 2} from: #key to: #value.
	
	view announce: (MOMouseDown event: nil on: view root edges first).
	
	self assert: boolean.
! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 4/26/2009 09:57'!
testEventToTheRoot
	"The subscription made between a 'nodes:' and the 'open', are for the root. Currently, the announcer (event handler) is installed on the root only when open is sent."
	
	| view sum ui |
	view := MOViewRenderer new.
	sum := 0.
	view interaction on: MOMouseEnter do: [:ann | sum := sum + 10].
	view nodes: (1 to: 10).
	view root interaction on: MOMouseEnter do: [:ann | sum := sum + 1].
	ui := view open.

	view announce: (MOMouseEnter event: nil on: view root).
	self assert: (sum = 1).
	
	ui delete! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 3/31/2009 21:22'!
testEventToTheRoot2
	"The subscription made between a 'nodes:' and the 'open', are for the root. Currently, the announcer (event handler) is installed on the root only when open is sent."
	
	| view sum ui |
	view := MOViewRenderer new.
	sum := 0.
	view interaction on: MOMouseEnter do: [:ann | sum := sum + 10].
	view nodes: (1 to: 10).
	view resetInteraction.
	view root interaction on: MOMouseEnter do: [:ann | sum := sum + 1].
	ui := view open.
	
	view announce: (MOMouseEnter event: nil on: view root).
	self assert: (sum = 1).
	
	ui delete! !

!MOEventHandlerTest methodsFor: 'forwarder' stamp: 'AlexandreBergel 9/16/2010 14:43'!
testForward

	| view node1 node2 |
	view := MOViewRenderer new.
	node1 := view node: 10 forIt: [
		view shape rectangle size: 30.
		view interaction forward: MOElementSelection.
		node2 := view node: 20
	].
	
	self deny: (node1 isSelected).
	self deny: (node2 isSelected).
	
	node2 announce: (MOElementSelection new).
	self assert: (node1 isSelected).
	self deny: (node2 isSelected).
	! !

!MOEventHandlerTest methodsFor: 'forwarder' stamp: 'Alexandre.Bergel 4/26/2009 10:08'!
testForwarder
	| value view bigNode innerNode |
	value := 0.
	view := MOViewRenderer new.

	"No forwarder"
	view interaction subscribe: MOMouseDown do: [ :announcement | value := value + 10].
	bigNode := view node: #abc using: MORectangleShape new forIt: [
		view interaction subscribe: MOMouseDown do: [ :announcement | value := value + 1].
		innerNode := view node: #foo].	
	self assert: (bigNode model = #abc).
	self assert: (innerNode model = #foo).
	view announce: (MOMouseDown event: nil on: innerNode).
	self assert: (value = 1).
	value := 0.
	
	"With forwarder"
	view interaction subscribe: MOMouseDown do: [ :announcement | value := value + 10].
	bigNode := view node: #abc using: MORectangleShape new forIt: [
		view interaction forward.
		view interaction subscribe: MOMouseDown do: [ :announcement | value := value + 1].
		innerNode := view node: #foo].	
	self assert: (bigNode model = #abc).
	self assert: (innerNode model = #foo).
	view announce: (MOMouseDown event: nil on: innerNode).
	self assert: (value = 10).! !

!MOEventHandlerTest methodsFor: 'forwarder' stamp: 'Alexandre.Bergel 9/26/2009 10:31'!
testForwarderAndDraggable
	| view outerNode innerNode |
	view := MOViewRenderer new.

	view shape rectangle size: 90.
	outerNode := view node: #outer forIt: [
		view interaction forward.
		view shape rectangle size: 45.
		innerNode := view node: #inner].
	
	window := view open.
	self assert: (outerNode model = #outer).
	self assert: (innerNode model = #inner).
	
	self assert: (outerNode bounds topLeft = (5@5)).
	view announce: ((MOMouseDrag event: nil on: outerNode) step: 2 @ 1).
	self assert: (outerNode bounds topLeft = (7@6)).
	self assert: (innerNode bounds topLeft = (5@5)).
	
	view announce: ((MOMouseDrag event: nil on: innerNode) step: 2 @ 1).
	self assert: (outerNode bounds topLeft = (9@7)).
	self assert: (innerNode bounds topLeft = (5@5)).
! !

!MOEventHandlerTest methodsFor: 'forwarder' stamp: 'tg 9/14/2010 07:03'!
testForwarderAndFigureSelection
	| view outerNode innerNode |
	view := MOViewRenderer new.

	view shape rectangle size: 90.
	outerNode := view node: #outer forIt: [
		view interaction forward.
		view shape rectangle size: 45.
		innerNode := view node: #inner].
	
	window := view open.
	
	self assert: (outerNode bounds topLeft = (5@5)).
	self deny: (outerNode isSelected).
	self deny: (innerNode isSelected).

	view announce: (MOElementSelection event: nil on: innerNode).
	self assert: (outerNode isSelected).
	self deny: innerNode isSelected! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 4/26/2009 09:57'!
testMultipleAnnouncer
	
	| view sum nodeFive nodeTen |
	sum := 0.
	view := MOViewRenderer new.
	view interaction subscribe: MOMouseDown do: [ :ann | sum := sum + ann element model].
	view nodes: (1 to: 5).

	view interaction subscribe: MOMouseDown do: [ :ann | sum := sum + (2 * ann element model)].
	view nodes: (6 to: 10).

	window := view open.
	
	nodeFive := view root nodes detect: [:monode | monode model = 5].
	nodeTen := view root nodes detect: [:monode | monode model = 10].
	
	self assert: (sum = 0).
	view announce: (MOMouseDown event: nil on: nodeFive).
	self assert: (sum = 5).
	view announce: (MOMouseDown event: nil on: nodeTen).
	self assert: (sum = 25).


! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 4/26/2009 09:57'!
testMultipleAnnouncer2
	
	| view ui sum nodeFive nodeTen |
	sum := 0.
	view := MOViewRenderer new.
	view interaction subscribe: MOMouseDown do: [ :ann | sum := sum + ann element model].
	view nodes: (1 to: 5).

	view resetInteraction.
	view interaction subscribe: MOMouseDown do: [ :ann | sum := sum + (2 * ann element model)].
	view nodes: (6 to: 10).

	ui := view open.
	
	nodeFive := view root nodes detect: [:monode | monode model = 5].
	nodeTen := view root nodes detect: [:monode | monode model = 10].
	
	self assert: (sum = 0).
	view announce: (MOMouseDown event: nil on: nodeFive).
	self assert: (sum = 5).
	view announce: (MOMouseDown event: nil on: nodeTen).
	self assert: (sum = 25).

	ui delete
! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 4/26/2009 09:57'!
testOnClick
	
	| boolean view |
	boolean := false.
	view := MOViewRenderer new.

	view interaction subscribe: MOMouseDown do: [ :announcement | boolean := true].
"	view interaction: (MOEventHandler onClick: [ :anEntity | boolean := true])."

	view node: #abc using: MORectangleShape new.
	"figure redButtonPressedEvent."
	
	view announce: (MOMouseDown event: nil on: view root nodes first).
	
	self assert: boolean.! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 2/3/2009 23:55'!
testOnDoubleClick
	
	| boolean view figure |
	boolean := false.
	view := MOViewRenderer new.
	view announcer on: MOMouseDouble do: [ :ann | boolean := true].
	figure := view node: #abc using: MORectangleShape new.
	view announce: (MOMouseDouble event: nil on: figure).
	self assert: boolean.! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 4/26/2009 09:57'!
testOnSelect
	
	| boolean view figure ui |
	boolean := false.
	view := MOViewRenderer new.
	view interaction subscribe: MOMouseDown do: [ :ann | boolean := true].
	figure := view node: #abc using: MORectangleShape new.
	ui := view open.
	view announce: (MOMouseDown event: nil on: figure).
	self assert: boolean.

	"We reset"
	boolean := false.

	view gridLayout.	
	view announce: (MOMouseDown event: nil on: figure).
	self assert: boolean.
	
	ui delete
! !

!MOEventHandlerTest methodsFor: 'TODO' stamp: 'Alexandre.Bergel 2/2/2009 09:23'!
testOnUnselect
	"unselecting does not seems supported currently. Is that really used in practice ?"
"	
	| boolean view figure ui |
	boolean := false.
	view := MOViewRenderer new.
	view interaction: (MOEventHandler onUnselect: [ :anEntity | boolean := true]).
	figure := view node: #abc using: MORectangleShape new.
	ui := view open.
	figure select.
	figure deselect.
	self assert: boolean.
	ui delete."! !

!MOEventHandlerTest methodsFor: 'TODO' stamp: 'Alexandre.Bergel 8/30/2009 13:42'!
testSubview
	
	| view int nodes |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new width: 36; height: 10).
	view interaction popupText: [:es | 'first level'].
	view node: (1) forIt: [
		view interaction popupText: [:e | '2nd level'].
		view nodes: (1 to: 5).
		view gridLayout gapSize:0].

	view shape: (MORectangleShape new width: 36; height: 10).
	view node: (2).

	window := view open.

	nodes := view root nodes.
		
	"The root has a different event handler than its nodes"
	self assert: (view interaction ~~ nodes first interaction).
	
	"There are two calls to node:, therefore these two nodes must have different event handlers"
	self assert: (view root nodes first interaction ~~ nodes second interaction).
	
	"All subnodes must have the same interaction"
	int := view root nodes first nodes first interaction.
	self assert: (nodes first nodes allSatisfy: [:each | each interaction == int]).
	
	"the subnodes and the second node cannot have the same event handler"
	self assert: (nodes second hasInteraction)! !

!MOEventHandlerTest methodsFor: 'TODO' stamp: 'Alexandre.Bergel 8/30/2009 13:42'!
testSubview2
	
	| view int nodes |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new width: 36; height: 10).
	view interaction popupText: [:es | 'first level'].
	view node: (1) forIt: [
		view nodes: (1 to: 5).
		view gridLayout gapSize:0].

	view shape: (MORectangleShape new width: 36; height: 10).
	view node: (2).

	window := view open.
	
	"The root has a different event handler than its nodes"
	self assert: (view interaction ~~ view root nodes first interaction).
	
	"There are two calls to node:, therefore these two nodes must have different event handlers"
	self assert: (view root nodes first interaction ~~ view root nodes second interaction).
	
	"All subnodes must have the same interaction"
	int := view root nodes first nodes first interaction.
	self assert: (view root nodes first nodes allSatisfy: [:each | each interaction == int]).
	
	"the subnodes and the second node cannot have the same event handler"
	nodes := view root nodes.
	self assert: (nodes second interaction ~~ int)! !

!MOEventHandlerTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 8/18/2009 21:34'!
testSubviews
	| t view nodes |
	t := 0.
	
	view := MOViewRenderer new.
	view nodes: (1 to: 2) forEach: [:each |
		view interaction on: MOMouseDouble do: [:ann | t := t + 1].
		nodes := view nodes: (1 to: 100).
	view gridLayout].

	nodes third announce: (MOMouseDouble event: nil on: nodes third).
	self assert: (t = 1).! !

!MOEventHandlerTest methodsFor: 'TODO' stamp: 'Alexandre.Bergel 2/1/2009 14:07'!
testUseOnceEdges
	"
	| view handler figure |
	
	handler := EventHandler onClick: [:entity | 'Test'].

	view := MOViewRenderer new.
	view nodes: #(1 2) using: MORectangleShape withBorder.
	self assert: view interaction hasNoFunctionality.
	view interaction: handler.
	self assert: view interaction = handler.
	figure := view edge: #a from: 1 to: 2 using: MOLineShape new.
	self assert: view interaction hasNoFunctionality.
	view evaluateLazyEdges.
	self assert: figure eventHandler = handler."! !

!MOEventHandlerTest methodsFor: 'TODO' stamp: 'Alexandre.Bergel 2/1/2009 14:07'!
testUseOnceForEach
	"
	| view handlerA handlerB figureA figureB |
	
	handlerA := EventHandler onClick: [:entity | 'Test'].
	handlerB := EventHandler onClick: [:entity | 'Test'].

	view := MOViewRenderer new.
	self assert: view interaction hasNoFunctionality.
	view interaction: handlerA.
	self assert: view interaction == handlerA.
	figureA := view node: #abc using: MORectangleShape withBorder forIt: [
		view interaction: handlerB.
		figureB := view node: #abcd using: MORectangleShape withBorder.
	].
	self assert: figureA eventHandler = handlerA.
	self assert: figureB eventHandler = handlerB.
	self assert: view interaction hasNoFunctionality."! !

!MOEventHandlerTest methodsFor: 'TODO' stamp: 'Alexandre.Bergel 2/1/2009 14:32'!
testUseOnceForEachReloaded
	
"	| view handlerA figureA figureB |
	
	handlerA := MOEventHandler onClick: [:entity | 'Test'].

	view := MOViewRenderer new.
	self assert: view interaction hasNoFunctionality.
	view interaction: handlerA.
	self assert: view interaction == handlerA.
	figureA := view node: #abc using: MORectangleShape new forIt: [
		figureB := view node: #abcd using: MORectangleShape new.
	].
	self assert: figureA eventHandler == handlerA.
	self assert: figureB eventHandler hasNoFunctionality.
	self assert: view interaction hasNoFunctionality."! !

!MOEventHandlerTest methodsFor: 'TODO' stamp: 'Alexandre.Bergel 2/2/2009 09:24'!
testUseOnceNodes
	"Does this still makes sense with announcement?"
"	| view handler figure |
	
	handler := MOEventHandler onClick: [:entity | 'Test'].
	self deny: handler hasNoFunctionality.

	view := MOViewRenderer new.
	self assert: view interaction hasNoFunctionality.
	view interaction: handler.
	self assert: view interaction == handler.
	figure := view node: #abc using: MORectangleShape new.
	self assert: figure eventHandler == handler.
	self assert: view interaction hasNoFunctionality."! !

MondrianTestCase subclass: #MOFormsBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOFormsBuilderTest class methodsFor: 'history' stamp: 'simon.denier 7/6/2009 16:39'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testColumnFill; add: #testSimple; add: #testColumnLeft; add: #testRowFill; add: #testRowCenter; add: #testAdvancedApi; add: #testColumnCenter; add: #testColumnRight; add: #testRowBottom; add: #testRowTop; yourself)); add: (#timeStamp->'6 July 2009 4:38:46 pm' asTimeStamp); add: (#failures->((Set new) add: #testPxSize; add: #testRecomputePreferredBounds; yourself)); add: (#errors->((Set new) add: #testColumnCenterResize; add: #testRowBottomResize; add: #testRowCenterResize; add: #testOoApi; add: #testColumnLeftResize; add: #testPxReSize; add: #testColumnFillResize; add: #testRowFillResize; add: #testRowTopResize; add: #testColumnRightResize; yourself)); yourself)! !

!MOFormsBuilderTest methodsFor: 'testing' stamp: 'Alexandre.Bergel 9/25/2009 21:09'!
expectedFailures
	^  #(#testPxSize #testColumnRightResize #testRowCenterResize #testColumnLeftResize #testRowBottomResize #testPxReSize #testRowTopResize #testColumnCenterResize)! !

!MOFormsBuilderTest methodsFor: 'advanced - api' stamp: 'Alexandre Bergel 6/16/2010 22:21'!
testAdvancedApi
	
	| builder view shape figure orangeRectangle |

	orangeRectangle := MORectangleShape width: 10 height: 15 fillColor: Color orange.
	builder := MOFormsBuilder new.

	builder 
		column; pref;
		column; fill; pref; grow;
		column; pref;
		column; fill; pref; grow;
		column; fill; pref; grow.
	builder 
		row; fill; pref; grow;
		row; fill; pref; grow;
		row; pref;
		row; pref.
	builder x: 1 y: 2 add: orangeRectangle.
	builder x: 2	 y: 1 h: 2 add: (MORectangleShape width: 30 height: 30 fillColor: Color red).
	builder x: 2 y: 3 w: 3 add: (MORectangleShape new fillColor: Color blue).
	builder x: 3	 y: 1 add: ((MORectangleShape new withoutBorder; withText) text: [:entity | 'Hello']).
	builder x: 4 y: 2 add: ((MORectangleShape new withoutBorder; withText) text: [:entity | 'World']).
	builder x: 4	 y: 4 add: (MORectangleShape new width: 24;	height: 24; fillColor: Color green).
	builder x: 5 y: 1 add: (MORectangleShape new width: 10; height: 15; fillColor: Color brown).
	shape := builder shape.
	
	view := MOViewRenderer new.
	figure := view node: 1 using: shape.

	window := view open.
	self assert: (shape boundsFor: figure ) origin = (5 @ 5).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 2/20/2009 00:53'!
testColumnCenter
	
	| builder view ui completeShape figure centeredRectangle |
	centeredRectangle := MORectangleShape width: 10 height: 10 fillColor: Color blue.
	builder := MOFormsBuilder new.
	builder column; center; pref.
	builder 
		row; pref; 
		row; pref.
	builder x: 1 y: 1 add: centeredRectangle.
	builder x: 1 y: 2 add: (MORectangleShape
							width: 30
							height: 10
							fillColor: Color red).
	completeShape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: completeShape.

	"I do not understand what this line is here for"
"	builder asLayout doExecute: figure."

	ui := view open.
	self assert: (completeShape boundsFor: figure) = (Rectangle
						origin: 5 @ 5
						width: 30
						height: 20).
	self assert: (centeredRectangle boundsFor: figure) = (Rectangle
						origin: 15 @ 5
						width: 10
						height: 10).
	ui delete! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'AlexandreBergel 9/5/2010 09:58'!
testColumnCenterResize
	
	| builder view shape element rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder column; center; pref; grow.
	builder 
		row; pref;
		row; pref.
	builder x: 1 y: 1 add: rectangle.
	builder
		x: 1
		y: 2
		add:
			(MORectangleShape
				width: 30
				height: 10
				fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	element := view node: #node using: shape.
	window := view open.
	element
		setBoundsTo:
			(Rectangle
				origin: 5 @ 5
				width: 50
				height: 20).
	self
		assert:
			(element shapeBoundsAt: shape)
				=
					(Rectangle
						origin: 5 @ 5
						width: 50
						height: 20).
	self
		assert:
			(element shapeBoundsAt: rectangle)
				=
					(Rectangle
						origin: 25 @ 5
						width: 10
						height: 10).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'jlr 11/25/2008 16:25'!
testColumnFill
	
	| builder view ui shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder column; fill; pref.
	builder 
		row; pref;
	 	row; pref.
	builder x: 1 y: 1 add: rectangle.
	builder
		x: 1
		y: 2
		add:
			(MORectangleShape
				width: 30
				height: 10
				fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	ui := view open.
	self
		assert:
			(shape boundsFor: figure )
				=
					(Rectangle
						origin: 5 @ 5
						width: 30
						height: 20).
	self
		assert:
			(rectangle boundsFor: figure )
				=
					(Rectangle
						origin: 5 @ 5
						width: 30
						height: 10).
	ui delete! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 8/13/2009 14:36'!
testColumnFillResize
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder column; fill; pref; grow.
	builder 
		row; pref;
		row; pref.
	builder x: 1 y: 1 add: rectangle.
	builder
		x: 1
		y: 2
		add:
			(MORectangleShape
				width: 30
				height: 10
				fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure
		setBoundsTo:
			(Rectangle
				origin: 5 @ 5
				width: 50
				height: 20).
	self
		assert:
			(shape boundsFor: figure )
				=
					(Rectangle
						origin: 5 @ 5
						width: 50
						height: 20).
	self
		assert:
			(rectangle boundsFor: figure )
				=
					(Rectangle
						origin: 5 @ 5
						width: 50
						height: 10).! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 2/24/2009 00:26'!
testColumnLeft
	| builder view shape figure smallRectangle largeRectangle |
	smallRectangle := MORectangleShape width: 10 height: 10 fillColor: Color orange.
	largeRectangle := (MORectangleShape width: 30 height: 10 fillColor: Color red).
	builder := MOFormsBuilder new.
	builder
		column; left; pref.
	builder row; pref; row; pref.
	builder x: 1 y: 1 add: smallRectangle.
	builder x: 1 y: 2 add: largeRectangle.
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	self assert: (shape boundsFor: figure) = (Rectangle 
				origin: 5 @ 5
				extent: 30 @ 20).
	self assert: (smallRectangle boundsFor: figure) = (Rectangle 
				origin: 5 @ 5
				extent: 10 @ 10).
	self assert: (largeRectangle boundsFor: figure) = (Rectangle 
				origin: 5 @ 15
				extent: 30 @ 10).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 8/13/2009 14:36'!
testColumnLeftResize
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; 
			left; 
			pref; 
			grow.
		builder 
		row; pref;
		row; pref.
	builder x: 1 y: 1 add: rectangle.
	builder
		x: 1
		y: 2
		add:
			(MORectangleShape
				width: 30
				height: 10
				fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure
		setBoundsTo:
			(Rectangle
				origin: 5 @ 5
				width: 50
				height: 20).
	self
		assert:
			(shape boundsFor: figure )
				=
					(Rectangle
						origin: 5 @ 5
						width: 50
						height: 20).
	self
		assert:
			(rectangle boundsFor: figure )
				=
					(Rectangle
						origin: 5 @ 5
						width: 10
						height: 10).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'jlr 11/25/2008 10:42'!
testColumnRight
	
	| builder view ui shape figure rectangle |
	rectangle := MORectangleShape width: 10 height: 10 fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder column; right; pref.
	builder row; pref; row; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 1 y: 2 add: (MORectangleShape width: 30 height: 10 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	ui := view open.
	self assert: (shape boundsFor: figure) = (5 @ 5 extent: 30@20).
	self assert: (rectangle boundsFor: figure) = (25 @ 5 extent: 10 @ 10).
	ui delete! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 8/13/2009 14:36'!
testColumnRightResize
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder column; right; pref.
	builder row; pref; row; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 1	y: 2 add: (MORectangleShape width: 30 height: 10 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure
		setBoundsTo:
			(Rectangle
				origin: 5 @ 5
				width: 50
				height: 20).
	self
		assert:
			(shape boundsFor: figure)
				=
					(Rectangle
						origin: 5 @ 5
						width: 50
						height: 20).
	self
		assert:
			(rectangle boundsFor: figure)
				=
					(Rectangle
						origin: 45 @ 5
						width: 10
						height: 10).
! !

!MOFormsBuilderTest methodsFor: 'shape tests' stamp: 'Alexandre Bergel 6/16/2010 22:21'!
testForm
	| view |
	view := MOViewRenderer new.
view shape 
	form: [:b | 
					b column; fill; row; fill; row; fill; row; fill. 
					b x:1 y:1 add: (MORectangleShape new fillColor: Color lightGreen).
					b x:1 y:2 add: (MORectangleShape new withoutBorder; withText).
					b x:1 y:3 add: (MORectangleShape new fillColor: Color lightBlue).].
view node: 'hello world'.

	window := view open.
	
	self assert: (view root nodes size = 1).
	self assert: (view root nodes first model = 'hello world').
	self assert: (view root nodes first shape isKindOf: MOFormsShape).
	self assert: (view root nodes first shape builder numberOfRows = 3).
	self assert: (view root nodes first shape builder numberOfColumns = 1).! !

!MOFormsBuilderTest methodsFor: 'advanced - api' stamp: 'AlexandreBergel 9/6/2010 18:30'!
testNestingOfFormBuilder

	| view builder rectangleShape1 rectangleShape2 bigNode subnodes adaptor1 adaptor2 formShape |
	view := MOViewRenderer new.

	builder := MOFormsBuilder new.
	builder column; fill.
	builder row; fill; row; fill.
	builder x: 1 y: 1 add: (rectangleShape1 := MORectangleShape new width: 30; height: 25; fillColor: Color lightBlue).
	builder x: 1 y: 2 add: (rectangleShape2 := MORectangleShape new width: 30; height: 25).

	bigNode := view node: 10 forIt: [
		view shape: builder shape.
		subnodes := view nodes: #(1 2).
	].

	window := view open.

	self assert: (subnodes size = 2).
	self assert: (subnodes first bounds = ( 5@5 corner: 35@55)).
	self assert: (subnodes second bounds = ( 45@5 corner: 75@55)).
	
	"Some hygienic checks"
	self assert: (subnodes first shape isKindOf: MOFormsShape).
	self assert: (subnodes first shape builder == builder).

	self assert: (subnodes second shape isKindOf: MOFormsShape).
	self assert: (subnodes second shape builder == builder).

	self assert: (subnodes second shape builder shapes isCollection).
	self assert: (subnodes second shape builder shapes size = 2).
	adaptor1 := subnodes second shape builder shapes first.
	adaptor2 := subnodes second shape builder shapes second.
	
	self assert: (adaptor1 isKindOf: MOShapeAdaptor).
	self assert: (adaptor2 isKindOf: MOShapeAdaptor).
	self assert: (adaptor1 shape == rectangleShape1).
	self assert: (adaptor2 shape == rectangleShape2).
	self assert: ((adaptor1 shape absoluteBoundsFor: subnodes first) = ( 10@10 corner: 40@35)).
	self assert: ((adaptor2 shape absoluteBoundsFor: subnodes first) = ( 10@35 corner: 40@60)).

	self assert: (bigNode absoluteBounds = ( 5@5 corner: 85@65)).
	
	self assert: (subnodes second owner == bigNode).
	formShape := subnodes second shape.
	self assert: (formShape isKindOf: MOFormsShape).
	self assert: ((formShape boundsFor: subnodes second) = (subnodes second bounds)).
	self assert: ((formShape absoluteBoundsFor: subnodes second) = ( 50@10 corner: 80@60)).
	
	self assert: (builder boundsOf: rectangleShape1) = ( 0@0 corner: 30@25).
	self assert: (builder boundsOf: rectangleShape2) = ( 0@25 corner: 30@50).

	self assert: ((adaptor1 shape absoluteBoundsFor: subnodes second) = ( 50@10 corner: 80@35)).

! !

!MOFormsBuilderTest methodsFor: 'oo - api - tests' stamp: 'Alexandre.Bergel 3/3/2009 13:47'!
testOoApi
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 	column; fill; pref; grow.
	builder row; pref.
	builder	row; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 1	y: 2 add: (MORectangleShape width: 30 height: 10 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure
		setBoundsTo:
			(Rectangle
				origin: 5 @ 5
				width: 50
				height: 20).
	self
		assert:
			(shape boundsFor: figure)
				=
					(Rectangle
						origin: 5 @ 5
						width: 50
						height: 20).
	self
		assert:
			(rectangle boundsFor: figure )
				=
					(Rectangle
						origin: 5 @ 5
						width: 50
						height: 10).! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 3/3/2009 13:32'!
testPxReSize
	
	| builder view shape figure r1 r2 |
	r1 := MORectangleShape fillColor: Color orange.
	r2 := (MORectangleShape
		width: 30
		height: 10
		fillColor: Color red).
	builder := MOFormsBuilder new.
	builder columns: 'fill:20px'.
	builder rows: '50px, pref'.
	builder x: 1 y: 1 add: r1.
	builder x: 1 y: 2 add: r2.
	shape := builder asShape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure
		setBoundsTo:
			(Rectangle
				origin: 5 @ 5
				width: 100
				height: 200).
	self assert: (shape boundsFor: figure ) = (5 @ 5 corner: 105 @ 205).
	self assert: (r1 boundsFor: figure ) = (5 @ 5 corner: 25.0 @ 10).
	self assert: (r2 boundsFor: figure ) = (6 @ 56 corner: 24.0 @ 66).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 3/26/2009 14:43'!
testPxSize
	
	| builder view shape figure r1 r2 |
	r1 := MORectangleShape fillColor: Color orange.
	r2 := (MORectangleShape
		width: 30
		height: 10
		fillColor: Color red).
	builder := MOFormsBuilder new.

	builder columns: 'fill:20px'.
	builder rows: '50px, pref'.
	builder x: 1 y: 1 add: r1.
	builder x: 1 y: 2 add: r2.
	shape := builder asShape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	self assert: (shape boundsFor: figure ) = (5 @ 5 corner: 25 @ 67).
	self assert: (r1 boundsFor: figure ) = (5 @ 5 corner: 25.0 @ 10).
	self assert: (r2 boundsFor: figure ) = (6 @ 56 corner: 24.0 @ 66).
! !

!MOFormsBuilderTest methodsFor: 'shape tests' stamp: 'Alexandre.Bergel 8/30/2009 11:37'!
testRecomputePreferredBounds
	self flag: #TODO.
"	| builder view node |
	builder := MOFormsBuilder new.
	builder row; fill; pref; grow.
	builder column; fill; pref; grow.
	builder x: 1 y: 1 add: MORectangleShape withBorder.
	view := MOViewRenderer new.
	node := view
		node: #test
		using: builder asShape.
	window := view open.
	

	self assert: node bounds = (5 @ 5 extent: 7 @ 7).
	node setBoundsTo: (40 @ 35 extent: 20 @ 21).
	self assert: node bounds = (40 @ 35 extent: 20 @ 21).
	node recomputePreferredBounds.
	self assert: node bounds = (40 @ 35 extent: 7 @ 7).
"! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'jlr 11/26/2008 09:40'!
testRowBottom
	
	| builder view ui shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref; 
		column; pref.
	builder row; bottom; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2	y: 1	add: (MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	ui := view open.
	self	assert: (shape boundsFor: figure ) =	(Rectangle origin: 5 @ 5	width: 30 height: 30).
	self	assert: (rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 25	width: 10 height: 10).
	ui delete! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 3/3/2009 13:32'!
testRowBottomResize
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref;
		column; pref.
	builder row; bottom; pref; grow.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2	y: 1	 add: (MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure setBoundsTo: 	(Rectangle origin: 5 @ 5	width: 30 height: 50).
	self	assert:(shape boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 30 height: 50).
	self	assert: (rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 45 width: 10 height: 10).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 2/24/2009 00:28'!
testRowCenter
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref; 
		column; pref.
	builder row; center; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2 y: 1 add: (MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	self assert:	(shape boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 30 height: 30).
	self assert:	(rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 15 width: 10	height: 10).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 3/3/2009 13:32'!
testRowCenterResize
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref;
		column; pref.
	builder row; center; pref; grow.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2 y: 1 add: (MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure setBoundsTo:	(Rectangle origin: 5 @ 5 width: 30 height: 50).
	self assert: (shape boundsFor: figure ) = (Rectangle	origin: 5 @ 5 width: 30 height: 50).
	self assert: (rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 25 width: 10 height: 10).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'jlr 11/26/2008 09:57'!
testRowFill
	
	| builder view ui shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref;
		column; pref.
	builder row; fill; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2 y: 1 add: (MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	ui := view open.
	self assert: (shape boundsFor: figure ) =	(Rectangle origin: 5 @ 5 width: 30 height: 30).
	self	assert: (rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 10 height: 30).
	ui delete! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 3/3/2009 13:32'!
testRowFillResize
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref; 
		column; pref.
	builder row; fill; pref; grow.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2 y: 1 add:(MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure setBoundsTo: (Rectangle origin: 5 @ 5 width: 30 height: 50).
	self assert: (shape boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 30 height: 50).
	self	assert: (rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 10 height: 50).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'jlr 11/26/2008 10:02'!
testRowTop
	
	| builder view ui shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref;
		column; pref.
	builder row; top; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2 y: 1 add: (MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	ui := view open.
	self assert: (shape boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 30 height: 30).
	self assert: (rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 10 height: 10).
	ui delete! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 3/3/2009 13:32'!
testRowTopResize
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape
		width: 10
		height: 10
		fillColor: Color orange.
	builder := MOFormsBuilder new.
	builder 
		column; pref;
		column; pref.
	builder row; top; pref.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2 y: 1 add: (MORectangleShape width: 20 height: 30 fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.
	window := view open.
	figure setBoundsTo: (Rectangle origin: 5 @ 5 width: 30 height: 50).
	self assert: (shape boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 30 height: 50).
	self assert: (rectangle boundsFor: figure ) = (Rectangle origin: 5 @ 5 width: 10 height: 10).
! !

!MOFormsBuilderTest methodsFor: 'alignment - tests' stamp: 'Alexandre.Bergel 2/20/2009 19:14'!
testSimple
	
	| builder view ui shape figure rectangle |
	rectangle := MORectangleShape width: 10 height: 15 fillColor: Color blue.
	builder := MOFormsBuilder new.
	builder column; center; pref.
	builder row; pref.
	builder x: 1 y: 1 add: rectangle.
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.

	ui := view open.
	self assert: (shape boundsFor: figure) =
					(Rectangle
						origin: 5 @ 5
						width: 10
						height: 15).
	self assert: (shape collectAllShapes size = 2).
	ui delete! !

MondrianTestCase subclass: #MOInteractionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOInteractionTest methodsFor: 'low level tests' stamp: 'Alexandre Bergel 3/2/2010 23:12'!
testEmittingOnAPort
	| view transmission nodeSet1 nodeSet2 globalVariable node1 node2 |

	view := MOViewRenderer new.
	view interaction 
		on: MOMouseEnter do: [:ann | (ann elementInteraction port: #output) value: 42 ].
	nodeSet1 := view nodes: (1 to: 20).
	node1 := nodeSet1 first.
	
	view interaction 
		on: MOMouseEnter do: [:ann | globalVariable := (ann elementInteraction port: #input) value ].
	nodeSet2 := view nodes: (21 to: 40).
	node2 := nodeSet2 first.
		
	transmission := (MOTransmission new) 
		origin: (node1 interaction port: #output); 
		destination: (node2 interaction port: #input); 
		yourself. 
		
	window := view open.
	
	self assert: (globalVariable isNil).
	node1 announce: (MOMouseEnter new).
	self assert: (globalVariable isNil).
	transmission transmit.
	self assert: (globalVariable isNil).
	node2 announce: (MOMouseEnter new).
	self assert: (globalVariable = 42).! !

!MOInteractionTest methodsFor: 'low level tests' stamp: 'AlexandreBergel 9/6/2010 18:36'!
testEmittingOnAPort2
	| view nodeSet1 nodeSet2 globalVariable node1 interaction1 |

	view := MOViewRenderer new.
	interaction1 := 
		view interaction 
			on: MOMouseEnter do: [:ann | ann transmit: 42 onPort: #output ];
			yourself.
	nodeSet1 := view nodes: (1 to: 20).
	node1 := nodeSet1 first.
	
	view interaction 
		from: interaction1 port: #output do: [:ann | globalVariable := ann  value ].
	nodeSet2 := view nodes: (21 to: 40).
			
	window := view open.
	
	self assert: (globalVariable isNil).
	node1 announce: (MOMouseEnter new).
	self assert: (globalVariable = 42).! !

!MOInteractionTest methodsFor: 'low level tests' stamp: 'Alexandre Bergel 3/2/2010 22:45'!
testEmittingOnAPortWithoutBeingBinded
	| view |

	view := MOViewRenderer new.
	view interaction 
		on: MOMouseEnter do: [:ann | (ann currentInteraction port: #output) value: 42 ].
	view nodes: (1 to: 20).
	window := view open! !

!MOInteractionTest methodsFor: 'low level tests' stamp: 'Alexandre Bergel 3/2/2010 21:25'!
testSimplePort 
	 
	| port | 
	port := MOPort new. 
	port name: #foo. 
	port value: 42. 
	self assert: port name = #foo. 
	self assert: port value = 42. 
! !

!MOInteractionTest methodsFor: 'low level tests' stamp: 'Alexandre Bergel 7/26/2010 15:00'!
testSimpleTransmission
	| node1 node2 transmission |
	node1 := MONode on: 'test1'.
	node2 := MONode on: 'test2'.
	transmission := (MOTransmission new)
		origin: (node1 interaction port: #output);
		destination: (node2 interaction port: #input);
		yourself.
	(node1 interaction port: #output) value: 42.
	self assert: (node1 interaction port: #output) value = 42.
	self assert: (node2 interaction port: #input) value isNil.
	transmission transmit.
	self assert: (node1 interaction port: #output) value = 42.
	self assert: (node2 interaction port: #input) value = 42! !

MondrianTestCase subclass: #MOLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOLayoutTest class methodsFor: 'history' stamp: 'simon.denier 7/6/2009 16:39'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testCircleLayout; add: #testSortBlockE; add: #testChildrenNodes; add: #testSimpleLoop; add: #testRootNodes; add: #testDoubleLoopWithNoRoot; add: #testSortBlockC; add: #testSortBlockA; add: #testBoxFigureResize; add: #testFromPosition; add: #testMOTreeLayoutWithLocalEdges; add: #testDominanceTreeLayout; add: #testFormsLayout; add: #testNodeFigureResize; add: #testLoopWithNoRoot; add: #testNested; add: #testSortBlockD; add: #testToPosition; add: #testParentNodes; add: #testConnectionPositions; add: #testChangingLayout; add: #testSortBlockB; add: #testNegativeGap; yourself)); add: (#timeStamp->'6 July 2009 4:38:46 pm' asTimeStamp); add: (#failures->((Set new) add: #testContextTransfer; yourself)); add: (#errors->((Set new) add: #testScatterplotLayout; add: #testScatterplotLayout2; add: #testScatterplot; add: #testTransparentEdges; yourself)); yourself)! !

!MOLayoutTest methodsFor: 'testing' stamp: 'Alexandre Bergel 8/15/2010 12:18'!
expectedFailures
	^ #(#testContextTransfer #testTransparentEdges #testScatterplotLayoutBoundsWithUpSideDown)! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:36'!
horizontalLayoutStrech4TOBEFIXED
	| view nodes ui |
	view := MOViewRenderer new.

"	view shape rectangle width: 150; height: 130."
	view node: #foo forIt: [
		view shape rectangle width: #x; height: #y.
		view nodes: {80@30}.
		
		view node: #bar forIt: [
"			view shape rectangle width: #x; height: #y."
			view nodes: {40@30}.
			view horizontalLineLayout stretchHorizontally. 		
		].
		view verticalLineLayout stretchHorizontally. 
	].

	window := view open.

! !

!MOLayoutTest methodsFor: 'obsolete' stamp: 'Alexandre.Bergel 8/30/2009 11:41'!
obsoleteTestScatterplot
	
	| view nodeA nodeC ui nodeB |
	view := MOViewRenderer new.
	nodeA := view
		node: #a
		forIt:
			[view figure
				x: [:entity | #centered]
				y: 10.
			nodeB := view node: #b.
			view figure x: 90 y: 30.
			nodeC := view node: #c.
			view layout: (MOScatterplotLayout new
				xOutGap: 0;
				yOutGap: 5)].
	ui := view open.
	self assert: nodeA bounds = (5.0 @ 5 corner: 104.0 @ 49).
	self assert: nodeB bounds = (51.0 @ 16 corner: 58.0 @ 23).
	self assert: nodeC bounds = (96.0 @ 36 corner: 103.0 @ 43).
	ui delete! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'tg 7/25/2010 14:44'!
testBoxFigureResize
	
	| model view box |
	model := MOTestModel new.
	view := MOViewRenderer new.
	box := view
		node: #box
		using: MORectangleShape withBorder
		forIt:
			[view
				nodes: model allNodes
				using: model shapeForNode.
			view
				localEdges: model allEdges
				from: [:entity | entity first]
				to: [:entity | entity last]
				using: model shapeForEdge.
			view layout: MOVerticalNarrowTreeLayout new.
			].
	window := view open.

	self assert: box origin = (5 @ 5).
	"box applyLayout."	"Reapply the layout"
	view root applyLayout.
	self assert: box origin = (5 @ 5).
! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'tg 7/25/2010 14:44'!
testChangingLayout
	
	| view node layout |
	layout := MOVerticalNarrowTreeLayout new.
	view := MOViewRenderer new.
	view
		nodes: #(#'1' #'2a' #'2b' #'3a' #'3b' #'3c').
		
	view
		edges:
			#(#(#'1' #'2a') #(#'1' #'2b') #(#'2a' #'3a') #(#'2a' #'3b') #(#'2b' #'3c'))
		from: [:entity | entity first]
		to: [:entity | entity last].

	view layout: layout.
	window := view open.
"	view evaluate."

	"node := view peek deepFindNodeWithEntity: #'2a'."	"Test that applying the layout worked"
	node := view nodeForDomainValue: #'2a'.

	self assert: (layout childrenFor: node) size = 2.
	self assert: (layout parentsFor: node) size = 1.	"Reapply the same layout"
	view root applyLayout.
	self assert: (layout childrenFor: node) size = 2.
	self assert: (layout parentsFor: node) size = 1.	"Use an other layout"
	layout := MOHorizontalTreeLayout new.
	view root layout: layout.
	view root applyLayout.
	self assert: (layout childrenFor: node) size = 2.
	self assert: (layout parentsFor: node) size = 1! !

!MOLayoutTest methodsFor: 'utils' stamp: 'Alexandre.Bergel 4/10/2009 19:10'!
testChildrenNodes
	
	| view layout nodes node |
	layout := MOTreeLayout new.
	view := MOViewRenderer new.
	node := view node: 1.
	nodes := view nodes: #(2 3).
	view
		edge: 1 -> 2
		from: #key
		to: #value.
	view
		edge: 1 -> 3
		from: #key
		to: #value.
	view layout: layout.
	window := view open.
"	view evaluate."
	self assert: (layout childrenFor: node) size = 2.
	self assert: ((layout childrenFor: node) includes: nodes first).
	self assert: ((layout childrenFor: node) includes: nodes second)! !

!MOLayoutTest methodsFor: 'test layout' stamp: ' 29/3/09 10:47'!
testCircleLayout
	
	self assert: MOCircleLayout new scaleFactor = 11.	"Default  value"
	self assert: (MOCircleLayout scaleBy: 35) scaleFactor = 35! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'tg 7/25/2010 14:44'!
testConnectionPositions
	
	| model view figure |
	model := MOTestModel new.
	view := MOViewRenderer new.
	view
		nodes: model allNodes
		using: model shapeForNode.
	view
		localEdges: model allEdges
		from: [:entity | entity first]
		to: [:entity | entity last]
		using: model shapeForEdge.
	view layout: MOVerticalNarrowTreeLayout new.

	view root applyLayout.
	figure := view root edges
		detect:
			[:aFigure | 
			aFigure source model == model b1
				& (aFigure target model == model c1)].
	self assert: figure fromPositions = #(#bottomCenter).
	self assert: figure toPositions = #(#topCenter)! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'tg 7/25/2010 14:44'!
testContextTransfer
	"When we change the layout the nodes and edges information should be passed to the"
	
	| view edges model layout |
	model := MOTestModel new.
	view := MOViewRenderer new.
	view
		nodes: model allNodes
		using: model shapeForNode.
	edges := view
		localEdges: model allEdges
		from: [:entity | entity first]
		to: [:entity | entity last]
		using: model shapeForEdge.	"Add an other edge that should not be taken in to account."
	view
		edge:
			(Array
				with: model a1
				with: model d1)
		from: [:entity | entity first]
		to: [:entity | entity last]
		using: model shapeForEdge.
	layout := MOTreeLayout withEdges: edges.
	view layout: layout.
	window := view open.

	self
		assert:
			(layout childrenFor: (view root deepFindNodeWithEntity: model a1)) size = 2.
	self
		assert:
			(layout childrenFor: (view root deepFindNodeWithEntity: model d1)) isEmpty.	"Change to a totaly other layout"
	view layout: MOHorizontalLineLayout new.
	view root deepApplyLayout.	"Change back to a tree layout"
	view updateWindow.
	layout := MOVerticalNarrowTreeLayout new.
	view layout: layout.
	view root deepApplyLayout.
	self
		assert:
			(layout childrenFor: (view root deepFindNodeWithEntity: model a1)) size = 2.
	self
		assert:
			(layout childrenFor: (view root deepFindNodeWithEntity: model d1)) isEmpty! !

!MOLayoutTest methodsFor: 'dominance tree layout' stamp: 'Alexandre Bergel 12/20/2009 15:38'!
testDominanceTreeLayout
	| view nodes node1 node2 node3 node4 x y |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 4).
	view edges: {1 -> 2. 1-> 3. 1->4} from: #key to: #value.
	view dominanceTreeLayout.
	window := view open.
	
	node1 := nodes first.
	node2 := nodes second.
	node3 := nodes third.
	node4 := nodes fourth.
	
	x := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft x < n2 bounds topLeft x].
	self assert: (x asArray = {node2 . node3. node1. node4}).

	y := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft y < n2 bounds topLeft y].
	self assert: (y asArray = {node1 . node3. node2. node4})! !

!MOLayoutTest methodsFor: 'loops' stamp: 'tg 7/25/2010 14:44'!
testDoubleLoopWithNoRoot
	
	| view |
	view := MOViewRenderer new.
	view nodes: #(1 2 3 4 5 6).
	view
		edge: 1 -> 2
		from: #key
		to: #value.
	view
		edge: 2 -> 3
		from: #key
		to: #value.
	view
		edge: 3 -> 1
		from: #key
		to: #value.
	view
		edge: 4 -> 5
		from: #key
		to: #value.
	view
		edge: 5 -> 6
		from: #key
		to: #value.
	view
		edge: 6 -> 4
		from: #key
		to: #value.
	view layout: (MOVerticalNarrowTreeLayout new).
	window := view open! !

!MOLayoutTest methodsFor: 'flowInLayout' stamp: 'AlexandreBergel 9/6/2010 18:36'!
testFlowInLayout
	" self debug: #testFlowInLayout "
	| shape view nodes |

	view := MOViewRenderer new.
	shape := MORectangleShape new width: #yourself; height: #yourself.
	shape fillColor: Color blue.
	view shape: shape.
	nodes := view nodes: #(10 30 50 100 35 10 45).
	view layout: (MOFillInFlowLayout new).
	window := view open.
	
	self assert: nodes first bounds = (5@5 corner: 15@15).
	self assert: nodes third bounds = (65@5 corner: 115@55).
	self assert: nodes fourth bounds = (5@65 corner: 105@165).
! !

!MOLayoutTest methodsFor: 'force based Layout' stamp: 'Alexandre Bergel 2/17/2010 21:38'!
testForceBasedLayout
	| view edges |
	view := MOViewRenderer new.
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine width: 2.
	edges := view edges: {1 -> 2 . 1 -> 3 . 1 -> 5 . 2 -> 4 . 4 -> 1 } from: #key to: #value.
	view forceBasedLayout.
	
	self assert: (edges allSatisfy: [:edge | edge fromPositions isNil ]).
	self assert: (edges allSatisfy: [:edge | edge toPositions isNil ]).

	window := view open.
	
	self assert: (edges allSatisfy: [:edge | edge fromPositions = #() ]).
	self assert: (edges allSatisfy: [:edge | edge toPositions = #() ]).

	self assert: (edges collect: [:edge | | t |
		t := edge shape getAttachPointsFor: edge.
		{t first asIntegerPoint . t second asIntegerPoint } ] ) asArray = {{114@95. 146@110}. {74@95. 45@70}. {94@75. 114@45}. {146@110. 137@165}. {117@145. 94@115}}! !

!MOLayoutTest methodsFor: 'circle layout' stamp: 'Alexandre.Bergel 9/26/2009 14:09'!
testForceBasedLayout1
	| view nodes node1 node2 node3 node4 x y |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 4).
	view edges: {1 -> 2. 1-> 3. 1->4} from: #key to: #value.
	view circleLayout.
	window := view open.
	
	node1 := nodes first.
	node2 := nodes second.
	node3 := nodes third.
	node4 := nodes fourth.
	
	x := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft x < n2 bounds topLeft x].
	self assert: (x asArray = {node3 . node4. node2. node1}).

	y := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft y < n2 bounds topLeft y].
	self assert: (y asArray = {node4 . node1. node3. node2})! !

!MOLayoutTest methodsFor: 'forms - tests' stamp: 'Alexandre.Bergel 4/10/2009 19:43'!
testFormsLayout
	
	| builder view nodeA nodeB nodeC |
	"Initialize the layout"
	builder := MOFormsBuilder new.
	builder columns: 'pref, 20px, pref, 50px, pref'.
	builder rows: 'pref'.	"Add nodes"
	view := MOViewRenderer new.

	view
		shape:
			(MORectangleShape
				width: 40
				height: 50
				fillColor: Color green).

	nodeA := view node: #a.
	view
		shape:
			(MORectangleShape
				width: 20
				height: 90
				fillColor: Color blue).

	nodeB := view node: #b.
	view
		shape:
			(MORectangleShape
				width: 80
				height: 20
				fillColor: Color yellow).

	nodeC := view node: #c.	"Position the components"
	builder x: 1 y: 1 add: nodeA.
	builder x: 3 y: 1 add: nodeB.
	builder x: 5 y: 1 add: nodeC.	"Apply layout"
	view layout: builder asLayout.

	window := view open.

	self assert: nodeA bounds = ( 0@0 corner: 40@50).
	self assert: nodeB bounds = ( 60@0 corner: 80@90).
	self assert: nodeC bounds = ( 130@0 corner: 210@20).
! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'tg 7/25/2010 14:44'!
testFromPosition
	
	| view handle |
	view := MOViewRenderer new.
	view nodes: #(1 2 3).
	handle := view
		edge: 1 -> 2
		from: #key
		to: #value.
	view
		layout:
			(MOVerticalNarrowTreeLayout new fromPositions:
					#(#rightCenter #leftCenter #topCenter #bottomCenter)).
	window := view open.
	self
		assert:
			handle value fromPositions =
					#(#rightCenter #leftCenter #topCenter #bottomCenter)! !

!MOLayoutTest methodsFor: 'dominance tree layout' stamp: 'Alexandre.Bergel 9/26/2009 21:44'!
testHorizontalDominanceTreeLayout
	| view nodes node1 node2 node3 node4 x y |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 4).
	view edges: {1 -> 2. 1-> 3. 1->4} from: #key to: #value.
	view horizontalDominanceTreeLayout.
	window := view open.
	
	node1 := nodes first.
	node2 := nodes second.
	node3 := nodes third.
	node4 := nodes fourth.
	
	x := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft x < n2 bounds topLeft x].
	self assert: (x asArray = {node1 . node3. node2. node4}).

	y := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft y < n2 bounds topLeft y].
	self assert: (y asArray = {node2 . node3. node1. node4})! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:36'!
testHorizontalLayoutStrech
	| view nodes outterNode innerNodes form form2 canvas2 firstInnerNode |
	view := MOViewRenderer new.

	view shape rectangle width: 150; height: 130.
	outterNode := view node: #foo forIt: [
		view shape rectangle width: #x; height: #y.
		innerNodes := view nodes: {10@30 . 40 @ 20}.
		view horizontalLineLayout stretchVertically. 
	].

	view root applyLayout.
	form := view getRenderedForm. 
	self assert: (outterNode bounds = ( 5@5 corner: 155@135)).
	self assert: (innerNodes collect: #bounds )= {5@5 corner: 15@125. 25@5 corner: 65@125}.
	self assert: (innerNodes collect: #absoluteBounds )= {(10@10 corner: 20@130). (30@10 corner: 70@130)}.
	
	firstInnerNode := innerNodes first.
	self assert: (firstInnerNode shape extentFor: firstInnerNode) = firstInnerNode bounds extent.
	
	"Checking the bitmap"
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
			frameAndFillRectangle: ( 5@5 corner: 155@135)
				fillColor: Color white
				borderWidth: 1
				borderColor: Color black.
	canvas2 
				frameAndFillRectangle: (10@10 corner: 20@130)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.
	canvas2 
				frameAndFillRectangle: (30@10 corner: 70@130)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.

	self assert: form bits = form2 bits
! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:31'!
testHorizontalLayoutStrech2
	| view nodes |
	view := MOViewRenderer new.

	view node: #foo forIt: [
		view shape rectangle width: #x; height: #y.
		nodes := view nodes: {10@30 . 40 @ 20}.
		view horizontalLineLayout stretchVertically. 
	].

	window := view open.

	self assert: (nodes collect: #bounds )=  {5@5 corner: 15@35. 25@5 corner: 65@35}! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:38'!
testHorizontalLayoutStrech3
	| view nodes |
	view := MOViewRenderer new.

	view shape rectangle width: 150; height: 130.
	view node: #foo forIt: [
		view shape rectangle width: #x; height: #y.
		nodes := view nodes: {10@30 . 40 @ 20}.
		view horizontalLineLayout stretchHorizontally. 
	].

	window := view open.
	self assert: (nodes collect: #bounds) = {5@5 corner: 31@35. 41@5 corner: 145@25}! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:40'!
testHorizontalLineLayout
	| shape view nodes |
	view := MOViewRenderer new.

	shape := MORectangleShape new width: #yourself; height: #yourself.
	shape fillColor: Color blue.
	view shape: shape.
	nodes := view nodes: #(10 30 50).
	view horizontalLineLayout alignment: #center.
	
	window := view open.

	self assert: nodes first bounds = (5@25 corner: 15@35).
	self assert: nodes second bounds = (25@15 corner: 55@45).	
	self assert: nodes third bounds = (65@5 corner: 115@55).
	
! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:37'!
testHorizontalLineLayout2
	| shape view nodes |
	view := MOViewRenderer new.

	shape := MORectangleShape new width: #yourself; height: #yourself.
	shape fillColor: Color blue.
	view shape: shape.
	nodes := view nodes: #(10 30 50).
	view horizontalLineLayout alignment: #bottom.
	
	window := view open.

	self assert: nodes first bounds = (5@45 corner: 15@55).
	self assert: nodes second bounds = (25@25 corner: 55@55).	
	self assert: nodes third bounds = (65@5 corner: 115@55).
	! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:40'!
testHorizontalLineLayoutStretchHorizontally
	| view bigNode smallNodes |

	view := MOViewRenderer new.

	view shape rectangle width: 400.
	bigNode := view node: #foo forIt: [
		smallNodes := view nodes: (1 to: 5).
		view horizontalLineLayout stretchHorizontally
	].

	window := view open.

	self assert: (bigNode bounds) width = 400.

	self assert: (smallNodes collect: #absoluteBounds) = {10@10 corner: 80@15. 90@10 corner: 160@15. 170@10 corner: 240@15. 250@10 corner: 320@15. 330@10 corner: 400@15}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:37'!
testHorizontalLineLayoutStretchHorizontallyNested


	| view bigNode innerNode innerInnerNodes |
	view := MOViewRenderer new.

bigNode := view node: 1 forIt: [
	view shape rectangle width: 100.
	view node: #foo.
	innerNode := view node: #bar forIt:[
		innerInnerNodes := view nodes: #(1 2).
		view horizontalLineLayout stretchHorizontally
	].
	view verticalLineLayout stretchHorizontally].



	window := view open.
	self assert: (bigNode bounds) width = 110.
	self assert: (innerNode bounds) width = 100.
	self assert: (innerInnerNodes collect: #width) = #(40 40).
	self assert: (innerInnerNodes collect: #bounds) =  {5@5 corner: 45@10. 55@5 corner: 95@10}.! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:38'!
testHorizontalLineLayoutStretchHorizontallyNestedNoHorizontalGap


	| view bigNode innerNode innerInnerNodes |
	view := MOViewRenderer new.

bigNode := view node: 1 forIt: [
	view shape rectangle width: 100.
	view node: #foo.
	innerNode := view node: #bar forIt:[
		innerInnerNodes := view nodes: #(1 2).
		view horizontalLineLayout horizontalGap: 0; stretchHorizontally
	].
	view verticalLineLayout stretchHorizontally].



	window := view open.
	self assert: (bigNode bounds) width = 110.
	self assert: (innerNode bounds) width = 100.
	self assert: (innerInnerNodes collect: #width) = #(45 45).
	self assert: (innerInnerNodes collect: #bounds) = {5@5 corner: 50@10. 50@5 corner: 95@10}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:39'!
testHorizontalLineLayoutStretchHorizontallyNestedNoHorizontalOutGap


	| view bigNode innerNode innerInnerNodes |
	view := MOViewRenderer new.

	bigNode := view node: 1 forIt: [
		view shape rectangle width: 100.
		view node: #foo.
		innerNode := view node: #bar forIt:[
			innerInnerNodes := view nodes: #(1 2).
			view horizontalLineLayout horizontalOutGap: 0; stretchHorizontally
		].
	view verticalLineLayout stretchHorizontally].



	window := view open.
	self assert: (bigNode bounds) width = 110.
	self assert: (innerNode bounds) width = 100.
	self assert: (innerInnerNodes collect: #width) = #(45 45).
	self assert: (innerInnerNodes collect: #bounds) = {0@5 corner: 45@10. 55@5 corner: 100@10}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:39'!
testHorizontalLineLayoutStretchHorizontallyNoHorizontalGap
	| view bigNode smallNodes |

	view := MOViewRenderer new.

	view shape rectangle width: 400.
	bigNode := view node: #foo forIt: [
		smallNodes := view nodes: (1 to: 5).
		view horizontalLineLayout horizontalOutGap: 0; stretchHorizontally
	].

	window := view open.
	self assert: (bigNode bounds) width = 400.

	self assert: (smallNodes collect: #absoluteBounds) = {5@10 corner: 77@15. 87@10 corner: 159@15. 169@10 corner: 241@15. 251@10 corner: 323@15. 333@10 corner: 405@15}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'Alexandre Bergel 2/23/2010 19:52'!
testHorizontalLineLayoutStretchHorizontallyNoHorizontalGap2


	| view bigNode smallNode |
	view := MOViewRenderer new.

view shape rectangle width: 400.
bigNode := view node: #foo forIt: [
	smallNode := view node: #bar.
	view horizontalLineLayout horizontalOutGap: 0; stretchHorizontally
].

	window := view open.
	self assert: (bigNode bounds) width = 400.
	self assert: (smallNode bounds) width = 400.! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'Alexandre Bergel 2/23/2010 17:09'!
testHorizontalLineLayoutStretchVertically
	| view bigNode smallNode1 smallNode2 |

	view := MOViewRenderer new.

view shape rectangle width: 50; height: 30.
bigNode := view node: #abc forIt: [
	view shape rectangle width: 50; height: 30.
	smallNode1 := view node: #foo.
	view shape rectangle width: 20; height: 10.
	smallNode2 := view node: #bar.
	view horizontalLineLayout stretchVertically
].

	window := view open.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #bounds) = {5@5 corner: 95@45. 5@5 corner: 55@35. 65@5 corner: 85@35}.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #absoluteBounds) = {5@5 corner: 95@45. 10@10 corner: 60@40. 70@10 corner: 90@40}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'Alexandre Bergel 2/23/2010 18:20'!
testHorizontalLineLayoutStretchVerticallyNested
	| view bigNode smallNode1 smallNode2 |

	view := MOViewRenderer new.

view shape rectangle width: 50; height: 30.
bigNode := view node: #abc forIt: [
	smallNode1 := view node: #foo forIt: [
			view shape rectangle width: 50; height: 30.
			view node: #foofoo
	].
	view shape rectangle width: 20; height: 10.
	smallNode2 := view node: #bar.
	view horizontalLineLayout stretchVertically
].

	window := view open.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #bounds) = {5@5 corner: 105@55. 5@5 corner: 65@45. 75@5 corner: 95@45}.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #absoluteBounds) =  {5@5 corner: 105@55. 10@10 corner: 70@50. 80@10 corner: 100@50}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'Alexandre Bergel 2/23/2010 19:05'!
testHorizontalLineLayoutStretchVerticallyNestedNested
	| view bigNode smallNode1 smallNode2 smallNode3 |

	view := MOViewRenderer new.

view shape rectangle height: 60.
bigNode := view node: #foo forIt: [
	smallNode1 := view node: #a.
	smallNode2 := view node: #b forIt: [ 
		smallNode3 := view node: #c.
		view horizontalLineLayout stretchVertically
	].
	view horizontalLineLayout stretchVertically
].

	window := view open.

	self assert: ({bigNode . smallNode1 . smallNode2. smallNode3} collect: #bounds) =  {5@5 corner: 45@65. 5@5 corner: 10@55. 20@5 corner: 35@55. 5@5 corner: 10@45}.

	self assert: ({bigNode . smallNode1 . smallNode2 . smallNode3} collect: #absoluteBounds) = {5@5 corner: 45@65. 10@10 corner: 15@60. 25@10 corner: 40@60. 30@15 corner: 35@55}! !

!MOLayoutTest methodsFor: 'horizontal tree layout' stamp: 'Alexandre Bergel 2/17/2010 19:05'!
testHorizontalTreeLayout
	| view nodes node1 node2 node3 node4 x y |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 4).
	view edges: {1 -> 2. 1-> 3. 1->4} from: #key to: #value.
	view horizontalTreeLayout.
	window := view open.
	
	node1 := nodes first.
	node2 := nodes second.
	node3 := nodes third.
	node4 := nodes fourth.
	
	x := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft x < n2 bounds topLeft x].
	self assert: (x asArray = {node1 . node3. node2. node4}).

	y := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft y < n2 bounds topLeft y].
	self assert: (y asArray = {node2 . node3. node1. node4})! !

!MOLayoutTest methodsFor: 'horizontal tree layout' stamp: 'tg 8/16/2010 17:02'!
testLayoutingTreeLayout
	| view nodes node1 node2 node3 node4 |
	view := MOViewRenderer new.
	view shape rectangle height: [:x | x * 10].
	nodes := view nodes: (1 to: 4).
	view edges: {1 -> 2. 3->4} from: #key to: #value.
	view treeLayout layered; verticalGap: 10.
	view root applyLayout.
	
	node1 := nodes first.
	node2 := nodes second.
	node3 := nodes third.
	node4 := nodes fourth.
	
	self assert: node1 absoluteBounds top = 5.
	self assert: node2 absoluteBounds top = 45.
	self assert: node3 absoluteBounds top = 5.
	self assert: node4 absoluteBounds top = 45.! !

!MOLayoutTest methodsFor: 'loops' stamp: 'Alexandre.Bergel 4/10/2009 20:00'!
testLoopWithNoRoot
	
	| view |
	view := MOViewRenderer new.
	view nodes: #(1 2 3 4 5 6).
	view
		edge: 1 -> 2
		from: #key
		to: #value.
	view
		edge: 2 -> 3
		from: #key
		to: #value.
	view
		edge: 3 -> 1
		from: #key
		to: #value.
	view narrowTreeLayout.
	window := view open! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'Alexandre.Bergel 8/30/2009 15:32'!
testMOTreeLayoutWithLocalEdges
	"The tree layout should only take local edges in to account"
	
	| view edges model layout |
	model := MOTestModel new.
	view := MOViewRenderer new.
	view
		nodes: model allNodes
		using: model shapeForNode.
	edges := view
		localEdges: model allEdges
		from: [:entity | entity first]
		to: [:entity | entity last]
		using: model shapeForEdge.	"Add an other edge that should not be taken in to account."
	view
		edge:
			(Array
				with: model a1
				with: model d1)
		from: [:entity | entity first]
		to: [:entity | entity last]
		using: model shapeForEdge.
	layout := MOTreeLayout withEdges: edges.
	view layout: layout.
	window := view open.
	self
		assert:
			(layout childrenFor: (view root deepFindNodeWithEntity: model a1)) size = 2.
	self
		assert:
			(layout childrenFor: (view root deepFindNodeWithEntity: model d1)) isEmpty! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:31'!
testMixOfLayout

	| view |
	view := MOViewRenderer new.

	view node: 'B' forIt:[
			view node: 'C'.
			view shape: (MORectangleShape new borderWidth: 2; borderColor: Color red).
			view node: 'D' forIt: [view nodes: #(1 2 3). view horizontalTreeLayout].
			view horizontalLineLayout gapSize:4;stretchVertically].


	self shouldnt: [window := view open] raise: Error.
	
! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:36'!
testMixOfLayout2

	| view |
	view := MOViewRenderer new.

	view node: 'B' forIt:[
			view node: 'C'.
			view shape: (MORectangleShape new borderWidth: 2; borderColor: Color red).
			view node: 'D' forIt: [view nodes: #(1 2 3). view horizontalTreeLayout].
			view horizontalLineLayout gapSize:4;stretchVertically].


	self shouldnt: [ window := view open ] raise: Error.
	
! !

!MOLayoutTest methodsFor: 'narrow tree' stamp: 'tg 7/25/2010 14:44'!
testNarrowHorizontalTreeFromToPositions
	| layout |
	layout := MOHorizontalNarrowTreeLayout new.
	self assert: layout fromPositions = #(rightCenter).
	self assert: layout toPositions = #(leftCenter).! !

!MOLayoutTest methodsFor: 'narrow tree' stamp: 'tg 7/25/2010 14:44'!
testNarrowVerticalTreeFromToPositions
	| layout |
	layout := MOVerticalNarrowTreeLayout new.
	self assert: layout fromPositions = #(bottomCenter).
	self assert: layout toPositions = #(topCenter).! !

!MOLayoutTest methodsFor: 'forms - tests' stamp: 'Alexandre.Bergel 3/29/2009 20:05'!
testNegativeGap
	
	| builder view nodeA nodeB nodeC |
	"Initialize the layout"
	builder := MOFormsBuilder new.
	builder columns: 'pref, -1px, pref, -1px, pref'.
	builder rows: 'pref'.	"Add nodes"
	view := MOViewRenderer new.
	view
		shape:
			(MORectangleShape
				width: 40
				height: 50
				fillColor: Color green).

	nodeA := view node: #a.
	view
		shape:
			(MORectangleShape
				width: 20
				height: 90
				fillColor: Color blue).

	nodeB := view node: #b.
	view
		shape:
			(MORectangleShape
				width: 80
				height: 20
				fillColor: Color yellow).

	nodeC := view node: #c.	"Position the components"
	builder x: 1 y: 1 add: nodeA.
	builder x: 3 y: 1 add: nodeB.
	builder x: 5 y: 1 add: nodeC.	"Apply layout"
	view layout: builder asLayout.
	
	window := view open.
	self assert: nodeA bounds = ( 0@0 corner: 40@50).
	self assert: nodeB bounds = ( 39@0 corner: 59@90).
	self assert: nodeC bounds = ( 58@0 corner: 138@20).
! !

!MOLayoutTest methodsFor: 'forms - tests' stamp: 'Alexandre.Bergel 3/29/2009 20:09'!
testNested
	
	| builder view node |
	"Initialize the layout"
	builder := MOFormsBuilder new.
	builder columns: 'pref'.
	builder rows: 'pref'.
	view := MOViewRenderer new.
	node := view
		node: #a
		using: MORectangleShape withBorder
		forIt:
			[view nodes: #(1 2 3 4 5).
			view layout: MOVerticalLineLayout new].
	builder x: 1 y: 1 add: node.
	view layout: builder asLayout.
	window := view open.

	self assert: node bounds = ( 0@0 corner: 15@75)! !

!MOLayoutTest methodsFor: 'abstractlayout' stamp: 'Alexandre Bergel 8/18/2010 10:17'!
testNoLeafAbstractLayout
	self assert: (MOLayout allSubclasses 
					select: [:cls | cls subclasses isEmpty and: [ cls isAbstractClass ] ]) isEmpty
	! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'tg 7/25/2010 14:44'!
testNodeFigureResize
	
	| model view box |
	model := MOTestModel new.
	view := MOViewRenderer new.
	view
		node: #aNode
		using: MORectangleShape new
		forIt:
			[view
				nodes: model allNodes
				using: MORectangleShape new.
			view
				localEdges: model allEdges
				from: [:entity | entity first]
				to: [:entity | entity last]
				using: model shapeForEdge.
			view layout: MOVerticalNarrowTreeLayout new.
			box := view root].
	window := view open.
	self assert: box origin = (5 @ 5).
	box applyLayout.	"Reapply the layout"
	self assert: box origin = (0@0).

	view root applyLayout.	"Reapply the layout"
	self assert: box origin = (5 @ 5).
! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'Alexandre.Bergel 8/30/2009 15:33'!
testParentNodes
	
	| view layout nodeOne nodeTwo |
	layout := MOTreeLayout new.
	view := MOViewRenderer new.
	nodeOne := view node: 1.
	nodeTwo := view node: 2.
	view
		edge: 1 -> 2
		from: #key
		to: #value.
	view layout: layout.
	window := view open.
	self assert: (layout parentsFor: nodeOne) isEmpty.
	self assert: (layout parentsFor: nodeTwo) size = 1.
	self assert: (layout parentsFor: nodeTwo) first = nodeOne! !

!MOLayoutTest methodsFor: 'radial tree layout' stamp: 'AlexandreBergel 9/6/2010 11:20'!
testRadialTreeLayout
	| view nodes node1 node2 node3 node4 x y |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 4).
	view edges: {1 -> 2. 1-> 3. 1->4} from: #key to: #value.
	view radialTreeLayout.
	window := view open.
	
	node1 := nodes first.
	node2 := nodes second.
	node3 := nodes third.
	node4 := nodes fourth.
	
	x := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft x < n2 bounds topLeft x].
	self assert: (x asArray = {node3 . node1. node4. node2}).

	y := nodes asSortedCollection: [:n1 :n2 | n1 bounds topLeft y < n2 bounds topLeft y].
	self assert: (y asArray = {node4 . node1. node3. node2}).

	self assert: ((nodes collect: #absoluteBounds)  collect: #truncated) = {(30@30 corner: 35@35). (44@54 corner: 49@59). (3@30 corner: 8@35). (44@7 corner: 49@12)}! !

!MOLayoutTest methodsFor: 'utils' stamp: 'Alexandre.Bergel 4/10/2009 20:12'!
testRootNodes
	
	| view layout nodes |
	layout := MOTreeLayout new.
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2 3 4).
	view
		edge: 1 -> 2
		from: #key
		to: #value.
	view
		edge: 2 -> 3
		from: #key
		to: #value.
	view layout: layout.
	window := view open.
	self assert: (layout rootNodesFor: nodes) size = 2.
	self assert: (layout rootNodesFor: nodes) first = nodes first.
	self assert: (layout rootNodesFor: nodes) last = nodes last! !

!MOLayoutTest methodsFor: 'scatterplot' stamp: 'Alexandre.Bergel 8/13/2009 12:40'!
testScatterplotLayout
	
	| view nodes |
	view := MOViewRenderer new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40))
		using: MORectangleShape withBorder.
	view layout: (MOScatterplotLayout new 
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!MOLayoutTest methodsFor: 'scatterplot' stamp: 'Alexandre Bergel 10/20/2009 11:41'!
testScatterplotLayoutBounds
	"
	self debug: #testScatterplotLayoutBounds
	"
	| view nodes |
	view := MOViewRenderer new.
		
	view node: #foo forIt: [
		view layout: (MOScatterplotLayout new 
							x: #first ;
							y: #last).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!MOLayoutTest methodsFor: 'scatterplot' stamp: 'Alexandre Bergel 10/20/2009 11:42'!
testScatterplotLayoutBoundsWithUpSideDown
	"
	self debug: #testScatterplotLayoutBoundsWithUpSideDown
	"
	| view nodes |
	view := MOViewRenderer new.
		
	view node: #foo forIt: [
		view layout: (MOScatterplotLayout new 
							x: #first ;
							y: #last;
							upSideDown).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.

! !

!MOLayoutTest methodsFor: 'scatterplot' stamp: 'JeanRemyFalleri 7/16/2010 11:48'!
testScatterplotLayoutOffset
	
	| view nodes |
	view := MOViewRenderer new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40))
		using: MORectangleShape withBorder.
	view layout: (MOScatterplotLayout new 
						offset: 2;
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 12.
	self assert: nodes first bounds topLeft y = 22.

	self assert: nodes last bounds topLeft x = 32.
	self assert: nodes last bounds topLeft y = 42.
! !

!MOLayoutTest methodsFor: 'scatterplot' stamp: 'Alexandre Bergel 3/7/2010 13:26'!
testScatterplotLayoutScalled

	| view nodes |
	view := MOViewRenderer new.
		
	view node: #foo forIt: [
		view layout: (MOScatterplotLayout new 
							x: #first ;
							y: #last
							;
							scaledToWidth: 20;
							scaledToHeight: 15 ).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 6.
	self assert: nodes first bounds topLeft y =  7.

	self assert: nodes last bounds topLeft x = 20.
	self assert: nodes last bounds topLeft y = 15.

! !

!MOLayoutTest methodsFor: 'loops' stamp: 'Alexandre.Bergel 3/29/2009 18:23'!
testSimpleLoop
	
	| view |
	view := MOViewRenderer new.
	view nodes: #(1 2 3 4).
	view
		edge: 1 -> 2
		from: #key
		to: #value.
	view
		edge: 2 -> 3
		from: #key
		to: #value.
	view
		edge: 3 -> 4
		from: #key
		to: #value.
	view
		edge: 4 -> 2
		from: #key
		to: #value.
	view treeLayout.
! !

!MOLayoutTest methodsFor: 'sort-block' stamp: ' 29/3/09 10:47'!
testSortBlockA
	
	| a b list |
	a := #a -> (SortedCollection with: 1 with: 4 with: 7).
	b := #b -> (SortedCollection with: 3 with: 8).
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: a;
		add: b.
	self assert: list first key = #b.
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: b;
		add: a.
	self assert: list first key = #b! !

!MOLayoutTest methodsFor: 'sort-block' stamp: ' 29/3/09 10:47'!
testSortBlockB
	
	| a b list |
	a := #a -> (SortedCollection with: 3 with: 4 with: 9).
	b := #b -> (SortedCollection with: 1 with: 5 with: 9).
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: a;
		add: b.
	self assert: list first key = #b.
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: b;
		add: a.
	self assert: list first key = #b! !

!MOLayoutTest methodsFor: 'sort-block' stamp: ' 29/3/09 10:47'!
testSortBlockC
	
	| a b list |
	a := #a -> (SortedCollection with: 3 with: 3).
	b := #b -> (SortedCollection with: 3 with: 3).
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: a;
		add: b.
	self assert: list first key = #a.
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: b;
		add: a.
	self assert: list first key = #b! !

!MOLayoutTest methodsFor: 'sort-block' stamp: ' 29/3/09 10:47'!
testSortBlockD
	
	| a b list |
	a := #a -> (SortedCollection with: 3 with: 3).
	b := #b -> (SortedCollection with: 3).
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: a;
		add: b.
	self assert: list first key = #a.
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: b;
		add: a.
	self assert: list first key = #a! !

!MOLayoutTest methodsFor: 'sort-block' stamp: ' 29/3/09 10:47'!
testSortBlockE
	
	| a b list |
	a := #a
		->
			((SortedCollection new)
				add: 2;
				add: 3;
				add: 4;
				add: 7;
				yourself).
	b := #b
		->
			((SortedCollection new)
				add: 2;
				add: 3;
				add: 5;
				add: 7;
				yourself).
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: a;
		add: b.
	self assert: list first key = #b.
	list := SortedCollection sortBlock: MOSortBlock new.
	list
		add: b;
		add: a.
	self assert: list first key = #b! !

!MOLayoutTest methodsFor: 'spring layout' stamp: 'AlexandreBergel 9/6/2010 18:39'!
testSpringLayout1
	| view nodes layout edge node1 node2 |
	view := MOViewRenderer new.
"
	view interaction 
		every: 10 do: [ :v | view layout doExecute: view root. view updateWindow ].
"
	view shape rectangle size: 15.
	nodes := view nodes: #(1 2).
	edge := view edge: nil from: 1 to: 2.
	layout := MOSpringLayout new.
	view layout: (layout).

	"view layout doExecute: view root"

	view root applyLayout.
	window := view open.

	node1 := nodes first.
	node2 := nodes second.	
	self assert: (layout hookeAttractionFor: node1 and: edge) = (layout hookeAttractionFor: node2 and: edge) negated.
	self assert: (layout coulombRepulsion: node1 and: node2) = (layout coulombRepulsion: node2 and: node1) negated.
! !

!MOLayoutTest methodsFor: 'spring layout' stamp: 'Alexandre Bergel 3/15/2010 18:34'!
testSpringLayout2
	| view nodes edges layout edge node1 node2 |
	view := MOViewRenderer new.
"
	view interaction 
		every: 30 do: [ :v | view layout doExecute: view root. view updateWindow ].
"
	view shape rectangle size: 15.
	nodes := view nodes: (1 to: 5).
	edge := view edges: ((2 to: 5) collect: [:v | 1 -> v]) from: #key to: #value.
	layout := MOSpringLayout new.
	view layout: (layout).

	"view layout doExecute: view root"

	view root applyLayout.
	window := view open.

"
	10 timesRepeat: [ view layout doExecute: view root. view updateWindow ].
"

"	node1 := nodes first.
	node2 := nodes second.	
	self assert: (layout hookeAttractionFor: node1 and: edge) = ( 0.1@0.0).
	self assert: (layout hookeAttractionFor: node2 and: edge) = ( -0.1@0.0).
	self assert: (layout coulombRepulsion: node1 and: node2).
	self halt.
"! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'tg 7/25/2010 14:44'!
testToPosition
	
	| view handle |
	view := MOViewRenderer new.
	view nodes: #(1 2 3).
	handle := view
		edge: 1 -> 2
		from: #key
		to: #value.
	view
		layout:
			(MOVerticalNarrowTreeLayout new toPositions:
					#(#rightCenter #leftCenter #topCenter #bottomCenter)).
	window := view open.
	self
		assert:
			handle value toPositions =
					#(#rightCenter #leftCenter #topCenter #bottomCenter)! !

!MOLayoutTest methodsFor: 'test layout' stamp: 'Alexandre.Bergel 4/10/2009 20:24'!
testTransparentEdges
	
	| view edges model |
	model := MOTestModel new.
	view := MOViewRenderer new.
	view
		nodes: model allNodes
		using:
			(MORectangleShape new width: 60; height: 60 "fixedWidth: 60 fixedHeight: 60").
	edges := view
		localEdges: model allEdges
		from: [:entity | entity first]
		to: [:entity | entity last]
		using: model shapeForEdge.
	window := view open.
	self assert: edges value size = model allEdges size.
	view layout: MOTreeMapLayout new.
	view root deepApplyLayout.
	edges value do: [:edge | self deny: edge isVisible].
	view layout: MOTreeLayout new.
	view root deepApplyLayout.
	edges value do: [:edge | self assert: edge isVisible]! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:36'!
testVerticalLineLayout
	| shape view nodes |
	view := MOViewRenderer new.

	shape := MORectangleShape new width: #yourself; height: #yourself.
	shape fillColor: Color blue.
	view shape: shape.
	nodes := view nodes: #(10 30 50).
	view verticalLineLayout alignment: #center.
	
	window := view open.

	self assert: nodes first bounds = (25@5 corner: 35@15).
	self assert: nodes second bounds = (15@25 corner: 45@55).	
	self assert: nodes third bounds = (5@65 corner: 55@115).
	! !

!MOLayoutTest methodsFor: 'line layout' stamp: 'AlexandreBergel 9/6/2010 18:38'!
testVerticalLineLayout2
	| shape view nodes |
	view := MOViewRenderer new.

	shape := MORectangleShape new width: #yourself; height: #yourself.
	shape fillColor: Color blue.
	view shape: shape.
	nodes := view nodes: #(10 30 50).
	view verticalLineLayout alignment: #right.
	
	window := view open.

	self assert: nodes first bounds = (45@5 corner: 55@15).
	self assert: nodes second bounds = (25@25 corner: 55@55).	
	self assert: nodes third bounds = (5@65 corner: 55@115).
	
! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'Alexandre Bergel 2/23/2010 17:07'!
testVerticalLineLayoutStretchHorizontally
	| view bigNode smallNode1 smallNode2 |

	view := MOViewRenderer new.

view shape rectangle width: 50; height: 30.
bigNode := view node: #abc forIt: [
	view shape rectangle width: 50; height: 30.
	smallNode1 := view node: #foo.
	view shape rectangle width: 20; height: 30.
	smallNode2 := view node: #bar.
	view verticalLineLayout stretchHorizontally
].

	window := view open.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #bounds) = {5@5 corner: 65@85. 5@5 corner: 55@35. 5@45 corner: 55@75}.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #absoluteBounds) =  {5@5 corner: 65@85. 10@10 corner: 60@40. 10@50 corner: 60@80}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'Alexandre Bergel 2/23/2010 18:22'!
testVerticalLineLayoutStretchHorizontallyNested
	| view bigNode smallNode1 smallNode2 |

	view := MOViewRenderer new.

view shape rectangle width: 50; height: 30.
bigNode := view node: #abc forIt: [
	smallNode1 := view node: #foo forIt: [
		view shape rectangle width: 50; height: 30.
		view node: #foofoo.
	].
	view shape rectangle width: 20; height: 30.
	smallNode2 := view node: #bar.
	view verticalLineLayout stretchHorizontally
].


	window := view open.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #bounds) =  {5@5 corner: 75@95. 5@5 corner: 65@45. 5@55 corner: 65@85}.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #absoluteBounds) =  {5@5 corner: 75@95. 10@10 corner: 70@50. 10@60 corner: 70@90}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'Alexandre Bergel 2/23/2010 19:01'!
testVerticalLineLayoutStretchHorizontallyNestedNested
	| view bigNode smallNode1 smallNode2 smallNode3 |

	view := MOViewRenderer new.

view shape rectangle width: 30.
bigNode := view node: #foo forIt: [
	smallNode1 := view node: #a.
	smallNode2 := view node: #b forIt: [ 
		smallNode3 := view node: #c.
		view verticalLineLayout stretchHorizontally
	].
	view verticalLineLayout stretchHorizontally
].

	window := view open.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #bounds) =   {5@5 corner: 35@45. 5@5 corner: 25@10. 5@20 corner: 25@35}.

	self assert: ({bigNode . smallNode1 . smallNode2} collect: #absoluteBounds) = {5@5 corner: 35@45. 10@10 corner: 30@15. 10@25 corner: 30@40}.
	
	self assert: (smallNode3 bounds = ( 5@5 corner: 15@10)).
	self assert: (smallNode3 absoluteBounds = ( 15@30 corner: 25@35))! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:36'!
testVerticalLineLayoutStretchHorizontallyNestedNoHorizontalGap

	| view smallNode smallInnerNodes |
	view := MOViewRenderer new.

view nodes: #('test test') forEach: [:nod |
	view shape: (MORectangleShape new text: [:meth | meth asString]; width: 200; height: 40; borderColor: Color gray).
	view node: nod.
	view shape:  (MORectangleShape new borderColor: Color green).
	smallNode := view node: nod forIt:[
			view shape rectangle withoutBorder.view node: nod.
			view shape: (MORectangleShape new borderWidth: 2; borderColor: Color red).
			view node: nod.
			view horizontalLineLayout gapSize:1;stretch].
	view verticalLineLayout 
		"gapSize:1"
		verticalGap: 0;
		horizontalGap: 0;
		verticalOutGap: 0;
		horizontalOutGap: 0;
		stretch].
view gridLayout.

	window := view open.

	self assert: (smallNode bounds = ( 0@40 corner: 200@47)).
	self assert: (smallNode absoluteBounds = ( 5@45 corner: 205@52)).
	smallInnerNodes := smallNode nodes.
	self assert: (smallInnerNodes size = 2).

	self assert: (smallInnerNodes collect: #bounds) asArray =  {(1@1 corner: 99@6). (101@1 corner: 199@6)}.
	
	self assert: (smallInnerNodes collect: #absoluteBounds) asArray =  {(6@46 corner: 104@51). (106@46 corner: 204@51)}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:37'!
testVerticalLineLayoutStretchHorizontallyNoHorizontalGap

	| view smallNodes smallNode1 |
	view := MOViewRenderer new.

	view shape rectangle width: 400.
	view node: #foo forIt: [
		smallNodes := view nodes: (1 to: 5).
		view verticalLineLayout horizontalGap: 0; stretchHorizontally
	].

	window := view open.

	self assert: (smallNodes collect: #bounds) =  {5@5 corner: 395@10. 5@20 corner: 395@25. 5@35 corner: 395@40. 5@50 corner: 395@55. 5@65 corner: 395@70}.

	self assert: (smallNodes collect: #absoluteBounds) = {10@10 corner: 400@15. 10@25 corner: 400@30. 10@40 corner: 400@45. 10@55 corner: 400@60. 10@70 corner: 400@75}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:38'!
testVerticalLineLayoutStretchHorizontallyNoHorizontalOutGap

	| view smallNodes smallNode1 |
	view := MOViewRenderer new.

	view shape rectangle width: 400.
	view node: #foo forIt: [
		smallNodes := view nodes: (1 to: 5).
		view verticalLineLayout horizontalOutGap: 0; stretchHorizontally
	].

	window := view open.

	self assert: (smallNodes collect: #bounds) = {0@5 corner: 400@10. 0@20 corner: 400@25. 0@35 corner: 400@40. 0@50 corner: 400@55. 0@65 corner: 400@70}.

	self assert: (smallNodes collect: #absoluteBounds) = {5@10 corner: 405@15. 5@25 corner: 405@30. 5@40 corner: 405@45. 5@55 corner: 405@60. 5@70 corner: 405@75}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:37'!
testVerticalLineLayoutStretchVertically
	| view bigNode smallNodes |

	view := MOViewRenderer new.

	view shape rectangle height: 200.
	bigNode := view node: #foo forIt: [
		smallNodes := view nodes: (1 to: 5).
		view verticalLineLayout stretchVertically
	].

	window := view open.

	self assert: (bigNode bounds) height = 200.

	self assert: (smallNodes collect: #absoluteBounds) = {10@10 corner: 15@40. 10@50 corner: 15@80. 10@90 corner: 15@120. 10@130 corner: 15@160. 10@170 corner: 15@200}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:38'!
testVerticalLineLayoutStretchVerticallyNoHorizontalGap
	| view bigNode smallNodes |

	view := MOViewRenderer new.

view shape rectangle height: 200.
bigNode := view node: #foo forIt: [
	smallNodes := view nodes: (1 to: 5).
	view verticalLineLayout horizontalGap: 0; stretchVertically
].

	window := view open.

	self assert: (bigNode bounds) height = 200.

	self assert: (smallNodes collect: #absoluteBounds) = {10@10 corner: 15@40. 10@50 corner: 15@80. 10@90 corner: 15@120. 10@130 corner: 15@160. 10@170 corner: 15@200}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:36'!
testVerticalLineLayoutStretchVerticallyNoVerticalGap
	| view bigNode smallNodes |

	view := MOViewRenderer new.

view shape rectangle height: 200.
bigNode := view node: #foo forIt: [
	smallNodes := view nodes: (1 to: 5).
	view verticalLineLayout verticalGap: 0; stretchVertically
].

	window := view open.

	self assert: (bigNode bounds) height = 200.

	self assert: (smallNodes collect: #absoluteBounds) = {10@10 corner: 15@48. 10@48 corner: 15@86. 10@86 corner: 15@124. 10@124 corner: 15@162. 10@162 corner: 15@200}! !

!MOLayoutTest methodsFor: 'line layout - strech' stamp: 'AlexandreBergel 9/6/2010 18:39'!
testVerticalLineLayoutStretchVerticallyNoVerticalOutGap
	| view bigNode smallNodes |

	view := MOViewRenderer new.

	view shape rectangle height: 200.
	bigNode := view node: #foo forIt: [
		smallNodes := view nodes: (1 to: 5).
		view verticalLineLayout verticalOutGap: 0; stretchVertically
	].

	window := view open.

	self assert: (bigNode bounds) height = 200.

	self assert: (smallNodes collect: #absoluteBounds) = {10@5 corner: 15@37. 10@47 corner: 15@79. 10@89 corner: 15@121. 10@131 corner: 15@163. 10@173 corner: 15@205}! !

MondrianTestCase subclass: #MONewFormsBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MONewFormsBuilderTest class methodsFor: 'history' stamp: 'simon.denier 7/6/2009 16:39'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testErrorBounds; add: #testSimpleWithComposedRectangle; add: #testArrowedEdges; add: #testSimple2; add: #testSimple; add: #testErrorShape; add: #testFormsShape; add: #testSimple2FormsShape; add: #testLayout; add: #testSimpleWithLabel; add: #testViewAndBuilder; yourself)); add: (#timeStamp->'6 July 2009 4:38:46 pm' asTimeStamp); add: (#failures->((Set new))); add: (#errors->((Set new))); yourself)! !

!MONewFormsBuilderTest methodsFor: 'arrowed edges' stamp: 'Alexandre Bergel 7/26/2010 12:33'!
testArrowedEdges
	| view |
	view := MOViewRenderer new.
	view nodes: {1 . 2}.
	
	view shape: (MOStraightLineShape new).
	view edges: {1 . 2} from: 1 to: 2.	
	self shouldnt: [window := view open. window delete] raise: Error.
	
	view edgeShape: (MOArrowedLineShape new).
	view edges: {1 . 2} from: 1 to: 2.
	self shouldnt: [window := view open. window changed. window delete] raise: Error.
	window := view open.! !

!MONewFormsBuilderTest methodsFor: 'test - errors' stamp: 'Alexandre.Bergel 2/1/2009 10:07'!
testErrorBounds
	"We create a 'small' builder, and we add element at an outside location"

	"The size of the builder is 1x1"
	| builder shape |
	builder := MOFormsBuilder new.
	builder column; center; pref.
	builder row; pref.
	
	shape := MORectangleShape new.
	
	self shouldnt: [builder x: 1 y: 1 add: shape] raise: Error.
	self should: [builder x: 2 y: 1 add: shape] raise: Error.	
	self should: [builder x: 1 y: 2 add: shape] raise: Error.	
	self should: [builder x: 2 y: 2 add: shape] raise: Error.	! !

!MONewFormsBuilderTest methodsFor: 'test - errors' stamp: 'Alexandre.Bergel 2/1/2009 10:09'!
testErrorShape
	"Only shape must be added in a form builder"

	| builder shape |
	
	self deny: (Object new isShape).
	self assert: (MORectangleShape new isShape).
	
	builder := MOFormsBuilder new.
	builder column; center; pref.
	builder row; pref.
	
	shape := Object new.
	
	self shouldnt: [builder x: 1 y: 1 add: shape] raise: Error.
	self should: [builder x: 2 y: 1 add: shape] raise: Error.	
	self should: [builder x: 1 y: 2 add: shape] raise: Error.	
	self should: [builder x: 2 y: 2 add: shape] raise: Error.	! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'AlexandreBergel 9/6/2010 18:41'!
testFormsShape
	
	| builder view shape rectangle firstAdaptor |
	rectangle := MORectangleShape width: [:each | 10] height: [:each | 15] fillColor: Color blue.
	builder := MOFormsBuilder new.
	builder column; center; pref.
	builder row; pref.
	builder x: 1 y: 1 add: rectangle.
	shape := builder shape.
	view := MOViewRenderer new.
	view node: #node using: shape.

	self assert: (shape class == MOFormsShape).
	self assert: (shape builder == builder).
	self assert: ((shape builder shapes collect: [:sh | sh class]) asArray = {MOShapeAdaptor }).
	
	"Adaptor for the rectangle shape"
	firstAdaptor := shape builder shapes first.
	self assert: (firstAdaptor component class == MORectangleShape ).
! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'Alexandre.Bergel 3/29/2009 12:11'!
testLayout
	"This test ensure that applying layouts does not raise exception"
	| view layouts |
	layouts := {MOCircleLayout . MOGridLayout . MOBottomFlowLayout . MOTreeLayout . MORadialTreeLayout . MOForceBasedLayout}.
	
	view := MOViewRenderer new.
	view nodes: (1 to: 10).
	view edgesFrom: [:each | each * each].
	
	"we iterate over different layout"
	layouts do: [:l|
		view layout: l new.
		self shouldnt: [window := view open. window delete] raise: Error.
		]	! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'Alexandre.Bergel 4/3/2009 15:35'!
testSimple
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape width: 10 height: 15 fillColor: Color blue.
	builder := MOFormsBuilder new.
	builder column; center; pref.
	builder row; pref.
	builder x: 1 y: 1 add: rectangle.
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.

	self assert: (figure bounds) =
					(Rectangle
						origin: 0 @ 0
						width: 10
						height: 15).

	window := view open.
	self assert: (figure bounds) =
					(Rectangle
						origin: 5 @ 5
						width: 10
						height: 15).
	self assert: (shape collectAllShapes size = 2).
! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'Alexandre.Bergel 2/24/2009 15:36'!
testSimple2
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape width: [:each | 10] height: [:each | 15] fillColor: Color blue.
	builder := MOFormsBuilder new.
	builder column; center; pref.
	builder row; pref.
	builder x: 1 y: 1 add: rectangle.
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.

	self assert: (shape boundsFor: figure) =
					(Rectangle
						origin: 0 @ 0
						width: 10
						height: 15).

	window := view open.
	self assert: (shape boundsFor: figure) =
					( 5@5 extent: 10@15).
	
	"A form shape and a rectangle shape is contained"
	self assert: (shape collectAllShapes size = 2).
! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'AlexandreBergel 9/6/2010 18:41'!
testSimple2FormsShape
	
	| builder view shape firstAdaptor secondAdaptor rectangleShape labelShape |
	builder := MOFormsBuilder new.
	builder column; center.
	builder row; pref; row; pref.
	builder x: 1 y: 1 add: (rectangleShape := MORectangleShape width: 10 height: 15 fillColor: Color blue).
	builder x: 1 y: 1 add: (labelShape := (MORectangleShape new withoutBorder; withText) text: [:entity | 'Hello']).
	shape := builder shape.
	view := MOViewRenderer new.
	view node: #bouba using: shape.

	self assert: (shape class == MOFormsShape).
	self assert: (shape builder == builder).
	self assert: ((shape builder shapes collect: [:sh | sh class]) asArray = {MOShapeAdaptor . MOShapeAdaptor}).
	
	"Adaptor for the rectangle shape"
	firstAdaptor := shape builder shapes first.
	self assert: (firstAdaptor component class == MORectangleShape ).
	
	"Adaptor for the children shape???? What the hell is that"
	secondAdaptor := shape builder shapes second.
	self assert: (secondAdaptor component class == MORectangleShape ).

	"Adaptor for the children shape"
"	thirdAdaptor := shape builder shapes third.
	self assert: (thirdAdaptor component class == MOChildrenShape ).
	self assert: (thirdAdaptor component parent isNil ).
	self assert: ((thirdAdaptor component instVarNamed: 'next') isNil ).
"	
	window := view open.

	"Adaptor for the children shape"
"	thirdAdaptor := shape builder shapes third.
	self assert: (thirdAdaptor component class == MOChildrenShape ).
	self assert: (thirdAdaptor component parent isNil ).
	self assert: ((thirdAdaptor component instVarNamed: 'next') isNil ).
"
! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'Alexandre.Bergel 2/22/2009 22:54'!
testSimpleWithComposedRectangle
	
	| builder view shape figure rectangle |
	rectangle := MORectangleShape width: 10 height: 15 fillColor: Color blue.
	builder := MOFormsBuilder new.
	builder column; left; column; left.
	builder row; left; row; left.
	builder x: 1 y: 1 add: rectangle.
	builder x: 2 y: 1 add: (rectangle copy fillColor: Color green).
	builder x: 1 y: 2 add: (rectangle copy fillColor: Color red).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #node using: shape.

	"The shape has a reference to itself"						
	self assert: (shape collectAllShapes size = 4).
	self assert: (shape collectAllShapes first  == shape).
	self assert: (shape collectAllShapes noneSatisfy: [:s | s isKindOf: MOShapeAdaptor]).

	"Before we open the window"
	self assert: (figure bounds) =
					(Rectangle
						origin: 0@0
						width: 20
						height: 30).


	window := view open.
	"After we have openend the window"
	self assert: (figure bounds) =
					(Rectangle
						origin: 5 @ 5
						width: 20
						height: 30).! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'Alexandre Bergel 6/16/2010 22:21'!
testSimpleWithLabel
	
	| builder view shape figure rectangleShape labelShape |
	builder := MOFormsBuilder new.
	builder column; center.
	builder row; pref; row; pref.
	builder x: 1 y: 1 add: (rectangleShape := MORectangleShape width: 10 height: 15 fillColor: Color blue).
	builder x: 1 y: 2 add: (labelShape := (MORectangleShape new withoutBorder; withText) text: [:entity | 'Hello']).
	shape := builder shape.
	view := MOViewRenderer new.
	figure := view node: #bouba using: shape.
			
	self assert: (shape collectAllShapes size = 3).
	self assert: (shape collectAllShapes first  == shape).
	self assert: (shape collectAllShapes noneSatisfy: [:s | s isKindOf: MOShapeAdaptor]).

	self assert: (shape collectAllShapes anySatisfy: [:s | s == labelShape]).
	self assert: (shape collectAllShapes anySatisfy: [:s | s == rectangleShape]).


	"Before we open the window"
	self assert: (figure bounds) = ( 0@0 corner: (labelShape widthFor: figure)@(15 + (labelShape heightFor: figure ))).

	"After we open the window"
	window := view open.
	self assert: (figure bounds) = ( 5@5 extent: (labelShape widthFor: figure)@(15 + (labelShape heightFor: figure ))).
! !

!MONewFormsBuilderTest methodsFor: 'test' stamp: 'Alexandre.Bergel 3/28/2009 18:45'!
testViewAndBuilder
	
	| builder view figure |
	view := MOViewRenderer new.
	view node: #node forIt: [
		builder := MOFormsBuilder new.
		builder column; center; pref.
		builder row; pref.
		builder x: 1 y: 1 add: (view node: #blah forIt: [view nodes: (1 to: 5)]).

		"view layout: builder asLayout"
	].

	window := view open.
	figure := view root nodes first.
	self assert: figure bounds = (5@5 corner: 90@30)! !

MondrianTestCase subclass: #MOSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOSerializationTest methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 7/26/2010 12:19'!
testXML
	| view stream content |
	view := MOViewRenderer new.
	view shape rectangle 
		width: [:m | m asInteger - $a asInteger * 20 ];
		height: [:m | (m asInteger - $a asInteger * 20) + 10].
	view nodes: {$a . $b . $c}.
	view edges: {$a -> $b . $b -> $c . $c -> $a} from: #key to: #value.
	
	stream := WriteStream on: String new.
	self assert: (stream isEmpty).
	view canvas exportAsXMLOn: stream.
	self deny: (stream isEmpty).
	content := stream contents.

	self assert: (content = 
'<graph>
	<node id="1" name="$a width ="5" height ="10""/>
	<node id="2" name="$b width ="20" height ="30""/>
	<node id="3" name="$c width ="40" height ="50""/>
	<edge source="1" target= "2"/>
	<edge source="2" target= "3"/>
	<edge source="3" target= "1"/>
</graph>
')! !

MondrianTestCase subclass: #MOViewRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOViewRendererTest class methodsFor: 'history' stamp: 'simon.denier 7/6/2009 16:39'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testTranslation; add: #testSubview3; add: #testCloseContainment2; add: #testTranslation2; add: #testStetch2; add: #testCache2; add: #testDragging3; add: #testStetch; add: #testCenter2; add: #testCloseContainment3; add: #testEdges; add: #testSubview4; add: #testDefaultFontFamily; add: #testCenter; add: #testLabel1; add: #testSize; add: #testNodesForEach; add: #testSubview5; add: #testScope2; add: #testLabel2; add: #testPositionsEdges; add: #testCloseContainment; add: #testZoomWithSubview; add: #testDragging; add: #testNodes; add: #testTranslationUsingEvent; add: #testSubview1; add: #testAllChildrenDo; add: #testScope3; add: #testLabel3; add: #testUnExistingEdge; add: #testScope; add: #testZoom; add: #testNodeForItWith; add: #testSubview2; add: #testFigureSelection; add: #testScope4; add: #testLabel4; add: #testCache; add: #testCache1; add: #testDragging2; add: #testNestedEdges; yourself)); add: (#timeStamp->'6 July 2009 4:38:46 pm' asTimeStamp); add: (#failures->((Set new))); add: (#errors->((Set new))); yourself)! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'Alexandre.Bergel 5/25/2009 15:23'!
TODOtestResize
	| view nodes semaphore |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 20) forEach: [:each  | view nodes: (1 to: 100). view gridLayout].

	self assert: (nodes allSatisfy: [:each | each hasCachedForm not]).  

	window := view open.
	
	semaphore := Semaphore new.
	[(Delay forSeconds: 2) wait. semaphore signal] fork.
	semaphore wait.
	"(Delay forSeconds: 2) wait."

	self assert: (nodes first hasCachedForm).  
	
	window extent: 300@500.
	self assert: (nodes allSatisfy: [:each | each hasCachedForm not]).  ! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 4/24/2010 17:06'!
TOFIXtestUpdateNodeAndSubview
	| view nodes |
	view := MOViewRenderer new.
	nodes := view nodes: {1 . 10 . 20} forEach: [:each|
		view shape rectangle size: 20.
		view interaction 
			whenEnteringUpdateNode: [:node | 
				view nodes: (1 to: node).
				view edges: (1 to: node) from: #yourself to: [ :v | v \\ 3] fromGlobal: false toGlobal: false.
				view treeLayout.
				view updateWindow ] 
			whenLeavingUpdateNode:  [:node | ]  
			withLayoutUpdate: true.
		view node: each].

	window := view open.
	
	self assert: (nodes first bounds = ( 5@5 corner: 35@35)).
	nodes first announce: (MOMouseEnter new).
	self assert: (nodes first bounds ~= ( 5@5 corner: 35@35)).
! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 9/6/2010 18:31'!
covers: oneArgBlock for: aSymbol
	| types |
	types := self perform: aSymbol.
	types do: [:c | 
		self shouldnt: [oneArgBlock value: (self createInstanceOf: c)] raise: Error ]
	! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 09:49'!
createInstanceOf: aClass
	aClass isMeta
		ifTrue: [ ^ aClass theNonMetaClass ].
		
	^ aClass initializedInstance
! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 21:57'!
notExecutetestNoError
	| view |
	view := MOViewRenderer new.
	
	self covers: [:shape | view nodes: (1 to: 100) using: shape] for: #typeOfMOViewRendererNodesUsing.
	self covers: [:shape | view node: #foo using: shape] for: #typeOfMOViewRendererNodeUsing.
	self covers: [:shape | view node: #foo using: shape forIt: [view node: $y]] for: #typeOfNodeUsingForIt.	
	
	self 
		covers: 
			[:shape | view nodes: (1 to: 5) using: shape forEach: [:each | view node: $a]] 
		for: #typeOfMOViewRendererNodesUsingForEach.
	
	self covers: 
		[:shape | view edges: (1 to: 5) from: #yourself toAll: (1 to: 5) using: shape fromGlobal: true toGlobal: true ] for: #typeOfEdgesFromToAllUsingFromGlobalToGlobal.

	self covers: 
		[:shape | view edge: (1) from: #yourself to: (2) using: shape ] for: #typeOfEdgeFromToUsing.

	self covers: 
		[:shape | view edges: (1 to: 5) from: #yourself to: 1 using: shape ] for: #typeOfEdgesFromToUsing. 

	self covers: 
			[:shape | view edges: (1 to: 5) from: #yourself toAll: (1 to: 5) using: shape ] 
		for: #typeOfEdgesFromToAllUsing. 


	self covers: [ :announcement | view announce: announcement ] for: #typeOfMOViewRendererAnnounce.
	
	self covers: 
		[ :layout | 
			view layout: layout.
			window := view open.
			window delete ] for: #typeOfMOViewRendererlayout! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 5/10/2010 18:37'!
testAllEdgesConnectedToMe
	| view nodes allEdges |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 5).
	view edges: (2 to: 5) from: #yourself to: 1.

	allEdges := nodes first allEdgesConnectedToMe.
	self assert: (allEdges size = 4 ).
	
	allEdges first remove.
	self assert: (nodes first allEdgesConnectedToMe size = 3 ).! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 12/7/2009 23:09'!
testAllNodesDo
	| view sum |
	view := MOViewRenderer new.
	view nodes: #(1 10) forEach: [:each |
		view node: 2].
	
	sum := 0.
	view root allNodesDo: [:aNode | sum := sum + aNode model].
	self assert: (sum = 15)! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 7/26/2010 12:23'!
testAsMorph
	| view morph |
	view := MOViewRenderer new.
	view nodes: #(1 10) forEach: [:each |
		view node: 2].
	morph := view asMorph.
	self assert: (morph isMorph).
	self assert: (morph class == MOCanvas).! !

!MOViewRendererTest methodsFor: 'attributes' stamp: 'AlexandreBergel 9/16/2010 09:26'!
testAttributes
	| view nodes firstNode |
	view := MOViewRenderer new.
	view interaction on: MOElementSelection do: [:ann | ann element attributeAt: #foo  put: 'zork' ].
	nodes := view nodes: (1 to: 50).
	
	firstNode := nodes first.
	self deny: (firstNode hasAttribute: #foo).
	self should: [ firstNode attributeAt: #foo ] raise: Error.

	firstNode attributeAt: #foo put: 50.
	self shouldnt: [ firstNode attributeAt: #foo ] raise: Error.
	self assert: (firstNode attributeAt: #foo) = 50.
	
	firstNode removeAttribute: #foo.
	self deny: (firstNode hasAttribute: #foo).
	
	firstNode announce: (MOElementSelection event: nil on: firstNode).
	self assert: (firstNode hasAttribute: #foo).
	self assert: (firstNode attributeAt: #foo) = 'zork'.
	

	self deny: (firstNode hasAttribute: #zork).
	self assert: (firstNode attributeAt: #zork ifAbsent: [30]) = 30.
	self assert: (firstNode attributeAt: #zork ifAbsentPut: [20]) = 20.

	self assert: (firstNode hasAttribute: #zork).
	self assert: (firstNode attributeAt: #zork) = 20.

	firstNode attributeAt: #zorzor put: true.
	firstNode removeAttributesMatching: 'zor*'.
	self deny: (firstNode hasAttribute: #zork).
	self deny: (firstNode hasAttribute: #zorzor).! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'AlexandreBergel 9/6/2010 18:32'!
testBasic
	| view node1 node2 form form2 canvas2 |
	view := MOViewRenderer new.
	node1 := view node: #foo forIt: [
		node2 := view node: #bar 
	].
	view root applyLayout.

	self assert: (node1 bounds = ( 5@5 corner: 20@20)).
	self assert: (node2 bounds = ( 5@5 corner: 10@10)).


	form := view getRenderedForm. 
	
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
			frameAndFillRectangle: ( 5@5 extent: 15@15)
				fillColor: Color white
				borderWidth: 1
				borderColor: Color black.
	canvas2 
				frameAndFillRectangle: (10@10 extent: 5@5)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.

	self assert: form bits = form2 bits
! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testBasic2
	| view node1 node2 form canvas form2 canvas2 node3 |
	view := MOViewRenderer new.
	node1 := view node: #foo forIt: [
		node2 := view node: #bar forIt: [
			node3 := view node: #zork.
		]
	].
	view root applyLayout.

	self assert: (node1 bounds = ( 5@5 corner: 30@30)).
	self assert: (node2 bounds = ( 5@5 corner: 20@20)).
	self assert: (node3 bounds = ( 5@5 corner: 10@10)).

	form := view getRenderedForm. 
		
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
				frameAndFillRectangle: ( 5@5 extent: 25@25)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.
	canvas2 
				frameAndFillRectangle: (10@10 extent: 15@15)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.

	canvas2 
				frameAndFillRectangle: (15@15 extent: 5@5)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.

	self assert: form bits = form2 bits
! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'Alexandre Bergel 7/18/2010 15:52'!
testBasic3

	| view bounds form canvas form2 canvas2 node1 node2 node3 node4 |
	view := MOViewRenderer new.
	node1 := view node: 10 forIt: [
		node2 := view node: #foo forIt: [
			node3 := view node: #foo forIt: [
				node4 := view node: 1]].

		view verticalLineLayout ].
	view root applyLayout.

	self assert: (node1 bounds = ( 5@5 corner: 40@40)).
	self assert: (node2 bounds = ( 5@5 corner: 30@30)).
	self assert: (node3 bounds = ( 5@5 corner: 20@20)).
	self assert: (node4 bounds = ( 5@5 corner: 10@10)).
	
	form := view getRenderedForm. 
	
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
				frameAndFillRectangle: ( 5@5 extent: 35@35)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.
	canvas2 
				frameAndFillRectangle: (10@10 extent: 25@25)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.

	canvas2 
				frameAndFillRectangle: (15@15 extent: 15@15)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.

	canvas2 
				frameAndFillRectangle: (20@20 extent: 5@5)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.
	
	self assert: form bits = form2 bits
! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'ab 5/12/2009 22:23'!
testCache1

	| view edge bounds form canvas |
	view := MOViewRenderer new.
	view nodes: (1 to: 2).
	edge := view edge: #(a) from: [:each | 1 ] to: [:each | 2].
	window := view open.
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	view root displayOn: canvas.

	self assert: edge cacheFromPoint notNil.
	self assert: edge cacheToPoint notNil.
	
	view root displayOn: canvas.
	
	self assert: edge cacheFromPoint notNil.
	self assert: edge cacheToPoint notNil.
	! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'Alexandre Bergel 6/7/2010 18:28'!
testCache2
	|view size nodes bounds form canvas |
	view := MOViewRenderer new.
	size := 10.
	nodes := view nodes: (1 to: size) forEach: [:each | view nodes: (1 to: size)].
	view edges: (1 to: size) from: #yourself toAll: (1 to: size).

	"Before to do a display, we make sure that no bitmap was created"
	self assert: (nodes allSatisfy: [:node | node hasCachedForm not]).

	view root applyLayout.
	bounds := view root bounds.

	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	view root displayOn: canvas.
	self assert: ((nodes select: [:n | n bounds origin x < 10000])
						anySatisfy: [:node | node hasCachedForm]).! !

!MOViewRendererTest methodsFor: 'attributes' stamp: 'AlexandreBergel 8/22/2010 20:59'!
testCacheInNodes
	| t view nullCanvas |
	t := 0.
	"With cache"
	view := MOViewRenderer new.
	view shape rectangle size: [:v | t := t + 1. v].
	view nodes: (1 to: 20).
	
	nullCanvas := CountingNullCanvas new.
	self assert: t = 0.
	view root displayOn:  nullCanvas.
	self assert: t = 40.
	view root displayOn:  nullCanvas.
	self assert: t = 40.
	
	"---------------"
	"Without cache"
	t := 0.
	view := MOViewRenderer new.
	view shape rectangle size: [:v | t := t + 1. v]; disableCache.
	view nodes: (1 to: 20).
	
	nullCanvas := CountingNullCanvas new.
	self assert: t = 0.
	view root displayOn:  nullCanvas.
	self assert: t = 120.
	view root displayOn:  nullCanvas.
	self assert: t = 120.
	! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testCacheIsEffective

	| view edge bounds form canvas node nullCanvas |
	view := MOViewRenderer new.
	node := view node: #(b) forIt: [
		view nodes: (1 to: 2).
		edge := view edge: #(a) from: [:each | 1 ] to: [:each | 2]].
	view root applyLayout.

	"three nodes and one edge are displayed "
	view root resetFormCacheResursively.

	self assert: (node externalEdges isEmpty).
	self assert: (view root externalEdges isEmpty).
	
	"Check if the edge is among the elements to be displayed"
	self assert: (view root elementsToDisplay includes: edge).
	self assert: (view root elementsToLookup includes: edge).
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	nullCanvas := CountingNullCanvas new.
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	
	self deny: (node hasCachedForm).

	view root displayOn: canvas.
	self assert: (node hasCachedForm).

	"Check if the edge is among the elements to be displayed"
"	self assert: (view root elementsToDisplay includes: edge).
	self assert: (view root elementsToLookup includes: edge).
"
	
	view root displayOn: nullCanvas.
	"Only one rectangle is displayed, the root, which is the white background"
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	"Only one image is displayed, the cache of #b"
	self assert: nullCanvas numberOfImages = 1.
	
	"If we display once more, the cache should be rendered"
	view root displayOn: nullCanvas.
	self assert: (node hasCachedForm).
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	self assert: nullCanvas numberOfImages = 2.

	"a third time"
	view root displayOn: nullCanvas.
	self assert: (node hasCachedForm).
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	self assert: nullCanvas numberOfImages = 3.
! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'AlexandreBergel 9/6/2010 18:33'!
testCacheIsEffective2

	| view bounds form canvas node nullCanvas nodes |
	view := MOViewRenderer new.
	nodes := view nodes: {$a . $b . $c} forEach: [ :each|
		view node: #foo forIt: [
			view nodes: (1 to: 200).
			view gridLayout gapSize: 1 ]
	].
	node := nodes first.
	view root applyLayout.
	
	"three nodes and one edge are displayed "
	view root resetFormCacheResursively.

	self assert: (node bounds = ( 5@5 corner: 134@99)).
	self assert: (node externalEdges isEmpty).
	self assert: (view root externalEdges isEmpty).
	
	self assert: (view root elementsToDisplay size =   606).
	self assert: (view root elementsToLookup size = 606).
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	nullCanvas := CountingNullCanvas new.
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	
	self deny: (node hasCachedForm).
	view root displayOn: canvas.

	self assert: (view root elementsToDisplay size =  3).
	self assert: (view root elementsToLookup size = 606).

	node resetFormCache.
	self assert: (view root elementsToDisplay size =  606).

	"We simulate the cache"
	nodes do: [ :n |  
		n cacheCanvas: canvas. 
		n updateOwner ]. 
	self assert: (node hasCachedForm).
	
	view root displayOn: canvas.
	self assert: (view root elementsToDisplay size =  3).
	node select.
	self assert: (view root elementsToDisplay size =  606).
	
	node announce: (MOMouseDrag step: 1@2).

	self assert: (view root elementsToDisplay size =  606).
	"We simulate the display"
	nodes do: [ :n |  
		n cacheCanvas: canvas. 
		n updateOwner ]. 
	self assert: (view root elementsToDisplay size =  3).

	view root displayOn: nullCanvas.
	self assert: (nodes allSatisfy: #hasCachedForm).
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfImages = 3.
	
	"If we display once more, the cache should be rendered"
	view root displayOn: nullCanvas.
	self assert: (node hasCachedForm).
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfImages = 6.

	"a third time"
	view root displayOn: nullCanvas.
	self assert: (node hasCachedForm).
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfImages = 9.
! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'Alexandre Bergel 7/15/2010 21:56'!
testCacheIsEffective3

	| view edge step bounds form canvas node nullCanvas |
	view := MOViewRenderer new.
	view node: 1 forIt: [view node: 1 forIt: [view node: 1 forIt: []]].
	view root applyLayout.

	nullCanvas := CountingNullCanvas new.
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	

	view root displayOn: nullCanvas.
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	"Only one image is displayed, the cache of #b"
	self assert: nullCanvas numberOfImages = 1.
	
	"If we display once more, the cache should be rendered"
	view root displayOn: nullCanvas.
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	self assert: nullCanvas numberOfImages = 2.

	"a third time"
	view root displayOn: nullCanvas.
	self assert: nullCanvas numberOfRectangles = 0.
	self assert: nullCanvas numberOfLines = 0.
	self assert: nullCanvas numberOfImages = 3.
! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 7/14/2010 09:42'!
testCachedShape
	self assert: MONode new shape isCached.
	self assert: MOEdge new shape isCached.
	
	self assert: MORectangleShape new isCached.
	self assert: (MOShape defaultNodeShapeInstance isCached)! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 9/26/2009 21:43'!
testCanvas
	| view |
	view := MOViewRenderer new.
	self assert: (view canvas notNil).
	self assert: (view canvas isKindOf: MOCanvas).! !

!MOViewRendererTest methodsFor: 'canvas' stamp: 'AlexandreBergel 9/6/2010 17:15'!
testCanvasSize
	| view canvas scrollPane v wishedWindowBounds |
	
	view := MOViewRenderer new.
	view shape rectangle width: 40; height: 30.
	view node: #foo.
	
	self assert: (view root bounds = ( 0@0 corner: 40@30)).
	
	view root applyLayout.
	self assert: (view root bounds = ( 0@0 corner: 45@35)).
	
	window := view open.
	wishedWindowBounds :=  13@182 corner: 763@562.
	window doLayoutIn: wishedWindowBounds.
	
	canvas := window findDeeplyA: MOCanvas.
	scrollPane := window findDeeplyA: ScrollPane.
	v := scrollPane extent.
	self assert: v >= (700@300).
	self assert: (canvas bounds = (0@0 corner: 45@35)).
	"self assert: canvas extent = scrollPane extent"! !

!MOViewRendererTest methodsFor: 'canvas' stamp: 'AlexandreBergel 9/6/2010 17:15'!
testCanvasSize2
	| view canvas scrollPane v wishedWindowBounds |
	
	view := MOViewRenderer new.
	view shape rectangle width: 5; height: 5.
	view node: #foo.
	
	self assert: (view root bounds = ( 0@0 corner: 5@5)).
	
	view root applyLayout.
	self assert: (view root bounds = ( 0@0 corner: 10@10)).
	
	window := view open.
	wishedWindowBounds :=  13@182 corner: 763@562.
	window doLayoutIn: wishedWindowBounds.
	
	canvas := window findDeeplyA: MOCanvas.
	scrollPane := window findDeeplyA: ScrollPane.
	v := scrollPane extent.
	self assert: v >= (700@300).
	self assert: (canvas bounds = ( 0@0 corner: 10@10)).
	"self assert: canvas extent = scrollPane extent"! !

!MOViewRendererTest methodsFor: 'canvas' stamp: 'AlexandreBergel 9/6/2010 17:15'!
testCanvasSize3
	| view canvas scrollPane v wishedWindowBounds node |
	
	view := MOViewRenderer new.
	view node: 1 forIt: [
		view shape rectangle size: 30.
		view node: 2 ].
	
	window := view open.
	wishedWindowBounds :=  13@182 corner: 763@562.
	window doLayoutIn: wishedWindowBounds.
	
	canvas := window findDeeplyA: MOCanvas.
	scrollPane := window findDeeplyA: ScrollPane.
	v := scrollPane extent.
	self assert: v >= (700@300).
	self assert: (canvas bounds = ( 0@0 corner: 45@45)).
	
	node := view nodeForDomainValue: 1.
	node announce: ((MOMouseDrag event: nil on: node) step: -100 @ -100).
	self assert: (canvas bounds = ( 0@0 corner: 45@45)).! !

!MOViewRendererTest methodsFor: 'canvas' stamp: 'AlexandreBergel 9/6/2010 10:13'!
testCanvasStretch
	| view canvas scrollPane v wishedWindowBounds |
	
	view := MOViewRenderer new.
	window := view open.
	
	self assert: (view root bounds = ( 0@0 corner: 5@5)).
	view root expandToIncludePoint: 100@30.
	self assert: (view root bounds = ( 0@0 corner: 100@30)).
	
	view root expandToIncludePoint: 10@20.
	self assert: (view root bounds = ( 0@0 corner: 100@30)).! !

!MOViewRendererTest methodsFor: 'centered and stretch' stamp: 'Alexandre Bergel 6/11/2010 08:26'!
testCenter
	| view nodes |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new width: #yourself; height: #yourself).
	nodes := view nodes: #(10 100).
	view layout: (MOHorizontalLineLayout new center).
	window := view open.

	self assert: (nodes first bounds = (5@50 corner: 15@60)).
	self assert: (nodes second bounds = (25@5 corner: 125@105)).! !

!MOViewRendererTest methodsFor: 'centered and stretch' stamp: 'Alexandre.Bergel 4/24/2009 18:46'!
testCenter2
	| view nodes |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new width: #yourself; height: #yourself).
	nodes := view nodes: #(10 100).
	view layout: (MOVerticalLineLayout new center).
	window := view open.
	
	self assert: (nodes first bounds = ( 50@5 corner: 60@15)).
	self assert: (nodes second bounds = ( 5@25 corner: 105@125)).! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'Alexandre Bergel 8/9/2010 17:51'!
testChildrenShape
	| builder formShape |
	self deny: MORectangleShape default canHandleChildren.
	self deny: MOFormsShape default canHandleChildren.
	
	builder := MOFormsBuilder new.
	builder column; row.
	builder x: 1 y: 1 add: MOChildrenShape new.
	formShape := builder asShape.
	self assert: formShape canHandleChildren.

! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 9/6/2010 18:32'!
testChildrenShapeBounds

	| view umlClassShape node1 node2 |
	view := MOViewRenderer new.

	umlClassShape := MOChildrenShape new.
	view nodeShape: umlClassShape.
	node1 := view node: 10 forIt: [ view nodes: (1 to: 5)].

	node2 := view node: 10 forIt: [ view nodes: (1 to: 5)].

	view root applyLayout.

	self assert: ((node2 shape computeExtentHavingChildrenFor: node2) = ( 75@15)).
	self assert: (node2 bounds = ( 90@5 corner: 165@20)).

	self assert: ((node1 shape computeBoundsFor: node1) = ( 0@0 corner: 75@15)).
	self assert: ((node1 shape computeExtentHavingChildrenFor: node1) = ( 75@15)).
	self assert: (node1 bounds = ( 5@5 corner: 80@20))! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testChildrenShapeBounds2
	| view childrenShape node2 node1 builder formShape innerNodes |
	view := MOViewRenderer new.

	childrenShape := MOChildrenShape new.
	builder := MOFormsBuilder new.
	builder column; row.
	builder x: 1 y: 1 add: childrenShape.
	formShape := builder asShape.
	view shape: formShape.
	node1 := view node: 10 forIt: [ innerNodes := view nodes: (1 to: 5)].

	view root applyLayout.

"	self assert: (node1 shapeBounds size = 1).
	self assert: (node1 shapeBounds keys includesAllOf: {formShape}).
"
	self assert: (formShape builder widthsFor: node1) = #(75).
	self assert: (formShape builder heightsFor: node1) = #(15).

	self deny: (formShape builder shapes includes: childrenShape).
	self assert: ((node1 shape computeBoundsFor: node1) = ( 0@0 corner: 75@15)).
	self assert: ((node1 shape computeExtentFor: node1) = ( 75@15)).

	"We are now testing the dictionary that contains the shapes"
	self assert: (node1 shapeBounds size = 2).
	self assert: (node1 shapeBounds keys includesAllOf: {childrenShape . formShape}).

	self assert: ((node1 shape boundsFor: node1) = ( 5@5 corner: 80@20)).
	self assert: (node1 bounds = ( 5@5 corner: 80@20)).
	
	"---------"
	"We check inner nodes"
	self assert: (innerNodes size = 5).
	"The height of the node is 15. An inner node can therefore not move more than 15 pixels vertically"
	self assert: (innerNodes first getBoundedTranslationStep: 76@16) =  ( 65@5).! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'tg 2/12/2010 23:35'!
testCloseContainment
	"A subnode cannot escape its enclosing object by dragging it"
	| view bigNode smallNode |
	view := MOViewRenderer new.
	bigNode := view node: #abc forIt: [
		smallNode := view node: #bar ].
	
	window := view open.

	self assert: bigNode bounds = (5@5 corner: 20@20).
	self assert: smallNode bounds = (5@5 corner: 10@10).
	
	view announce: ((MOMouseDrag event: nil on: smallNode) step: 100 @ 40).
	self assert: (smallNode bounds  = (10@10 corner: 15@15))! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 6/11/2010 08:25'!
testCloseContainment2
	"A subnode cannot escape its enclosing object by dragging it"
	| view bigNode smallNode |
	view := MOViewRenderer new.
	bigNode := view node: #abc forIt: [
		smallNode := view node: #bar].
	
	window := view open.

	self assert: bigNode bounds = (5@5 corner: 20@20).
	self assert: smallNode bounds = (5@5 corner: 10@10).
	
	view announce: ((MOMouseDrag event: nil on: smallNode) step: -100 @ -40).
	self assert: (smallNode bounds = (0@0 corner: 5@5))! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'jannik.laval 5/15/2009 14:41'!
testCloseContainment3
	"A subnode cannot escape its enclosing object by dragging it"
	| view bigNode smallNode |
	view := MOViewRenderer new.
	bigNode := view node: #abc forIt: [
		smallNode := view node: #bar].
	
	window := view open.

	self assert: bigNode bounds = (5@5 corner: 20@20).
	self assert: smallNode bounds = (5@5 corner: 10@10).
	
	view announce: ((MOMouseDrag event: nil on: smallNode) step: 5 @ 5).
	view announce: ((MOMouseDrag event: nil on: smallNode) step: 5 @ 5).
	view announce: ((MOMouseDrag event: nil on: smallNode) step: 5 @ 5).
	view announce: ((MOMouseDrag event: nil on: smallNode) step: 5 @ 5).
	view announce: ((MOMouseDrag event: nil on: smallNode) step: 5 @ 5).
	self assert: (smallNode bounds = (10@10 corner: 15@15))! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 3/8/2010 15:51'!
testConditionalColor
	"
	self debug: #testConditionalColor
	"
	| view nodes |
	view := MOViewRenderer new.
	view shape rectangle 
			if: #odd fillColor: Color red.
	
	nodes := view nodes: (1 to: 10).

	
	self assert: (nodes first shape fillColorFor: nodes first) == Color red.
	self assert: (nodes second shape fillColorFor: nodes second) == Color white.

	view shape rectangle 
			if: #odd fillColor: Color blue;
			if: [:el | el even ] fillColor: Color yellow.
	
	nodes := view nodes: (1 to: 10).
	self assert: (nodes first shape fillColorFor: nodes first) == Color blue.
	self assert: (nodes second shape fillColorFor: nodes second) == Color yellow.

! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 23:28'!
testCoverage
	| view |
	view := MOViewRenderer new.
	
	self covers: [:shape | view nodes: (1 to: 100) using: shape] for: #typeOfMOViewRendererNodesUsing.
	self covers: [:shape | view node: #foo using: shape] for: #typeOfMOViewRendererNodeUsing.
	self covers: [:shape | view node: #foo using: shape forIt: [view node: $y]] for: #typeOfNodeUsingForIt.	
	
	self 
		covers: 
			[:shape | view nodes: (1 to: 5) using: shape forEach: [:each | view node: $a]] 
		for: #typeOfMOViewRendererNodesUsingForEach.
	
	self covers: 
		[:shape | view edges: (1 to: 5) from: #yourself toAll: (1 to: 5) using: shape fromGlobal: true toGlobal: true ] for: #typeOfEdgesFromToAllUsingFromGlobalToGlobal.

	self covers: 
		[:shape | view edge: (1) from: #yourself to: (2) using: shape ] for: #typeOfEdgeFromToUsing.

	self covers: 
		[:shape | view edges: (1 to: 5) from: #yourself to: 1 using: shape ] for: #typeOfEdgesFromToUsing. 

	self covers: 
			[:shape | view edges: (1 to: 5) from: #yourself toAll: (1 to: 5) using: shape ] 
		for: #typeOfEdgesFromToAllUsing. 


	self covers: [ :announcement | view announce: announcement ] for: #typeOfMOViewRendererAnnounce.
	
	window := view open! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 23:28'!
testCoverageLayout
	| view |
	view := MOViewRenderer new.
	
	view nodes: (1 to: 100).
	view edges: (1 to: 100) from: #yourself to: [:x | x + 1].
	
	self covers: 
		[ :layout | 
			view layout: layout.
			window := view open.
			window delete ] for: #typeOfMOViewRendererlayout! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 4/14/2010 09:02'!
testDashedLines

	| view edge1 edge2 edge3 edge4 |
	view := MOViewRenderer new.
	
	view shape rectangle size: 15.
	view nodes: (1 to: 5).
	
	view shape arrowedDashedLine width: 3.
	edge1 := view edge: 1 -> 2 from: #key to: #value.

	view shape dashedLine.
	edge2 := view edge: 2 -> 3 from: #key to: #value.

	view shape dashedLine dashLengths: {5 . 2}; width: 4.
	edge3 := view edge: 2 -> 4 from: #key to: #value.

	view shape dashedLine dashLengths: {1 . 0}; width: 4.
	edge4 := view edge: 2 -> 5 from: #key to: #value.

	view treeLayout.
	
	window := view open.
	self assert: edge1 shape isDashed.
	self assert: edge1 shape isArrowed.
	
	self assert: edge2 shape isDashed.
	self deny: edge2 shape isArrowed.	

	self assert: edge3 shape isDashed.
	self deny: edge3 shape isArrowed.

	"edge 4 is not dashed since its the space between dashes is 0"
	self deny: edge4 shape isDashed.
	self deny: edge4 shape isArrowed.

	! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'jannik.laval 5/15/2009 11:56'!
testDefaultFontFamily

	| shape v |
	shape := MORectangleShape new.
	v := shape fontFamilyFor: MONode new.
	self assert: v notNil.
	self assert: v = shape class defaultFont familyName.! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 9/26/2009 14:19'!
testDefaultLayout
	| view |
	view := MOViewRenderer new.
	view nodes: #(1 10) forEach: [:each |
		view node: 2].
	
	self assert: (view layout notNil).
	self assert: (view layout isKindOf: MOHorizontalLineLayout).! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 6/17/2010 12:23'!
testDefaultShapeForEdges

	self deny: (MOShape isDefaultLineShape).

	self assert: (MOEdge new shape notNil).
	self assert: (MOEdge new shape isKindOf: MOLineShape).
	self assert: (MOEdge new shape == MOShape defaultLineShapeInstance).! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 6/26/2010 13:31'!
testDefaultShapeInstance
	| view edge lineShape nodeShape |
	view := MOViewRenderer new.
	self assert: (view defaultNodeShapeInstance isNil).
	self assert: (view defaultLineShapeInstance isNil).
	
	"View is not aware of the default nodes"
	view node: 10.
	view node: 11.
	edge := view edges: {10 -> 11} from: #key to: #value.
	self assert: ((view nodeForDomainValue: 10) shape isKindOf: MOShape defaultNodeShapeClass).
	self assert: (edge first shape isKindOf: MOShape defaultLineShapeClass).
	
	view shape: nil.

	"View is aware of the default nodes"
	view defaultLineShapeInstance: (lineShape := MOStraightLineShape new width: 3; color: Color red).
	view defaultNodeShapeInstance: (nodeShape := MORectangleShape new fillColor: Color blue).
	self assert: (view nodeShape == nodeShape).
	self assert: (view edgeShape == lineShape).
	self assert: (view nodeShape == nodeShape).

	view node: 12.
	view node: 13.
	self assert: (view nodeShape == nodeShape).
	edge := view edges: {12 -> 13} from: #key to: #value.
	
	self assert: (view nodeShape == nodeShape).
	
	self assert: ((view nodeForDomainValue: 12) shape == nodeShape).
	self assert: ((view nodeForDomainValue: 13) shape == nodeShape).
	self assert: (edge first shape == lineShape).

! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'jannik.laval 7/13/2010 16:46'!
testDefaultShapeNode

	self deny: (MOShape isDefaultNodeShape).
	
	self assert: (MONode new shape notNil).
	self assert: (MONode new shape isKindOf: MONodeShape).
	self assert: (MONode new shape == MOShape defaultNodeShapeInstance).
	
	self assert: (MONode defaultNodeShapeClass == MORectangleShape).
	self assert: (MOEdge defaultLineShapeClass == MOStraightLineShape).
! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/6/2010 18:45'!
testDiamondAndTriangleShapes
	| view node1 node2 node3 diamondNodes triangleNodes |
	view := MOViewRenderer new.

	view shape diamond height: 30; width: 15; fillColor: Color lightBlue.
	diamondNodes := view nodes: (1 to: 10).

	view shape triangle height: 30; width: 15; fillColor: Color lightGreen.
	triangleNodes := view nodes: (1 to: 10).
		
	window := view open.

	self assert: (diamondNodes first bounds =  (5@5 corner: 20@35)).
	self assert: (triangleNodes first bounds = (255@5 corner: 270@35)).
! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testDisplayingFormsShape

	| builder childrenShape titleShape view form formShape node |
	view := MOViewRenderer new.
	childrenShape := MOChildrenShape new.
	titleShape := MORectangleShape new text: 'Title'.
	builder := MOFormsBuilder new.
	builder column; center; fill; pref; grow.
	builder row; center; pref; fill; grow; row; center; fill; pref; grow.
	builder x: 1 y: 1 add: titleShape.
	builder x: 1 y: 2 add: childrenShape.
	formShape := builder asShape.

	view nodeShape: formShape.
	node := view node: 1 forIt: [
		view nodes: (1 to: 2) ].
	
	view root applyLayout.

	form := view getRenderedForm.

	self assert: (formShape builder widthsFor: node) =  #(30.0).
	self assert: (formShape builder heightsFor: node) = #(15.0 15.0).

	self assert: (formShape builder boundsOf: titleShape) = ( 0@0 corner: 30@15).
	self assert: (formShape builder boundsOf: childrenShape) = ( 0@15 corner: 30@30).
! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'AlexandreBergel 9/5/2010 11:45'!
testDragAndDrop
	 | view nodes classes |


	view := MOViewRenderer new.
	view shape rectangle size: 20.
	view interaction action: #inspect.
	view interaction 
		whenEnteringUpdateNode: [:node | 
			view interaction forwarder.
			view nodes: (1 to: 20).
				view interaction forwarder.
			view edgesFrom: [:v | v \\ 3]..
			view treeLayout
			] 
		whenLeavingUpdateNode:  [:node | ]  
		withLayoutUpdate: false.
	nodes := view nodes: #(a b c).
	
	window := view open.
	
	self assert: view root allNodes size = 3.
	
	self assert: nodes first bounds =  (5@5 corner: 25@25).
	nodes first announce: MOMouseEnter new.
	self assert: nodes first bounds =  ( 5@5 corner: 156.0@45).
	self assert: view root allNodes size > 3.
	
	nodes first announce: (MOMouseDrag new step: 80@40).
	self assert: nodes first bounds =  ( 85@45 corner: 236.0@85).

	self deny: nodes first isSelected.
	nodes first announce: (MOElementSelection new).
	self assert: nodes first isSelected.
		
	nodes first announce: (MOMouseLeave new).
	self assert: nodes first bounds =  (85@45 corner: 105@65).
	self assert: view root allNodes size = 3.! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'ab 5/12/2009 22:17'!
testDragging

	| view nodes edge p1 p2 step bounds form canvas |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 2).
	edge := view edge: #(a) from: [:each | 1 ] to: [:each | 2].
	window := view open.
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	view root displayOn: canvas.

	p1 := edge cacheFromPoint.
	p2 := edge cacheToPoint.
	step := 1@2.
	nodes do: [:node |
		view announce: ((MOMouseDrag event: nil on: node) step: step)].
	
	view root displayOn: canvas.
	
	self assert: p1 + step = edge cacheFromPoint.
	self assert: p2 + step = edge cacheToPoint.

	! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'Alexandre Bergel 1/23/2010 11:28'!
testDragging2

	| view edge step bounds form canvas node |
	view := MOViewRenderer new.
	node := view node: #(b) forIt: [
		view nodes: (1 to: 2).
		edge := view edge: #(a) from: [:each | 1 ] to: [:each | 2]].
	window := view open.
	view root resetFormCacheResursively.
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	view root displayOn: canvas.

	step := 1@2.
	view announce: ((MOMouseDrag event: nil on: node) step: step).

	view root displayOn: canvas.
	
"	self assert: edge cacheFromPoint isNil.
	self assert: edge cacheToPoint isNil.
"	
	
	view root resetFormCacheResursively.
	view root displayOn: canvas.
	
	self assert: edge cacheFromPoint notNil.
	self assert: edge cacheToPoint notNil.
	! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 1/23/2010 17:56'!
testDragging3

	| view edge p1 p2 step bounds form canvas node t |
	view := MOViewRenderer new.
	node := view node: #(b) forIt: [
		view node: #(c) forIt: [
			view nodes: (1 to: 2).
			edge := view edge: #(a) from: [:each | 1 ] to: [:each | 2]]].
	window := view open.
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	view root resetFormCacheResursively.
	view root displayOn: canvas.

	p1 := edge cacheFromPoint.
	p2 := edge cacheToPoint.
	step := 1@2.
	
	t := OrderedCollection new.
	node withAllNodesDo: [:n | t add: n absoluteBounds ].
	self assert: (t asArray = {5@5 corner: 45@30. 10@10 corner: 40@25. 15@15 corner: 20@20. 30@15 corner: 35@20}).
	
	view announce: ((MOMouseDrag event: nil on: node) step: step).

	t := OrderedCollection new.
	node withAllNodesDo: [:n | t add: n absoluteBounds ].
	self assert: (t asArray =  {6@7 corner: 46@32. 11@12 corner: 41@27. 16@17 corner: 21@22. 31@17 corner: 36@22}).

	view root resetFormCacheResursively.
	view root displayOn: canvas.
	
	self assert: p1 + step = edge cacheFromPoint.
	self assert: p2 + step = edge cacheToPoint.
	! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 7/17/2010 08:55'!
testDraggingAndSubviews
	| view subnodes edge |

	view := MOViewRenderer new.
	view shape rectangle width: 70; height: 60.
	view node: 10 forIt: [
		view shape rectangle size: 30.
		subnodes := view nodes: #('a' 'b').
		edge := view edge: 'a' -> 'b' from: 'a' to: 'b' ].
	window := view open.

	self assert: (subnodes collect: #bounds) =  {5@5 corner: 35@35. 45@5 corner: 75@35}.
	self assert: ((edge shape getAttachPointsFor: edge) =  {40@25. 50@25}).
	self assert: ((edge shape computeAttachPointsFor: edge source and: edge target) = 
						{40@25. 50@25}).
	self assert: (subnodes noneSatisfy: #isSelected).

	self assert: (subnodes collect: #absoluteBounds) =   {10@10 corner: 40@40. 50@10 corner: 80@40}.
	self assert: ((edge shape getAttachPointsFor: edge) = {40@25. 50@25}).
	
	"We trigger a drag and drop"
	subnodes second announce: ((MOMouseDrag event: nil on: subnodes second) step: 5@5).

	"So the cache of the attach point much be set of nil"
	self deny: edge isCacheLoaded.

	self assert: (subnodes collect: #absoluteBounds) =  {10@10 corner: 40@40. 55@15 corner: 85@45}.

	self assert: (subnodes collect: #bounds) =  {5@5 corner: 35@35. 50@10 corner: 80@40}.
	self assert: ((edge shape computeAttachPointsFor: edge source and: edge target) =  {40@25. 55@30}).
	self assert: ((edge shape getAttachPointsFor: edge) = {40@25. 55@30}).

	self assert: (subnodes noneSatisfy: #isSelected).
! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testDraggingAndSubviews2
	| view edge xNode edges wishedWindowBounds innerNodes outerNode bounds form canvas |

	view := MOViewRenderer new.
	outerNode := view node: #outer forIt: [
		xNode := view node: #x forIt: [
			innerNodes := view nodes: (1 to: 32).
			edges := view edgesFrom: [:x | x // 10 ].
			view treeLayout ] ].

	self assert: (edges noneSatisfy: #isCacheLoaded).
	
	view root applyLayout.
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	view root displayOn: canvas.
	
	self assert: (outerNode isCacheLoaded).
	self deny: (xNode isCacheLoaded).
	
"	window := view open."

	"We force a refresh to active the edge cache"
	"wishedWindowBounds :=  13@182 corner: 763@562.
	window doLayoutIn: wishedWindowBounds."


	edges do: [ :ed | ed shape getAttachPointsFor: ed ].
	self assert: (edges allSatisfy: #isCacheLoaded).

	
	self assert: (xNode absoluteBounds = ( 10@10 corner: 249.0@50)).
	self assert: (xNode allNodes 
						allSatisfy: [:n | xNode absoluteBounds containsRect: n absoluteBounds ]).

	self assert: (xNode allEdges 
						allSatisfy: [:n | xNode absoluteBounds containsRect: n absoluteBounds ]).


	self assert: (xNode getBoundedTranslationStep: 20@30) = ( 5.0@5).

	xNode announce: (MOMouseDrag new step: 20@30).

	self assert: (xNode absoluteBounds = ( 15.0@15 corner: 254.0@55)).
	self assert: (xNode allNodes 
						allSatisfy: [:n | xNode absoluteBounds containsRect: n absoluteBounds ]).
	self assert: (xNode allEdges 
						allSatisfy: [:n | xNode absoluteBounds containsRect: n absoluteBounds ]).
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/26/2010 12:23'!
testEdgeContainsPoint
	| view nodes edges domainNodes assoc edge edgeBound root |
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2).
	assoc := 1 -> 2.
	edges := view edges: {assoc} from: #key to: #value.
	window := view open. 
	
	edge := edges anyOne.
	edgeBound := edge shape computeBoundsFor: edge.

	self assert: (edgeBound = ( 10@7 corner: 20@7)).

	"--------"
	"MORoot>>elementAt:"
	root := nodes first root.
	self assert: (root isRoot).
	self assert: (root elementAt: (edge shape computeBoundsFor: edge) center) == edge.
	"--------"
		
	nodes first translateBy: 0@5.

	self assert: (edge shape lineSegmentsFor: edge) size = 1. 
	self assert: (edge shape lineSegmentsFor: edge) first class == LineSegment. 
	self assert: (edge shape lineSegmentsFor: edge) first valueAtStart = ( 10@12). 
	self assert: (edge shape lineSegmentsFor: edge) first valueAtEnd = ( 20@7). 

	edgeBound := edge shape computeBoundsFor: edge.
	self assert: (edgeBound = ( 10@7 corner: 20@12)).

	self assert: (edge shape containsPoint: 7@15 for: edge).
	self assert: (edge shape containsPoint: 7@14 for: edge).
	self assert: (edge shape containsPoint: 7@11 for: edge).
	self deny:   (edge shape containsPoint: 7@10 for: edge).

! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/26/2010 12:23'!
testEdgeContainsPointCurveFitter
	| view nodes edges domainNodes assoc edge edgeBound root |
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2).
	assoc := 1 -> 2.
	view shape curvedLine.
	edges := view edges: {assoc} from: #key to: #value.
	window := view open. 
	
	edge := edges anyOne.
	edgeBound := edge shape computeBoundsFor: edge.

	self assert: (edge shape getAttachPointsFor:  edge) =   {10@7. 20@7}.

	"--------"
	"MORoot>>elementAt:"
	root := nodes first root.
	self assert: (root isRoot).
	self assert: (root elementAt: (edge shape computeBoundsFor: edge) center) == edge.
	"--------"
		
	nodes first translateBy: 0@5.

	self assert: (edge shape lineSegmentsFor: edge) size = 2. 
	self assert: ((edge shape lineSegmentsFor: edge) allSatisfy: [:t | t class == LineSegment ]).
	self assert: (((edge shape lineSegmentsFor: edge) collect: [:line | line valueAtStart -> line valueAtEnd]) =  {(10@12)->(10@11). (10@11)->(20@7)}).


	edgeBound := edge shape computeBoundsFor: edge.
	self assert: (edgeBound = ( 10@7 corner: 20@12)).

	self assert: (edge shape containsPoint: (edgeBound center) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@1)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@2)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@3)) for: edge).
	self deny: (edge shape containsPoint: (edgeBound center + (0@4)) for: edge).
	self deny: (edge shape containsPoint: (edgeBound center + (0@5)) for: edge).
	self deny: (edge shape containsPoint: (edgeBound center - (0@5)) for: edge).

! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/26/2010 12:23'!
testEdgeContainsPointSplineLine
	| view nodes edges domainNodes assoc edge edgeBound root |
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2).
	assoc := 1 -> 2.
	view shape splineLine.
	edges := view edges: {assoc} from: #key to: #value.
	window := view open. 
	
	edge := edges anyOne.
	edgeBound := edge shape computeBoundsFor: edge.

	self assert: (edgeBound = ( 10@7 corner: 20@7)).

	"--------"
	"MORoot>>elementAt:"
	root := nodes first root.
	self assert: (root isRoot).
	self assert: (root elementAt: (edge shape computeBoundsFor: edge) center) == edge.
	"--------"
		
	nodes first translateBy: 0@5.

	self assert: (edge shape lineSegmentsFor: edge) size = 3. 
	self assert: ((edge shape lineSegmentsFor: edge) allSatisfy: [:t | t class == LineSegment ]).
	self assert: (((edge shape lineSegmentsFor: edge) collect: [:line | line valueAtStart -> line valueAtEnd]) =  {(10@12)->(10@11).( 10@11)->(18@10). (18@10)->(20@7)}).


	edgeBound := edge shape computeBoundsFor: edge.
	self assert: (edgeBound = ( 10@7 corner: 20@12)).

	self assert: (edge shape containsPoint: (edgeBound center) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@1)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@2)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@3)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@4)) for: edge).
	self deny: (edge shape containsPoint: (edgeBound center + (0@5)) for: edge).
	self deny: (edge shape containsPoint: (edgeBound center - (0@5)) for: edge).

! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testEdgeContainsPointVerticalOrthogonalLine
	| view nodes edges assoc edge edgeBound root |
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2).
	assoc := 1 -> 2.
	view shape verticalOrthogonalLine.
	edges := view edges: {assoc} from: #key to: #value.
	window := view open. 
	
	edge := edges anyOne.
	edgeBound := edge shape computeBoundsFor: edge.

	self assert: (edgeBound = ( 10@7 corner: 20@7)).

	"--------"
	"MORoot>>elementAt:"
	root := nodes first root.
	self assert: root isRoot.
	self assert: (nodes first isNotRoot).
	self assert: (root elementAt: (edge shape computeBoundsFor: edge) center) == edge.
	"--------"
		
	nodes first translateBy: 0@5.

	self assert: (edge shape lineSegmentsFor: edge) size = 3. 
	self assert: ((edge shape lineSegmentsFor: edge) allSatisfy: [:t | t class == LineSegment ]).
	self assert: (((edge shape lineSegmentsFor: edge) collect: [:line | line valueAtStart -> line valueAtEnd]) = {(7@15)->(7@10). (7@10)->(22@10). (22@10)->(22@5)}).


	edgeBound := edge shape computeBoundsFor: edge.
	self assert: (edgeBound = ( 10@7 corner: 20@12)).

	self assert: (edge shape containsPoint: (edgeBound center) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@1)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@2)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@3)) for: edge).
	self assert: (edge shape containsPoint: (edgeBound center + (0@4)) for: edge).
	self deny: (edge shape containsPoint: (edgeBound center + (0@5)) for: edge).
	self deny: (edge shape containsPoint: (edgeBound center - (0@5)) for: edge).

! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/26/2010 12:24'!
testEdgeContainsPointWithEdges
	| view nodes edges domainNodes assoc edge edgeBound root |
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2).
	assoc := 1 -> 2.
	view shape line width: [:el | el key + el value].
	edges := view edges: {assoc} from: #key to: #value.
	window := view open. 
	
	edge := edges anyOne.
	edgeBound := edge shape computeBoundsFor: edge.

	self assert: (edgeBound = ( 10@7 corner: 20@7)).

	"--------"
	"MORoot>>elementAt:"
	root := nodes first root.
	self assert: (root isRoot).
	self assert: (root elementAt: (edge shape computeBoundsFor: edge) center) == edge.
	"--------"
		
	nodes first translateBy: 0@5.

	self assert: (edge shape lineSegmentsFor: edge) size = 1. 
	self assert: (edge shape lineSegmentsFor: edge) first class == LineSegment. 
	self assert: (edge shape lineSegmentsFor: edge) first valueAtStart = ( 10@12). 
	self assert: (edge shape lineSegmentsFor: edge) first valueAtEnd = ( 20@7). 

	edgeBound := edge shape computeBoundsFor: edge.
	self assert: (edgeBound = ( 10@7 corner: 20@12)).

	self assert: (edge shape containsPoint: 7@15 for: edge).
	self assert: (edge shape containsPoint: 7@14 for: edge).
	self assert: (edge shape containsPoint: 7@11 for: edge).
	self deny:   (edge shape containsPoint: 7@10 for: edge).

! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre.Bergel 9/26/2009 21:48'!
testEdgeFromTo
	| view edges |
	view := MOViewRenderer new.
	view nodes: (0 to: 9).
	edges := view edgeFrom: #yourself to: [:v | v + 1 \\ 10].
	view circleLayout.
	window := view open.
	self assert: edges size = 10.! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'tg 4/25/2008 09:59'!
testEdges
	| view |
	view := MOViewRenderer new.
	view nodes: #(1 2).
	view edge: 1 from: #yourself to: [:x | x + 1].
	self assert: (view root edges size = 1).
	self assert: (view root edges first source model = 1).
	self assert: (view root edges first target model = 2).! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 5/10/2010 17:45'!
testEdgesFromAllTo
	| view edges |
	view := MOViewRenderer new.
	view nodes: (1 to: 10).
	
	edges := view edges: (1 to: 10) fromAll: [:v | (1 to: v)] to: #yourself.
	view circleLayout.
	window := view open.

	self assert: edges size = 45! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 2/28/2010 22:12'!
testEdgesToAll
	| view edges |
	view := MOViewRenderer new.
	view nodes: (1 to: 20).
	edges := view edgesToAll: [:v | {v + 1 . v + 2. v + 3}].
	view treeLayout.
	window := view open.
	
	self assert: (edges size =  54).
	self assert: (edges first source model = 1).
	self assert: (edges first target model = 2).
	self assert: (edges second source model = 1).
	self assert: (edges second target model = 3).
	self assert: (edges third source model = 1).
	self assert: (edges third target model = 4).
	
	self assert: (edges fourth source model = 2).! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 9/6/2010 18:45'!
testElementAtAndChildrenShape

	| builder childrenShape titleShape view form formShape node innerNodes innerNode form2 canvas2 |

	view := MOViewRenderer new.
	childrenShape := MOChildrenShape new.
	titleShape := MORectangleShape new width: 30 ; height: 15.
	builder := MOFormsBuilder new.
	builder column; center; fill; pref; grow.
	builder row; center; pref; fill; grow; row; center; fill; pref; grow.
	builder x: 1 y: 1 add: titleShape.
	builder x: 1 y: 2 add: childrenShape.
	formShape := builder asShape.

	view nodeShape: formShape.
	node := view node: 10 forIt: [
		innerNodes := view nodes: (1 to: 2) ].

	view root applyLayout.

	form := view getRenderedForm.

	self assert: (node bounds = ( 5@5 corner: 35@35)).
	"on the border"
	self assert: (view root elementAt: (5@5)) == node.

	"in the title"
	self assert: (view root elementAt: (7@7)) == node.

	innerNode := innerNodes first.
	self assert: (innerNode owner == node).

	self assert: (formShape builder boundsOf: titleShape) = ( 0@0 corner: 30@15).	
	self assert: (formShape builder boundsOf: childrenShape) = ( 0@15 corner: 30@30).
	
	self assert: (innerNode shape hasParentShapeFor: innerNode).
	self assert: (innerNode shape computeParentShapeFor: innerNode) == childrenShape.
	self assert: (innerNode shape computeAssociatedBuiderFor: innerNode) == builder.

"	self assert: (innerNode shape boundsFor: innerNode) = ( 5@5 corner: 10@10).	"
	self assert: (innerNode shape absoluteBoundsFor: innerNode) = ( 10@25 corner: 15@30).
	self assert: (innerNode absoluteBounds = ( 10@25 corner: 15@30)).
	self assert: (innerNodes second absoluteBounds = ( 25@25 corner: 30@30)).
	
	
	"We draw in a form"
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
			frameAndFillRectangle: (( 0@0 corner: 30@15) translateBy: 5@5)
			fillColor: Color white
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: ( 10@25 corner: 15@30)
			fillColor: Color white
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: ( 25@25 corner: 30@30)
			fillColor: Color white
			borderWidth: 1
			borderColor: Color black.

	self assert: form bits = form2 bits.
	"-----------"

	"Drag and drop of the node"
	node announce: (MOMouseDrag step: 10 @ 5).
	self assert: (innerNode absoluteBounds = ( 20@30 corner: 25@35)).
	self assert: (innerNodes second absoluteBounds = ( 35@30 corner: 40@35)).
! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 8/29/2010 21:15'!
testElementAtAndChildrenShape2

	| viewA childrenShape builder formShape nodeA view innerNodesA viewB nodeB innerNodesB |
	viewA := MOViewRenderer new.
	childrenShape := MOChildrenShape new.
	builder := MOFormsBuilder new.
	builder column; center; fill; pref; grow.
	builder row; center; pref; fill; grow.
	builder x: 1 y: 1 add: childrenShape.
	formShape := builder asShape.

	viewA nodeShape: formShape.
	nodeA := viewA node: 10 forIt: [
		innerNodesA := viewA nodes: (1 to: 2) ].

	viewA root applyLayout.
	
	"========"
	viewB := MOViewRenderer new.
	nodeB := viewB node: 10 forIt: [
		innerNodesB := viewB nodes: (1 to: 2) ].

	viewB root applyLayout.

	"========"
	self assert: (nodeA shape computeBoundsFor: nodeA) = ( 0@0 corner: 30@15).
	self assert: (nodeB shape computeBoundsFor: nodeB) = ( 0@0 corner: 30@15).
	
	self assert: (nodeA bounds = nodeB bounds).
	self assert: (innerNodesA first bounds = innerNodesB first bounds).
	self assert: (innerNodesA second bounds = innerNodesB second bounds).

	self assert: (innerNodesA first absoluteBounds = innerNodesB first absoluteBounds).
	self assert: (innerNodesA second absoluteBounds = innerNodesB second absoluteBounds).! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'AlexandreBergel 9/5/2010 11:56'!
testElementSelection

	| view node1 node2 t numberOfSelectionEvents |
	view := MOViewRenderer new.
	view nodes: (1 to: 2).

	node1 := view nodeForDomainValue: 1.
	node2 := view nodeForDomainValue: 2.

	t := 0.
	numberOfSelectionEvents := 0.
	node1 announcer
		on: MOElementSelection do: [:ann | numberOfSelectionEvents := numberOfSelectionEvents + 1 ].
	node1 announcer 
		on: MOElementDeselection do: [:ann | t := t + 1 ].
	
	self assert: t isZero.
	self deny: (node1 isSelected).
	self assert: (view root allSelectedNodes isEmpty).
	self assert: (numberOfSelectionEvents = 0).

	node1 announce: (MOElementSelection new).
	self assert: (numberOfSelectionEvents = 1).
	self assert: (view root allSelectedNodes asArray = {node1}).
	self assert: (node1 isSelected).
	self deny: (node2 isSelected).
	self assert: t isZero.
	
	node2 announce: (MOElementSelection new).
	self deny: (node1 isSelected).
	self assert: (node2 isSelected).
	self assert: t = 1.
	
	node1 announce: (MOElementSelection new).
	self assert: (node1 isSelected).
	self deny: (node2 isSelected).
	self assert: t = 2.
	! !

!MOViewRendererTest methodsFor: 'zOrder' stamp: 'Alexandre Bergel 6/7/2010 20:20'!
testElementsToDisplay
	| view |
	view := MOViewRenderer new.
	view nodes: #(a b).
	view edges: {#a -> #b} from: #key to: #value.

	self assert: view root allEdges size = 1. 
	self assert: view root elementsToDisplay size = 3. 

	window := view open.

	view node: #c.
	view edges: {#b-> #c . #a -> #c} from: #key to: #value.

	self assert: view root allEdges size = 3. 
	self assert: view root elementsToDisplay size = 6. 
! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testEllipseShape
	| view node1 node2 node3 |
	view := MOViewRenderer new.

	view shape ellipse width: 100; height: 40.
	node1 := view node: #foo.
	node2 := view node: #bar forIt: [
		view shape ellipse width: 50; height: 20.
		node3 := view node: #zork.
	].
		
	window := view open.

	self assert: (node1 bounds width = 100).
	self assert: (node1 bounds height = 40).
! !

!MOViewRendererTest methodsFor: 'event' stamp: 'Alexandre Bergel 12/17/2009 19:03'!
testEventAndViewRenderer
	| view t |
	view := MOViewRenderer new.
	t := false.
	view interaction on: MOMouseDown do: [:ann | t := (ann viewRenderer == view)].
	view nodes: (1 to: 5).
	view root nodes first announce: (MOMouseDown new).
	self assert: t
	! !

!MOViewRendererTest methodsFor: 'event' stamp: 'Alexandre Bergel 12/28/2009 11:24'!
testEventOnRoot
	"
	self debug: #testEventOnRoot
	"
	| view t nodes morphicEvent |
	t := 0.
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 100).
	view gridLayout.
	view root interaction
		on: MOMouseDown do: [:ann | t := t + 1 ].
	window := view open.

	"We send an event in the middle of  the first two nodes"
	morphicEvent := MouseEvent new  
						setPosition: ((nodes first bounds center + nodes second bounds center) / 2) asIntegerPoint.
	view root announce: (MOMouseDown event:  morphicEvent on: view root).

	self assert: (t = 1)! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/2/2010 14:33'!
testFixedRectangle
	| view form form2 canvas2 |
	view := MOViewRenderer new.
	view shape: (MOFixedRectangleShape new
					width: 25; height: 25;
					withBorder;
					borderColor: Color black).
	view node: 1.

	view shape: (MORectangleShape new
					width: 25; height: 25;
					withBorder;
					borderColor: Color black).
	view node: 2.
	
	view root applyLayout.
	self assert: (view root nodes collect: #bounds) asArray =  {(5@5 corner: 30@30). (40@5 corner: 65@30)}.
	view root increaseZoom.

	"We first check that bounds are okay"
	self assert: (view root nodes first bounds extent  = view root nodes second bounds extent). 
	self assert: (view root nodes collect: #bounds) asArray =  {(5.5@5.5 corner: 33.0@33.0). (44.0@5.5 corner: 71.5@33.0)}.


	"Then, we check if the nodes are displayed properly"
"We draw in a form"
	form := view getRenderedForm.
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
			frameAndFillRectangle: (5.5@5.5 corner: 33.0@33.0)
			fillColor: Color white
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: (44.0@5.5 corner: 71.5@33.0)
			fillColor: Color white
			borderWidth: 1
			borderColor: Color black.

	self assert: form bits = form2 bits.
! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/2/2010 14:35'!
testFixedRectangle2
	| view form form2 canvas2 |
	view := MOViewRenderer new.
	view shape: (MOFixedRectangleShape new
					width: 25; height: 25;
					withBorder;
					borderColor: Color black).
	view node: 1 forIt: [ view nodes: (1 to: 100)].
	
	view root applyLayout.
	self assert: (view root nodes collect: #bounds) asArray =  {(5@5 corner: 30@30)}.
	view root increaseZoom.

	self assert: (view root nodes collect: #bounds) asArray =   {(5.5@5.5 corner: 33.0@33.0)}.
! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testFormsAndTranslateTo

	| viewA childrenShape builder formShape nodeA innerNodesA viewB nodeB innerNodesB |
	viewA := MOViewRenderer new.
	childrenShape := MOChildrenShape new.
	builder := MOFormsBuilder new.
	builder column; center; fill; pref; grow.
	builder row; center; pref; fill; grow.
	builder x: 1 y: 1 add: childrenShape.
	formShape := builder asShape.

	viewA nodeShape: formShape.
	nodeA := viewA node: 10 forIt: [
		innerNodesA := viewA nodes: (1 to: 2) ].
	
	viewA root applyLayout.

	"========"
	self assert: (nodeA bounds = ( 5@5 corner: 35@20)).
	self assert: (innerNodesA first absoluteBounds = ( 10@10 corner: 15@15)).
	self assert: (innerNodesA second absoluteBounds = ( 25@10 corner: 30@15)).
	
	nodeA translateTo: 23@14.
	
	self assert: (nodeA bounds = ( 23@14 corner: 53@29)).
	self assert: (innerNodesA first absoluteBounds = ( 28@19 corner: 33@24)).
	self assert: (innerNodesA second absoluteBounds = ( 43@19 corner: 48@24)).
! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/6/2010 18:45'!
testHorizontalOrthogonalLine
	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: 10).
	view shape horizontalOrthogonalLine.
	view edges: (1 to: 10) from:  1 to: # yourself.
	view horizontalTreeLayout.
	window := view open.

	self assert: (view root nodes collect: #bounds) asArray =  {5@37.0 corner: 10@42.0. 30@5.0 corner: 35@10.0. 30@13.0 corner: 35@18.0. 30@21.0 corner: 35@26.0. 30@29.0 corner: 35@34.0. 30@37.0 corner: 35@42.0. 30@45.0 corner: 35@50.0. 30@53.0 corner: 35@58.0. 30@61.0 corner: 35@66.0. 30@69.0 corner: 35@74.0}! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre.Bergel 9/25/2009 22:06'!
testIncomingEdges
	| view edge |
	view := MOViewRenderer new.
	view nodes: #(10 20).
	view edge: 10 from: #yourself to: 20.
	
	self assert: (view root edges size = 1).

	edge := view root edges first.
	self assert: (edge source model = 10).
	self assert: (edge target model = 20).
	
	self assert: (edge target incomingEdges asArray = {edge}).
	self deny: (edge source hasIncomingEdges).
	self assert: (edge target hasIncomingEdges).! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre.Bergel 9/25/2009 22:23'!
testIncomingEdges2
	| view edges1 |
	view := MOViewRenderer new.

view node: #tr forIt: [
view node: 1 forIt: [ view node: #foo forIt: [view node: #zork1 ] ].
view node: 2 forIt: [ view node: #bar forIt: [view node: #zork2 ]].

].

view node: #tr2 forIt: [
view node: #zork1 .
view node: #zork2 .

edges1 := (view edges: {#zork1 -> #zork2 }  from: #key to: #value fromGlobal: true toGlobal: false).
].

	self assert: (edges1 allSatisfy: [:ed | ed target incomingEdges asArray = {ed} ]).
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 6/7/2010 19:12'!
testIncomingEdgesAndSubviews
	| view edge subnodes |
	view := MOViewRenderer new.
	view shape rectangle width: 70; height: 60.
	view node: 10 forIt: [
		view shape rectangle size: 30.
		subnodes := view nodes: #('a' 'b').
		edge := view edge: 'a' -> 'b' from: 'a' to: 'b'].
	
	window := view open.

	self assert: subnodes first outgoingEdges asArray = { edge }.
	self assert: subnodes first incomingEdges isEmpty.
	self assert: subnodes first allOutcomingEdges asArray = { edge }.
	self assert: subnodes first allIncomingEdges isEmpty.

	self assert: subnodes second outgoingEdges isEmpty.
	self assert: subnodes second incomingEdges asArray = { edge }.
	self assert: subnodes first allOutcomingEdges asArray = { edge }.
	self assert: subnodes first allIncomingEdges isEmpty.
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/26/2010 12:23'!
testInnerEdgeContainsPoint
	| view nodes domainNodes assoc edge edgeBound root |
	view := MOViewRenderer new.

	view shape rectangle size: 50.
	nodes :=view nodes: #(1 2) forEach:[:e |
		view nodes: #(3 4).
		view interaction
			item: 'inspect' action: #inspect.
		edge := view edge: 3->4 from: #key to: #value].

	window := view open. 
	
	edgeBound := edge shape computeBoundsFor: edge.

	self assert: (edgeBound = ( 30@12 corner: 70@12)).

	"--------"
	"Check how many elements"
	self assert: (view root allEdges size = 2).
	self assert: (view root allNodes size = 6).
	self assert: (view root elementsToDisplay size = 8).
	"--------"


	"--------"
	"MORoot>>elementAt:"
	root := nodes first root.
	self assert: (root isRoot).
	self assert: (root elementAt: (edge shape computeBoundsFor: edge) center) == edge.
	"--------"

	self assert: (edge shape lineSegmentsFor: edge) size = 1. 
	self assert: (edge shape lineSegmentsFor: edge) first class == LineSegment. 
	self assert: (edge shape lineSegmentsFor: edge) first valueAtStart = ( 70@12). 
	self assert: (edge shape lineSegmentsFor: edge) first valueAtEnd = ( 30@12). 

	edgeBound := edge shape computeBoundsFor: edge.
	self assert: (edgeBound = ( 30@12 corner: 70@12)).

	self assert: (edgeBound center = (50@12)).

	self deny: (edge shape containsPoint: 50@16 for: edge).	
	self assert: (edge shape containsPoint: 50@15 for: edge).
	self assert: (edge shape containsPoint: 50@14 for: edge).
	self assert: (edge shape containsPoint: 50@13 for: edge).

	self assert: (edge shape containsPoint: 50@12 for: edge).
	self assert: (edge shape containsPoint: 50@11 for: edge).
	self assert: (edge shape containsPoint: 50@10 for: edge).
	self assert: (edge shape containsPoint: 50@9 for: edge).
	self deny: (edge shape containsPoint: 50@8 for: edge).
! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/17/2009 19:25'!
testInteraction
	| view nodes |
	view := MOViewRenderer new.
	view interaction highlightWhenOver: #yourself.
	nodes := view nodes: (1 to: 5).
	window := view open.
	
	self assert: (nodes first shape borderColor == Color black).
	nodes first announce: (MOMouseEnter new).
	self assert: (nodes first shape borderColor == Color red).
	nodes first announce: (MOMouseLeave new).
	self assert: (nodes first shape borderColor == Color black).! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/6/2010 18:45'!
testInteraction10AddingSubNodesAndElementToDisplay
	| view elementsToDisplay v bounds form canvas |
	view := MOViewRenderer new.
	view shape rectangle 
		width: 40;
		height: 30.
	view nodes: (1 to: 16) forEach: [:each | view nodes: (1 to: 5)].
	view gridLayout gapSize: 2.
	window := view open.
	
	self assert: (view root allNodes size = 96).
	elementsToDisplay := view root elementsToDisplay.
	self assert: elementsToDisplay size = 96.
	view forNode: 4 do: [ view nodes: (1 to: 20). view gridLayout ].
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	view root displayOn: canvas.
	
	v := view root elementsToDisplay size.
	self assert:  v = view root nodes size.
	self assert: elementsToDisplay ~=  view root elementsToDisplay.
	self assert: (view root allNodes size = 111).
! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testInteraction11AddingAndRemovingEdges
	| view nodes |
	view := MOViewRenderer new.
	view shape rectangle size: 30.
	view interaction
	  whenEnteringUpdateNode: [:aValue |
		  view edges: ((1 to: 20) collect: [:v | aValue -> v]) from: #key to: #value ]
	  withLayoutUpdate: false.
	nodes := view nodes: (1 to: 20).
	view circleLayout.
	
	window := view open.

	self assert: (view root allEdges isEmpty).
	self assert: (nodes first allEdges isEmpty).
	
	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size = 19).
	self assert: (nodes first allEdges size = 19).

	nodes first announce: (MOMouseLeave new).
	nodes first removeAllEdges.
	self assert: (nodes first allEdges isEmpty).
	self assert: (view root allEdges isEmpty).
	
	"-------"
	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size = 19).
	self assert: (nodes first allEdges size = 19).

	nodes first announce: (MOMouseLeave new).
	self assert: (nodes first allEdges isEmpty).
	self assert: (view root allEdges isEmpty).

! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 7/26/2010 12:06'!
testInteraction12ExpandingNodes

	| view bounds5 node5 node10 |
	view := MOViewRenderer new.
	
	view shape rectangle size: 50.
	view interaction 
		whenEnteringUpdateNode: [ :node | view node: #bar ].
	
	view node: 10 forIt: [
		view shape rectangle size: 20.
		view node: 5 ].
	
	window := view open.
	
	node5 := view root nodeForDomainValue: 5.
	node10 := view root nodeForDomainValue: 10.
	
	self assert: node5 notNil.
	bounds5 := node5 bounds.
	self assert: (view root elementAt: bounds5 center) == node5.
	
	self assert: (node5 elementsToLookup isEmpty).
	self assert: (node10 elementsToLookup notEmpty).
	self assert: (node10 elementsToLookup size = 1).

	node10 announce: MOMouseEnter new.
	self assert: (node10 nodes size = 1 ).
	self assert: (node10 nodes first model == #bar ).
	self assert: (node10 elementsToLookup size = 1 ).
	self assert: (node10 elementsToLookup first model = #bar ).
	
	self deny: (view root elementsToLookup includes: node5).

	node10 announce: MOMouseLeave new.
	self assert: (node10 nodes isEmpty ).
! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/6/2010 18:45'!
testInteraction13NestedInteractions

	| view node5 node10 innerNodes |
	view := MOViewRenderer new.
	
	view interaction on: MOMouseDown do: [:ann |
		view forNode: ann element model do: [
			view interaction on: MOMouseDown do: [:ann2|
				view forNode: ann2 element model do: [
					view shape triangle. view nodes: {6 . 7 . 8 . 9} ] ].
			view shape diamond size: 20. 
			view nodes: {3 . 4 . 5} ] ].
	view nodes: {1 . 2}.
	
	view root applyLayout.
"	window := view open."

	self deny: (view root nodes first isCacheLoaded).
	view getRenderedForm. 
	"No cache since there is no inner nodes"
	self deny: (view root nodes first isCacheLoaded).
	
	self assert: (view root allNodes size = 2).
	self assert: (view root nodes size = 2).
	self assert: ((view root nodes collect: #model) includesAllOf: {1 . 2}).
	
	"All the nodes are eligible to be looked up"
	self assert: (view root elementsToLookup size = 2).
	
	"We click on the first node"
	view root nodes first announce: MOMouseDown new.
	view getRenderedForm. 
	self assert: (view root nodes first isCacheLoaded).

	"All the nodes are eligible to be looked up"
	self assert: (view root elementsToLookup size = 5).
	
	"We still have the two nodes"
	self assert: (view root nodes size = 2).
	self assert: ((view root nodes collect: #model) includesAllOf: {1 . 2}).
	self assert: (view root allNodes size = 5).
	self assert: (view root nodes first nodes size = 3).
	self assert: ((view root nodes first nodes collect: #model) includesAllOf: {3 . 4 . 5}).	
	
	"We click on an inner node"
	innerNodes := view root nodes first nodes.
	self assert: innerNodes first nodes isEmpty.
	innerNodes first announce: MOMouseDown new.

	"We haven't redisplayed the node, so the cache should be invalidated'"
	self deny: (view root nodes first isCacheLoaded).
	view getRenderedForm. 
	"We redisplay, so it is loaded"
	self assert: (view root nodes first isCacheLoaded).

	self deny: innerNodes first nodes isEmpty.
	self assert: innerNodes first nodes size = 4.
	self assert: ((innerNodes first nodes collect: #model) includesAllOf: {6 . 7 . 8 . 9}).

	"All the nodes are eligible to be looked up"
	self assert: (view root elementsToLookup size = view root allNodes size).
! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 7/20/2010 11:39'!
testInteraction14AddingSubnodeToIncreaseRootSize
	"We have a small node, click on it, we check the size of the root increased"

	| view bounds5 node5 node10 innerNodes initialRootBounds updatedRootBounds |
	view := MOViewRenderer new.
	
	view interaction on: MOMouseDown do: [:ann |
		view forNode: ann element model do: [
			view shape rectangle size: 100.
			view node: 2.
		] ].
	view node: 1.

	view root applyLayout.
	initialRootBounds := view root bounds.

	"We click on the first node"
	view root nodes first announce: MOMouseDown new.

	self assert: (view root nodeForDomainValue: 2) bounds = (5@5 corner: 105@105).
	self assert: (view root nodeForDomainValue: 2) absoluteBounds = ( 10@10 corner: 110@110).

	updatedRootBounds := view root bounds.
	self assert: ((0@0 corner: 115@115)= updatedRootBounds)! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/1/2010 18:57'!
testInteraction15HighlightingInnerNodes
	| view nodes |
	view := MOViewRenderer new.
	view node: #foo forIt: [
		view interaction strongHighlightWhenOver: [:v | {v - 1 . v + 1. v + 4 . v - 4}].
		view shape rectangle 
			width: 40;
			height: 30;
			withText.
		nodes := view nodes: (1 to: 16).
		view gridLayout gapSize: 2 ].
	window := view open.
	
	self assert: (nodes first shape fillColor == Color white).
	nodes first announce: (MOMouseEnter new).
	self assert: ((nodes at: 2)  shape fillColor == Color red).
	self assert: ((nodes at: 5)  shape fillColor == Color red).
	nodes first announce: (MOMouseLeave new).
	self assert: (nodes first shape fillColor == Color white).! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/1/2010 19:16'!
testInteraction16HighlightingInnerNode
	| view outterNode innerNode form form2 canvas2 |
	view := MOViewRenderer new.
	outterNode := view node: 10 forIt: [
		view interaction highlightWhenOver.
		view shape rectangle 
			width: 40;
			height: 30.
		innerNode := view node: 20 ].
	
	view root applyLayout.
	view getRenderedForm.
	
	self assert: (innerNode shape fillColor == Color white).
	self assert: (outterNode absoluteBounds = ( 5@5 corner: 55@45)).
	self assert: (innerNode absoluteBounds = ( 10@10 corner: 50@40)).

	innerNode announce: (MOMouseEnter new).
	form := view getRenderedForm.
	
	self assert: (innerNode shape borderColor == Color red).
	
	self assert: (outterNode absoluteBounds = ( 5@5 corner: 55@45)).
	self assert: (innerNode absoluteBounds = ( 10@10 corner: 50@40)).
	
	"----"
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
			frameAndFillRectangle: (( 5@5 corner: 55@45))
			fillColor: Color white
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: (( 10@10 corner: 50@40) )
			fillColor: Color white
			borderWidth: 1
			borderColor: Color red.

	self assert: form bits = form2 bits.
	
	"----"

	innerNode announce: (MOMouseLeave new).
	self assert: (innerNode shape fillColor == Color white).! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 7/9/2010 11:02'!
testInteraction2
	| view nodes shape1 shape2 t |
	view := MOViewRenderer new.
	t := 0.
	view interaction highlightWhenOver: [:v | t := t + 1. {v - 1 . v + 1. v + 4 . v - 4}].
	view shape rectangle 
		width: 40;
		height: 30;
		withText.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	window := view open.
	
	shape1 := nodes first shape.
	self assert: (nodes first shape borderColor == Color black).
	nodes first announce: (MOMouseEnter new).
	shape2 := nodes first shape.
	self assert: (t = 1).
	self assert: (shape1 == shape2).
	self assert: ((nodes at: 2)  shape borderColor == Color red).
	self assert: ((nodes at: 5)  shape borderColor == Color red).
	nodes first announce: (MOMouseLeave new).
	self assert: (nodes first shape borderColor == Color black).! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/17/2009 19:56'!
testInteraction3
	| view nodes |
	view := MOViewRenderer new.
	view interaction strongHighlightWhenOver: [:v | {v - 1 . v + 1. v + 4 . v - 4}].
	view shape rectangle 
		width: 40;
		height: 30;
		withText.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	window := view open.
	
	self assert: (nodes first shape fillColor == Color white).
	nodes first announce: (MOMouseEnter new).
	self assert: ((nodes at: 2)  shape fillColor == Color red).
	self assert: ((nodes at: 5)  shape fillColor == Color red).
	nodes first announce: (MOMouseLeave new).
	self assert: (nodes first shape fillColor == Color white).! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/6/2010 18:43'!
testInteraction4AddingSubNodes
	| view elementsToDisplay |
	view := MOViewRenderer new.
	view shape rectangle 
		width: 40;
		height: 30.
	view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	window := view open.
	
	self assert: (view root allNodes size = 16).
	elementsToDisplay := view root elementsToDisplay.
	self assert: elementsToDisplay size = 16.
	view forNode: 4 do: [ view nodes: (1 to: 20). view gridLayout ].
	self assert:  view root elementsToDisplay size = 36.
	self assert: elementsToDisplay ~=  view root elementsToDisplay.
	self assert: (view root allNodes size = 36).
	self assert: (view root allNodes collect: #bounds) asArray =  {2@2 corner: 42@32. 46@2 corner: 86@32. 90@2 corner: 130@32. 134@2 corner: 209@62. 5@5 corner: 10@10. 20@5 corner: 25@10. 35@5 corner: 40@10. 50@5 corner: 55@10. 65@5 corner: 70@10. 5@20 corner: 10@25. 20@20 corner: 25@25. 35@20 corner: 40@25. 50@20 corner: 55@25. 65@20 corner: 70@25. 5@35 corner: 10@40. 20@35 corner: 25@40. 35@35 corner: 40@40. 50@35 corner: 55@40. 65@35 corner: 70@40. 5@50 corner: 10@55. 20@50 corner: 25@55. 35@50 corner: 40@55. 50@50 corner: 55@55. 65@50 corner: 70@55. 2@36 corner: 42@66. 46@36 corner: 86@66. 90@36 corner: 130@66. 134@36 corner: 174@66. 2@70 corner: 42@100. 46@70 corner: 86@100. 90@70 corner: 130@100. 134@70 corner: 174@100. 2@104 corner: 42@134. 46@104 corner: 86@134. 90@104 corner: 130@134. 134@104 corner: 174@134}! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 1/14/2010 16:47'!
testInteraction5AddingSubNodesUponMooseEvent
	| view nodes tmp |
	view := MOViewRenderer new.
	view interaction
		forNode: #yourself
		whenEnteringUpdateNode: [:node | tmp := node.  view nodes: #(a b c d f). view gridLayout] 
		whenLeavingUpdateNode: [:node | ]
		withLayoutUpdate: true.
	view shape rectangle size: 10.
	nodes := view nodes: (1 to: 16).
	view gridLayout.
	window := view open.

	self assert: (view root allNodes size = 16).

	nodes first announce: (MOMouseEnter new).
	self assert: (tmp == nodes first model).
	self assert: (view root allNodes size = 21).

	nodes first announce: (MOMouseLeave new).
	self assert: (nodes first nodes isEmpty ).
	self assert: (view root allNodes size = 16).! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 1/12/2010 12:47'!
testInteraction6AddingSubNodesUponMooseEventWithEdge
	| view nodes edge |
	view := MOViewRenderer new.
	view interaction
		forNode: #yourself
		whenEnteringUpdateNode: [:node | view nodes: #(a b c d f). view gridLayout] 
		whenLeavingUpdateNode: [:node | ]
		withLayoutUpdate: true.
	view shape rectangle size: 10.
	nodes := view nodes: (1 to: 16).
	edge := view edge: 1 from: 1 to: 2.
	view gridLayout.
	window := view open.

	self assert: ((edge shape getAttachPointsFor: edge) =  {15@10. 25@10}).

	nodes second announce: (MOMouseEnter new).
	self assert: ((edge shape getAttachPointsFor: edge) =  {15@10. 25@20}).

	nodes second announce: (MOMouseLeave new).
	self assert: ((edge shape getAttachPointsFor: edge) =  {15@10. 25@10}).
! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 3/2/2010 12:50'!
testInteraction7AddingAndRemovingInnerEdges
	| view nodes edge |
	view := MOViewRenderer new.
	view interaction
		forNode: #yourself
		whenEnteringUpdateNode: [:node | view edges: {1 -> 2} from: #key to: #value ] 
		whenLeavingUpdateNode: [:node | ]
		withLayoutUpdate: true.
	view shape rectangle size: 10.
	nodes := view nodes: (1 to: 2).
	window := view open.
	
	self assert: (view root allEdges isEmpty).
	
	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size = 1).

	nodes first announce: (MOMouseLeave new).
	self assert: (view root allEdges isEmpty).

	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size = 1).
! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'Alexandre Bergel 3/2/2010 12:50'!
testInteraction8AddingAndRemovingInnerEdges2
	| view nodes edge |
	view := MOViewRenderer new.
	view interaction
		forNode: #yourself
		whenEnteringUpdateNode: [:node | view nodes: #(#a #b). view edges: {#a -> #b} from: #key to: #value ] 
		whenLeavingUpdateNode: [:node | ]
		withLayoutUpdate: true.
	view shape rectangle size: 50.
	nodes := view nodes: (1 to: 2).
	window := view open.

	self assert: (view root allEdges isEmpty).
	
	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size = 1).

	nodes first announce: (MOMouseLeave new).
	self assert: (view root allEdges isEmpty).

	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size = 1).
! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testInteraction9AddingAndRemovingInnerEdges3
	| view nodes |
	view := MOViewRenderer new.
	view shape rectangle size: 20.
	view interaction action: #inspect.
	view interaction 
		whenEnteringUpdateNode: [:node | 
			view interaction forwarder.
			view nodes: (MOShape allSubclasses).
			view interaction forwarder.
			view edgesFrom: #superclass.
			view treeLayout ] 
		whenLeavingUpdateNode:  [:node | ]  
		withLayoutUpdate: true.
		
	nodes := view nodes: (1 to: 3).
	window := view open.

	self assert: (view root allEdges isEmpty).
	
	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size > 16).

	nodes first announce: (MOMouseLeave new).
	self assert: (view root allEdges isEmpty).

	nodes first announce: (MOMouseEnter new).
	self assert: (view root allEdges size > 16).
! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'Alexandre Bergel 4/26/2010 17:22'!
testLabel1

	| view nodes |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new 
						width: 100; height: 100; text: 'hello').
"	view node: 10 forIt: [ view nodes: #(a b c) ]."
	view node: 10.
	
	view shape label 
		linearFontSize: #yourself within: (1 to: 40).
	nodes := view nodes: (1 to: 40).
	
	window := view open.
	
	self assert: (view root nodes first bounds = (5@5 extent: 100@100)).
	self assert: ((nodes at: 10) shape fontSizeFor: (nodes at: 10)) = 14.
	self assert: ((nodes at: 20) shape fontSizeFor: (nodes at: 20)) = 24.	
! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'Alexandre.Bergel 4/24/2009 18:39'!
testLabel2

	| view shape node |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new 
						width: 100; height: 0; text: 'hello').
"	view node: 10 forIt: [ view nodes: #(a b c) ]."
	node := view node: 10.
	window := view open.
	shape := view root nodes first shape.
	self assert: (view root nodes first bounds = (5@5 extent: 100@(shape textHeightFor: node)))! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'AlexandreBergel 9/13/2010 00:27'!
testLabel3

	| view shape node |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new 
						text: 'hello').
"	view node: 10 forIt: [ view nodes: #(a b c) ]."
	node := view node: 10.
	window := view open.
	shape := view root nodes first shape.
	self assert: (view root nodes first bounds = 
						(5@5 extent: (((shape fontFor: node) widthOfString: 'hello') + (2 * (shape computeBorderWidthFor: node)))@
						(shape textHeightFor: node)))! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'Alexandre.Bergel 4/9/2009 01:17'!
testLabel4

	| view shape |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new 
						width: 100; height: 100;
						text: 'hello').
	view node: 10 forIt: [ view nodes: #(a b c) ].
	window := view open.
	shape := view root nodes first shape.
	self assert: (view root nodes first bounds = 
						(5@5 extent: 100@100))! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testLabel5Multiline
	| view shape node font |
	view := MOViewRenderer new.
	view shape rectangle withText.
	node := view node: 'Hello' , (String with: Character cr) , 'World '.
	window := view open.
	shape := node shape.
	font := shape defaultFont.

	self assert: node bounds extent = ((shape textWidthFor: node) @ (shape textHeightFor: node))! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testLabel6Padding

	| view node1 node2 shape1 innerNode1 |
	view := MOViewRenderer new.
	node1 := view node: #foo forIt: [
		shape1 := view shape label fontSize: 10.
		view interaction forwarder.
		innerNode1 := view node: 'hello world!!'.
	].

	view shape rectangle withText; textPadding: 5; fontSize: 10.
	node2 := view node: 'hello world!!'.

	window := view open.

	self assert: (innerNode1 bounds extent = ((shape1 textWidthFor: innerNode1) @ (shape1 textHeightFor: innerNode1))).
	self assert: (node1 bounds extent = (innerNode1 bounds extent + (10 @ 10))).
	
	self assert: (node2 bounds extent = (((node2 shape textWidthFor: node2) @ (node2 shape textHeightFor: node2)) )).! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'Alexandre Bergel 3/9/2010 08:25'!
testLabel7HorizontalPadding

	| view node |
	view := MOViewRenderer new.
	view shape rectangle withText; textHorizontalPadding: 5; fontSize: 10.
	node := view node: 'hello world!!'.

	window := view open.


	self assert: (node bounds extent = (((node shape textWidthFor: node) @ (node shape textHeightFor: node)) )).! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'Alexandre Bergel 3/9/2010 08:26'!
testLabel8VerticalPadding

	| view node |
	view := MOViewRenderer new.
	view shape rectangle withText; textVerticalPadding: 5.
	node := view node: 'hello world!!'.

	window := view open.

	self assert: (node bounds extent = (((node shape textWidthFor: node) @ (node shape textHeightFor: node)) )).
! !

!MOViewRendererTest methodsFor: 'labels' stamp: 'AlexandreBergel 9/13/2010 00:29'!
testLabel9TextColor
	| view node1 node2 |
	view := MOViewRenderer new.
	view shape rectangle withoutBorder; withoutBackground.
	node1 := view node: 4 forIt: [
			view shape rectangle
				 borderColor:[ :each| Color blue ].
			view node: 10 forIt: [ 
				view node: 10 using: (view shape rectangle withoutBorder 
														withoutBackground;
														fontColor:[ :each| Color black ];
														text:[ :e| e asString ]).
				view layout gapSize: 0
			]. 
		] .
	view layout gapSize: 0.

	view getRenderedForm.
	self assert: node1 hasCachedForm.

	self assert: (node1 bounds = ( 0@0 corner: 14@13)).
	
	"-----------"
	view := MOViewRenderer new.
	view shape rectangle
			 borderColor:[ :each| Color blue ].
	node2 := view node: 10 forIt: [ 
		view node: 10 using: (view shape rectangle withoutBorder 
											withoutBackground;
											fontColor:[ :each| Color black ];
											text:[ :e| e asString ]).
		view layout gapSize: 0].
	
	view getRenderedForm.
	self assert: node2 hasCachedForm.

	self assert: (node2 bounds = ( 0@0 corner: 14@13)).

	"-----------"
	self deny: (node1 cacheForm bits = node2 cacheForm bits )! !

!MOViewRendererTest methodsFor: 'bitmap cache' stamp: 'tg 7/25/2010 14:35'!
testLargeNode
	"The node below the root is too big for being cached. Its size is above what is fixed in #shouldCache. Inner nodes are then cached."
	"This test is currently ignored because it consumes a lot of memory"
	| view largeNode smallNode bounds form canvas form2 canvas2 verySmallNode |
	view := MOViewRenderer new.
	view shape rectangle 
		width: 2000;
		height: 2000.
	largeNode := view node: #foo forIt: [
		smallNode := view node: 5 forIt: [
			verySmallNode := view node: 6 ]].
	view root applyLayout.

	self assert: (largeNode bounds = ( 5@5 corner: 2005@2005)).
	self assert: (smallNode bounds = ( 5@5 corner: 20@20)).
	self assert: (verySmallNode bounds = ( 5@5 corner: 10@10)).

	self deny: largeNode shouldCache.
	self assert: smallNode shouldCache.	
		
	bounds := view root bounds.

	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	view root displayOn: canvas.
	
	form2 := Form extent: bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
				frameAndFillRectangle: ( 5@5 extent: 2000@2000)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.
	canvas2 
				frameAndFillRectangle: (10@10 extent: 15@15)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.
	canvas2 
				frameAndFillRectangle: (15@15 extent: 5@5)
					fillColor: Color white
					borderWidth: 1
					borderColor: Color black.
	self assert: form bits = form2 bits! !

!MOViewRendererTest methodsFor: 'layout' stamp: 'Alexandre Bergel 3/2/2010 14:20'!
testLayout
	| view layout |
	view := MOViewRenderer new.
	self assert: (view layout isKindOf: MOHorizontalLineLayout).
	
	layout := MOTreeLayout new.
	view layout: layout.
	self assert: (view layout == layout)! !

!MOViewRendererTest methodsFor: 'interaction' stamp: 'AlexandreBergel 9/6/2010 18:44'!
testMenu

	| root aWindow rootAnnouncer menuMorph view |
	view := MOViewRenderer new.
	view root interaction action: #inspect.
	view node: #foo.
		
	"The root has an announcer"
	root := view root.
	rootAnnouncer := root announcer.
	self assert: rootAnnouncer notNil.
	
	"The following test should pass. But MOAnnouncer>>menuMorphFor: anElement check if menuMorphBlock is nil or not."
	self assert: (rootAnnouncer menuMorphFor: root ) hasItems.

	rootAnnouncer menuMorphBlock: [:v | MenuMorph new ].

	self assert: (rootAnnouncer menuMorphFor: root ) hasItems.
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 11/30/2009 23:07'!
testModelAndEdges
	| view nodes edges domainNodes assoc |
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2).
	assoc := 1 -> 2.
	edges := view edges: {assoc} from: #key to: #value.
	
	self assert: (edges size = 1).
	self assert: (edges first model == assoc).! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'AlexandreBergel 9/5/2010 17:06'!
testMultipleElementDragAndDrop

	| view dragAndDropEvent |
	view := MOViewRenderer new.
	view nodes: (1 to: 5).

	dragAndDropEvent := MOMouseDrag step: 10@30.
	view root nodes first announce: dragAndDropEvent.
	self assert: (dragAndDropEvent nodesToDrag asArray = {view root nodes first}).
	
	view root nodes first select.
	view root nodes second select.
	view root nodes third select.
	
	dragAndDropEvent := MOMouseDrag step: 10@30.
	view root nodes first announce: dragAndDropEvent.
	self assert: (dragAndDropEvent nodesToDrag 
					includesAllOf: {view root nodes first. view root nodes second. view root nodes third}).
! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'AlexandreBergel 9/5/2010 16:33'!
testMultipleElementSelectionEvent

	self deny: (MOElementSelection new) isMultiple.
	self assert: (MOElementSelection new) isUnique.
	self assert: (MOElementSelection new setAsMultiple) isMultiple.
	self deny: (MOElementSelection new setAsMultiple) isUnique.


	! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'AlexandreBergel 9/5/2010 16:54'!
testMultipleElementSelectionsAndDragAndDrop

	| view node1 node2 t numberOfSelectionEvents dragAndDropEvent node1Bounds node2Bounds |
	view := MOViewRenderer new.
	view nodes: (1 to: 2).
	view root applyLayout.
	
	node1 := view nodeForDomainValue: 1.
	node2 := view nodeForDomainValue: 2.

	t := 0.
	numberOfSelectionEvents := 0.
	node1 announcer
		on: MOElementSelection do: [:ann | numberOfSelectionEvents := numberOfSelectionEvents + 1 ].
	node1 announcer 
		on: MOElementDeselection do: [:ann | t := t + 1 ].

	node1 announce: (MOElementSelection new).
	self assert: (numberOfSelectionEvents = 1).
	self assert: (view root allSelectedNodes asArray = {node1}).
	self assert: (node1 isSelected).
	self deny: (node2 isSelected).
	self assert: t isZero.
	
	node2 announce: (MOElementSelection new setAsMultiple).
	self assert: (node1 isSelected).
	self assert: (node2 isSelected).
	self assert: t = 0.
	
	node1 announce: (MOElementSelection new setAsMultiple).
	self assert: (node1 isSelected).
	self assert: (node2 isSelected).
	self assert: t = 0.
	
	dragAndDropEvent := MOMouseDrag step: 10@30.
	node1Bounds := node1 bounds.
	node2Bounds := node2 bounds.
	node1 announce: (dragAndDropEvent).
	self assert: (dragAndDropEvent nodesToDrag size = 2).
	self assert: (dragAndDropEvent nodesToDrag includesAllOf: { node1 . node2 }).
	self assert: (node1 bounds = (node1Bounds translateBy: (10@30))).
	self assert: (node2 bounds = (node2Bounds translateBy: (10@30))).
! !

!MOViewRendererTest methodsFor: 'multiple selection' stamp: 'AlexandreBergel 9/6/2010 10:18'!
testMultipleSelectionBox

	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: 10).
	view root applyLayout.
	view root nodes first translateBy: 0@40.
	
	self assert: view root bounds  =  (0@0 corner: 145@50).
	
	self deny: view root hasSelectionBox.
	view root announce: (MOMouseDown 
							event: (MouseEvent new setPosition: 20@30) on: view root).
	self deny: view root hasSelectionBox.

	view root announce: (MOMouseMove 
							event: (MouseEvent new setPosition: 50@67) on: view root).
	self assert: view root hasSelectionBox.	
	self assert: (view root selectBoxBounds = (20@30 corner: 50@67))! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/9/2010 10:41'!
testNestedEdges

	| view edge |
	view := MOViewRenderer new.
	view nodes: #(10 20) forEach: [:each |
		view nodes: (each to: each + 9).
	].
	edge := view edge: 11 from: [:each | each + 10] to: #yourself.
	self assert: (view root edges size = 1).
	self assert: (view root edges first source model = 21).
	self assert: (view root edges first target model = 11).

	self assert: (view root elementsToDisplay includes: edge).
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/9/2010 11:12'!
testNestedEdges2

	| view nodeA nodeB edge fromPoint toPoint attachPoints bounds form canvas |
	view := MOViewRenderer new.
	nodeA := 
		view node: #a forIt: [
			view node: #source].

	nodeB := view node: #b forIt: [
		view node: #target.
		view shape arrowedLine.
		edge := view edges: {#source -> #target} from: #key to: #value fromGlobal: true toGlobal: false].
	edge := edge first.
	window := view open.

	self assert: nodeB externalEdges size = 1.
	self assert: (nodeB externalEdges includes: edge).

	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	view root displayOn: canvas.

	self assert: (view root elementsToDisplay includes: edge).
	self assert: (view root computeElementsToDisplay includes: edge).

	self assert: (view root elementsToLookup includes: edge).
	
	self assert: nodeA edges isEmpty.
	self assert: nodeA nodes first edges isEmpty.
	self assert: nodeA nodes first outgoingEdges size = 1.
	self assert: nodeB edges size = 1.
	self assert: nodeB outgoingEdges isEmpty.
	self assert: nodeB allEdges size = 1.
	
	self assert: view root allEdges size = 1.
	self assert: view root edges isEmpty.
	
	attachPoints := edge shape getAttachPointsFor: edge.
	self assert: attachPoints = {(15@12). (35@12)}.
	
	nodeA announce: (MOMouseDrag new step: 30@50).
	self assert: (edge shape getAttachPointsFor: edge) ~=  {(15@12). (35@12)}.
	! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/26/2010 12:06'!
testNestedEdges3

	| view nodeA nodeB edge fromPoint toPoint attachPoints |
	view := MOViewRenderer new.
	nodeA := 
		view node: #a forIt: [
			view node: #source].

	nodeB := view node: #b forIt: [
		view node: #target ].
	view shape arrowedLine.
	edge := view edges: {#source -> #target} from: #key to: #value fromGlobal: true toGlobal: false.
	edge := edge first.
	window := view open.

	self assert: nodeA edges isEmpty.
	self assert: nodeA nodes first edges isEmpty.
	self assert: nodeA nodes first outgoingEdges size = 1.
	self assert: nodeB edges isEmpty.
	self assert: nodeB outgoingEdges isEmpty.
	self assert: nodeB allEdges isEmpty.
	
	self assert: view root allEdges size = 1.
	self assert: view root edges size = 1.
	self deny: view root edges isEmpty.
	
	attachPoints := edge shape getAttachPointsFor: edge.
	self assert: attachPoints = {(15@12). (35@12)}.
	
	nodeA announce: (MOMouseDrag new step: 30@50).
	self assert: (edge shape getAttachPointsFor: edge) ~=  {(15@12). (35@12)}.! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'AlexandreBergel 9/6/2010 18:43'!
testNestedEdges4

	| view nodeA edge bounds form canvas attachPoints pointToLookup |
	view := MOViewRenderer new.
	nodeA := 
		view node: #a forIt: [
			view node: #source].

	view node: #b forIt: [
		view node: #target.
		view shape arrowedLine.
		edge := view edges: {#source -> #target} from: #key to: #value fromGlobal: true toGlobal: false].
	edge := edge first.
	window := view open.

	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	view root displayOn: canvas.
	
	attachPoints := edge shape getAttachPointsFor: edge.
	self assert: attachPoints = {(15@12). (35@12)}.
	
	nodeA announce: (MOMouseDrag new step: 30@50).
	self assert: (edge shape getAttachPointsFor: edge) =  {(42@60). (37@15)}.

	pointToLookup := (((42@60) + (37@15)) / 2) asIntegerPoint.
	self assert: (edge shape lineSegmentsFor: edge) size = 1.
	self assert: (edge shape lineSegmentsFor: edge) first controlPoints = ( LineSegment from: 42@60 to: 37@15) controlPoints.	
	self assert: (edge shape containsPoint: pointToLookup for: edge).
	self assert: (view root elementAt: pointToLookup) == edge.
	

! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 7/9/2010 10:58'!
testNestedEdges5
	"Same than testNestedEdges4 but with the edge defined just below the root"
	| view nodeA nodeB edge bounds form canvas attachPoints pointToLookup |
	view := MOViewRenderer new.
	nodeA := 
		view node: #a forIt: [
			view node: #source].

	nodeB := view node: #b forIt: [
		view node: #target ].

	view shape arrowedLine.
	edge := view edges: {#source -> #target} from: #key to: #value fromGlobal: true toGlobal: false.
		
	edge := edge first.
	window := view open.

	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	view root displayOn: canvas.
	
	attachPoints := edge shape getAttachPointsFor: edge.
	self assert: attachPoints = {(15@12). (35@12)}.
	
	nodeA announce: (MOMouseDrag new step: 30@50).
	self assert: (edge shape getAttachPointsFor: edge) =  {(42@60). (37@15)}.

	pointToLookup := (((42@60) + (37@15)) / 2) asIntegerPoint.
	self assert: (edge shape lineSegmentsFor: edge) size = 1.
	self assert: (edge shape lineSegmentsFor: edge) first controlPoints = ( LineSegment from: 42@60 to: 37@15) controlPoints.	
	self assert: (edge shape containsPoint: pointToLookup for: edge).
	self assert: (view root elementAt: pointToLookup) == edge.
	

! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'Alexandre Bergel 8/10/2010 09:28'!
testNoMoreThanOneChildrenInABuilder
	| builder v |
	builder := MOFormsBuilder new.
	builder column; row; row.
	builder x: 1 y: 1 add: (v := MOChildrenShape new).
	
	self assert: (builder x: 1 y: 1) == v.
	self shouldnt: [ builder x: 1 y: 1 add: MOChildrenShape new ] raise: Error.
	self should: [ builder x: 1 y: 2 add: MOChildrenShape new ] raise: Error.! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 9/26/2009 21:42'!
testNodeForDomainValues
	| view node13 node2 nodes |
	view := MOViewRenderer new.
	node2 := OrderedCollection new.
	node13 := view nodes: #(1 10) forEach: [:each |
		node2 add: (view node: 2)].

	nodes := view nodeForDomainValues: #(1 2 10).
	nodes with: {node13 first . node2 first . node13 second} do: [:v1 :v2 |
		self assert: v1 == v2].
	
	self assert: (view nodeForDomainValue: #zork ifAbsent: [ true ])! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 12/17/2009 19:39'!
testNodeForDomainValues2
	| view node13 node2 nodes |
	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 2).

	self assert: (view nodeForDomainValues: #(1 2)) asArray = nodes asArray.
	self assert: (view nodeForDomainValues: 1) asArray = {nodes first}.
	self assert: (view nodeForDomainValues: #(1 2 3)) asArray = nodes asArray.! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 3/29/2009 15:34'!
testNodeForItWith

	| view fig1 fig2 fig3 |
	view := MOViewRenderer new.
	view shape: (MORectangleShape fillColor: Color blue).
	fig1 := view node: #box
		using: (MORectangleShape fillColor: Color red)
		forIt: [ fig2 := view node: #bar].
	
	fig3 := view node: #zork.
	window := view open.
	self assert: (fig1 shape fillColor == Color red).
	self assert: (fig2 shape fillColor == Color white).
	
	"I find the next assert strange. I would have expected blue instead"
	self assert: (fig3 shape fillColor == Color white).! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'tg 10/5/2008 22:22'!
testNodes
	| view |
	view := MOViewRenderer new.
	view nodes: #(1 2 3 4 5 ).
	self assert: view root nodes size = 5.
	self assert: (view root layout isKindOf: MOHorizontalLineLayout)! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 12/20/2009 12:02'!
testNodes2
	| view |
	view := MOViewRenderer new.
	view nodes: #(0 10 ) forEach: [:each |
		view nodes: (each + 1 to: each + 9)].
	
	self assert: view root nodes size = 2.
	self assert: view root allNodes size = 20.! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'tg 4/25/2008 09:58'!
testNodesForEach
	| view |
	view := MOViewRenderer new.
	view 
		nodes: #(1 2 3 )
		forEach: [ :each | view nodes: (1 to: each) ].
	self assert: view root nodes first nodes size = 1.
	self assert: view root nodes last nodes size = 3.
	view root do: [ :each | self assert: each owner = view root ].
	view root nodes last do: [ :each | self assert: each owner = view root nodes last ]! !

!MOViewRendererTest methodsFor: 'event' stamp: 'Alexandre Bergel 2/25/2010 18:34'!
testPopupView
	| view node viewBlock |
	
	view := MOViewRenderer new.
view shape rectangle size: 50.
view interaction popupView: (viewBlock := [:myNode :myView | 
	myView shape rectangle size: 50; fillColor: Color lightBlue. 
	myView node: 'World'
]).
view interaction action: #inspect.
node := view node: 'hello'.
	window := view open.
	
	self assert: (node popup isNil).
	"This is hard to programmatically generate the popupView:, since the mouse location is used"
	"node announce: (MOMouseEnter event: nil on: node)."
	
	"Instead, we generate it manually"
	node popup: (MOPopup showView: (viewBlock value: node value: (MOViewRenderer new))).
	self assert: (node popup notNil).
	
	"We simulate a click on the node"
	node announce: (MOMouseDown event: nil on: node).
	
	"The menu must have disapeared"
	self assert: (node popup isNil).	! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 2/17/2010 20:49'!
testPositionsEdges
	| view edge nodes v |
	view := MOViewRenderer new.
	nodes := view nodes: #(1 2).
	edge := view edge: 1 -> 2 from: #key to: #value.

	"We check that there is no default initialization"
	self assert: edge toPositions isNil.
	self assert: edge fromPositions isNil.

	window := view open.
	v := edge shape computeAttachPointsFor: nodes first and: nodes second.
	self assert: v first = (10@7).
	self assert: v second = (20@7).
	window delete.

	"Opening the window (and thus displaying the edge) does not initialize the positions"
	self assert: edge toPositions isEmpty.
	self assert: edge fromPositions isEmpty.

	"Set the positions"
	edge fromPositions: #(#bottomCenter).
	edge toPositions: #(#topCenter).
	self assert: edge fromPositions = #(#bottomCenter).
	self assert: edge toPositions = #(#topCenter).

	window := view open.
	v := edge shape computeAttachPointsFor: nodes first and: nodes second.
	self assert: v first = (7@10).
	self assert: v second = (22@5).
	window delete.

! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre Bergel 6/4/2010 17:53'!
testPositionsEdgesInSubnodes
	| subclasses view edges  firstEdge firstEdgeBounds |
	subclasses := {MOShape . MOLineShape . MONodeShape . MOBezierLineShape .   MOFilledShape}.
	view := MOViewRenderer new.
	view node: #foo forIt: [
		view nodes: (subclasses sortedAs: #name).
		view shape: (MOOrthoVerticalLineShape new).
		edges := view edgesFrom: #superclass.
		view treeLayout
	].
	window := view open.

	firstEdge := edges first.
	firstEdgeBounds := firstEdge bounds.
	self assert:( firstEdge source bounds = ( 5.0@30 corner: 10.0@35)).
	self assert:( firstEdge target bounds = ( 5.0@55 corner: 10.0@60)).
	self assert: (firstEdge shape getAttachPointsFor:  firstEdge) = {12@40. 12@60}! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 6/25/2010 23:39'!
testRectangleShapeAndInnerNodes
"
self debug: #testRectangleShapeAndInnerNodes
"
	| view b nodes outerNode realWidth |
	
	b := [ :each | view interaction forwarder. view nodes: (1 to: 10). view verticalLineLayout gapSize: 2 ].

	view := MOViewRenderer new.
	nodes := view nodes: (1 to: 5) forEach: [ :each |
		view interaction forwarder.
		view nodes: (10 to: 15) forEach: b.
		
		view horizontalLineLayout gapSize: 0 ; stretch.
	].

	outerNode := nodes first.
	"There hasn't been a layout so far"
	self assert: (outerNode bounds width
						~= (outerNode nodes inject: 0 into: [:sum :el | el bounds width + sum ])).

	window := view open.
	self assert: (nodes allSatisfy: [:n | n bounds extent = nodes anyOne bounds extent]).
	
	realWidth := outerNode nodes inject: 0 into: [:sum :el | el bounds width + sum ].
	
	"Dichotomy of message sending"
	self assert: (outerNode shape computeExtentHavingChildrenFor: outerNode) = (realWidth@90).	
	self assert: (outerNode shape computeWidthFor: outerNode) = realWidth.	

	self assert: (outerNode shape widthFor: outerNode) = realWidth.	
	self assert: (outerNode shape computeExtentFor: outerNode) x = realWidth.	
	self assert: (outerNode shape computeBoundsFor: outerNode) width = realWidth.	
	self assert: (outerNode bounds width = realWidth).! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 7/26/2010 12:07'!
testRemoveNodesAndEdges

	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: 3).
	view edges: {1 -> 2 . 2 -> 3} from: #key to: #value.
	
	window := view open.

	self assert: view root allNodes size = 3.
	self assert: view root allEdges size = 2.
	
	"remove 1 node"
	view root removeNode: 1.
	self assert: view root allNodes size = 2.
	self assert: view root allEdges size = 1.

	"remove the remaining nodes"
	view root removeNodes: {2 . 3}.
	self assert: view root allNodes isEmpty.
	self assert: view root allEdges isEmpty
	! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 4/9/2010 15:41'!
testResetCacheInEdgesAndSubviews
	| view subnodes edge |

	view := MOViewRenderer new.
	view shape rectangle width: 70; height: 60.
	view node: 10 forIt: [
		view shape rectangle size: 30.
		subnodes := view nodes: #('a' 'b').
		edge := view edge: 'a' -> 'b' from: 'a' to: 'b' ].
	window := view open.
	
	self assert: (subnodes collect: #bounds) =  {5@5 corner: 35@35. 45@5 corner: 75@35}.
	self assert: ((edge shape getAttachPointsFor: edge) =  {40@25. 50@25}).
	self assert: ((edge shape computeAttachPointsFor: edge source and: edge target) = {40@25. 50@25}).
	self assert: (subnodes noneSatisfy: #isSelected).


	"So the cache of the attach point much be set of nil"
	self assert: (edge cacheToPoint notNil).
	self assert: (edge cacheFromPoint notNil).

	subnodes second resetCacheInEdges.
	self assert: (edge cacheToPoint isNil).
	self assert: (edge cacheFromPoint isNil).

	! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 3/10/2010 12:08'!
testRoundedRectangleShape
	| view ui node1 node2 node3 |
	view := MOViewRenderer new.

	view shape roundedRectangle width: 100; height: 40.
	node1 := view node: #foo.
	node2 := view node: #bar forIt: [
		view shape roundedRectangle width: 50; height: 20.
		node3 := view node: #zork.
	].
		
	window := view open.

	self assert: (node1 bounds width = 100).
	self assert: (node1 bounds height = 40).
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre.Bergel 4/8/2009 17:45'!
testScope

	| view edge node1 node2 |
	view := MOViewRenderer new.
	view nodes: #(1 2) forEach: [:each |
		view nodes: #(1 2)].
	view edges: #(1 2)
		from: [:ea | ea]
		to: [:ea | ea + 1]
		fromGlobal: true
		toGlobal: true.
	window := view open.
		
	self assert: (view root edges size = 1).
	edge := view root edges first.
	
	self assert: (view root nodes size = 2).
	node1 := view root nodes first.
	node2 := view root nodes second.
	self assert: (edge source == node1).
	self assert: (edge target == node2).
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'AlexandreBergel 9/12/2010 18:06'!
testScope2

	| view edge node1 node2 |
	view := MOViewRenderer new.
	view nodes: #(1 2) forEach: [:each |
		view nodes: #(1 2)].
	view edges: #(1 2)
		from: [:ea | ea]
		to: [:ea | ea + 1]
		fromGlobal: false
		toGlobal: false.
	window := view open.
		
	self assert: (view root edges size = 1).
	edge := view root edges first.

	self assert: (view localLookupNode: 1) == view root nodes first. 
	self assert: (view localLookupNode: 2) == view root nodes second. 

	self assert: (view root nodes size = 2).
	node1 := view root nodes first.
	node2 := view root nodes second.
	self assert: (edge source == node1).
	self assert: (edge target == node2).
	
! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'AlexandreBergel 9/6/2010 18:32'!
testScope3
	"Edges are defined in a forEach:"

	| view edge |

	view := MOViewRenderer new.
	view interaction popupText.
	view nodes: #(1 2) forEach: [:each |
		view nodes: #(1 2).
		view edges: #(1 2)
			from: [:ea | ea]
			to: [:ea | ea + 1]
			fromGlobal: false
			toGlobal: true.].
	window := view open.
		
	self assert: (view root edges isEmpty).
	self assert: (view root nodes first edges size = 1).
	self assert: (view root nodes second edges size = 1).
	
	edge := view root nodes first edges first.
	self assert: (edge source == view root nodes first nodes first).
	self assert: (edge target == view root nodes second).
	
	edge := view root nodes second edges first.
	self assert: (edge source == view root nodes second nodes first).
	self assert: (edge target == view root nodes second).

	! !

!MOViewRendererTest methodsFor: 'edges' stamp: 'Alexandre.Bergel 9/26/2009 10:12'!
testScope4
	"Edges are defined in a forEach:"
	| view tab |

	tab := #(1 2 3 4 5).
	view := MOViewRenderer new.
	view nodes: (1 to: 2) forEach: [:each |
		view interaction popupText.
		view nodes: (1 to: 2) forEach: [:eac |
			view nodes: tab.
			view gridLayout.
		].
		view edges: view domain
			from: [:ea | 1] 
			to: [:ea | ea+1] 
			fromGlobal: false 
			toGlobal: false. 
	].

	window := view open.

		
	self assert: (view root edges isEmpty).
	self assert: (view root nodes first edges size = 2).
	self assert: (view root nodes first edges first source == view root nodes first nodes first).
	self assert: (view root nodes first edges first target == view root nodes first nodes second).
	
	self assert: (view root nodes first edges second source == view root nodes first nodes first).
	self assert: (view root nodes first edges second target == view root nodes first nodes first nodes third).! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 7/26/2010 12:07'!
testSelectedNodes

	| view nodes root |
	view := MOViewRenderer new.
	view shape rectangle size: 50.
	nodes := view nodes: #($a $b $c) forEach: [ :each | 
		view shape rectangle size: 20.
		view node: 3
	].
	window := view open.
	root := view root.
	self assert: (root allSelectedNodes isEmpty).

	nodes first select.
	self assert: (root allSelectedNodes size = 1).	
	
	nodes first deselect.
	self assert: (root allSelectedNodes isEmpty).	
	
	nodes second select.
	self assert: (root allSelectedNodes size = 1).	

	nodes first nodes first select.
	self assert: (root allSelectedNodes size = 2).	
	self assert: (root allSelectedNodes includesAllOf: {nodes first nodes first . nodes second})


! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'AlexandreBergel 9/5/2010 11:45'!
testSelectedNodesFromEvent

	| view nodes root bounds form canvas |
	view := MOViewRenderer new.
	view shape rectangle size: 50.
	nodes := view nodes: #($a $b $c) forEach: [ :each | 
		view shape rectangle size: 20.
		view node: 3
	].
	window := view open.
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.	
	nodes do: [ :n |  
		n cacheCanvas: canvas. 
		n updateOwner ]. 

	self assert: (nodes first hasCachedForm).
	self assert: (nodes second hasCachedForm).


	
	root := view root.
	self assert: (root allSelectedNodes isEmpty).

	nodes first announce: MOElementSelection new.
	self assert: (root allSelectedNodes size = 1).	
	
	nodes second announce: MOElementSelection new.
	self assert: (root allSelectedNodes size = 1).	

	nodes first nodes first announce: MOElementSelection new.
	self assert: (root allSelectedNodes size = 1).	
	self assert: (root allSelectedNodes includesAllOf: {nodes first nodes first}).

	nodes second nodes first announce: MOElementSelection new.
	self assert: (root allSelectedNodes size = 1).	
	self assert: (root allSelectedNodes includesAllOf: {nodes second nodes first}).

	"Cache of previously selected nodes must have their cache reseted"
	self deny: (nodes first hasCachedForm).
	self deny: (nodes second hasCachedForm).

! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 8/2/2010 09:20'!
testShapeAndFraction
	| s n |
	s := MORectangleShape new height: 30.5; width: 10000/3.
	n := MONode on: 10.
	self assert: (s heightFor: n) isInteger.
	self assert: (s widthFor: n) isInteger.! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'tg 2/12/2010 22:18'!
testSize
	| view biggerNode1 biggerNode2 |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new
		width: 180; height: 100).
	view node: 1 forIt: [
		view nodes: (1 to: 100).
		view layout: (MOGridLayout withGap: 2)].
	
	view shape: (MORectangleShape new).
	view node: 2 forIt: [
		view nodes: (1 to: 100).
		view layout: (MOGridLayout withGap: 2)].
	
	biggerNode1 := view root nodes first.
	biggerNode2 := view root nodes second.
		
	"The view hasn't been open yet. Therefore, all nodes are located in the same location"
	"This could change in the future, but this is the way it is now"
"	self assert: (theNode bounds = (0@0 extent: 5@5)).
	self assert: (theNode children allSatisfy: [:subNode | subNode bounds = (0@0 extent: 5@5)]).
"
	"We layout the all thing!!"
"	view root applyLayout."

	window := view open.
	self assert: biggerNode2 bounds extent = ( 117@72).
	
	self assert: biggerNode1 bounds origin =  (5@5).
	self assert: biggerNode1 bounds extent = (180@100).

! !

!MOViewRendererTest methodsFor: 'centered and stretch' stamp: 'Alexandre Bergel 1/6/2010 22:17'!
testStetch
	| view nodes |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new width: #yourself; height: #yourself).
	nodes := view nodes: #(10 100).
	view layout: (MOHorizontalLineLayout new stretchVertically ).
	window := view open.
	
	self assert: (nodes first bounds = ( 5@5 corner: 15@105)).
	self assert: (nodes second bounds = ( 25@5 corner: 125@105)).! !

!MOViewRendererTest methodsFor: 'centered and stretch' stamp: 'Alexandre Bergel 1/6/2010 22:17'!
testStetch2
	| view nodes |
	view := MOViewRenderer new.
	view shape: (MORectangleShape new width: #yourself; height: #yourself).
	nodes := view nodes: #(10 100).
	view layout: (MOVerticalLineLayout new stretchHorizontally).
	window := view open.
	
	self assert: (nodes first bounds = ( 5@5 corner: 105@15)).
	self assert: (nodes second bounds = ( 5@25 corner: 105@125)).! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'AlexandreBergel 9/6/2010 11:25'!
testSubview1
	"It seems that once we asked for the bounds on elements, the layout is not properly done. I have to check why (alexandre bergel)"
	
	| view biggerNode |
	view := MOViewRenderer new.
	view interaction draggable.
	view nodes: #(a) forEach: [:each |
		view nodes: (1 to: 5).
	].

	self assert: (view root nodes size = 1).
	
	biggerNode := view root nodes first.
	self assert: (biggerNode model == #a).
	self assert: (biggerNode nodes size = 5).
	self assert: (biggerNode nodes collect: [:node | node model]) asArray = (1 to: 5) asArray.

	window := view open.

	self assert: biggerNode bounds extent = (biggerNode shape computeBoundsFor: biggerNode) extent.	
	self assert: biggerNode bounds = ( 5@5 corner: 80@20 ).
	self assert: (biggerNode shape computeBoundsFor: biggerNode) = ( 0@0 corner: 75@15).
 
	self assert: biggerNode nodes first bounds = ( 5@5 corner: 10@10 ).
	self assert: biggerNode nodes second bounds = ( 20@5 corner: 25@10 ).
	self assert: biggerNode nodes third bounds = ( 35@5 corner: 40@10 ).
	self assert: biggerNode nodes fourth bounds = ( 50@5 corner: 55@10 ).

	self assert: biggerNode bounds = ( 5@5 corner: 80@20 ).
	self assert: (biggerNode shape computeBoundsFor: biggerNode) = ( 0@0 corner: 75@15).
 
	self assert: biggerNode nodes first bounds = ( 5@5 corner: 10@10 ).
	self assert: biggerNode nodes second bounds = ( 20@5 corner: 25@10 ).
	self assert: biggerNode nodes third bounds = ( 35@5 corner: 40@10 ).
	self assert: biggerNode nodes fourth bounds = ( 50@5 corner: 55@10 ).
! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 7/26/2010 13:01'!
testSubview2
	"Two subviews"
		
	| view theNode |
	view := MOViewRenderer new.
	view nodes: #(a) forEach: [:each |
		view nodes: (1 to: 5) forEach: [:e |
			view nodes: (1 to: 5).
		].
	].

	self assert: (view root nodes size = 1).
	
	theNode := view root nodes first.
	self assert: (theNode model == #a).
	self assert: (theNode nodes size = 5).
	self assert: (theNode nodes collect: [:node | node model]) asArray = (1 to: 5) asArray.

	window := view open.

	self assert: theNode bounds = (theNode shape boundsFor: theNode).	
	self assert: theNode bounds extent = (theNode shape boundsFor: theNode) extent.	
	self assert: theNode bounds = ( 5@5 corner: 430@30).
 
	self assert: theNode nodes first bounds = ( 5@5 corner: 80@20).
	self assert: theNode nodes second bounds = ( 90@5 corner: 165@20).
	self assert: theNode nodes third bounds = ( 175@5 corner: 250@20).
	self assert: theNode nodes fourth bounds = ( 260@5 corner: 335@20).


	self assert: theNode bounds = ( 5@5 corner: 430@30).
	self assert: (theNode shape computeBoundsFor: theNode) = ( 0@0 corner: 425@25).
 
	self assert: theNode nodes first bounds = ( 5@5 corner: 80@20).
	self assert: theNode nodes second bounds = ( 90@5 corner: 165@20).
	self assert: theNode nodes third bounds = ( 175@5 corner: 250@20).
	self assert: theNode nodes fourth bounds = ( 260@5 corner: 335@20).

! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 7/26/2010 13:02'!
testSubview3
	"One subview"
		
	| view biggerNode |
	view := MOViewRenderer new.

	view nodes: #(a) forEach: [:each |
		view shape: (MORectangleShape new width: 10; height: 15).
		view nodes: (1 to: 1).
	].

	self assert: (view root nodes size = 1).
	
	biggerNode := view root nodes first.
	self assert: (biggerNode model == #a).
	self assert: (biggerNode nodes size = 1).
	self assert: (biggerNode nodes collect: [:node | node model]) asArray = {1}.
	
	"The view hasn't been open yet. Therefore, all nodes are located in the same location"
	"This could change in the future, but this is the way it is now"
	"self assert: (biggerNode bounds = ( 0@0 corner: 15@20))."
"	self assert: (theNode children allSatisfy: [:subNode | subNode bounds = (0@0 extent: 5@5)]).
"
	"We layout the all thing!!"
"	view root applyLayout."

	window := view open.

	"bounds returns the bounds using an absolute position"
	"bounds returns a relative bounds, so, the origin is always 0@0"
	self assert: biggerNode bounds ~= (biggerNode shape computeBoundsFor: biggerNode).	
	self assert: biggerNode bounds extent = (biggerNode shape computeBoundsFor: biggerNode) extent.	

	self assert: biggerNode bounds = (biggerNode shape boundsFor: biggerNode).
	self assert: biggerNode bounds = ( 5@5 corner: 25@30).
 
	self assert: biggerNode nodes first bounds = ( 5@5 corner: 15@20).
! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 7/26/2010 13:02'!
testSubview4
	"One subview"
		
	| view biggerNode insideNode |
	view := MOViewRenderer new.

	view nodes: #(a) forEach: [:each |
		view shape: (MORectangleShape new width: 10; height: 15).
		view nodes: (1 to: 5).
	].

	self assert: (view root nodes size = 1).
	
	biggerNode := view root nodes first.
	self assert: (biggerNode model == #a).
	
	"The view hasn't been open yet. Therefore, all nodes are located in the same location"
	"This could change in the future, but this is the way it is now"
	self assert: (biggerNode bounds = ( 0@0 corner: 10@15)).
"	self assert: (theNode children allSatisfy: [:subNode | subNode bounds = (0@0 extent: 5@5)]).
"
	"We layout the all thing!!"
"	view root applyLayout."

	window := view open.

	self assert: biggerNode bounds = (biggerNode shape boundsFor: biggerNode).
	self assert: biggerNode bounds extent = (biggerNode shape boundsFor: biggerNode) extent.
	self assert: biggerNode bounds = ( 5@5 corner: 105@30).
 
	self assert: biggerNode nodes first bounds = ( 5@5 corner: 15@20).
	self assert: biggerNode nodes second bounds = ( 25@5 corner: 35@20).
	self assert: biggerNode nodes third bounds = ( 45@5 corner: 55@20).
	
	insideNode := biggerNode nodes first.
	self assert: (insideNode shape computeBoundsFor: insideNode) = ( 0@0 corner: 10@15).! !

!MOViewRendererTest methodsFor: 'subviews' stamp: 'Alexandre Bergel 4/24/2010 17:28'!
testSubview5
	| view outterNode innerNode |
	view := MOViewRenderer new.
	outterNode := view node: 1 forIt: [
		view shape rectangle size: 30. 
		innerNode := view node: 2 ].
	
	window := view open.
	
	self assert: (outterNode bounds = ( 5@5 corner: 45@45)).
	self assert: (innerNode bounds = ( 5@5 corner: 35@35)).
	self assert: (innerNode absoluteBounds  = ( 10@10 corner: 40@40)).
	
	self assert: (view root elementAt: (10@10)) == innerNode.

! !

!MOViewRendererTest methodsFor: 'threading' stamp: 'Alexandre Bergel 8/12/2010 11:59'!
testThreading1
	| view allProcessesBefore allProcessesAfter theProcess |
	allProcessesBefore := Process allInstances.
	
	view := MOViewRenderer new.
	view interaction 
		every: 100 do: [  ].
	view nodes: #(1 2).
	window := view open.

	allProcessesAfter := Process allInstances.	
	self assert: allProcessesAfter size = (allProcessesBefore size + 1).
	theProcess := (allProcessesAfter copyWithoutAll: allProcessesBefore) first.
	self deny: theProcess isTerminated.
	
	window delete.
	window := nil.
	
	self assert: theProcess isSuspended! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 1/23/2010 17:10'!
testTranslation

	| view firstEdge |
	view := MOViewRenderer new.
	view nodes: #(1 2).
	view edge: 1 from: #yourself to: [:x | x + 1].
	
	"We open and delete the window to update the position of each of the graph elements. 
	I find this rather ugly. We should compute the position without having to open the window."
	window := view open.

	self assert: (view root bounds = ( 0@0 corner: 25@10)).
	self assert: (view root absoluteBounds = ( 0@0 corner: 25@10)).
	self assert: (view root absoluteBounds = ( 0@0 corner: 25@10)).
	self assert: (view root shapeBounds isDictionary).

	
	"shapeBounds contains the cache. it cannot be empty once the view has been rendered"
	self assert: (view root nodes allSatisfy: [:node | node shapeBounds notEmpty ]).
	
	firstEdge := view root edges first.	
"	self assert: (firstEdge origin = (7@10))."
	self assert: (firstEdge source origin = (5@5)).
	self assert: (firstEdge target origin = (20@5)).

	"-------------------------------"
	"-------------------------------"
	view root translateBy: 8@5. 
	"We go a bit deeper in the uglyness. We update the window to reflect the change in the position"
	window changed.	

	self assert: (view root bounds = ( 0@0 corner: 33@15)).
	self assert: (view root absoluteBounds = ( 0@0 corner: 33@15)).
	self assert: (view root origin = ( 0@0)).

	"The next breaks, is that normal?"
	"self assert: (view root edges first absoluteBounds = (...))."

	"self assert: (firstEdge origin = (0@0))."
	self assert: (firstEdge source origin = (13@10)).
	self assert: (firstEdge target origin = (28@10)).

	"-------------------------------"
	"-------------------------------"
	view root translateBy: 8@5. 
	window changed.

	self assert: (view root absoluteBounds = ( 0@0 corner: 41@20)).
	self assert: (view root origin = (0@0)).

	self assert: (view root edges first source origin = ( 21@15)).
	self assert: (view root edges first target origin = ( 36@15)).
! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'tg 2/12/2010 21:50'!
testTranslation2

	| view figure bounds |
	view := MOViewRenderer new.
	view node: #abc.
	figure := view root nodes first.

	window := view open.

	bounds := figure shape boundsFor: figure.
	self assert: (bounds extent = (5@5)).
	self assert: figure origin = (5@5).
	
	figure translateTo: 45@34.
	
	bounds := figure shape boundsFor: figure.
	self assert: (bounds extent = (5@5)).
	self assert: figure origin = (45@34).! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre Bergel 1/23/2010 17:11'!
testTranslationUsingEvent

	| view firstNode oldPosition edge |
	view := MOViewRenderer new.
	view noInteraction.
	view interaction subscribe: MOMouseDrag do: 
		[:ann |  ann element translateBy: ann step.].

	view nodes: #(1 2).
	edge := view edge: 1 from: #yourself to: [:x | x + 1].
	
	"We open and delete the window to update the position of each of the graph elements. 
	I find this rather ugly. We should compute the position without having to open the window."
	window := view open.

	self assert: (view root bounds = (0@0 corner: 25@10)).
	self assert: (view root absoluteBounds = (0@0 corner: 25@10)).
	self assert: (view root absoluteBounds = (0@0 corner: 25@10)).

	"We get a hand on the first node"
	firstNode := view root nodes first.
	self assert: (firstNode model = 1).
	self assert: (firstNode origin = (5@5)).
	oldPosition := firstNode origin.

	"We try to get the node from the left top corner"
	self assert: (view root elementAt: (5@5)) == firstNode.
	"... from the bottom right now"	
	self assert: (view root elementAt: ((5@5) + (firstNode width @ firstNode height))) == edge.
	self assert: (view root elementAt: ((4@4) + (firstNode width @ firstNode height))) == firstNode.

	view noInteraction.
	view interaction subscribe: MOMouseDrag do: [:ann | ann element translateBy: ann step].
 	view announce: ((MOMouseDrag event: nil on: firstNode) step: 1@2).
	
	self assert: ( 6@7 = firstNode origin).
	
	"Since the figure has moved, we cannot get it from its old location"
	self assert: (view root elementAt: (5@5)) == view root.
	self assert: (view root elementAt: (6@7)) == firstNode.
	self assert: (view root elementAt: ((6@7) + (firstNode width @ firstNode height))) == edge.
	self assert: (view root elementAt: ((5@6) + (firstNode width @ firstNode height))) == firstNode.

	"The general bounds must have grown"
	self assert: (view root bounds = ( 0@0 corner: 25@12)).! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 8/31/2010 18:33'!
testUMLShape

	| view builder umlShape form form2 canvas2 shape1 shape2 nodes |
	view := MOViewRenderer new.
	builder := MOFormsBuilder new.
	builder column; fill.
	builder row; fill; row; fill.
	builder x: 1 y: 1 add: 
		(shape1 := MORectangleShape new width: 30; height: 15; fillColor: Color green).
	builder x: 1 y: 2 add: 
		(shape2 := MORectangleShape new width: 60; height: 80; fillColor: Color blue).
	umlShape := builder shape.
	
	view shape: umlShape.
	nodes := view nodes: {MOShape . MOBoundedShape}.
	
	view root applyLayout.
	form := view getRenderedForm.

	"---"
	self assert: (nodes first absoluteBounds =  (5@5 corner: 65@100)).
	self assert: (nodes second absoluteBounds = (75@5 corner: 135@100)).

	self assert: (umlShape builder boundsOf: shape1) = ( 0@0 corner: 60@15).
	self assert: (umlShape builder boundsOf: shape2) = ( 0@15 corner: 60@95).
	! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 8/31/2010 18:33'!
testUMLShape2

	| view builder umlShape form form2 canvas2 shape1 shape2 nodes |
	view := MOViewRenderer new.
	builder := MOFormsBuilder new.
	builder column; fill.
	builder row; fill; row; fill.
	builder x: 1 y: 1 add: 
		(shape1 := MORectangleShape new width: 30; height: 15; fillColor: Color green).
	builder x: 1 y: 2 add: 
		(shape2 := MORectangleShape new width: 60; height: 80; fillColor: Color blue).
	umlShape := builder shape.
	
	view shape: umlShape.
	nodes := view nodes: {MOShape}.
	
	view root applyLayout.
	form := view getRenderedForm.
	
	"We draw in a form"
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
			frameAndFillRectangle: (( 0@0 corner: 60@15) translateBy: 5@5)
			fillColor: Color green
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: (( 0@0 corner: 60@80) translateBy: 5@20)
			fillColor: Color blue
			borderWidth: 1
			borderColor: Color black.

	self assert: form bits = form2 bits.
! !

!MOViewRendererTest methodsFor: 'children shape' stamp: 'AlexandreBergel 9/5/2010 10:20'!
testUMLShape3

	| view builder umlShape form form2 canvas2 shape1 shape2 nodes |
	view := MOViewRenderer new.
	builder := MOFormsBuilder new.
	builder column; fill.
	builder row; fill; row; fill.
	builder x: 1 y: 1 add: 
		(shape1 := MORectangleShape new width: 30; height: #first; fillColor: Color green).
	builder x: 1 y: 2 add: 
		(shape2 := MORectangleShape new width: 60; height: #second; fillColor: Color blue).
	umlShape := builder shape.
	
	view shape: umlShape.
	nodes := view nodes: {{30 . 80} . {15 . 90} . {40 . 100}}.
	
	view root applyLayout.
	form := view getRenderedForm.
		
	self assert: (nodes first shape computeBoundsFor: nodes first) = ( 0@0 corner: 60@110).
	self assert: (nodes second shape computeBoundsFor: nodes second )= ( 0@0 corner: 60@105).
	self assert: (nodes third shape computeBoundsFor: nodes third) = ( 0@0 corner: 60@140).
	
	self assert: (nodes first shapeBoundsAt: shape1) = ( 0@0 corner: 60@30).
	self assert: (nodes first shapeBoundsAt: shape2) = ( 0@30 corner: 60@110).

	self assert: (nodes second shapeBoundsAt: shape1) = ( 0@0 corner: 60@15).
	self assert: (nodes second shapeBoundsAt: shape2) = ( 0@15 corner: 60@105).

	self assert: (nodes third shapeBoundsAt: shape1) = ( 0@0 corner: 60@40).
	self assert: (nodes third shapeBoundsAt: shape2) = ( 0@40 corner: 60@140).

		
	"We draw in a form"
	form2 := Form extent: view root bounds extent depth: Display depth.
	canvas2 := FormCanvas on: form2.
	canvas2 
			frameAndFillRectangle: (( 0@0 corner: 60@30) translateBy: 5@5)
			fillColor: Color green
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: (( 0@30 corner: 60@110) translateBy: 5@5)
			fillColor: Color blue
			borderWidth: 1
			borderColor: Color black.
			

	canvas2 
			frameAndFillRectangle: (( 0@0 corner: 60@15) translateBy: ( nodes second absoluteBounds origin))
			fillColor: Color green
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: (( 0@15 corner: 60@105) translateBy: ( nodes second absoluteBounds origin))
			fillColor: Color blue
			borderWidth: 1
			borderColor: Color black.


	canvas2 
			frameAndFillRectangle: (( 0@0 corner: 60@40) translateBy: ( nodes third absoluteBounds origin))
			fillColor: Color green
			borderWidth: 1
			borderColor: Color black.
	canvas2 
			frameAndFillRectangle: (( 0@40 corner: 60@140) translateBy: ( nodes third absoluteBounds origin)) 
			fillColor: Color blue
			borderWidth: 1
			borderColor: Color black.

	self assert: form bits = form2 bits.
! !

!MOViewRendererTest methodsFor: 'nodes' stamp: 'Alexandre.Bergel 2/10/2009 09:53'!
testUnExistingEdge

	| view |
	view := MOViewRenderer new.

	"If there is no node"
	view edgesFrom: [:each | each].
	self assert: (view root edges isEmpty).
	
	view nodes: #(1).
	view edgesFrom: [:each | each].
	self assert: (view root edges isEmpty).
	
	view nodes: #(1).
	view edgesFrom: [:each | each * 2].
	self assert: (view root edges isEmpty).! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'AlexandreBergel 9/6/2010 18:45'!
testVerticalOrthogonalLine

	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: 10).
	view shape verticalOrthogonalLine.
	view edges: (1 to: 10) from:  1 to: # yourself.
	view treeLayout.
	window := view open.

	self assert: (view root nodes collect: #bounds) asArray =  {37.0@5 corner: 42.0@10. 5.0@30 corner: 10.0@35. 13.0@30 corner: 18.0@35. 21.0@30 corner: 26.0@35. 29.0@30 corner: 34.0@35. 37.0@30 corner: 42.0@35. 45.0@30 corner: 50.0@35. 53.0@30 corner: 58.0@35. 61.0@30 corner: 66.0@35. 69.0@30 corner: 74.0@35}! !

!MOViewRendererTest methodsFor: 'shapes' stamp: 'Alexandre Bergel 10/15/2009 20:01'!
testWrongShape
	"
	self debug: #testWrongShape
	"
	| view nodes |
	view := MOViewRenderer new.
	view shape line.
	nodes := view nodes: (1 to: 10).
	self assert: (view shape notNil).
	self shouldnt: [window := view open] raise: Error.
	self assert: (nodes allSatisfy: [:n | n shape isKindOf: view defaultNodeShapeClass]).
	
	self assert: (view defaultNodeShapeClass new isNodeShape).
	self deny: (view defaultNodeShapeClass new isLineShape).
	self deny: (view defaultLineShapeClass new isNodeShape).
	self assert: (view defaultLineShapeClass new isLineShape).! !

!MOViewRendererTest methodsFor: 'zOrder' stamp: 'Alexandre Bergel 8/11/2010 08:45'!
testZOrder
	| view x y ui zOrder |

	x := #(1 2).
	y := #(#(5 6) #(7 8)).

	view := MOViewRenderer new.
	view node: x using: MORectangleShape withBorder forIt: [
		view nodes: x using: MORectangleShape withBorder.
	].
	view node:  y using: MORectangleShape withBorder forIt: [
		view nodes: y using: MORectangleShape withBorder forEach: [ :b |
			view nodes: b.
		].
	].
	view edge: 1 -> 7 from: #key to: #value.
	window := view open.

	zOrder := view root elementsToDisplay collect: [:e | e zOrder].
	self assert: zOrder asArray = #(3 3 5 5 5 5 6 7 7 7 7).

! !

!MOViewRendererTest methodsFor: 'zooming' stamp: 'Alexandre.Bergel 3/26/2009 22:58'!
testZoom
	"No subviews"
	| view node |
	view := MOViewRenderer new.
	view node: #foobar.	

	node := view nodeForDomainValue: #foobar.
	self assert: node bounds = (0@0 extent: 5@5).
	
	window := view open.
	self assert: node bounds = (5@5 extent: 5@5).
	view root increaseZoom.
	self assert: node bounds ~= (5@5 extent: 5@5).
	self assert: node bounds = ((5@5 extent: 5@5) scaleBy: 1.1).

	view root decreaseZoom.
	self assert: node bounds = ( 4.95@4.95 corner: 9.9@9.9).

! !

!MOViewRendererTest methodsFor: 'zooming' stamp: 'Alexandre Bergel 7/26/2010 13:00'!
testZoomWithSubview
	"No subviews"
	| view node |
	view := MOViewRenderer new.
	view node: #foobar forIt: [
		view nodes: (1 to: 100).
		view gridLayout
		"view layout: (MOGridLayout new gapSize: 6)"].	

	node := view nodeForDomainValue: #foobar.
	self assert: node bounds = ( 0@0 corner: 5@5).
	
	window := view open.
	self assert: node bounds = ( 5@5 corner: 200@125).
	self assert: node nodes first bounds = ( 5@5 corner: 10@10).
	
	view root increaseZoom.
	self assert: node bounds = (( 5@5 corner: 200@125) scaleBy: 1.1).
	self assert: node nodes first bounds = (( 5@5 corner: 10@10) scaleBy: 1.1).

	view root decreaseZoom.
	self assert: node bounds = ((( 5@5 corner: 200@125) scaleBy: 1.1) scaleBy: 0.9).
	self assert: node nodes first bounds = 
			((( 5@5 corner: 10@10) scaleBy: 1.1) scaleBy: 0.9).
! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 20:12'!
typeOfEdgeFromToUsing
	^ #(MOArrowedLineShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 19:58'!
typeOfEdgesFromToAllUsing
	^ #(MOArrowedLineShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 18:30'!
typeOfEdgesFromToAllUsingFromGlobalToGlobal
	^ #(MOArrowedLineShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 19:56'!
typeOfEdgesFromToUsing
	^ #(MOArrowedLineShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 10:28'!
typeOfMOViewRendererAnnounce
	^ #(MOMouseLeave MOKeyPressed MOKeyDown MOKeyEvent MOZoomEvent MOContentChanged MOMouseEvent MOKeyUp MOMouseMove MOMouseUp) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'Alexandre Bergel 6/17/2010 12:28'!
typeOfMOViewRendererNodeUsing
	^ #(MOEllipseShape MOFixedRectangleShape MORoundedRectangleShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'Alexandre Bergel 6/17/2010 12:28'!
typeOfMOViewRendererNodesUsing
	^ #(MOFixedRectangleShape MORoundedRectangleShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'Alexandre Bergel 6/17/2010 12:28'!
typeOfMOViewRendererNodesUsingForEach
	^ #(MOFormsShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'Alexandre Bergel 8/15/2010 12:46'!
typeOfMOViewRendererlayout
	^ #(MOFlowLayout MOBulletTreeLayout MOSugiyamaLayout) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 19:59'!
typeOfNodeUsingForIt
	^ #(MOEllipseShape MOFixedRectangleShape MORoundedRectangleShape) collect: [:s | Smalltalk at: s]! !

!MOViewRendererTest methodsFor: 'type covering' stamp: 'AlexandreBergel 10/28/2009 19:48'!
typeOfNodesUsingForEach
	^ #(MOEllipseShape MOFixedRectangleShape MORoundedRectangleShape) collect: [:s | Smalltalk at: s]! !

!MondrianTestCase methodsFor: 'running' stamp: 'Alexandre Bergel 3/3/2010 00:23'!
tearDown
	super tearDown.
	window ifNotNil: [window delete. window := nil]! !

PluggableTextMorph subclass: #MOEaselTextEditor
	instanceVariableNames: 'unstyledTextMondrian shoutStylerMondrian'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselTextEditor class methodsFor: 'instance creation' stamp: 'DavidRoethlisberger 1/26/2010 20:57'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel 
	| styler answer stylerClass |
	answer := self new.
	stylerClass := Smalltalk classNamed: #SHTextStylerST80.
	styler := stylerClass isNil ifFalse: 
		[ stylerClass new
			view: answer;
			yourself ].
	^ answer
		styler: styler;
		on: anObject
			text: getTextSel
			accept: setTextSel
			readSelection: getSelectionSel
			menu: getMenuSel! !

!MOEaselTextEditor methodsFor: 'binding' stamp: 'tg 5/20/2008 17:38'!
bindingOf: aSymbol
   ^model bindingOf: aSymbol! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
classOrMetaClass: aBehavior
	"set the classOrMetaClass in the receiver's styler to aBehavior"
		
	shoutStylerMondrian classOrMetaClass: aBehavior ! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
correctFrom: start to: stop with: aString 
	"see the comment in #acceptTextInModel "
	unstyledTextMondrian isNil ifFalse: 
		[ unstyledTextMondrian 
			replaceFrom: start
			to: stop
			with: aString ].
	^ super 
		correctFrom: start
		to: stop
		with: aString! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
environment: anObject
	"set the environment in the receiver's styler to anObject"
		
	shoutStylerMondrian environment: anObject ! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
font: aFont 
	super font: aFont.
	shoutStylerMondrian isNil ifFalse: [ shoutStylerMondrian font: aFont ]! !

!MOEaselTextEditor methodsFor: 'binding' stamp: 'tg 5/20/2008 17:40'!
hasBindingOf: aString
   ^(model bindingOf: aString) notNil! !

!MOEaselTextEditor methodsFor: 'binding' stamp: 'Alexandre.Bergel 3/9/2009 00:35'!
hasBindingThatBeginsWith: aString
	^model allVariableKeys anySatisfy: [:each | each beginsWith: aString]! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
hasUnacceptedEdits: aBoolean
	"re-implemented to re-style the text iff aBoolean is true"
	 
	super hasUnacceptedEdits: aBoolean.
	(aBoolean and: [self okToStyle])
		ifTrue: [ shoutStylerMondrian styleInBackgroundProcess: textMorph contents]! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'jl 9/20/2010 16:23'!
okToStyle
	shoutStylerMondrian ifNil:[^false].
	SHPreferences enabled ifFalse: [^false].
	(model respondsTo: #shoutAboutToStyle: ) ifFalse:[^true].
	^model shoutAboutToStyle: self
! !

!MOEaselTextEditor methodsFor: 'private' stamp: 'DavidRoethlisberger 1/26/2010 20:55'!
privateSetText: aText 
	scrollBar setValue: 0.0.
	textMorph isNil 
		ifTrue: 
			[ textMorph := self textMorphClass new 
				contents: aText
				wrappedTo: self innerBounds width - 6.
			textMorph setEditView: self.
			scroller addMorph: textMorph ]
		ifFalse: [ textMorph newContents: aText ].
	self hasUnacceptedEdits: false.
	self setScrollDeltas! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
setText: aText
	
	self okToStyle ifFalse:[^self privateSetText: aText].
	self privateSetText: (shoutStylerMondrian format: aText asText).
	aText size < 4096
		ifTrue:[	shoutStylerMondrian style: textMorph contents]
		ifFalse:[shoutStylerMondrian styleInBackgroundProcess:  textMorph contents]
! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
sourceMap: aSortedCollection
	"set the sourceMap in the receiver's styler to aSortedCollection"
		
	shoutStylerMondrian sourceMap: aSortedCollection
! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
styler
	^shoutStylerMondrian
! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
styler: anObject
	
	shoutStylerMondrian := anObject
! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'DavidRoethlisberger 1/26/2010 20:53'!
stylerStyled: styledCopyOfText 
	textMorph contents runs: styledCopyOfText runs.
	"textMorph paragraph recomposeFrom: 1 to: textMorph contents size delta: 0."	"caused chars to appear in wrong order esp. in demo mode. remove this line when sure it is fixed"
	textMorph updateFromParagraph.
	selectionInterval isNil ifFalse: 
		[ textMorph editor
			selectInvisiblyFrom: selectionInterval first
				to: selectionInterval last;
			storeSelectionInParagraph;
			setEmphasisHere ].
	textMorph editor blinkParen.
	self scrollSelectionIntoView! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'DavidRoethlisberger 1/26/2010 20:53'!
stylerStyledInBackground: styledCopyOfText 
	"It is possible that the text string	has changed since the styling began. Disregard the styles if styledCopyOfText's string differs with the current textMorph contents string"
	
	textMorph contents string = styledCopyOfText string
		ifTrue: [self stylerStyled: styledCopyOfText]
	! !

!MOEaselTextEditor methodsFor: 'private' stamp: 'tg 5/20/2008 17:13'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^MOTextMorphWithShout! !

!MOEaselTextEditor methodsFor: 'styler' stamp: 'AlexandreBergel 9/15/2010 14:17'!
workspace: anObject
	"set the workspace in the receiver's styler to anObject"
		
	shoutStylerMondrian workspace: anObject ! !

Object subclass: #DistributionMapExample
	instanceVariableNames: 'propertiesMap propertyBlock elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!DistributionMapExample class methodsFor: 'public' stamp: 'Alexandre.Bergel 4/20/2009 19:06'!
openOn: classes

	^ (self new render: classes) open! !

!DistributionMapExample class methodsFor: 'public' stamp: 'simon.denier 4/19/2009 20:57'!
sample

	(self new properties: self sampleProperties;
				propertiesMap: self sampleMap;
				propertyBlock: self sampleBlock;
				elements: self sampleOrderedElements;
				render: Collection withAllSubclasses)
				open! !

!DistributionMapExample class methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:21'!
sampleBlock
	"should extend Dictionary to make a switch control structure"
	
	^ [ :method ||numArgs|
			numArgs := method numArgs.
			(numArgs = 0)  ifTrue: [ #unary ]
								ifFalse: [
									(numArgs = 1) ifTrue: [ #binary ]
													 ifFalse: [ #keywords ]
												]]! !

!DistributionMapExample class methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:15'!
sampleElements

	^ #methods! !

!DistributionMapExample class methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:33'!
sampleMap

	^ Dictionary with: (#unary -> Color white) with: (#binary -> Color gray) with: (#keywords -> Color black)! !

!DistributionMapExample class methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:56'!
sampleOrderedElements

	^ [:class ||dic orderedMethods|
			orderedMethods := OrderedCollection new.
			dic := Dictionary new.
			self sampleProperties do: [:prop | dic at: prop put: OrderedCollection new].
			class methods do: [ :mth|
				(dic at: (self sampleBlock value: mth)) add: mth
				].
			self sampleProperties do: [:prop |
				orderedMethods addAll: (dic at: prop)
				].
			orderedMethods
		]! !

!DistributionMapExample class methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:05'!
sampleProperties

	^ #(#unary #binary #keywords)! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/20/2009 19:06'!
colorAtIndex: anInteger
	"Maybe some colors are duplicated. But does it really make sense to have a large amonts of different properties?"

	^ (anInteger <= Color strongColors size)
		ifTrue: [ Color strongColors at: anInteger ]
		ifFalse: [ Color indexedColors at: anInteger ]
		! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:49'!
colorForElement: element

	^ self propertiesMap at: (self propertyBlock value: element)! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:52'!
elements: aSymbolOrBlock

	elements := aSymbolOrBlock ! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:56'!
elementsFor: aContainer

	^ elements moValue: aContainer! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/20/2009 19:02'!
properties: aCollectionOfProperties

	| map |
	map := self propertiesMap.
	1 to:aCollectionOfProperties size do: [ :i |
		map add: ((aCollectionOfProperties at: i) -> (self colorAtIndex: i + 1))
		].
	^ map! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 19:40'!
propertiesMap

	^ propertiesMap ifNil: [ propertiesMap := Dictionary new]! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:23'!
propertiesMap: aDictionary

	propertiesMap := aDictionary! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'simon.denier 4/19/2009 20:01'!
propertyBlock

	^ propertyBlock ifNil: [ ^ [:element | element property]]! !

!DistributionMapExample methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 13:54'!
propertyBlock: oneParameterBlock

	propertyBlock := oneParameterBlock ! !

!DistributionMapExample methodsFor: 'public-view rendering' stamp: 'Alexandre Bergel 12/16/2009 23:33'!
render: classes
	"(DistributionMapExample new render: Collection withAllSubclasses) open"
	"broken"
	| nodes view |
	nodes := classes.

	view := MOViewRenderer new.
	view interaction nodraggable.
	view interaction popupText.
	view nodes: nodes forEach: [ :node |
		view interaction nodraggable.
		view interaction popupText: [:el| el selector].
		view shape: (
			MORectangleShape new squareSize: 10 ;
				fillColor: [:el | self colorForElement: el]
		).
		view nodes: (self elementsFor: node).
		view layout: (MOGridLayout new gapSize: 1).
	].
	view gridLayout.

	^ view! !

Object subclass: #MOBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

MOBenchmarks class
	instanceVariableNames: 'view'!

MOBenchmarks class
	instanceVariableNames: 'view'!

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre.Bergel 9/25/2009 21:06'!
edges
	"
	Time millisecondsToRun: self new edges        
		=> 13922 (Alexandre.Bergel 9/25/2009 21:06 -- with the cache, but it is buggy)
		=> 26589 (Alexandre.Bergel 9/25/2009 21:04 - new and faster machine, but without the cache)
		
		=> 14198 (Alexandre.Bergel 8/18/2009 21:40)
		
		=> 13238 (Alexandre.Bergel 5/14/2009 01:03) Doru screwed everything now
		=> 13044 (Alexandre.Bergel 5/14/2009 00:58) Doru screwed up something
		=> 12982 (ab 5/12/2009 22:54 With Jannik pair programming) smarter cache
		=> 13033 (ab 5/12/2009 22:31) node are always cached
		=> 12773 April 15, 2009 (13:55) no aliasing
		=> 22602 April 15, 2009 (13:54) with aliasing
		=> 12961 April 15, 2009 (13:50) Minor addition (cache for edges)
		=> 12919 April 10, 2009 (23:51) Fixed a bug when using the cache
		=> 13234 April 10, 2009 (23:09) Added caches in edges
		=> 21914 April 10, 2009 (17:56) Added a cache for bounds in MORoot, see comments of MORoot>>absoluteBounds
		=> 28266 April 10, 2009 (17:37) Removed haltOnce
		=> 35737 April 10, 2009 (17:32) Aliasing removed, use of absolute bounds instead of relative bounds
		=> 27260 March 26, 2009 (11:18) 
		=> 28470 March 10, 2009 (13:55) Replaced calls to 
					drawPath:borderWidth:borderColor: by line:to:width:color: in BalloonCanvas
		=> 41319 March 10, 2009 (13:52) No idea how I gained improvement
		=> 43842 March 9, 2009 (13:17) No idea why this is slow
		=> 36441 March 6, 2009 (10:42) removed some indirection with nil
		=> 38067 March 6, 2009 (10:18) I replaced IdentityDictionary by RBIdentityDictionary
		=> 51333 March 6, 2009 (9:55)

	MessageTally spyOn: MOBenchmarks new edges
	"
	
	| view bounds form canvas size |
	view := MOViewRenderer new.
	size := 30.
	view nodes: (1 to: size).
	view edges: (1 to: size) from: #yourself toAll: (1 to: size).

	view root applyLayout.
	bounds := view root bounds.
	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	^ [1 to: 1000 do: [:i | view root displayOn: canvas]]
	
"Time millisecondsToRun:[	| view bounds form canvas size |
	view := MOViewRenderer new.
	size := 30.
	view nodes: (1 to: size).
	view edges: (1 to: size) from: #yourself toAll: (1 to: size).

	view root applyLayout.
	bounds := view root bounds.
	
	form := Form extent: bounds extent.
	canvas := BalloonCanvas on: form.

	^ [1 to: 1000 do: [:i | view root displayOn: canvas]]]"
	! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre.Bergel 9/25/2009 21:04'!
edges2
	"
	self new edges2    
		=> 1325 (Alexandre.Bergel 9/25/2009 21:04 - new and faster machine)
		
		=>  1707 (Alexandre.Bergel 8/18/2009 21:40)
		=>  1543 (Alexandre.Bergel 4/10/2009 23:10)
		=>  1352 (Alexandre.Bergel 4/10/2009 17:47)
		=> 1291 (Alexandre.Bergel 4/2/2009 01:16)
		=> 2692 (March 26, 2009)  -- VW: 19
	"
	
	| view size|
	view := MOViewRenderer new.
	size := 5.
	view nodes: (1 to: size) forEach: [:each | view nodes: (1000 to: 1010). view gridLayout].
	view edges: (1 to: size) from: #yourself toAll: [:each | (1 to: size) copyWithout: each].

	^ Time millisecondsToRun: [
		1 to: 1000 do: [:i | view root applyLayout]]

"	^ Time millisecondsToRun: [view root applyLayout].
""	bounds := view root bounds.
	
	form := Form extent: bounds extent.
	canvas := BalloonCanvas on: form.
"
"	^ Time millisecondsToRun: [
		1 to: 1000 do: [:i | view root displayOn: canvas]]
	
"	

"VW CODE:

Time millisecondsToRun: [	
  | view size |
	view := ViewRenderer new.
	view := MOViewRenderer new.
	size := 5.
	view nodes: (1 to: size) forEach: [:each | view nodes: (1000 to: 1010). view gridLayout].
	view edges: (1 to: size) from: #yourself toAll: [:each | (1 to: size) copyWithout: each].

	1 to: 1000 do: [:i | view canvas]].
"! !

!MOBenchmarks methodsFor: 'forms' stamp: 'ab 5/12/2009 22:29'!
form1
	"
	self new form1
	Pair programming with Fabrizio Perin

	MessageTally spyOn: MOBenchmarks new form1
	Time millisecondsToRun: self new form1 
	
	=>  155 (ab 5/12/2009 22:29) 
	=>  145 Alexandre.Bergel 5/10/2009 23:52 Added the form cache
	=> 2476 Alexandre.Bergel 5/10/2009 22:28  No cache at all
	MessageTally spyOn: MOBenchmarks new form1
	"
	
	| view bounds form canvas size |
	view := MOViewRenderer new.

	size := 30.
	view nodes: (1 to: 5) forEach: [:each|
		view nodes: (1 to: size).
		view edges: (1 to: size) from: #yourself toAll: (1 to: size) using: (MOStraightLineShape new) fromGlobal: false toGlobal: false.
		view gridLayout].

	view root applyLayout.
	bounds := view root bounds.
	
	"The size of each node is 90@75"
	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	^ [1 to: 50 do: [:i | view root displayOn: canvas]]
! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre.Bergel 8/18/2009 22:14'!
manyNodes
	"
	Time millisecondsToRun: self new manyNodes  

	=> 3200 nodes =>  13088 ms	
	=> 1600 nodes =>  3349 ms	
	=> 800 nodes =>   817 ms	
	=> 400 nodes =>   211 ms	
	=> 200 nodes =>   56 ms	
	=> 100 nodes =>  18 ms

	
	
	=> 800 nodes => 831 ms (Alexandre.Bergel 8/18/2009 22:10) Added caches for bounds and removed unnecessary call in origin. 
	=> 800 nodes => 1888 (Alexandre.Bergel 8/18/2009 21:45) added a cache for the bounds
	=> 800 nodes => 3811 (Alexandre.Bergel 8/18/2009 21:42) just added a temporary variable in MORoot>>updatesBounds to call bounds only once
	=> 800 nodes => 3962 (Alexandre.Bergel 8/18/2009 21:39)

	No optimization Alexandre.Bergel 7/22/2009 09:39
	=> 3200 nodes =>  62365 ms	
	=> 1600 nodes =>  17317 ms	
	=> 800 nodes =>  4587 ms	
	=> 400 nodes =>  1152 ms	
	=> 200 nodes =>  252 ms	
	=> 100 nodes =>  65 ms



	MessageTally spyOn: self new manyNodes
	"
	
	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: 3200).
	^ [ view root applyLayout ] 
	
"Time millisecondsToRun:[	| view bounds form canvas size |
	view := MOViewRenderer new.
	size := 30.
	view nodes: (1 to: size).
	view edges: (1 to: size) from: #yourself toAll: (1 to: size).

	view root applyLayout.
	bounds := view root bounds.
	
	form := Form extent: bounds extent.
	canvas := BalloonCanvas on: form.

	^ [1 to: 1000 do: [:i | view root displayOn: canvas]]]"
	! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre.Bergel 8/18/2009 21:40'!
openSimpleGraph
	"
	self new openSimpleGraph 
	=> 2424 (Alexandre.Bergel 8/18/2009 21:40)
	=> 1231 (Alexandre.Bergel 4/10/2009 23:11)
	=> 1471 (Alexandre.Bergel 4/10/2009 17:58)
	=> 1178 (Alexandre.Bergel 4/2/2009 01:17)
	=> 3674 (March 27, 2009)  (VW: 10408)
	"
	^ Time millisecondsToRun: 
	[| view |
	view := MOViewRenderer new.
	view nodes: (1 to: 100) forEach: [:each|
		view nodes: (1 to: 500).
		view gridLayout
	].
	view gridLayout.
	view open.
]! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/14/2010 10:22'!
reportEdgeBounds: iteration
	"
	self new reportEdgeBounds: 500  
	=> 135 (AlexandreBergel 9/14/2010 10:21 & Henrik) with introducing the cache set in MOEdge>>bounds
	=> 1630 (AlexandreBergel 9/14/2010 10:20 & Henrik)

 	"

	| view edges |
	view := MOViewRenderer new.
	view nodes: (1 to: 1000).
	edges := view edges: {1} from: #yourself toAll: (2 to: 1000).

	^ Time millisecondsToRun: [ iteration timesRepeat: [ edges do: #bounds] ] 
! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre Bergel 6/10/2010 18:21'!
reportElementAtFor: iteration
	"
	self new reportElementAtFor: 100

	KaiProfiler viewProfiling: [	self new reportElementAtFor: 2500 ]
	"
	| view node center |
	view := MOViewRenderer new.
	view node: #a forIt: [ view node: #a forIt: [ view node: #a forIt: [ view node: #a forIt: [ node := view node: #a ] ] ] ].
	"view open.
	"
	
	center := node bounds center.
	^ [ iteration timesRepeat: [(view root elementAt: center )] ] timeToRun! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre Bergel 6/7/2010 21:01'!
reportManyDisplayingInnerNodesAndEdgesBenchFor: numberOfNodes


	| view bounds form canvas |
	view := MOViewRenderer new.
	view nodes: (1 to: numberOfNodes) forEach: 
		[:each1| view nodes: (1 to: numberOfNodes) forEach: 
			[:each2| view nodes: (1 to: numberOfNodes) forEach: 
				[:each3| view nodes: (1 to: numberOfNodes). view edges:  (1 to: numberOfNodes) from: #yourself toAll: (1 to: numberOfNodes)] ] ].
	 view root applyLayout.

	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	^ Time millisecondsToRun: [ 100 timesRepeat: [ view root displayOn: canvas ] ] 
! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre Bergel 6/7/2010 20:45'!
reportManyDisplayingInnerNodesBenchFor: numberOfNodes


	| view bounds form canvas |
	view := MOViewRenderer new.
	view nodes: (1 to: numberOfNodes) forEach: 
		[:each1| view nodes: (1 to: numberOfNodes) forEach: 
			[:each2| view nodes: (1 to: numberOfNodes) forEach: 
				[:each3| view nodes: (1 to: numberOfNodes) ] ] ].
	 view root applyLayout.

	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	^ Time millisecondsToRun: [ view root displayOn: canvas ] 
! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/6/2010 18:28'!
reportManyEdgesBenchFor: numberOfEdges

	| v view |
	v := 1 to: numberOfEdges.
	view := MOViewRenderer new.
	view nodes: v.

	^ Time millisecondsToRun: [
		view edges: v from: 1 toAll: v.
		view root applyLayout ] ! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre Bergel 6/7/2010 20:45'!
reportManyInnerNodesBenchFor: numberOfNodes

	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: numberOfNodes) forEach: 
		[:each1| view nodes: (1 to: numberOfNodes) forEach: 
			[:each2| view nodes: (1 to: numberOfNodes) forEach: 
				[:each3| view nodes: (1 to: numberOfNodes) ] ] ].
	^ Time millisecondsToRun: [ view root applyLayout ] 
! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre.Bergel 9/26/2009 12:30'!
reportManyNodesBenchFor: numberOfNodes


	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: numberOfNodes).
	^ Time millisecondsToRun: [ view root applyLayout ] 
! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre Bergel 7/16/2010 09:17'!
reportManySmallNodesBenchFor: numberOfNodes

	"
	self new reportManySmallNodesBenchFor: 2000
	"
	| view bounds form canvas node |
	view := MOViewRenderer new.
	view nodes: {$a . $b . $c} forEach: [:each|
		view node: #foo forIt: [
			view nodes: (1 to: numberOfNodes).
			view gridLayout gapSize: 1]
	].
	view root applyLayout.
	
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	
"	^ Time millisecondsToRun: [ view root displayOn: canvas ]"
	node := view root nodes first.
	
	^ Time millisecondsToRun: [ 10 timesRepeat: [ node announce: (MOMouseDrag step: 1@2). view root displayOn: canvas ] ]

"	KaiProfiler viewProfiling: [ 5 timesRepeat: [ node announce: (MOMouseDrag step: 1@2). view root displayOn: canvas ] ]
"! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre Bergel 7/15/2010 13:30'!
reportPackageBlueprintLikeProfiling

	"
	self new reportPackageBlueprintLikeProfiling 
	=>7204 (Alexandre Bergel 7/15/2010 13:30)
	"
	| view bounds form canvas node |
	view := MOViewRenderer new.
	view nodes: #(1 2) forEach: [:each |
		view nodes: (1 to: 26) forEach: [:each2|
			view node: #foo forIt: [
				view node: #foo forIt: [
					view nodes: (1 to: 114).
					view gridLayout gapSize: 1
				]
			]
		].
		view gridLayout gapSize: 1
	].
	view root applyLayout.
	
	node := view root nodes first.
	bounds := view root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	^ Time millisecondsToRun: [ 5 timesRepeat: [ node announce: (MOMouseDrag step: 1@2). view root displayOn: canvas ] ]

! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'AlexandreBergel 9/12/2010 17:50'!
reportSubnodesLookup: iteration
	"
	self new reportSubnodesLookup: 20000  
	=> 1810 (AlexandreBergel and Henrik 9/12/2010 17:50)
 	"

	| view |
	view := MOViewRenderer new.
	view nodes: (1 to: 2) forEach: [ :each | 
		view nodes: (2 to: 4) forEach: [ :each2 | 
			view nodes: (4 to: 8) forEach: [ :each3 | 
				view node: each * each2 * each3.
			] 
		] 
	].


	^ Time millisecondsToRun: [ iteration timesRepeat: [ view localLookupNode: 8 * 4 * 2 ] ] 
! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre.Bergel 8/18/2009 21:40'!
subviews
	"
	MessageTally spyOn: self new subviews
	Time millisecondsToRun: self new subviews
		=>  179 (Alexandre.Bergel 8/18/2009 21:40)
		=>  153  (ab 5/12/2009 22:55 with Jannik) smarter cache
		=>   159  (Alexandre.Bergel 5/11/2009 00:03) Added cache
		=>  986 (Alexandre.Bergel 4/30/2009 18:58) Added a test foir the border
		=> 868 (Alexandre.Bergel 4/10/2009 23:13)
		=> 772 (Alexandre.Bergel 4/10/2009 17:59)
		 1872 Feb 21 (with cache shapeBounds, but it seems that it does not recurs)
		2697 Feb 21
	"
	
	| view bounds form canvas |
	view := MOViewRenderer new.
	view nodes: #(a) forEach: [:each |
		view nodes: (1 to: 5) forEach: [:e |
			view nodes: (1 to: 5).
		].
	].

"	^ Time millisecondsToRun: [
		1 to: 1000 do: [:i | view root applyLayout]]"

	view root applyLayout.
	bounds := view root bounds.
	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.

	^[ 1 to: 1000 do: [:i | view root displayOn: canvas] ]
	
	! !

!MOBenchmarks methodsFor: 'benchmarks' stamp: 'Alexandre.Bergel 8/18/2009 21:41'!
subviews2
	"
	MessageTally spyOn: self new subviews2   
	Time millisecondsToRun: self new subviews2   
		=> 1145 (Alexandre.Bergel 8/18/2009 21:41)
		
		=> 833  	(Alexandre.Bergel 4/30/2009 18:59) Added a test for the border
		=> 788 	(Alexandre.Bergel 4/10/2009 23:13)
		=> 868 	(Alexandre.Bergel 4/10/2009 17:59) 
		=> 774  (Alexandre.Bergel 4/2/2009 01:15)
		=> 993  (Alexandre.Bergel 4/2/2009 01:14)
		=> 1055 (Alexandre.Bergel 4/2/2009 01:13)
		=> 1176 (Alexandre.Bergel 4/2/2009 01:12)
		=> 1273 (Alexandre.Bergel 4/2/2009 01:04)
		=> 1900 (April 2, 2009, 01:03)
		=> 1445 (March 26, 2009)  -- VW: 11
	"
	
	| view size|
	view := MOViewRenderer new.
	size := 5.
	view nodes: (1 to: size) forEach: [:each | view nodes: (1 to: size). view gridLayout].
	
"	^ MessageTally spyOn: [
		1 to: 1000 do: [:i | view root applyLayout]]
"	
	^ [ 1 to: 1000 do: [:i | view root applyLayout] ]


"	^ Time millisecondsToRun: [view root applyLayout].
"

"	bounds := view root bounds.
	
	form := Form extent: bounds extent.
	canvas := BalloonCanvas on: form.
"
"	^ Time millisecondsToRun: [
		1 to: 1000 do: [:i | view root displayOn: canvas]]
	
"	

"VW CODE:

Time millisecondsToRun: [	
  | view size |
	view := ViewRenderer new.
	size := 5.
	view nodes: (1 to: size) forEach: [:each | view nodes: (1 to: size). view gridLayout].
	1 to: 1000 do: [:i | view canvas]].
"! !

Object subclass: #MOBrowser
	instanceVariableNames: 'canvas root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Morphic'!

!MOBrowser methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 11:11'!
canvas
	^ canvas! !

!MOBrowser methodsFor: 'morphic' stamp: 'Alexandre Bergel 5/12/2010 09:41'!
exportAsBMP
	self canvas exportAsBMP! !

!MOBrowser methodsFor: 'morphic' stamp: 'Alexandre Bergel 5/12/2010 09:40'!
exportAsGIF
	self canvas exportAsGIF! !

!MOBrowser methodsFor: 'morphic' stamp: 'Alexandre Bergel 5/12/2010 09:40'!
exportAsJPEG
	self canvas exportAsJPEG! !

!MOBrowser methodsFor: 'morphic' stamp: 'tg 4/20/2010 09:58'!
exportAsPNG
	self canvas exportAsPNG! !

!MOBrowser methodsFor: 'morphic' stamp: 'Alexandre Bergel 7/4/2010 19:54'!
exportAsXML
	self canvas exportAsXML! !

!MOBrowser methodsFor: 'morphic' stamp: 'Alexandre Bergel 7/4/2010 19:52'!
exportMenu
	| menuMorph |
	menuMorph := MenuMorph new.
	menuMorph 
				add: 'Export as PNG'
				target: self
				selector: #exportAsPNG.
	menuMorph 
				add: 'Export as JPEG'
				target: self
				selector: #exportAsJPEG.
	menuMorph 
				add: 'Export as BMP'
				target: self
				selector: #exportAsBMP.
	menuMorph 
				add: 'Export as GIF'
				target: self
				selector: #exportAsGIF.
				
	menuMorph 
				add: 'Export as XML'
				target: self
				selector: #exportAsXML.

	^ menuMorph! !

!MOBrowser methodsFor: 'morphic' stamp: 'tg 9/6/2010 11:36'!
initializeButtonsIn: aWin

	| dock buttons tools offset |
	dock := aWin newToolDockingBar.
	buttons := OrderedCollection new.
	buttons add:( (aWin
			newButtonFor: self root
			getState: #isZoomOn
			action: #increaseZoom
			arguments: #()			
			getEnabled: nil
			labelForm: MenuIcons mondrianZoomIn 
			help: 'Zoom in') 
			valueOfProperty: #noBorder ifAbsentPut: [true];
			valueOfProperty: #noFill ifAbsentPut: [true];
			yourself).
	buttons add: ((aWin
			newButtonFor: self root
			getState: #isZoomOn
			action: #decreaseZoom
			arguments: #()			
			getEnabled: nil
			labelForm: MenuIcons mondrianZoomOut
			help: 'Zoom out') 
			valueOfProperty: #noBorder ifAbsentPut: [true];
			valueOfProperty: #noFill ifAbsentPut: [true];
			yourself).
	tools := aWin newToolbar: buttons.
	dock 
			add: 'Export' translated
			font: aWin theme menuBarFont
			icon: nil
			help: 'Export' translated
			subMenu: self exportMenu.
	dock addMorphBack: tools.
	offset := dock minExtent y.
	aWin 
		addMorph: dock
		fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 1 @ 0)
					offsets: (0 @ 0 corner: 0 @ offset))
"
	| zoomIncButton zoomDecButton |
	zoomIncButton := PluggableButtonMorph
				on: self root
				getState: #isZoomOn
				action: #increaseZoom
				label: #zoomIncLabel.
	aWindow 
		addMorph: zoomIncButton
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 0.5 @ 0) offsets: (0 @ 0 corner: 0 @ 24)).

	zoomDecButton := PluggableButtonMorph
				on: self root
				getState: #isZoomOn
				action: #decreaseZoom
				label: #zoomDecLabel.
	aWindow 
		addMorph: zoomDecButton
		fullFrame: (LayoutFrame fractions: (0.5 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ 24)).
"! !

!MOBrowser methodsFor: 'morphic' stamp: 'Alexandre Bergel 2/23/2010 22:11'!
open
	^ self open: 'Mondrian Canvas'! !

!MOBrowser methodsFor: 'morphic' stamp: 'tg 9/6/2010 11:37'!
open: windowLabel
	"The canvas needs to be accessed from outside, especially by the ViewRenderer. This is necessary for sharing the announcer between the canvas and the view"
	| window pane |
	window := StandardWindow labelled: windowLabel.
	window model: self.
	window extent: 640 @ 480.
		
	pane := ScrollPane new.
	
	canvas := MOCanvas on: self root.
	self initializeButtonsIn: window.

	pane scroller addMorph: canvas.
	window 
		addMorph: pane
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 26 corner: 0 @ 0)).

	window openInWorld.
	canvas updateBounds.
	^ window! !

!MOBrowser methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 20:29'!
root
	^ root! !

!MOBrowser methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 20:30'!
root:  aMORoot 
	root := aMORoot! !

!MOBrowser methodsFor: 'morphic' stamp: 'Alexandre Bergel 3/16/2010 09:00'!
windowIsClosing
	canvas root allNodesDo: [ :n | n interaction stopProcesses ]! !

Object subclass: #MODummyNode
	instanceVariableNames: 'edge index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MODummyNode class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
new
	"Answer a newly created and initialized instance."
	
	^super new initialize! !

!MODummyNode class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
on: anEdge slot: anIndex
	
	^(self new)
		edge: anEdge;
		slot: anIndex;
		yourself! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
edge
	
	^edge! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
edge: anEdge
	
	edge := anEdge! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
height
	
	^0! !

!MODummyNode methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	" *** Replace this comment with the appropriate initialization code *** "
	
	^self! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
slot: anIndex
	
	index := anIndex! !

!MODummyNode methodsFor: 'accessing' stamp: 'simon.denier 4/30/2009 14:07'!
translateTo: aPoint
	
	"edge index: index point: aPoint"! !

!MODummyNode methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
width
	
	^0! !

Object subclass: #MOEasel
	instanceVariableNames: 'window canvas canvasScrollPane textEditor view variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

MOEasel class
	instanceVariableNames: 'previousScripts'!

MOEasel class
	instanceVariableNames: 'previousScripts'!

!MOEasel class methodsFor: 'menu' stamp: 'Alexandre Bergel 6/19/2010 19:15'!
icon
	^ MenuIcons mondrian! !

!MOEasel class methodsFor: 'class initialization' stamp: 'Alexandre Bergel 5/7/2010 18:14'!
initialize
	self environment at: #TheWorldMenu ifPresent: [ :class |
		 ((class respondsTo: #registerOpenCommand:)
			and: [((class class >>#registerOpenCommand:) sendsSelector: #deprecated:) not])
 	     			ifTrue: [class registerOpenCommand: { 'Mondrian Easel' . {self. #open}}]]
! !

!MOEasel class methodsFor: 'menu' stamp: 'tg 8/7/2010 13:50'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'MondrianEasel')
		order: 3; 
		parent: #Moose;
		label: 'Mondrian Easel';
		icon: self icon;
		action:[MOEasel open]! !

!MOEasel class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 8/26/2009 17:48'!
open
	"^ MOEaselBuilder open: self new."
	^self new open! !

!MOEasel class methodsFor: 'instance creation' stamp: 'Alexandre Bergel 12/19/2009 16:29'!
openOn: bindingsOrABinding
	| easel |
	bindingsOrABinding isCollection
		ifTrue: [ easel := self new. bindingsOrABinding do: [:bind | easel addBinding: bind ]. ^ easel open].
	^self new addBinding: bindingsOrABinding; open! !

!MOEasel class methodsFor: 'instance creation' stamp: 'Alexandre Bergel 12/17/2009 01:43'!
openWithTitle: aTitle

	^self new openWithTitle: aTitle ! !

!MOEasel class methodsFor: 'previousscript' stamp: 'Alexandre Bergel 7/26/2010 10:16'!
previousScripts
	^ previousScripts ifNil: [ previousScripts := OrderedCollection new ]! !

!MOEasel methodsFor: 'button' stamp: 'tg 5/20/2008 17:50'!
accept
	self generate.
	textEditor hasUnacceptedEdits: false! !

!MOEasel methodsFor: 'text editor' stamp: 'Alexandre.Bergel 8/26/2009 17:47'!
accept: aString notifying: aController
	textEditor := aController.
    self generate.
	^true! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:36'!
addBinding: aBinding
	self addVariableNamed: aBinding key withValue: aBinding value! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:34'!
addVariableNamed: aSymbol withValue: aValue
	self variableBindings at: aSymbol put: aValue! !

!MOEasel methodsFor: 'interface opening' stamp: 'Alexandre Bergel 7/26/2010 10:11'!
allCommandClasses
	^ MOEaselCommand allSubclasses select: [:cls | cls category = self class category ]! !

!MOEasel methodsFor: 'binding' stamp: 'Alexandre Bergel 3/4/2010 14:17'!
allVariableKeys
	| keysCopy |
	keysCopy := self variableBindings keys asOrderedCollection copy.
	^ keysCopy add: #view; yourself! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:39'!
bindingOf: aSymbol
    ^ self variableBindings associationAt: aSymbol ifAbsent: [
		aSymbol asSymbol = #view ifTrue: [aSymbol -> view] ifFalse: [nil]
	]! !

!MOEasel methodsFor: 'accessing' stamp: 'jannik.laval 5/15/2009 17:25'!
canvas
	^ canvas! !

!MOEasel methodsFor: 'menu' stamp: 'Alexandre Bergel 12/17/2009 15:39'!
closeEasel
	(UIManager default confirm: 'Are you sure to close the Easel?')
		ifTrue: [ window delete ]! !

!MOEasel methodsFor: 'binding-completion' stamp: 'lr 7/7/2010 08:26'!
completionAdditionals
	^ SortedCollection new
		add: (ECLocalEntry contents: #view type: #local);
		addAll: (variableBindings keys
			collect: [ :each | ECLocalEntry contents: each type: #local ]);
		yourself! !

!MOEasel methodsFor: 'binding-completion' stamp: 'lr 7/7/2010 08:22'!
completionController
	| controller | 
	controller := self triggerEvent: #getCompletionController.
	controller ifNil:[ controller := self initializeCompletionController ].
	^controller! !

!MOEasel methodsFor: 'hooks' stamp: 'Alexandre Bergel 6/26/2010 13:03'!
configureView: aViewRenderer
	"Override this method to insert your particularization"! !

!MOEasel methodsFor: 'binding-completion' stamp: 'AlexandreBergel 9/2/2010 14:46'!
createCompletionController
	^ (Optimist ifTrue: [OController] ifFalse: [ECWorkspaceController]) model: self
	"^ ECWorkspaceController model: self"! !

!MOEasel methodsFor: 'zoom' stamp: 'simondenier 10/27/2009 16:36'!
decreaseZoom

	self canvas root decreaseZoom.
	self canvas root updateWindow.! !

!MOEasel methodsFor: 'error management' stamp: 'Alexandre.Bergel 9/25/2009 19:53'!
disableErrorFlag
	canvas disableErrorFlag! !

!MOEasel methodsFor: 'button' stamp: 'tg 5/20/2008 15:46'!
doButtonLabel
	^'Generate View'! !

!MOEasel methodsFor: 'button' stamp: 'Alexandre Bergel 3/31/2010 18:24'!
evaluate: text notify: textEdit
	Compiler 
		evaluate: text
		notifying: textEdit
		logged: false.
! !

!MOEasel methodsFor: 'menu' stamp: 'Alexandre Bergel 12/17/2009 15:50'!
exportAsBMP
	self canvas exportAsBMP! !

!MOEasel methodsFor: 'menu' stamp: 'Alexandre Bergel 12/17/2009 15:49'!
exportAsGIF
	self canvas exportAsGIF! !

!MOEasel methodsFor: 'menu' stamp: 'Alexandre Bergel 12/17/2009 15:49'!
exportAsJPEG
	self canvas exportAsJPEG! !

!MOEasel methodsFor: 'menu' stamp: 'Alexandre Bergel 12/17/2009 15:42'!
exportAsPNG
	self canvas exportAsPNG! !

!MOEasel methodsFor: 'menu' stamp: 'Alexandre Bergel 7/2/2010 10:38'!
exportAsXML
	self canvas exportAsXML! !

!MOEasel methodsFor: 'interface opening' stamp: 'tg 9/2/2010 17:14'!
fillDockingBar: dock usingFont: menuBarFont
	| commands groups menuMorph |
	commands := MOEaselCommand commandsForEasel: self.

	commands := commands select: #isMenu.
	groups := OrderedCollection new.
	commands do: [:c | (groups includes: c group) ifFalse: [ groups add: c group] ].

	groups do: [:groupName |
		
		menuMorph := MenuMorph new.
		commands do: [ :command |
			((command group = groupName) and: [ command class canUnderstand: #execute ] ) 
				ifTrue: [ menuMorph add: command title target: command selector: #execute ] ].
		menuMorph hasItems 
			ifTrue: [
				dock 
				add: groupName translated
				font: menuBarFont
				icon: nil
				help: groupName translated
				subMenu: menuMorph ].
	].

	dock 
			add: 'Previous scripts' translated
			font: menuBarFont
			icon: nil
			help: 'Export' translated
			subMenu: self previousScriptMenu.

	dock 
			add: 'Help' translated
			font: menuBarFont
			icon: nil
			help: 'Export' translated
			subMenu: self helpMenu.

! !

!MOEasel methodsFor: 'button' stamp: 'AlexandreBergel 9/5/2010 17:21'!
generate
	self stopAllProcesses.
	view := self viewRendererClass new.
	view setDefaultHandlers.
	view setDefaultHandlerForWindow: window.
	
	"This is a hook. Empty in MOEasel"
	self configureView: view. 
	
	"view setUsefulHandlersForNodes."
	self storeScript.
	self disableErrorFlag.

	self evaluate: textEditor text notify: textEditor.
	
	canvasScrollPane scroller removeMorph: canvas.
	canvas := MOCanvas on: view root.
	canvas initializeHanders.
	canvasScrollPane scroller addMorph: canvas.
	
	"(window submorphThat: [:m | m isKindOf: ScrollPane] ifNone: [nil])
		submorphs at: 1 put: canvas."
	"Horible hack"
	(window submorphs 
		detect: [:each | each class == ScrollPane]) scroller
	 		submorphs at: 1 put: canvas.

	canvas updateBounds.
! !

!MOEasel methodsFor: 'interface opening' stamp: 'tg 9/5/2010 00:09'!
getButtonForWindow: aWin	
	| commands |
	commands := MOEaselCommand commandsForEasel: self.
	commands := commands select: #isButton.
	
	^ commands collect: [ :command |
		(aWin
			newButtonFor: command
			getState: #isActive
			action: #execute
			arguments: #()			
			getEnabled: nil
			labelForm: command icon
"			getLabel: #title
"			help: command title)
			"this is a hack to tell the glamorous theme not to fill or draw borders"
			valueOfProperty: #noBorder ifAbsentPut: [true];
			valueOfProperty: #noFill ifAbsentPut: [true];
			yourself ]! !

!MOEasel methodsFor: 'binding-completion' stamp: 'lr 7/7/2010 08:30'!
guessTypeForName: aString
	aString = 'view'
		ifTrue: [ ^ self viewRendererClass ].
	variableBindings
		at: aString
		ifPresent: [ :value | ^ value class ].
	^ nil! !

!MOEasel methodsFor: 'binding-completion' stamp: 'lr 7/7/2010 08:21'!
hasBindingOf: aString 
	^ (self guessTypeForName: aString) notNil! !

!MOEasel methodsFor: 'binding-completion' stamp: 'lr 7/7/2010 08:21'!
hasBindingThatBeginsWith: aString
	^ false! !

!MOEasel methodsFor: 'help' stamp: 'Alexandre Bergel 6/26/2010 11:53'!
helpClass
	^ MOEaselHelp! !

!MOEasel methodsFor: 'help' stamp: 'AlexandreBergel 9/6/2010 18:29'!
helpMenu
	| menuMorph |
	menuMorph := MenuMorph new.
	self helpClass populateMenu: menuMorph forEasel: self.
	
	^ menuMorph ! !

!MOEasel methodsFor: 'zoom' stamp: 'simondenier 10/27/2009 16:36'!
increaseZoom

	self canvas root increaseZoom.
	self canvas root updateWindow.! !

!MOEasel methodsFor: 'interface opening' stamp: 'Alexandre Bergel 3/2/2010 21:38'!
initialExtent

	^ RealEstateAgent standardWindowExtent! !

!MOEasel methodsFor: 'interface opening' stamp: 'tg 9/5/2010 00:11'!
initializeButtonsIn: aWin

	| dock buttons tools offset |
	dock := aWin newToolDockingBar.
	buttons := self getButtonForWindow: aWin.			
			
	tools := aWin newToolbar: buttons.
	self fillDockingBar: dock usingFont: aWin theme menuBarFont.

	dock addMorphBack: tools.
	offset := dock minExtent y.
	aWin 
		addMorph: dock
		fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 1 @ 0)
					offsets: (0 @ 0 corner: 0 @ offset))
"
	| zoomIncButton zoomDecButton |
	zoomIncButton := PluggableButtonMorph
				on: self root
				getState: #isZoomOn
				action: #increaseZoom
				label: #zoomIncLabel.
	aWindow 
		addMorph: zoomIncButton
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 0.5 @ 0) offsets: (0 @ 0 corner: 0 @ 24)).

	zoomDecButton := PluggableButtonMorph
				on: self root
				getState: #isZoomOn
				action: #decreaseZoom
				label: #zoomDecLabel.
	aWindow 
		addMorph: zoomDecButton
		fullFrame: (LayoutFrame fractions: (0.5 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ 24)).
"! !

!MOEasel methodsFor: 'binding-completion' stamp: 'lr 7/7/2010 08:22'!
initializeCompletionController
	| controller |
	controller := self createCompletionController.
	self 
		when: #getCompletionController
		evaluate: (MessageSend 
				receiver: controller
				selector: #yourself).
	^ controller! !

!MOEasel methodsFor: 'button' stamp: 'Alexandre Bergel 12/17/2009 15:45'!
isOn
	^false! !

!MOEasel methodsFor: 'hooks' stamp: 'Alexandre Bergel 6/26/2010 11:31'!
label
	^ 'Mondrian Easel'! !

!MOEasel methodsFor: 'menu' stamp: 'Alexandre Bergel 7/8/2010 11:33'!
menu: aMenuMorph shifted: aFalse 
	^ aMenuMorph ! !

!MOEasel methodsFor: 'text editor' stamp: 'Alexandre Bergel 12/17/2009 00:34'!
menu: aMenuMorph shifted: aFalse selection: anOBTextSelection
	aMenuMorph add: 'previous script...' translated
		target: self
		action: #retrievingPreviousScript.
	^ aMenuMorph! !

!MOEasel methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 13:39'!
numberOfPreviousScripts
	^ self previousScripts size! !

!MOEasel methodsFor: 'interface opening' stamp: 'Alexandre Bergel 6/26/2010 11:31'!
open
	^ self openWithTitle: self label! !

!MOEasel methodsFor: 'interface opening' stamp: 'jl 9/20/2010 16:27'!
openWithTitle: aTitle

	| easel doButton variableList |
	window := StandardWindow labelled: aTitle.
	easel := self.
	window model: easel.
	window extent: 640 @ 480.
	canvasScrollPane := ScrollPane new.
	canvas := MOCanvas on: MORoot new.
	self initializeButtonsIn: window.

	canvas initializeHanders.

	canvasScrollPane scroller addMorph: canvas.
	window 
		addMorph: canvasScrollPane
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0.6) offsets: (0 @ 26 corner: 0 @ 0)).
		"frame: (0 @ 0 corner: 1 @ 0.6)."
	

	textEditor := MOEaselTextEditor
				on: easel 
				text: #text
				accept: #accept:notifying:
				readSelection: #selection
				menu: #menu:shifted:.

	textEditor
		font: StandardFonts codeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	window 
		addMorph: textEditor
		fullFrame: (LayoutFrame fractions: (0 @ 0.6 corner: 0.75 @ 1) offsets: (0@0 corner: 0@ -25)).
	doButton := PluggableButtonMorph
				on: easel
				getState: #isOn
				action: #accept
				label: #doButtonLabel.
	window 
		addMorph: doButton
		fullFrame: (LayoutFrame fractions: (0 @ 1 corner: 0.75 @ 1) offsets: (0@ -25 corner: 0@0)).
	variableList := PluggableListMorph
				on: self
				list: #variableBindingNames
				selected: #variableSelection
				changeSelected: #variableSelection: .
	window 
		addMorph: variableList
		fullFrame: (LayoutFrame fractions: (0.75 @ 0.6 corner: 1 @ 1)).

	window openInWorld.
	canvas updateBounds.
	^ window! !

!MOEasel methodsFor: 'interface opening' stamp: 'Alexandre Bergel 3/21/2010 21:22'!
previousScriptMenu
	| previousScriptMenu pScripts index |
	previousScriptMenu := MenuMorph new.
	self previousScripts ifEmpty: [ 
			previousScriptMenu
				add: 'No previous script'
				target: self
				selector: #yourself.
				^ previousScriptMenu ].
	
	pScripts := self previousScripts collect: [:each | each copyFrom: 1 to: (each size min: 20)].
	index := 1.
	pScripts do: [ :str | 
		previousScriptMenu 
				add: str
				target: self
				selector: #setScriptNumber:
				argument: index.
		index := index + 1].

	^ previousScriptMenu! !

!MOEasel methodsFor: 'accessing' stamp: 'Alexandre Bergel 7/26/2010 10:17'!
previousScripts
	^ self class previousScripts! !

!MOEasel methodsFor: 'accessing' stamp: 'Alexandre Bergel 2/23/2010 18:26'!
removeAPreviousScript
	^ self previousScripts removeLast! !

!MOEasel methodsFor: 'zoom' stamp: 'Alexandre Bergel 6/26/2010 02:09'!
returnFalse

	^ false! !

!MOEasel methodsFor: 'binding-completion' stamp: 'lr 7/7/2010 08:23'!
selectedClassOrMetaClass
	^ nil! !

!MOEasel methodsFor: 'text editor' stamp: 'tg 5/20/2008 15:35'!
selection
	^1 to: 0! !

!MOEasel methodsFor: 'text editor' stamp: 'Alexandre Bergel 12/17/2009 01:38'!
setScript: aText
	textEditor setText: aText! !

!MOEasel methodsFor: 'text editor' stamp: 'Alexandre Bergel 3/21/2010 21:18'!
setScriptNumber: anInteger
	self setScript: (self previousScripts at: anInteger)! !

!MOEasel methodsFor: 'binding-shout' stamp: 'tg 5/20/2008 17:02'!
shoutAboutToStyle: aPluggableShoutMorphOrView
	aPluggableShoutMorphOrView workspace: textEditor.
	^true! !

!MOEasel methodsFor: 'interface opening' stamp: 'Alexandre Bergel 6/20/2010 23:40'!
stopAllProcesses
	canvas stopAllProcesses! !

!MOEasel methodsFor: 'button' stamp: 'Alexandre Bergel 2/23/2010 18:26'!
storeScript

	textEditor ifNil: [ 
		"textEditor is not set yet, nothing to store then"
		^ self].
	
	self numberOfPreviousScripts > 0 
		ifTrue: 
			[ self previousScripts last ~= textEditor text ifTrue: [ self previousScripts addFirst: textEditor text copy ] ]
		ifFalse: [ self previousScripts add: textEditor text copy ].
	self numberOfPreviousScripts > 10 ifTrue: [ self removeAPreviousScript ]! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:28'!
text
	^ textEditor isNil ifTrue: ['' asText] ifFalse: [textEditor text]! !

!MOEasel methodsFor: 'binding' stamp: 'tg 8/1/2009 02:25'!
variableBindingNames
	^ self variableBindings associations collect: [:each |
		each key, '->', each value printString ]! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:33'!
variableBindings
	^variableBindings ifNil: [variableBindings := Dictionary new]! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:28'!
variableBindings: aCollectionOfBindings
	variableBindings := aCollectionOfBindings! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:29'!
variableSelection
	^0! !

!MOEasel methodsFor: 'binding' stamp: 'tg 5/20/2008 17:29'!
variableSelection: anInteger! !

!MOEasel methodsFor: 'hooks' stamp: 'Alexandre Bergel 6/26/2010 13:02'!
viewRendererClass 
	^ MOViewRenderer! !

!MOEasel methodsFor: 'interface opening' stamp: 'Alexandre Bergel 6/15/2010 09:06'!
windowIsClosing
	self stopAllProcesses! !

Object subclass: #MOEaselCommand
	instanceVariableNames: 'easel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommand class methodsFor: 'interface opening' stamp: 'Alexandre Bergel 6/26/2010 12:08'!
allCommandClasses
	^ self allSubclasses! !

!MOEaselCommand class methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 7/13/2010 22:45'!
commandsForEasel: easel
	"
	self commandsForEasel: nil
	"
	| answer |
	answer := easel allCommandClasses collect: #new.
	answer := answer reject: [ :obj | obj class class methodDict includesKey: #isAbstract ].
	answer do: [ :c | c easel: easel ].
	^ answer sortedAs: #priority! !

!MOEaselCommand class methodsFor: 'accessing' stamp: 'Alexandre Bergel 4/2/2010 10:54'!
group
	"Return a string"
	
	^ 'unclassified'! !

!MOEaselCommand class methodsFor: 'querying' stamp: 'Alexandre Bergel 4/2/2010 10:22'!
groups
	^ self allSubclasses collect: #group! !

!MOEaselCommand methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 4/2/2010 10:32'!
easel: anEasel
	easel := anEasel! !

!MOEaselCommand methodsFor: 'hooks' stamp: 'Alexandre Bergel 6/26/2010 11:26'!
execute
	self subclassResponsibility ! !

!MOEaselCommand methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 4/2/2010 10:24'!
group
	^ self class group! !

!MOEaselCommand methodsFor: 'testing' stamp: 'tg 9/2/2010 17:11'!
hasIcon
	^ self icon notNil! !

!MOEaselCommand methodsFor: 'testing' stamp: 'tg 9/2/2010 17:09'!
icon 
	^ nil! !

!MOEaselCommand methodsFor: 'testing' stamp: 'Alexandre Bergel 4/2/2010 10:55'!
isActive
	^ false! !

!MOEaselCommand methodsFor: 'testing' stamp: 'Alexandre Bergel 4/2/2010 10:47'!
isButton
	^ self isMenu not! !

!MOEaselCommand methodsFor: 'testing' stamp: 'Alexandre Bergel 4/2/2010 10:43'!
isMenu
	"if false then it is a button"
	^ true! !

!MOEaselCommand methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:59'!
priority
	^ 5! !

!MOEaselCommand methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:39'!
title
	self subclassResponsibility! !

MOEaselCommand subclass: #MOEaselCommandAbout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandAbout class methodsFor: 'accessing' stamp: 'Alexandre Bergel 4/2/2010 10:21'!
group
	^ 'Mondrian'! !

!MOEaselCommandAbout methodsFor: 'hooks' stamp: 'Alexandre Bergel 6/26/2010 12:28'!
execute
	"Identify software version"

	| text dialog width |
	text := self license.
	width := 0.
	text linesDo: [ :l | width := width max: (UITheme current textFont widthOfStringOrText: l) ].
	dialog := LongMessageDialogWindow new entryText: text.
	dialog open.
	dialog width: (width + 120 min: Display width - 50)! !

!MOEaselCommandAbout methodsFor: 'hooks' stamp: 'AlexandreBergel 9/16/2010 00:41'!
license
	^ 'Mondrian is an information visualization engine that 
lets the visualization be specified via a script. It is built in 
VisualWorks Smalltalk and Pharo, and the scripting language 
is the Smalltalk language. It is based on a graph model and 
works directly with the objects to be represented.

License: MIT
http://www.moosetechnology.org/tools/mondrian
'! !

!MOEaselCommandAbout methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 11:03'!
priority
	^ 1! !

!MOEaselCommandAbout methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:39'!
title
	^ 'About...'! !

MOEaselCommand subclass: #MOEaselCommandExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

MOEaselCommandExporter subclass: #MOEaselCommandBMPExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandBMPExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/21/2010 21:23'!
execute
	easel exportAsPNG! !

!MOEaselCommandBMPExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:40'!
title
	^ super title, 'BMP'! !

!MOEaselCommandExporter class methodsFor: 'accessing' stamp: 'Alexandre Bergel 4/2/2010 10:21'!
group
	^ 'Export'! !

!MOEaselCommandExporter class methodsFor: 'testing' stamp: 'Alexandre Bergel 7/13/2010 22:40'!
isAbstract
	^ true! !

!MOEaselCommandExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 11:03'!
priority
	^ 30! !

!MOEaselCommandExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:40'!
title
	^ 'Export as '! !

MOEaselCommandExporter subclass: #MOEaselCommandGIFExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandGIFExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/21/2010 21:23'!
execute
	easel exportAsGIF! !

!MOEaselCommandGIFExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:40'!
title
	^ super title, 'GIF'! !

MOEaselCommandExporter subclass: #MOEaselCommandPNGExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandPNGExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/21/2010 21:23'!
execute
	easel exportAsPNG! !

!MOEaselCommandPNGExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:40'!
title
	^ super title, 'PNG'! !

MOEaselCommandExporter subclass: #MOEaselCommandXMLExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandXMLExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 7/2/2010 10:38'!
execute
	easel exportAsXML! !

!MOEaselCommandXMLExporter methodsFor: 'hooks' stamp: 'Alexandre Bergel 7/2/2010 10:37'!
title
	^ super title, 'XML'! !

MOEaselCommand subclass: #MOEaselCommandQuit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandQuit class methodsFor: 'accessing' stamp: 'Alexandre Bergel 4/2/2010 10:21'!
group
	^ 'Mondrian'! !

!MOEaselCommandQuit methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:17'!
execute
	easel closeEasel! !

!MOEaselCommandQuit methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 11:03'!
priority
	^ 2! !

!MOEaselCommandQuit methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:39'!
title
	^ 'Quit...'! !

MOEaselCommand subclass: #MOEaselCommandZoomIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandZoomIn methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:49'!
execute
	easel increaseZoom! !

!MOEaselCommandZoomIn methodsFor: 'hooks' stamp: 'tg 9/2/2010 17:10'!
icon
	^ MenuIcons mondrianZoomIn! !

!MOEaselCommandZoomIn methodsFor: 'testing' stamp: 'Alexandre Bergel 4/2/2010 10:55'!
isMenu
	"if false then it is a button"
	^ false! !

!MOEaselCommandZoomIn methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 11:31'!
priority
	^ 50! !

!MOEaselCommandZoomIn methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:53'!
title
	^ 'Zoom in'
! !

MOEaselCommand subclass: #MOEaselCommandZoomOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Easel'!

!MOEaselCommandZoomOut methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:49'!
execute
	easel decreaseZoom! !

!MOEaselCommandZoomOut methodsFor: 'hooks' stamp: 'tg 9/2/2010 17:11'!
icon
	^ MenuIcons mondrianZoomOut! !

!MOEaselCommandZoomOut methodsFor: 'testing' stamp: 'Alexandre Bergel 4/2/2010 10:55'!
isMenu
	"if false then it is a button"
	^ false! !

!MOEaselCommandZoomOut methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 11:31'!
priority
	^ 51! !

!MOEaselCommandZoomOut methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/2/2010 10:53'!
title
	^ 'Zoom out'! !

Object subclass: #MOFormsAdaptor
	instanceVariableNames: 'gridX component bounds columnSpan gridY rowSpan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-ComplexShape'!

MOFormsAdaptor subclass: #MOFigureAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-ComplexShape'!

!MOFigureAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:07'!
height: aNumber
	
	bounds height: aNumber! !

!MOFigureAdaptor methodsFor: 'accessing' stamp: 'Alexandre.Bergel 3/29/2009 18:34'!
initializeBounds
	self flag: #TODO.
	"In VW, preferredBounds is called. I do not know the impact of using bounds instead
	Alexandre.Bergel 3/29/2009 18:34"
	"bounds := component preferredBounds copy"
	
	bounds := component bounds! !

!MOFigureAdaptor methodsFor: 'accessing' stamp: 'Alexandre.Bergel 3/29/2009 20:01'!
install
	self flag: #TODO.
	"What it was before: component setBoundsTo: bounds."
	
	component translateTo: bounds origin! !

!MOFigureAdaptor methodsFor: 'accessing' stamp: 'Alexandre.Bergel 3/29/2009 19:37'!
translateBy: aPoint
	
	bounds := (bounds origin + aPoint) extent: (bounds extent)! !

!MOFigureAdaptor methodsFor: 'accessing' stamp: 'Alexandre.Bergel 3/29/2009 19:35'!
translateTo: aPoint
	
	self translateBy: aPoint - bounds origin
"	component container notNil
		ifTrue:
			[self
				translateBy:
					aPoint - bounds origin + component container childArea origin]
		ifFalse: [self translateBy: aPoint - bounds origin]
	"! !

!MOFigureAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:07'!
width: aNumber
	
	bounds width: aNumber! !

!MOFormsAdaptor class methodsFor: 'instance creation' stamp: ' 23/10/08 11:11'!
new
	
	^super new initialize! !

!MOFormsAdaptor class methodsFor: 'instance creation' stamp: ' 23/10/08 11:11'!
on: aComponent
	
	^self new component: aComponent! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
bounds
	
	^bounds! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
columnSpan
	
	^columnSpan! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
columnSpan: aW
	
	columnSpan := aW! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
component
	
	^component! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
component: aComponent
	
	component := aComponent! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
gridX
	
	^gridX! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
gridX: aNumber
	
	gridX := aNumber! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
gridY
	
	^gridY! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
gridY: aNumber
	
	gridY := aNumber! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
height
	
	^bounds height! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
height: aNumber
	
	self subclassResponsibility! !

!MOFormsAdaptor methodsFor: 'delegation' stamp: 'Alexandre.Bergel 8/30/2009 13:27'!
heightFor: anElement
	^ component heightFor: anElement! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
install
	
	self subclassResponsibility! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
rowSpan
	
	^rowSpan! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
rowSpan: aH
	
	rowSpan := aH! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/21/2009 14:42'!
shape
	
	^component! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
translateBy: aPoint
	
	self subclassResponsibility! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
translateTo: aPoint
	
	self subclassResponsibility! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
width
	
	^bounds width! !

!MOFormsAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:11'!
width: aNumber
	
	self subclassResponsibility! !

!MOFormsAdaptor methodsFor: 'delegation' stamp: 'Alexandre.Bergel 8/30/2009 13:27'!
widthFor: anElement
	^ component widthFor: anElement! !

MOFormsAdaptor subclass: #MOShapeAdaptor
	instanceVariableNames: 'context element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-ComplexShape'!

!MOShapeAdaptor methodsFor: 'testing' stamp: 'Alexandre Bergel 8/9/2010 17:43'!
canHandleChildren
	"read only"
	^component canHandleChildren! !

!MOShapeAdaptor methodsFor: 'accessing-computed' stamp: ' 23/10/08 11:07'!
collectAllShapes
	
	^component collectAllShapes! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: ' 23/10/08 11:07'!
context
	
	^context! !

!MOShapeAdaptor methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 8/10/2010 09:47'!
figure
	^ element! !

!MOShapeAdaptor methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 8/10/2010 09:47'!
figure: aFigure
	
	element := aFigure.
	context := IdentityDictionary new.
"	bounds := component
		outerBoundsForFigure: aFigure
		forBounds: (0 @ 0 extent: 0 @ 0)
		context: context"! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'Alexandre Bergel 8/10/2010 09:47'!
height
	"read only"
	^(component extentFor: element) y! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2010 09:36'!
height: aNumber! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'Alexandre Bergel 8/10/2010 09:47'!
install
	
	context
		keysAndValuesDo: [:key :value | element shapeBoundsAt: key put: value]! !

!MOShapeAdaptor methodsFor: 'testing' stamp: ' 23/10/08 11:07'!
isShape
	
	^true! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'jlr 11/11/2008 15:37'!
parent: aParentShape 
	component parent: aParentShape! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'Alexandre Bergel 8/10/2010 09:47'!
translateBy: aPoint
	
	component translateBoundsForFigure: element by: aPoint context: context! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'Alexandre Bergel 8/10/2010 09:47'!
translateTo: aPoint
	
	self translateBy: aPoint - element bounds origin! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'Alexandre Bergel 8/10/2010 09:47'!
width
	"read only"
	^(component extentFor: element) x! !

!MOShapeAdaptor methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2010 09:37'!
width: aNumber! !

Object subclass: #MOFormsBuilder
	instanceVariableNames: 'columnAlignment columnResizeBehaviour rowAlignment rowResizeBehaviour components stack columnDefaultSize rowDefaultSize alignment resizeBehaviour defaultSize figures shapes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-ComplexShape'!

!MOFormsBuilder commentStamp: 'tg 1/5/2010 17:14' prior: 0!
FormsBuilder is a generic algorithm for placing elements that have size in a grid that can be scaled both horizontally and vertically.

In Mondrian it has two applications:

1. for building a complex shape. In this case x:y:add: accepts a Shape. You can see an example in UMLClassDiagram>>umlShape. You obtain the shape from the builder by sending #shape. A shape created by a FormsBuilder is an instance of FormsShape.

2. for laying out the nodes in a graph. This is achieved by passing MONodes in x:y:add: and by sending asLayout to the FormsBuilder and as you see in the MOMatrixRenderer.!

!MOFormsBuilder class methodsFor: 'instance creation' stamp: ' 22/10/08 14:21'!
new
	
	^super new initialize! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 11:36'!
add: aShape
	"This method belongs to the advanced API. Decorators are currently not suported
	Alexandre.Bergel 8/30/2009 11:36
	
	stack isEmpty
		ifTrue: [stack addLast: aShape]
		ifFalse: [self stack last decoratedWith: aShape]"! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 11:36'!
add: aShape with: aBlock
	"This method belongs to the advanced API. Decorators are currently not suported
	Alexandre.Bergel 8/30/2009 11:36

	self stack isEmpty ifFalse: [self stack last decoratedWith: aShape].
	self stack addLast: aShape.
	aBlock value.
	self stack removeLast"! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 11:55'!
asChildrenShape
	
	^(MOFormsShape on: self) setIsChildrenShape! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'jlr 11/27/2008 09:26'!
asLayout
	
	^MOFormsLayout on: self! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'Alexandre Bergel 8/9/2010 17:43'!
asShape
	
	| allShapes |	
	"If there is no ChildShape we add one to cell (1, 1)"
	allShapes := OrderedCollection new.
	self shapes
		do: [:component | allShapes addAll: component collectAllShapes].	"We also need the decorations"
	allShapes
		detect: [:shape | shape canHandleChildren]
		ifNone:
			["self
				x: 1
				y: 1
				add: MOChildrenShape new"].
	^MOFormsShape on: self! !

!MOFormsBuilder methodsFor: 'utils' stamp: ' 22/10/08 14:21'!
at: aX and: aY
	"Utility method that makes other methods easier to read."
	
	^self components
		select: [:component | component gridX = aX and: [component gridY = aY]]! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:56'!
bottom
	
	alignment
		removeLast;
		addLast: #bottom! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: 'Alexandre.Bergel 8/30/2009 14:06'!
boundsOf: aShape 
	| aComponent originX originY columnNumber rowNumber columnWidth rowHeight maxOriginX maxOriginY s componentWidth componentHeight |
	
	"pref says that the image inside sets the width, the shape has precedence"
	"grow says that when you resize the complete shape, the column will resize proportionally"
	
	originX := 0.
	originY := 0.
	columnWidth := 0.
	rowHeight := 0.

	aComponent := self shapes detect: [:each | each shape == aShape].
	columnNumber := aComponent gridX.
	rowNumber := aComponent gridY.

	componentWidth := aComponent width.
	componentHeight := aComponent height.


	1 to: self numberOfColumns do: [:column | 
		(self at: column and: rowNumber) do: [:comp |
			s := (comp heightFor: (comp figure)) / comp rowSpan.
			rowHeight := rowHeight max: s]].
"	componentHeight := rowHeight."
	
	1 to: self numberOfRows do: [:row | 
		(self at: columnNumber and: row) do: [:comp |
			s := (comp widthFor: (comp figure)) / comp columnSpan.
			columnWidth := columnWidth max: s]].
"	componentWidth := columnWidth."

	((self columnAlignmentAt: columnNumber) == #fill)
		ifTrue: [
			componentWidth := columnWidth.
			(columnNumber + 1) to: (columnNumber + aComponent columnSpan -1 ) do: [:cNumber |
				columnWidth := 0.
				1 to: self numberOfRows do: [:row | 
						(self at: cNumber and: row) do: [:comp |
							s := (comp widthFor: (comp figure)) / comp columnSpan.
							columnWidth := columnWidth max: s]].
				componentWidth := componentWidth + columnWidth]].

	((self rowAlignmentAt: rowNumber) == #fill)
		ifTrue: [	
			componentHeight := rowHeight.
			rowNumber + 1 to: (rowNumber + aComponent rowSpan - 1) do: [:rNumber |
				rowHeight := 0.
				1 to: self numberOfColumns do: [:column | 
						(self at: column and: rNumber) do: [:comp |
							s := (comp heightFor: (comp figure)) / comp rowSpan.
							rowHeight := rowHeight max: s]].
				componentHeight := componentHeight + rowHeight]].


	1 to: columnNumber -1 do: [:column | 
		maxOriginX := 0.
		1 to: self numberOfRows do: [:row | 
			(self at: column and: row) do: [:comp |
				s := (comp widthFor: (comp figure)) / comp columnSpan.
				maxOriginX := maxOriginX max: s]].
		originX := originX + maxOriginX].

	1 to: rowNumber - 1 do: [:row |
		maxOriginY := 0.
		1 to: self numberOfColumns do: [:column | 
			(self at: column and: row) do: [:comp | 
				s := (comp heightFor: (comp figure)) / comp rowSpan.
				maxOriginY := maxOriginY max: s]].
		originY := originY + maxOriginY].

	
	((self columnAlignmentAt: columnNumber) = #right	and: [aComponent columnSpan = 1])
		ifTrue: [originX :=  originX + (columnWidth - aComponent width)].
	((self columnAlignmentAt: columnNumber) = #center and: [aComponent columnSpan = 1])
		ifTrue: [originX :=  originX + (columnWidth / 2.0 - (aComponent width / 2.0))].
	((self rowAlignmentAt: rowNumber) = #bottom and: [aComponent rowSpan = 1])
		ifTrue: [originY :=   originY + (rowHeight - aComponent height)].
	((self rowAlignmentAt: rowNumber) = #center and: [aComponent rowSpan = 1])
		ifTrue:	[originY :=  originY + (rowHeight / 2.0 - (aComponent height / 2.0))].
	
	^ (originX @ originY) extent: (componentWidth @ componentHeight)! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:56'!
center
	
	alignment
		removeLast;
		addLast: #center! !

!MOFormsBuilder methodsFor: 'testing' stamp: 'Alexandre.Bergel 2/1/2009 10:06'!
checkIfOK: aBounds
	"This method is invoked when an element is added into the builder. The area associated with this element is aBounds.
	Prior to add it, we need this to ensure that the element to add is not out of bound (i.e., that the size of the builder is properly 
	defined). This is the purpose of this method."
	| raiseError |
	raiseError := false.
	((aBounds origin x + aBounds width) > (columnDefaultSize size + 1))
		ifTrue: [ raiseError := true].

	((aBounds origin y + aBounds height) > (rowDefaultSize size + 1))
		ifTrue: [ raiseError := true].
		
		
	raiseError ifTrue: [ self error: 'You trying to add an out of bounds element. Adjust the size of the builder' ]! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: ' 22/10/08 14:21'!
column
	
	alignment := columnAlignment.
	resizeBehaviour := columnResizeBehaviour.
	defaultSize := columnDefaultSize.
	alignment addLast: #none.
	resizeBehaviour addLast: #none.
	defaultSize addLast: #pref! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
columnAlignmentAt: anIndex
	
	^columnAlignment at: anIndex! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
columnDefaultSizeAt: anIndex
	
	^columnDefaultSize at: anIndex! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
columnResizeBehaviourAt: anIndex
	
	^columnResizeBehaviour at: anIndex! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
columns
	
	^self numberOfColumns! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2010 09:33'!
columns: aString
	| columns |
	"Get all the column definitions"
	columns := aString copyReplaceAll: ' ' with: ''.
	columns := columns subStrings: ','.
	columns
		do: [ :column | 
			| tokens |
			self column.
			tokens := column subStrings: ':'.
			tokens
				do: [ :token | 
					(token findString: 'px' startingAt: 1) = 0
						ifTrue: [ self perform: token asSymbol ]
						ifFalse: [ self size: (token copyFrom: 1 to: token size - 2) asNumber ] ] ]! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
components
	
	components isNil ifTrue: [components := OrderedCollection new].
	^components! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: 'AlexandreBergel 2/18/2009 18:55'!
extentOf: aShape
	^ (self boundsOf: aShape) extent! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
figures
	
	figures isNil ifTrue: [figures := OrderedCollection new].
	^figures! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:56'!
fill
	
	alignment
		removeLast;
		addLast: #fill! !

!MOFormsBuilder methodsFor: 'utils' stamp: ' 22/10/08 14:21'!
gridDo: aBlock
	"Utility method that makes other methods easier to read."
	
	1
		to: self numberOfRows
		do:
			[:row | 
			1
				to: self numberOfColumns
				do: [:column | aBlock value: row value: column]]! !

!MOFormsBuilder methodsFor: 'utils' stamp: 'jlr 11/10/2008 09:57'!
gridFrom: aRowIndex to: aColumnIndex do: aBlock
	"Utility method that makes other methods easier to read."
	
	1
		to: aRowIndex
		do:
			[:row | 
			1
				to: aColumnIndex
				do: [:column | aBlock value: row value: column]]! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:56'!
grow
	
	resizeBehaviour
		removeLast;
		addLast: #grow! !

!MOFormsBuilder methodsFor: 'layout-apply' stamp: 'Alexandre Bergel 8/10/2010 09:56'!
heightsFor: anElement
	
	| myHeights count availableSpace gapSize |
	self initComponentsFor: anElement.
	myHeights := self initialHeights.	"Iterate over all components that only span a single row"
	self
		gridDo:
			[:row :column | 
			(self at: column and: row)
				do:
					[:component | 
					component rowSpan = 1
						ifTrue:
							[(self rowDefaultSizeAt: row) = #pref
								ifTrue:
									[myHeights
										at: row
										put: (component height max: (myHeights at: row))].
							((self rowDefaultSizeAt: row) isKindOf: Number)
								ifTrue:
									[myHeights
										at: row
										put: (self rowDefaultSizeAt: row)]]]].	"Try to satisfy the wishes of the multi-row components"
	self
		gridDo:
			[:row :column | 
			(self at: column and: row)
				do:
					[:component | 
					"Calculate row heights"
					count := 0.
					availableSpace := 0.0.
					row
						to: row + component rowSpan - 1
						do:
							[:index | 
							availableSpace := availableSpace + (myHeights at: index).
							(self rowResizeBehaviourAt: index) = #grow
								ifTrue: [count := count + 1]].
					gapSize := (0.0 max: component height - availableSpace)
						/ (count max: 1).
					row
						to: row + component rowSpan - 1
						do:
							[:index | 
							(self rowResizeBehaviourAt: index) = #grow
								ifTrue:
									[myHeights
										at: index
										put: (myHeights at: index) + gapSize]]]].
	^myHeights! !

!MOFormsBuilder methodsFor: 'utils' stamp: ' 22/10/08 14:21'!
initComponentsFor: aFigure
	"Initialize shapes"
	
	aFigure
		ifNotNil: [self shapes do: [:component | component figure: aFigure]].	"Initialize figures"
	self figures do: [:component | component initializeBounds]! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: 'Alexandre Bergel 7/26/2010 14:59'!
initialHeights
	"Here we take rows into account that have a pixel height"

	| heights |
	heights := (Array new: self numberOfRows) atAllPut: 0.0.
	1 to: self numberOfRows do: [ :index | 
		((self rowDefaultSizeAt: index) isKindOf: Number)
			ifTrue: [ heights at: index put: (self rowDefaultSizeAt: index) ] ].
	^ heights! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: 'Alexandre Bergel 7/26/2010 14:59'!
initialWidths
	"Here we take columns into account that have a pixel width"

	| widths |
	widths := (Array new: self numberOfColumns) atAllPut: 0.0.
	1 to: self numberOfColumns do: [ :index | 
		((self columnDefaultSizeAt: index) isKindOf: Number)
			ifTrue: [ widths at: index put: (self columnDefaultSizeAt: index) ] ].
	^ widths! !

!MOFormsBuilder methodsFor: 'initialize-release' stamp: ' 22/10/08 14:21'!
initialize
	
	columnAlignment := OrderedCollection new.
	columnResizeBehaviour := OrderedCollection new.
	columnDefaultSize := OrderedCollection new.
	rowAlignment := OrderedCollection new.
	rowResizeBehaviour := OrderedCollection new.
	rowDefaultSize := OrderedCollection new! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:57'!
left
	
	alignment
		removeLast;
		addLast: #left! !

!MOFormsBuilder methodsFor: 'private' stamp: ' 22/10/08 14:21'!
numberOfColumns
	
	^columnAlignment size! !

!MOFormsBuilder methodsFor: 'private' stamp: ' 22/10/08 14:21'!
numberOfRows
	
	^rowAlignment size! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: 'AlexandreBergel 2/19/2009 01:12'!
originOf: aShape 
	| aComponent originX originY columnNumber rowNumber width height maxOriginX maxOriginY s |
	self flag: #TODO.
	"I find this method strange. Why a builder needs to know about the origin ? Moreover, the VW version of Mondrian does not have this method"

	originX := 0.
	originY := 0.
	width := 0.
	height := 0.
	
	aComponent := components detect: [:each | each component == aShape].
	columnNumber := aComponent gridX.
	rowNumber := aComponent gridY.

	"the component maybe a MOShapeAdaptor "
"	self gridDo: [:row :column | 
		(self at: column and: row)
				do: [:component | 
						width := width max: (component component widthFor: (component figure))]].
	self gridDo: [:row :column | (
		self at: column and: row)
				do: [:component | 
						height := height max: (component component heightFor: (component figure))]].
"
"	self gridDo: [:row :column | (self at: column and: row)
				do: [:component | width := width max: component component width]].
"	
"	self gridDo: [:row :column | (self at: column and: row)
				do: [:component | height := height max: component component height]].
"

	1 to: aComponent gridX do: [:column | 
		(self at: column and: aComponent gridY) do: [:comp |
			s := (comp component heightFor: (comp figure)) / comp rowSpan.
			height := height max: s]].
	
	1 to: aComponent gridY do: [:row | 
		(self at: aComponent gridX and: row) do: [:comp |
			s := (comp component widthFor: (comp figure)) / comp columnSpan.
			width := width max: s]].


	1 to: aComponent gridX -1 do: [:column | 
		maxOriginX := 0.
		1 to: self numberOfRows do: [:row | 
			(self at: column and: row) do: [:comp |
				s := (comp component widthFor: (comp figure)) / comp columnSpan.
				maxOriginX := maxOriginX max: s]].
		originX := originX + maxOriginX].

	1 to: aComponent gridY - 1 do: [:row |
		maxOriginY := 0.
		1 to: self numberOfColumns do: [:column | 
			(self at: column and: row) do: [:comp | 
				s := (comp component heightFor: (comp figure)) / comp rowSpan.
				maxOriginY := maxOriginY max: s]].
		originY := originY + maxOriginY].

	
	((self columnAlignmentAt: columnNumber) = #right	and: [aComponent columnSpan = 1])
		ifTrue: [originX :=  originX + (width - aComponent width)].
	((self columnAlignmentAt: columnNumber) = #center and: [aComponent columnSpan = 1])
		ifTrue: [originX :=  originX + (width / 2.0 - (aComponent width / 2.0))].
	((self rowAlignmentAt: rowNumber) = #bottom and: [aComponent rowSpan = 1])
		ifTrue: [originY :=   originY + (height - aComponent height)].
	((self rowAlignmentAt: rowNumber) = #center and: [aComponent rowSpan = 1])
		ifTrue:	[originY :=  originY + (height / 2.0 - (aComponent height / 2.0))].
	
	^ originX @ originY! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:57'!
pref
	
	defaultSize
		removeLast;
		addLast: #pref! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:56'!
right
	
	alignment
		removeLast;
		addLast: #right! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: ' 22/10/08 14:21'!
row
	
	alignment := rowAlignment.
	resizeBehaviour := rowResizeBehaviour.
	defaultSize := rowDefaultSize.
	alignment addLast: #none.
	resizeBehaviour addLast: #none.
	defaultSize addLast: #pref! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
rowAlignmentAt: anIndex
	
	^rowAlignment at: anIndex! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
rowDefaultSizeAt: anIndex
	
	^rowDefaultSize at: anIndex! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
rowResizeBehaviourAt: anIndex
	
	^rowResizeBehaviour at: anIndex! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
rows
	
	^self numberOfRows! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2010 09:33'!
rows: aString
	| rows |
	"Get all the column definitions"
	rows := aString copyReplaceAll: ' ' with: ''.
	rows := rows subStrings: ','.
	rows
		do: [ :row | 
			| tokens |
			self row.
			tokens := row subStrings: ':'.
			tokens
				do: [ :token | 
					(token findString: 'px' startingAt: 1) = 0
						ifTrue: [ self perform: token asSymbol ]
						ifFalse: [ self size: (token copyFrom: 1 to: token size - 2) asNumber ] ] ]! !

!MOFormsBuilder methodsFor: 'layout-apply' stamp: 'tg 2/12/2010 21:43'!
runWithWidths: myWidths heights: myHeights
	
	| x y width height |
	self
		gridDo:
			[:row :column | 
			(self at: column and: row)
				do:
					[:component | 
					"Move the shape to the proper position"
					x := (myWidths
						copyFrom: 1
						to: column - 1)
						inject: 0
						into: [:sum :next | sum + next].
					y := (myHeights
						copyFrom: 1
						to: row - 1)
						inject: 0
						into: [:sum :next | sum + next].	"By default we align #left"
					component translateTo: x @ y.	"Update the width"
					width := (myWidths
						copyFrom: column
						to: column + component columnSpan - 1)
						inject: 0.0
						into: [:sum :next | sum + next].	"If we use px size we may need to crop the size"
					(((self columnDefaultSizeAt: column) isKindOf: Number)
						and: [component columnSpan = 1])
						ifTrue: [component width: (width min: component width)].	"Update the width and position of the shape based on the alignment"
			
					((self columnAlignmentAt: column) = #fill
						or: [component columnSpan > 1]) ifTrue: [component width: width].	"(columnAlignment: column) = #left ifTrue: [We don't need to do anything]."
					((self columnAlignmentAt: column) = #right
						and: [component columnSpan = 1])
						ifTrue: [component translateBy: (width - component width) @ 0].
					((self columnAlignmentAt: column) = #center
						and: [component columnSpan = 1])
						ifTrue:
							[component translateBy: (width / 2.0 - (component width / 2.0)) @ 0].	"Update the height"
					height := (myHeights
						copyFrom: row
						to: row + component rowSpan - 1)
						inject: 0.0
						into: [:sum :next | sum + next].	"If we use px size we may need to crop the size"
					(((self rowDefaultSizeAt: row) isKindOf: Number)
						and: [component rowSpan = 1])
						ifTrue: [component height: (height min: component height)].	"Update the height and position of the shape based on the alignment"
					((self rowAlignmentAt: row) = #fill or: [component rowSpan > 1])
						ifTrue: [component height: height].	"(rowAlignment: row) = #top ifTrue: [We don't need to do anything]."
					((self rowAlignmentAt: row) = #bottom and: [component rowSpan = 1])
						ifTrue: [component translateBy: 0 @ (height - component height)].
					((self rowAlignmentAt: row) = #center and: [component rowSpan = 1])
						ifTrue:
							[component translateBy: 0 @ (height / 2.0 - (component height / 2.0))]]]! !

!MOFormsBuilder methodsFor: 'accessing' stamp: ' 22/10/08 14:21'!
shape
	
	^self asShape! !

!MOFormsBuilder methodsFor: 'accessing - data' stamp: ' 22/10/08 14:21'!
shapes
	
	shapes isNil ifTrue: [shapes := OrderedCollection new].
	^shapes! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:56'!
size: aNumber
	
	defaultSize
		removeLast;
		addLast: aNumber! !

!MOFormsBuilder methodsFor: 'private' stamp: ' 22/10/08 14:21'!
stack
	
	stack isNil ifTrue: [stack := OrderedCollection new].
	^stack! !

!MOFormsBuilder methodsFor: 'layout-define' stamp: 'Alexandre.Bergel 8/30/2009 15:56'!
top
	
	alignment
		removeLast;
		addLast: #top! !

!MOFormsBuilder methodsFor: 'layout-apply' stamp: ' 22/10/08 14:21'!
widthsFor: aFigure
	
	| myWidths count availableSpace gapSize |
	self initComponentsFor: aFigure.
	myWidths := self initialWidths.	"Iterate over all components that only span a single column"
	self
		gridDo:
			[:row :column | 
			(self at: column and: row)
				do:
					[:component | 
					component columnSpan = 1
						ifTrue:
							[(self columnDefaultSizeAt: column) = #pref
								ifTrue:
									[myWidths
										at: column
										put: (component width max: (myWidths at: column))].
							((self columnDefaultSizeAt: column) isKindOf: Number)
								ifTrue:
									[myWidths
										at: column
										put: (self columnDefaultSizeAt: column)]]]].	"Try to satisfy the wishes of multi-column components"
	self
		gridDo:
			[:row :column | 
			(self at: column and: row)
				do:
					[:component | 
					"Calculate column widths"
					count := 0.
					availableSpace := 0.0.
					column
						to: column + component columnSpan - 1
						do:
							[:index | 
							availableSpace := availableSpace + (myWidths at: index).
							(self columnResizeBehaviourAt: index) = #grow
								ifTrue: [count := count + 1]].
					gapSize := (0.0 max: component width - availableSpace)
						/ (count max: 1).
					column
						to: column + component columnSpan - 1
						do:
							[:index | 
							(self columnResizeBehaviourAt: index) = #grow
								ifTrue:
									[myWidths
										at: index
										put: (myWidths at: index) + gapSize]]]].
	^myWidths! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 9/6/2010 18:29'!
x: aX y: aY
	
	^ (self components detect: [:c | c gridX = aX and: [ c gridY = aY ]]) component! !

!MOFormsBuilder methodsFor: 'accessing' stamp: ' 22/10/08 14:21'!
x: aX y: aY add: anObject
	
	self x: aX y: aY w: 1 h: 1 add: anObject! !

!MOFormsBuilder methodsFor: 'accessing' stamp: ' 22/10/08 14:21'!
x: aX y: aY add: anObject with: aBlock
	
	self x: aX y: aY w: 1 h: 1 add: anObject with: aBlock! !

!MOFormsBuilder methodsFor: 'accessing' stamp: ' 22/10/08 14:21'!
x: aX y: aY h: aH add: anObject
	
	self x: aX y: aY w: 1 h: aH add: anObject! !

!MOFormsBuilder methodsFor: 'accessing' stamp: ' 22/10/08 14:21'!
x: aX y: aY h: aH add: anObject with: aBlock
	
	self x: aX y: aY w: 1 h: aH add: anObject with: aBlock! !

!MOFormsBuilder methodsFor: 'accessing' stamp: ' 22/10/08 14:21'!
x: aX y: aY w: aW add: anObject
	
	self x: aX y: aY w: aW h: 1 add: anObject! !

!MOFormsBuilder methodsFor: 'accessing' stamp: ' 22/10/08 14:21'!
x: aX y: aY w: aW add: anObject with: aBlock
	
	self x: aX y: aY w: aW h: 1 add: anObject with: aBlock! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 9/6/2010 18:29'!
x: aX y: aY w: aW h: aH add: aSomething
	
	| component |
	self checkIfOK: (aX@aY extent: (aW@aH)).
	self assert: [(aSomething isKindOf: MOViewRenderer) not].
	
	"We check we do not add more than one children shape. Note that this restriction may diseappar in the future"
	(aSomething isShape and: [ aSomething isChildShape ])
		ifTrue: [ | children | 
				 children := (self shapes select: [:v | v component isChildShape]).
				 children size >= 1 ifTrue: [
					(children anySatisfy: [:v | v gridX ~= aX or: [ v gridY ~= aY]])
						ifTrue: [ self error: 'no more than one MOChildrenShape may be added in a builder'. ^ self]
				 ]
				  ].
	
	aSomething isShape
		ifTrue:
			[component := MOShapeAdaptor on: aSomething.
			 aSomething disableCache.
			self shapes add: component]
		ifFalse:
			[component := MOFigureAdaptor on: aSomething.
			self figures add: component].
	self components add: component.
	component gridX: aX.
	component gridY: aY.
	component columnSpan: aW.
	component rowSpan: aH! !

!MOFormsBuilder methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/9/2010 19:33'!
x: aX y: aY w: aW h: aH add: aSomething with: aBlock
	
	| component |
	self assert: [(aSomething isKindOf: MOViewRenderer) not].
	aSomething isShape
		ifTrue:
			[component := MOShapeAdaptor on: aSomething.
			 aSomething disableCache.
			self shapes add: component.
			self stack addLast: aSomething.
			aBlock value.
			self stack removeLast]
		ifFalse:
			[component := MOFigureAdaptor on: aSomething.
			self figures add: component].
	self components add: component.
	component gridX: aX.
	component gridY: aY.
	component columnSpan: aW.
	component rowSpan: aH! !

Object subclass: #MOGraphElement
	instanceVariableNames: 'model owner announcer edges isSelected shape cacheShapeBounds cacheForm boundsCache layout popup nodes absoluteBoundsCache elementsToDisplayCache attributes elementsToLookup zOrder lookupNodeCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOGraphElement commentStamp: 'Alexandre.Bergel 2/21/2009 13:19' prior: 0!
Alexandre Bergel, Feb 2, 2009:
The variable origin was in the class MOFigure. However, this variable does not seem to be used. It was referenced only in the initialize method. The bounds variable seems to contains the position already.

Alexandre Bergel, Feb 21, 2009:
only shapeBounds should be used. This variables is a dictionary that contained computed values. This is a cache. keys are shape, values are bounds.

shapeBounds contains __absolute bounds__ The origin is therefore absolute. This is a cache, nothing has to be computed else
-=-=-=-=

A MOFigure is xxxxxxxxx.

Instance Variables
	announcer:		<Object>
	bounds:		<Object>
	children:		<Object>
	edges:		<Object>
	eventHandler:		<Object>
	handles:		<Object>
	initialOrigin:		<Object>
	isSelected:		<Object>
	layer:		<Object>
	layout:		<Object>
	model:		<Object>
	origin:		<Object>
	owner:		<Object>
	relativeOrigin:		<Object>
	shapeBounds:		<Object>
	style:		<Object>

announcer
	- xxxxx

bounds
	- xxxxx

children
	- xxxxx

edges
	- xxxxx

eventHandler
	- xxxxx

handles
	- xxxxx

initialOrigin
	- xxxxx

isSelected
	- xxxxx

layer
	- xxxxx

layout
	- xxxxx

model
	- xxxxx

origin
	- xxxxx

owner
	- xxxxx

relativeOrigin
	- xxxxx

shapeBounds
	- xxxxx

style
	- xxxxx
!

MOGraphElement subclass: #MOEdge
	instanceVariableNames: 'source target cacheFromPoint cacheToPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOEdge class methodsFor: 'default' stamp: 'jannik.laval 7/13/2010 16:46'!
defaultLineShapeClass 
	^ MOShape defaultLineShapeClass! !

!MOEdge class methodsFor: 'instance creation' stamp: 'tg 4/23/2008 20:10'!
from: aNode to: anotherNode

	^self new
		source: aNode;
		target: anotherNode;
		yourself! !

!MOEdge methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/2/2010 12:50'!
acceptVisitor: aVisitor
	^ aVisitor visitEdge: self! !

!MOEdge methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 9/14/2010 10:22'!
bounds
	^ boundsCache ifNil: [ boundsCache := self shape computeBoundsFor: self ].
! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/10/2009 23:01'!
cacheFromPoint
	^ cacheFromPoint! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/10/2009 23:01'!
cacheFromPoint: anObject
	cacheFromPoint := anObject! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/10/2009 23:02'!
cacheToPoint
	^ cacheToPoint! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/10/2009 23:02'!
cacheToPoint: anObject
	cacheToPoint := anObject! !

!MOEdge methodsFor: 'displaying' stamp: 'Alexandre Bergel 8/10/2010 18:56'!
displayOn: aCanvas 
"	[
"	 shape 
		display: self
		on: aCanvas
"		 ] on: Error do: [:ex | self handleException: ex ]. "! !

!MOEdge methodsFor: 'displaying' stamp: 'Alexandre Bergel 7/15/2010 23:20'!
displayWithoutCachingOn: aCanvas 
	shape display: self on: aCanvas! !

!MOEdge methodsFor: 'querying' stamp: 'Alexandre Bergel 12/1/2009 00:24'!
elementAt: aPoint ifAbsent: aBlock
	"Answer the element at aPoint or evaluate aBlock if none. Note that this implementation assumes that children are always fully contained within their owner and is therefore very efficient."
	(self shape containsPoint: aPoint for: self )
		ifTrue: [ ^ self ].
	^ aBlock value! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
fromPositions
	^ shape fromPositions! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
fromPositions: collection
	shape fromPositions: collection! !

!MOEdge methodsFor: 'initialization' stamp: 'Alexandre Bergel 6/17/2010 12:25'!
initialize 
	super initialize.
	shape := MOShape defaultLineShapeInstance! !

!MOEdge methodsFor: 'testing cache' stamp: 'Alexandre Bergel 7/17/2010 08:26'!
isCacheLoaded
	^ cacheFromPoint notNil and: [ cacheToPoint notNil ]! !

!MOEdge methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 3/15/2010 16:18'!
length
	^ (self target position - self source position) r! !

!MOEdge methodsFor: 'actions' stamp: 'Alexandre Bergel 3/2/2010 12:49'!
remove
	^ self owner removeEdge: self! !

!MOEdge methodsFor: 'cache' stamp: 'Alexandre Bergel 6/25/2010 20:00'!
resetCache
	cacheFromPoint := nil.
	cacheToPoint := nil! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 6/6/2009 13:14'!
setIfNilFromPositions: symbols
	self fromPositions ifNil: [ self fromPositions: symbols ]! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 6/6/2009 13:14'!
setIfNilToPositions: symbols
	self toPositions ifNil: [ self toPositions: symbols ]! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
source
	^ source! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
source: anObject
	source := anObject! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
target
	^ target! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
target: anObject
	target := anObject! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
toPositions
	^ shape toPositions! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
toPositions: collection
	shape toPositions: collection! !

!MOEdge methodsFor: 'actions' stamp: 'Alexandre Bergel 4/24/2010 17:54'!
translateBy: aPoint bounded: bounded
	"we do nothing, an edge cannot be translated"! !

!MOEdge methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 7/15/2010 14:50'!
zOrder
	^ zOrder ifNil: [ zOrder := (self source zOrder max: self target zOrder) - 1].
	
! !

!MOGraphElement class methodsFor: 'instance-creation' stamp: 'lr 11/6/2006 08:29'!
on: anObject
	^ self new setModel: anObject! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/24/2010 14:33'!
absoluteBounds
	"Answer the bounds in absolute terms (relative to the entire Canvas, not just the parent)."
	absoluteBoundsCache ifNotNil: [ ^ absoluteBoundsCache ].
	^ absoluteBoundsCache := self shape absoluteBoundsFor: self! !

!MOGraphElement methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/2/2010 12:49'!
acceptVisitor: aVisitor
	self subclassResponsibility ! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre Bergel 12/7/2009 20:25'!
add: anElement 
	"Add anElement to the children of the receiver."
	nodes ifNil: [ nodes := OrderedCollection new ].
	^ nodes add: (anElement setOwner: self)! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre.Bergel 9/26/2009 10:09'!
addEdge: anEdge 
	"Add anEdge to the children edges of the receiver."
	anEdge target addIncomingEdge: anEdge.
	anEdge source addOutgoingEdge: anEdge.
	^ self edges add: (anEdge setOwner: self)! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre Bergel 12/7/2009 20:25'!
addNode: anElement 
	"Add anElement to the children of the receiver."
	nodes ifNil: [ nodes := OrderedCollection new ].
	^ nodes add: (anElement setOwner: self)! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre.Bergel 8/18/2009 21:58'!
adoptNewShape: aShape
	"This method should be used to change the shape of myself.
	This method takes care of updating the cache"

	| oldShape |
	oldShape := self shape.
	self shape: aShape.
	self shapeBoundsAt: aShape put: (self shapeBoundsAt: oldShape)! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 3/2/2010 12:46'!
allEdges
	"return the recursively computed outgoing edges"
	| coll |
	coll := OrderedCollection new.
	coll addAll: self edges.
	self allNodesDo: [:n | coll addAll: n edges].
	^ coll! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/12/2010 14:53'!
allEdgesConnectedTo: aNode
	^ self allEdges select: [:edge | edge source == aNode or: [ edge target == aNode ]]! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 4/27/2010 09:43'!
allEdgesDo: aBlock
	"Evaluate aBlock all its edges."
	
	self edges copy do: [:edge | aBlock value: edge].
	self allNodesDo: [ :each |
		each allEdgesDo: aBlock ]
	
"	self edges do: [:edge | aBlock value: edge].
	self allNodesDo: [ :each |
		each edges do: [:edge | aBlock value: edge].
		each allEdgesDo: aBlock ]"! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 12/20/2009 12:03'!
allNodes
	| coll |
	coll := OrderedCollection new.
	self allNodesDo: [:n | coll add: n].
	^ coll! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 4/27/2010 09:44'!
allNodesDo: aBlock
	"Evaluate aBlock all its children."
	
	self copy do: [ :each |
		aBlock value: each.
		each allNodesDo: aBlock ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 12/20/2009 12:03'!
allNodesThat: aBlock
	| ans |
	ans := OrderedCollection new.
	self allNodesDo: [:node | (aBlock value: node) ifTrue: [ ans add: node]].
	^ ans! !

!MOGraphElement methodsFor: 'querying' stamp: 'Alexandre Bergel 7/14/2010 09:02'!
allSelectedNodes
	^ self elementsToLookup select: #isSelected! !

!MOGraphElement methodsFor: 'announce' stamp: 'Alexandre Bergel 12/17/2009 19:22'!
announce: anAnnouncement
	"public method"
	announcer ifNil: [ ^ self ].
	anAnnouncement element: self.
	announcer announce: anAnnouncement
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 3/8/2009 21:21'!
announcer
	"Answer the announcer of the receiver."
	
	^ announcer ifNil: [ announcer := MOAnnouncer new ]! !

!MOGraphElement methodsFor: 'layouting' stamp: 'AlexandreBergel 8/29/2010 21:03'!
applyLayout
	"Layout the receiver and all its children."

	| b |
	self resetMetricCachesResursively.
	b := self hasChildren
		ifTrue: [ 0 @ 0 extent: 0 @ 0 ]
		ifFalse: [ self shape computeBoundsFor: self ].

	self shapeBoundsAt: self shape put: b.	"if the node has children, then we need to apply the layout, else, we do nothing"
	self hasChildren
		ifTrue: [ 
			self do: [ :each | each applyLayout ].
			self layout applyOn: self ].	"nodes have been located properly. Now, we need to update the size of me (i.e., the size of my shape)"	
				
	"apply:bounds: does a side effect on b"
	shape apply: self bounds: b.
	
	"Special treatment with forms shape"
	shape isFormsShape
		ifTrue: [ self shapeBoundsAt: self shape put: (self shape computeBoundsFor: self) ] ! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 15:41'!
attributeAt: aSymbol

	^ self attributes at: aSymbol! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 9/16/2010 01:44'!
attributeAt: aSymbol ifAbsent: aBlock

	^ self attributes at: aSymbol ifAbsent: aBlock! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 9/16/2010 01:45'!
attributeAt: aSymbol ifAbsentPut: aBlock

	^ self attributes at: aSymbol ifAbsentPut: aBlock! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:27'!
attributeAt: aSymbol put: aValue
	^ self attributes at: aSymbol put: aValue! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:19'!
attributes
	^ attributes ifNil: [ attributes := IdentityDictionary new ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 8/9/2010 18:35'!
bounds
	"Answer the bounds of the receiver."
	"the bounds is has an absolute origin"
	"Note that the bounds computed above, may have (and it is likely to) a different origin. The reason is that the layout is in charge to position the nodes properly"
	| basicBounds |

	boundsCache ifNotNil: [ ^ boundsCache ].

	"We check if  the shape if present"
	self shapeBoundsAt: self shape ifPresent: [ :b | ^ boundsCache := b ].

	basicBounds := self shape computeBoundsFor: self.
	self shapeBoundsAt: self shape put: basicBounds.
	^ boundsCache := basicBounds! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/18/2009 22:00'!
boundsOf: aShape
	"Returns the bounds of myself for a given shape"
	| b |
	self shapeBoundsAt: aShape ifPresent: [:bou | ^ bou ].

	b := aShape computeBoundsFor: self.
	self shapeBoundsAt: aShape put: b.
	^ b! !

!MOGraphElement methodsFor: 'cache' stamp: 'jannik.laval 5/20/2009 10:54'!
cacheCanvas: aCanvas
	cacheForm := aCanvas form copy: ((self bounds origin + aCanvas origin - (1@1)) 
													extent: (self bounds extent + (2@2))).! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 9/16/2010 01:44'!
cachedNamed: aSymbol ifAbsentInitializeWith: aBlock
	"aSymbol should start with #cache, else it will not be properly reseted"
	^ self shape isCached
		ifTrue: [ self attributeAt: aSymbol ifAbsentPut: [ aBlock value] ]
		ifFalse: [ aBlock value ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 3/26/2009 10:54'!
center
	^ self bounds center copy! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 6/7/2010 20:20'!
computeElementsToDisplay

	| sorted |
	sorted := SortedCollection sortBlock: [:a :b | a zOrder <= b zOrder].
	self allNodesDo: [:e | sorted add: e].
	self allEdgesDo: [:e | sorted add: e].
	^ sorted asOrderedCollection.! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre.Bergel 9/25/2009 20:57'!
copyShapeAndDo: aOneArgumentBlock
	"Copy the shape of the receiver and evaluates the block with the copy as argument"
	self copyShapeWithoutUpdatingAndDo: aOneArgumentBlock.
	self root updateWindow! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre.Bergel 9/25/2009 20:57'!
copyShapeWithoutUpdatingAndDo: aOneArgumentBlock
	"Copy the shape of the receiver and evaluates the block with the copy as argument"
	| newShape |
	newShape := self shape copy.
	aOneArgumentBlock value: newShape.
	self adoptNewShape: newShape! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:43'!
corner
	"Alexandre Bergel, Feb 2, 2009: copied from Visual works"
	
	^self bounds corner
! !

!MOGraphElement methodsFor: 'layouting' stamp: 'Alexandre.Bergel 4/10/2009 19:17'!
deepApplyLayout
	self nodes do: [:each | each deepApplyLayout].
	self applyLayout.! !

!MOGraphElement methodsFor: 'querying' stamp: 'Alexandre.Bergel 4/10/2009 19:14'!
deepFindNodeWithEntity: anObject
	^ self firstSubnodeThat: [:each | each model = anObject]! !

!MOGraphElement methodsFor: 'configuration' stamp: 'Alexandre.Bergel 2/21/2009 13:21'!
defaultBounds

	^ self shape defaultBounds! !

!MOGraphElement methodsFor: 'initialization' stamp: 'Alexandre Bergel 10/15/2009 20:05'!
defaultLineShapeClass
	^ MOEdge defaultLineShapeClass! !

!MOGraphElement methodsFor: 'initialization' stamp: 'Alexandre Bergel 10/15/2009 20:06'!
defaultNodeShapeClass
	^ MONode defaultNodeShapeClass! !

!MOGraphElement methodsFor: 'configuration' stamp: 'jlr 11/18/2008 14:39'!
defaultOrigin
	^ 0@0! !

!MOGraphElement methodsFor: 'actions' stamp: 'AlexandreBergel 9/6/2010 09:53'!
deselect
	isSelected := false.
	self root deselect: self.! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 2/2/2009 15:44'!
diameter
	^2 * self radius! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 1/20/2010 11:15'!
displayOn: aCanvas 
	self subclassResponsibility ! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 7/26/2010 12:04'!
displayWithoutCachingOn: aCanvas
	self subclassResponsibility ! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'AlexandreBergel 8/29/2010 21:05'!
do: aBlock
	"Iterates over all the subnodes of the receiver."
	
	nodes ifNil: [ ^ self ].
	nodes do: aBlock! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
domain
	^ self root nodes collect: [ :each | each model ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'tg 4/23/2008 22:57'!
edges
	^edges ifNil: [edges := OrderedCollection new]! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 8/10/2010 18:56'!
edgesDo: aBlock
	"Iterates over all the edges of the receiver."
	
	edges ifNil: [ ^ self ].
	edges do: aBlock
"	[
		edges do: aBlock]
	on: Error do: [:ex | self handleException: ex ]"! !

!MOGraphElement methodsFor: 'querying' stamp: 'Alexandre Bergel 4/22/2010 14:40'!
elementAt: aPoint
	^ self elementAt: aPoint ifAbsent: [ self root ]! !

!MOGraphElement methodsFor: 'querying' stamp: 'AlexandreBergel 9/6/2010 18:30'!
elementAt: aPoint ifAbsent: aBlock
	"Answer the element at aPoint or evaluate aBlock if none. Note that this implementation assumes that children are always fully contained within their owner and is therefore very efficient."
	"aPoint is relative coordinate."

	"we do not call elementsToDisplay since its content may have been modified because of the cache"
	^ self elementsToLookup reverse 
			detect: [ :element | element shape containsPoint: aPoint for: element ] 
			ifNone: aBlock.
! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 6/10/2010 18:21'!
elementsToDisplay

	elementsToDisplayCache ifNotNil: [ ^ elementsToDisplayCache ].
	^ elementsToDisplayCache := self computeElementsToDisplay! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 7/8/2010 22:51'!
elementsToLookup
	"This method is used by elementAt:"

	elementsToLookup ifNotNil: [ ^ elementsToLookup ].
	^ elementsToLookup := self computeElementsToDisplay! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 2/21/2009 14:02'!
extent
	^ shape extentFor: self! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'jannik.laval 4/14/2009 14:14'!
firstSubnodeThat: aBlock
	^ self firstSubnodeThat: aBlock ifAbsent: [nil]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 12/7/2009 23:08'!
firstSubnodeThat: aBlock ifAbsent: aBlock2
	self allNodesDo: [:node | (aBlock value: node) ifTrue: [ ^ node]].
	^ aBlock2 value! !

!MOGraphElement methodsFor: 'error handling' stamp: 'Alexandre Bergel 8/10/2010 18:12'!
handleException: exception
	exception signal
"	self haltOnce.
	Transcript show: exception printString ; cr.
"! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:26'!
hasAttribute: aSymbol
	attributes ifNil: [ ^ false ].
	^ self attributes includesKey: aSymbol! !

!MOGraphElement methodsFor: 'testing cache' stamp: 'ab 5/12/2009 22:35'!
hasCachedForm
	^ cacheForm notNil! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/7/2009 20:25'!
hasChildren
	^(nodes isNil or: [nodes isEmpty]) not! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 8/30/2009 13:42'!
hasInteraction
	^ announcer notNil! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/21/2009 23:16'!
initialOrigin
	^ self bounds origin
! !

!MOGraphElement methodsFor: 'initialization' stamp: 'Alexandre Bergel 10/15/2009 20:09'!
initialize
	self resetCache.
	isSelected := false.
	! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 3/31/2009 21:15'!
interaction
	^ self announcer! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/21/2009 14:44'!
interaction: anAnnouncer
	announcer := anAnnouncer! !

!MOGraphElement methodsFor: 'testing cache' stamp: 'Alexandre Bergel 7/15/2010 16:35'!
isCacheLoaded
	^  cacheForm isNil not! !

!MOGraphElement methodsFor: 'testing' stamp: 'Alexandre Bergel 7/26/2010 12:22'!
isNotRoot
	^ self isRoot not! !

!MOGraphElement methodsFor: '*Mondrian-Events-testing' stamp: 'Alexandre.Bergel 9/21/2009 23:16'!
isNotSelected
	^ self isSelected not
! !

!MOGraphElement methodsFor: 'testing' stamp: 'jannik.laval 5/15/2009 13:43'!
isRoot
	^ false! !

!MOGraphElement methodsFor: '*Mondrian-Events-testing' stamp: 'tg 9/14/2010 07:05'!
isSelected
	^ isSelected! !

!MOGraphElement methodsFor: 'accessing' stamp: 'lr 11/9/2006 21:57'!
layout
	"Answer the layout of the receiver."
	
	^ layout! !

!MOGraphElement methodsFor: 'accessing' stamp: 'lr 11/9/2006 22:03'!
layout: aLayout
	layout := aLayout! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'lr 9/20/2006 16:33'!
model
	"Answer the underlying model of this element."
	
	^ model! !

!MOGraphElement methodsFor: 'initialization' stamp: 'tg 4/23/2008 21:37'!
model: anObject
	model := anObject! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject
	"Returns the MONode corresponding to the value anObject"
	
	^ self withAllSubnodes detect: [ :each | each model = anObject]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject ifAbsent: aBlock
	"Returns the MONode corresponding to the value anObject"
	
	^ self allNodes detect: [ :each | each model = anObject] ifNone: aBlock! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValues: aCollection
	"Returns the MONode corresponding to the values contained in aCollection"
	| result |
	aCollection isCollection
		ifFalse: [ ^ self nodeForDomainValues: {aCollection} ].
	result := aCollection collect: [:val | self nodeForDomainValue: val ifAbsent: [nil]].
	^ result copyWithout: nil! !

!MOGraphElement methodsFor: 'querying' stamp: 'Alexandre Bergel 7/26/2010 12:58'!
nodeWith: anObject
	^ self nodes detect: [:each | each model = anObject ] ! !

!MOGraphElement methodsFor: 'querying' stamp: 'AlexandreBergel 9/12/2010 18:11'!
nodeWith: anObject ifAbsent: aBlock 
	| nodeLookedUp |
	lookupNodeCache ifNil: [ lookupNodeCache := IdentityDictionary new ].
	lookupNodeCache at: anObject ifPresent: [ :v | ^ v ].
	nodeLookedUp := self nodes detect: [:each | each model = anObject ] ifNone: aBlock.
	lookupNodeCache at: anObject put: nodeLookedUp.
	^ nodeLookedUp
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 7/26/2010 12:57'!
nodes
	^ nodes ifNil: [ #() ]! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 8/10/2010 18:57'!
nodesDo: aBlock
	"Iterates over all the subnodes of the receiver."
	
	nodes ifNil: [ ^ self ].
	nodes do: aBlock"
	[
		nodes do: aBlock]
	on: Error do: [:ex | self handleException: ex ]"! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 2/28/2010 23:48'!
numberOfNodes
	^ self nodes size! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 14:13'!
origin
	"return a relative origin (position of myself from my parent)"
	^self bounds origin! !

!MOGraphElement methodsFor: 'printing' stamp: 'Alexandre Bergel 7/19/2010 10:51'!
originalPrintOn: aStream
	super printOn: aStream! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'lr 11/3/2006 17:33'!
owner
	"Answer the owning element of this element, or nil if this is the root."
	
	^ owner! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/1/2009 15:17'!
popup
	^ popup! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/1/2009 15:17'!
popup: anObject
	popup := anObject! !

!MOGraphElement methodsFor: 'printing' stamp: 'Alexandre Bergel 7/19/2010 10:51'!
printOn: aStream
	self originalPrintOn: aStream.
	aStream nextPutAll: ' model: '; print: self model! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 2/17/2009 17:32'!
radius
	^(self origin dist: self corner) / 2! !

!MOGraphElement methodsFor: 'actions' stamp: 'lr 11/10/2006 17:51'!
remove
	"Remove the receiver from the parent element."
	
	owner ifNil: [ ^ self ].
	owner remove: self! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre Bergel 12/7/2009 20:25'!
remove: anElement
	"Remove anElement from the children of the receiver."
	
	nodes ifNil: [ ^ self ].
	nodes remove: anElement ifAbsent: nil! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre Bergel 1/12/2010 15:02'!
removeAllEdges
	| root |
	root := self root.
	self allNodes do: [:n | (root allEdgesConnectedTo: n) do: #remove ].
	self allEdgesDo: #remove! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:28'!
removeAttribute: aSymbol
	self attributes removeKey: aSymbol! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 6/9/2010 19:36'!
removeAttributesMatching: aString
	self attributes keys copy do: [ :k |
		self attributes removeKey: k ]! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre Bergel 3/2/2010 12:49'!
removeEdge: anEdge
	^ self edges remove: anEdge! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 6/13/2010 11:50'!
removeElementToDisplay: element

	self elementsToDisplay remove: element ifAbsent: []! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 6/7/2010 20:22'!
removeElementsToDisplay: elements
	elements do: [:el | self removeElementToDisplay: el ]
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 7/7/2010 11:46'!
removeNode: object
	| node |
	node := self nodeForDomainValue: object.
	node incomingEdges do: [ :edge | self edges remove: edge ifAbsent: [] ].
	node outgoingEdges  do: [ :edge | self edges remove: edge ifAbsent: [] ].
	self nodes remove: node.! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 7/7/2010 11:41'!
removeNodes: objects
	objects do: [ :v | self removeNode: v ]! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre Bergel 2/25/2010 18:36'!
removePopupIfExist
	self popup ifNotNilDo: [:v | v delete].
	self popup: nil! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 1/23/2010 17:40'!
resetAbsoluteBoundsCache

	absoluteBoundsCache := nil.
! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 1/23/2010 17:41'!
resetAbsoluteBoundsCacheResursively
	self resetAbsoluteBoundsCache.
	self nodes do: [ :node | node resetCacheResursively ].
! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 6/25/2010 20:01'!
resetCache
	self resetElementsToLookup.
	boundsCache := absoluteBoundsCache := nil.	"Having IdentityDictionary instead of SmallDictionary works the same, it is faster although"
	cacheShapeBounds := SmallDictionary new.	"cacheShapeBounds := IdentityDictionary new"
	elementsToDisplayCache := nil.
	self resetMetricCaches! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 1/23/2010 16:57'!
resetCacheResursively
	self resetCache.
	self nodes do: [ :node | node resetCacheResursively ].
	self edges do: [ :edge | edge resetCacheResursively ].! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 1/26/2010 22:39'!
resetElementsToDisplayCache
	elementsToDisplayCache := nil! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 1/26/2010 22:39'!
resetElementsToDisplayCacheRecursively
	self withAllNodesDo: #resetElementsToDisplayCache! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 6/10/2010 18:40'!
resetElementsToLookup
	"This method is used by elementAt:"

	elementsToLookup := nil! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre Bergel 6/17/2010 15:14'!
resetElementsToLookupUpToTheRoot
	"This method is used by forNode: aBlockOrSymbol whenEnteringUpdateNode: enteringBlock whenLeavingUpdateNode: leavingBlock withLayoutUpdate: aBoolean. 
	It is related to elementAt:"
	self resetElementsToLookup.
	self owner ifNotNilDo: [:ow | ow resetElementsToLookupUpToTheRoot ]
! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 8/11/2010 08:37'!
resetFormCache
	self resetFormCacheSimply.
	
	owner resetElementsToDisplayCache 
! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 7/14/2010 09:05'!
resetFormCacheResursively
	self resetFormCacheSimply.
	self nodes do: [:node | node resetFormCacheResursively].
	
	"Currently, an edge cannot have inner nodes"
	"self edges do: [:edge | edge resetFormCacheResursively]."! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre.Bergel 5/11/2009 14:46'!
resetFormCacheSimply
	cacheForm := nil.
! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 7/14/2010 09:26'!
resetFormCacheUpToTheRoot
	self resetFormCacheSimply.
	elementsToDisplayCache := nil.
	self owner resetFormCacheUpToTheRoot! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 6/9/2010 19:40'!
resetMetricCaches
	self removeAttributesMatching: 'cache*'! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 6/9/2010 19:42'!
resetMetricCachesResursively
	self resetMetricCaches.
	self nodes do: [ :node | node resetMetricCachesResursively ].
	self edges do: [ :edge | edge resetMetricCachesResursively ].! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 9/1/2010 19:13'!
resetMetricCachesUpToTheRoot
	self resetMetricCaches.
	self owner resetMetricCachesUpToTheRoot
! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 8/10/2010 18:56'!
reverseDo: aBlock
	"Iterates over all the subnodes of the receiver in reverse order."
	
	nodes ifNil: [ ^ self ].
	nodes reverseDo: aBlock "
	[
		nodes reverseDo: aBlock ]
	on: Error do: [:ex | self handleException: ex ]"! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 8/10/2010 18:57'!
reverseEdgesDo: aBlock
	"Iterates over all the subedges of the receiver in reverse order."
	
	edges ifNil: [ ^ self ].
	edges reverseDo: aBlock."
	[
		edges reverseDo: aBlock.]
	on: Error do: [:ex | self handleException: ex ]"! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 8/10/2010 18:56'!
reverseWithEdgesDo: aBlock
	"Iterates over all the subnodes and edges of the receiver in reverse order."
	
	nodes ifNil: [ ^ self ].
	"["
		nodes reverseDo: aBlock.
		edges ifNil: [ ^ self ].
		edges reverseDo: aBlock."]
	on: Error do: [:ex | self handleException: ex ]"! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'tg 4/25/2008 09:58'!
root
	"Answer the root node of this graph element, by recursively walking upwards the owner nodes."
	^ owner root! !

!MOGraphElement methodsFor: 'actions' stamp: 'tg 2/13/2010 15:10'!
select
	isSelected := true.
	self root addSelection: self.
	self resetFormCache! !

!MOGraphElement methodsFor: 'initialization' stamp: 'lr 11/3/2006 17:31'!
setAnnouncer: anAnnouncer
	announcer := anAnnouncer! !

!MOGraphElement methodsFor: 'initialization' stamp: 'lr 11/9/2006 22:24'!
setLayout: aLayout
	layout := aLayout! !

!MOGraphElement methodsFor: 'initialization' stamp: 'lr 11/3/2006 17:31'!
setModel: anObject
	model := anObject! !

!MOGraphElement methodsFor: 'initialization' stamp: 'lr 9/18/2006 10:50'!
setOwner: aFigure
	owner := aFigure! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/11/2010 10:08'!
shape
	"Each element has a shape to graphically render itself"
	
	^ shape! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/28/2009 12:58'!
shape: aShape 
	"This method does not update the cache. Use adoptNewShape: if you wish to do so"
	shape := aShape.
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'simon.denier 3/5/2009 11:16'!
shapeBounds
	^ cacheShapeBounds! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre.Bergel 8/18/2009 21:58'!
shapeBoundsAt: aShape
	^ self shapeBounds at: aShape! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 8/9/2010 18:39'!
shapeBoundsAt: aShape ifPresent: aBlock

	self shapeBounds ifNil: [ ^ self ].
	^ self shapeBounds at: aShape ifPresent: aBlock! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 9/5/2010 09:52'!
shapeBoundsAt: aShape put: bounds

	boundsCache := absoluteBoundsCache := nil.
	self shapeBounds at: aShape put: bounds.
! !

!MOGraphElement methodsFor: 'testing cache' stamp: 'Alexandre Bergel 7/26/2010 12:12'!
shouldCache

	^ nodes notNil and: [owner shouldCache not and: [self bounds area < 3000000]]
! !

!MOGraphElement methodsFor: 'debugging' stamp: 'Alexandre Bergel 7/26/2010 12:05'!
structure
	| n |
	n := self nodes asSortedCollection: [:n1 :n2 | n1 nodes size > n2 nodes size ].
	^ n isEmpty
		ifTrue: [ 
			n size -> n first structure
			"n size ->( (n copyFrom: 1 to: (n size min: 5)) collect: #structure) asArray" ]
		ifFalse: [ n size ]! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre.Bergel 4/23/2009 16:07'!
threadholdSize
	"If the width or the heigh is below this size, then nested nodes and edges are not displayed"
	^ 4! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 2/28/2010 23:48'!
totalNumberOfNodes
	^ self withAllSubnodes size! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 1/23/2010 18:07'!
translateAbsoluteCacheBy: aPoint
	absoluteBoundsCache ifNil: [ ^ self ].
	absoluteBoundsCache := absoluteBoundsCache translateBy: aPoint! !

!MOGraphElement methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 7/26/2010 12:04'!
translateBy: aPoint bounded: bounded
	self subclassResponsibility! !

!MOGraphElement methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 4/26/2010 10:17'!
updateBounds
! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 12/7/2009 23:09'!
withAllNodesDo: aBlock
	"Evaluate aBlock with the receiver and all its nodes."
	
	aBlock value: self.
	self allNodesDo: aBlock! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'lr 11/12/2006 14:29'!
withAllOwnersDo: aBlock
	"Evaluates aBlock with the receiver and all its owning elements."

	| current |
	current := self.
	[ current isNil ] whileFalse: [ 
		aBlock value: current.
		current := current owner ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 12/20/2009 12:02'!
withAllSubnodes
	^ self allNodes, {self}! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/26/2010 21:51'!
zOrder
	self subclassResponsibility! !

MOGraphElement subclass: #MONode
	instanceVariableNames: 'incomingEdges outgoingEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

MONode subclass: #MOFramedNode
	instanceVariableNames: 'domainValues currentFrame frameBlock view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Animation'!

!MOFramedNode class methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 3/1/2010 07:47'!
for: domainNodes
	^ self new domainValues: domainNodes! !

!MOFramedNode methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/15/2010 14:17'!
currentFrame
	^ currentFrame! !

!MOFramedNode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 3/1/2010 12:17'!
currentValue

	^ domainValues at: currentFrame! !

!MOFramedNode methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/1/2010 07:47'!
domainValues
	^ domainValues! !

!MOFramedNode methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/1/2010 07:47'!
domainValues: anObject
	domainValues := anObject! !

!MOFramedNode methodsFor: 'actions' stamp: 'Alexandre Bergel 3/1/2010 12:50'!
eachFrameDo: aZeroArgBlock

	| tmpCurrentFrame |
	tmpCurrentFrame := self currentFrame.
	
	[ aZeroArgBlock value.
	  self nextFrame. ] doWhileTrue: [ tmpCurrentFrame ~= self currentFrame ]! !

!MOFramedNode methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/15/2010 14:17'!
frameBlock: oneArgBlock
	frameBlock := oneArgBlock.
	self initializeBounds! !

!MOFramedNode methodsFor: 'private' stamp: 'Alexandre Bergel 3/15/2010 14:17'!
generateFrame

	self hasFrameBlock ifFalse: [ ^ self ].
	view forFramedNode: self do: frameBlock! !

!MOFramedNode methodsFor: 'testing' stamp: 'Alexandre Bergel 3/1/2010 11:51'!
hasFrameBlock
	^ frameBlock notNil! !

!MOFramedNode methodsFor: 'initialization' stamp: 'Alexandre Bergel 3/1/2010 11:28'!
initialize
	super initialize.
	currentFrame := 1! !

!MOFramedNode methodsFor: 'actions' stamp: 'Alexandre Bergel 3/1/2010 14:57'!
initializeBounds
	"Set the current Bounds as the maximum one chose from the domainValues"
	
	| maxExtent newBounds |
	maxExtent := 0@0.
	self eachFrameDo: [
		newBounds := self shape boundsFor: self.
		maxExtent := maxExtent max: newBounds extent ].
	
	"self shapeBoundsAt: self shape put: (0@0 corner: maxExtent)."
	"Very ugly, need to be fixed in the future"
	self shape: (self shape copy width: newBounds width; height: newBounds height).! !

!MOFramedNode methodsFor: 'actions' stamp: 'Alexandre Bergel 3/2/2010 14:24'!
moveToFrame: newFrameAsInteger
	self assert: [ newFrameAsInteger between: 1 and: self numberOfFrames ] description: 'Wrong number of Frame '.
	currentFrame := newFrameAsInteger.
	self generateFrame.
	self resetFormCache.
	view updateWindow! !

!MOFramedNode methodsFor: 'actions' stamp: 'Alexandre Bergel 3/1/2010 12:28'!
nextFrame
	currentFrame = domainValues size
		ifTrue: [ currentFrame := 0 ].
	currentFrame := currentFrame + 1.
	self generateFrame.
	self resetFormCache.
	view updateWindow.! !

!MOFramedNode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 3/1/2010 07:47'!
numberOfFrames
	^ domainValues size! !

!MOFramedNode methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/1/2010 11:47'!
view: aViewRenderer
	view := aViewRenderer! !

!MONode class methodsFor: 'default' stamp: 'jannik.laval 7/13/2010 16:41'!
defaultNodeShapeClass 
	^ MOShape defaultNodeShapeClass
! !

!MONode methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/2/2010 12:50'!
acceptVisitor: aVisitor
	^ aVisitor visitNode: self! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/25/2009 22:04'!
addIncomingEdge: anEdge
	incomingEdges ifNil: [ incomingEdges := OrderedCollection new ].
	incomingEdges add: anEdge! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/25/2009 22:02'!
addIncomingEdges: aCollection
	incomingEdges ifNil: [ incomingEdges := OrderedCollection new ].
	incomingEdges addAll: aCollection! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/26/2009 10:11'!
addOutgoingEdge: anEdge
	outgoingEdges ifNil: [ outgoingEdges := OrderedCollection new ].
	outgoingEdges add: anEdge! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/16/2009 23:59'!
addOutgoingEdges: someEdges
	outgoingEdges ifNil: [ outgoingEdges := OrderedCollection new ].
	outgoingEdges addAll: someEdges! !

!MONode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/12/2010 14:52'!
allEdgesConnectedToMe
	^ self root allEdgesConnectedTo: self! !

!MONode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/9/2010 20:25'!
allIncomingEdges
	| coll |
	coll := OrderedCollection new.
	self withAllNodesDo: [:n | coll addAll: n incomingEdges].
	^ coll! !

!MONode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/9/2010 20:25'!
allOutcomingEdges
	| coll |
	coll := OrderedCollection new.
	self withAllNodesDo: [:n | coll addAll: n outgoingEdges].
	^ coll! !

!MONode methodsFor: 'cache' stamp: 'Alexandre Bergel 7/15/2010 18:44'!
cacheForm
	"used in the test"
	^ cacheForm! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 4/25/2010 11:54'!
decreaseZoom

	self decreaseZoomBy: 0.9! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 4/25/2010 11:53'!
decreaseZoomBy: aValue
	self scaleBy: aValue.
	self nodes do: [:node | node decreaseZoomBy: aValue ].
	self resetFormCacheResursively.! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 8/29/2010 20:38'!
displayOn: aCanvas 
	"	self layer isVisible ifFalse: [ ^ self ]."	
	| b canvas |
	(aCanvas isVisible: self absoluteBounds) ifFalse: [ ^ self ].

	self isCacheLoaded ifTrue: [
		aCanvas paintImage: cacheForm at: (self absoluteBounds origin - (1@1)).
		^ self ].
	
	self shouldCache ifFalse: [ 
		"If we cannot cache (for example if we are too big) then we display ourself, and iterate over inner nodes
		 while giving them a chance to cache"
		self displayWithoutCachingOn: aCanvas.
		^ self ].	
	
	b := self bounds.	
	canvas := FormCanvas extent: (b extent + (2@2)) .
		
"	self displayWithoutCachingOn: canvas."
	canvas 
		translateBy: self absoluteBounds origin negated + (1@1) 
		during: [:tmpCanvas | self displayWithoutCachingOn: tmpCanvas ].
	cacheForm := canvas form.	

	self updateOwner. 
	aCanvas paintImage: cacheForm at: (self absoluteBounds origin - (1@1)).
! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 8/29/2010 20:32'!
displayWithoutCachingOn: aCanvas 
	"a Node is displayed at the coordinate given by its _absolute_ position. The relative position
	 cannot be used because of the zOrder. An outter node may not be necessarily be displayed before 
	 its inner nodes"

	aCanvas 
		translateBy: self absoluteBounds origin
		during: [:tmpCanvas | shape display: self on: tmpCanvas ].
	
	"Per default, a shape cannot display its children. The only exception is with form shape."
	shape canHandleChildren
		ifFalse: [ self elementsToDisplay do: [ :each | each displayWithoutCachingOn: aCanvas ] ].
	! !

!MONode methodsFor: 'accessing-readonly' stamp: 'tg 10/5/2008 19:43'!
endPoint
	^self bounds topCenter! !

!MONode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 7/9/2010 11:12'!
externalEdges
	| tmpNodes |
	tmpNodes := self allNodes.
	^ self allEdges 
				select: [:edge | (tmpNodes noneSatisfy: [ :n | edge source == n ] )
									or: [ tmpNodes noneSatisfy: [ :n | edge target == n ]  ] ] ! !

!MONode methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 4/25/2010 11:49'!
getBoundedTranslationStep: wantedStepAsPoint
	"Return the real translation step when the translation is bounded"
	"We do not let the position to be outside of the parent"

	| newRelativePosition |
	^ owner isRoot not 
		ifTrue: [
			newRelativePosition := self origin + wantedStepAsPoint.
			newRelativePosition := newRelativePosition adhereTo: 
									(0@0 rect: (owner bounds extent - self bounds extent)).
			newRelativePosition - self bounds origin ]
		ifFalse: [
			wantedStepAsPoint ]
! !

!MONode methodsFor: 'testing' stamp: 'Alexandre.Bergel 9/25/2009 22:05'!
hasIncomingEdges
	incomingEdges ifNil: [ ^ false ].
	^ self incomingEdges notNil! !

!MONode methodsFor: 'testing' stamp: 'jlr 10/28/2008 17:04'!
hasNestedGraph
	^self edges isEmpty not! !

!MONode methodsFor: 'accessing-readonly' stamp: 'tg 4/24/2008 16:14'!
height
	^self bounds height! !

!MONode methodsFor: 'enumerating' stamp: 'Alexandre Bergel 3/15/2010 16:18'!
incomingAndOutgoingEdgesDo: oneArgBlock

	self incomingEdges do: oneArgBlock.
	self outgoingEdges do: oneArgBlock.! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/25/2009 22:01'!
incomingEdges
	incomingEdges ifNil: [ ^ #() ].
	^ incomingEdges! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 4/25/2010 11:54'!
increaseZoom

	self increaseZoomBy: 1.1! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 4/25/2010 11:53'!
increaseZoomBy: aValue
	self scaleBy: aValue.
	self nodes do: [:node | node increaseZoomBy: aValue ].
	self resetFormCacheResursively.! !

!MONode methodsFor: 'initialization' stamp: 'Alexandre Bergel 6/17/2010 12:24'!
initialize 
	super initialize.
	shape := MOShape defaultNodeShapeInstance! !

!MONode methodsFor: 'accessing' stamp: 'tg 10/5/2008 22:22'!
layout
	^ layout ifNil: [ layout := MOHorizontalLineLayout new ]! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/26/2009 10:13'!
outgoingEdges
	outgoingEdges ifNil: [ ^ #() ].
	^ outgoingEdges! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 3/15/2010 15:01'!
position
	^ self bounds center
	! !

!MONode methodsFor: 'cache' stamp: 'Alexandre Bergel 4/25/2010 12:07'!
resetCacheInEdges
	self edges do: [:edge | edge resetCache].
	self nodes do: [:node | node resetCacheInEdges].
	
	self allIncomingEdges do: [:edge | edge resetCache].
	self allOutcomingEdges do: [:edge | edge resetCache].
! !

!MONode methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 4/25/2010 11:58'!
scaleBy: aNumber 
	| keys |
	keys := self shapeBounds keys.
	keys do: [:key | 
		self shapeBoundsAt: key put: ((self shapeBoundsAt: key) scaleBy: aNumber).
	].
	boundsCache := absoluteBoundsCache := nil.
	
	self edges do: [:edge | edge resetCache].
	
	"The owner must update its bounds. It must scale as well"
	owner isRoot ifTrue: [owner updateBounds]! !

!MONode methodsFor: 'actions' stamp: 'Alexandre.Bergel 8/18/2009 22:03'!
setBoundsTo: newBounds
	"check if it is valid"
	| oldShapeBounds oldReferencialBounds deltaOrigin ratioW ratioH oldLocalBounds newLocalBounds |
	newBounds topLeft < newBounds bottomRight
		ifFalse: [ ^ self ].
	
	oldShapeBounds := self shapeBounds.
	self resetCache.
	"self shapeBounds at: self shape put: newBounds."
	
	oldReferencialBounds := oldShapeBounds at: self shape.
	deltaOrigin := newBounds topLeft - oldReferencialBounds topLeft.
	ratioW := newBounds width / oldReferencialBounds width.
	ratioH := newBounds height / oldReferencialBounds height.
	oldShapeBounds associationsDo:
		[:assoc | 
			oldLocalBounds := assoc value.
			newLocalBounds := Rectangle
							origin: (oldLocalBounds origin + deltaOrigin)
							width: (oldLocalBounds width * ratioW) asInteger
							height: (oldLocalBounds height * ratioH) asInteger.
			self shapeBoundsAt: assoc key put: newLocalBounds ].
	
	self resetFormCacheResursively
	
! !

!MONode methodsFor: 'accessing-readonly' stamp: 'tg 10/5/2008 19:43'!
startPoint
	^self bounds bottomCenter! !

!MONode methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 4/25/2010 11:49'!
translateBy: aPoint
	^ self translateBy: aPoint bounded: false! !

!MONode methodsFor: 'translation and bounds' stamp: 'AlexandreBergel 9/6/2010 18:30'!
translateBy: aPoint bounded: bounded
	"It moves the element by aPoint. 
	If bounded is true and the owner is not the root, 
	then the bounds are limited by the owner bounds.
	If the element is placed in the root, then the root's bounds are updated"
	| realStep newRelativePosition allShapes |
	self shapeBounds isNil ifTrue: [ ^ self bounds ].
	self shapeBounds isEmpty ifTrue: [ ^ self bounds ].

	realStep :=  bounded 
						ifTrue: [ self getBoundedTranslationStep: aPoint ]
						ifFalse: [ aPoint ].			

	newRelativePosition := self origin + aPoint.	

	allShapes := self shapeBounds keys.
	allShapes do: [ :eachShape | 
		self shapeBoundsAt: eachShape put: ((self shapeBoundsAt: eachShape) translateBy: realStep) ].
	boundsCache := absoluteBoundsCache := nil.
	self allNodesDo: [ :n | n translateAbsoluteCacheBy: realStep ].

	
	owner isRoot ifTrue: [
		"the root has to be extended in any case"
		owner expandToIncludePoint: (newRelativePosition +  self bounds extent) ].
	
	self resetCacheInEdges! !

!MONode methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 4/25/2010 11:49'!
translateTo: aPoint 
	self translateBy: (aPoint - self origin)! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 9/6/2010 18:30'!
updateOwner
	"This method is used when the bitmap cache is set"
	| elems |
	elems := self elementsToDisplay.
	elems := elems copyWithoutAll: self externalEdges.
	owner removeElementsToDisplay: elems.! !

!MONode methodsFor: 'accessing-readonly' stamp: 'tg 4/24/2008 16:14'!
width
	^self bounds width! !

!MONode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 7/15/2010 14:55'!
zOrder
	^ zOrder ifNil: [ zOrder := self owner zOrder + 2 ]! !

MONode subclass: #MORoot
	instanceVariableNames: 'selections cacheBounds canvas selectionBoxCorner1 selectionBoxCorner2 selectionBoxUsage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MORoot methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 4/10/2009 17:57'!
absoluteBounds
	"since a root does not have a owner/parent, and it has no shape, there is no point in looking up the 
	cacheShapeBounds"
	^ self bounds! !

!MORoot methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/4/2010 19:27'!
acceptVisitor: aVisitor
	^ aVisitor visitRoot: self! !

!MORoot methodsFor: 'selection' stamp: 'tg 4/26/2008 00:14'!
addSelection: aFigure

	selections add: aFigure! !

!MORoot methodsFor: 'layouting' stamp: 'AlexandreBergel 8/29/2010 20:59'!
applyLayout
	"Layout the receiver and all its children."

	self resetMetricCachesResursively.
	self shapeBoundsAt: self shape put: (0@0 corner: 0@0).

	self do: [ :each |
		each applyLayout ].
	self layout applyOn: self.
	self nodesDo: [:each |
		self bounds corner: (self bounds corner max: (each extent + each origin)).
	].
! !

!MORoot methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 4/10/2009 17:54'!
bounds
	^ cacheBounds ifNil: [ cacheBounds := super bounds]
	"^ super bounds"! !

!MORoot methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/12/2010 14:31'!
canvas
	^ canvas! !

!MORoot methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/12/2010 14:31'!
canvas: anObject
	canvas := anObject! !

!MORoot methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 4/1/2010 14:52'!
decreaseZoomBy: aValue

	self resetFormCacheResursively.
	self nodes do: [:node | node decreaseZoomBy: aValue ].
	self edges do: [:edge | edge resetCache].
	self announce: MOZoomEvent decrease.
	self updateWindow! !

!MORoot methodsFor: 'selection' stamp: 'tg 2/19/2010 18:27'!
deselect: aFigure
	selections remove: aFigure ifAbsent: []! !

!MORoot methodsFor: 'selection' stamp: 'tg 4/26/2008 00:17'!
deselectAll
	selections do: [:each | each deselect]! !

!MORoot methodsFor: 'displaying' stamp: 'AlexandreBergel 9/6/2010 18:31'!
displayOn: aCanvas 	
	(aCanvas isVisible: self absoluteBounds) ifFalse: [ ^ self ].

	self displaySelectionBoxIfNecessaryOn: aCanvas.
	self elementsToDisplay 
		do: [ :each | each displayOn: aCanvas ]


! !

!MORoot methodsFor: 'displaying' stamp: 'AlexandreBergel 9/6/2010 09:24'!
displaySelectionBoxIfNecessaryOn: aCanvas

	self hasSelectionBox ifFalse: [ ^ self ].
	aCanvas 
		frameAndFillRectangle: ((Rectangle encompassing: {selectionBoxCorner1. selectionBoxCorner2} ))
		fillColor: Color lightBlue
		borderWidth: 2
		borderColor: Color blue! !

!MORoot methodsFor: 'actions' stamp: 'AlexandreBergel 9/6/2010 10:08'!
expandToIncludePoint: aPoint
	"Cannot reduce the size of MORoot"
	| bounds |
	bounds := self bounds.
	bounds width: ((bounds width max: aPoint x) "*1.3") asInteger.
	bounds height: ((bounds height max: aPoint y) "* 1.3") asInteger.
	
	canvas ifNotNil: [ canvas updateBounds ]! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 9/6/2010 10:00'!
hasSelectedNodes
	^ self allNodes anySatisfy: #isSelected ! !

!MORoot methodsFor: 'selection' stamp: 'tg 4/26/2008 00:52'!
hasSelection
	^selections notEmpty! !

!MORoot methodsFor: 'testing' stamp: 'AlexandreBergel 9/5/2010 17:55'!
hasSelectionBox
	^ selectionBoxCorner1 notNil & selectionBoxCorner2 notNil 
 
! !

!MORoot methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 4/1/2010 14:52'!
increaseZoomBy: aValue

	self resetFormCacheResursively.
	self nodes do: [:node | node increaseZoomBy: aValue ].
	self edges do: [:edge | edge resetCache].
	self announce: MOZoomEvent increase.
	self updateWindow! !

!MORoot methodsFor: 'initialization' stamp: 'AlexandreBergel 9/5/2010 17:21'!
initialize
	super initialize.

	selections := OrderedCollection new.
	shape := self defaultNodeShapeClass new withoutBorder.

	selectionBoxCorner1 := nil.
	selectionBoxCorner2 := nil.
	
	self setDefaultHandlers! !

!MORoot methodsFor: 'testing' stamp: 'jannik.laval 5/15/2009 13:43'!
isRoot
	^ true! !

!MORoot methodsFor: 'zoom' stamp: 'simondenier 10/27/2009 17:13'!
isZoomOn

	^ false! !

!MORoot methodsFor: 'printing' stamp: 'Alexandre Bergel 7/19/2010 10:51'!
printOn: aStream
	self originalPrintOn: aStream.! !

!MORoot methodsFor: 'cache' stamp: 'Alexandre Bergel 7/18/2010 15:59'!
resetFormCache
	"Do nothing., the root does not have a cache"! !

!MORoot methodsFor: 'cache' stamp: 'Alexandre Bergel 7/14/2010 09:24'!
resetFormCacheUpToTheRoot
	"We do nothing since we are the root"! !

!MORoot methodsFor: 'cache' stamp: 'AlexandreBergel 9/1/2010 19:13'!
resetMetricCachesUpToTheRoot
	"We do nothing since we are the root"! !

!MORoot methodsFor: 'accessing-readonly' stamp: 'tg 4/25/2008 09:58'!
root
	^ self! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 9/6/2010 10:18'!
selectBoxBounds
	^ Rectangle encompassing: {selectionBoxCorner1 . selectionBoxCorner2 }.
! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 9/6/2010 10:18'!
selectElementsFromBox
	
	| rectangle |
	selectionBoxUsage := Time now.
	rectangle := self selectBoxBounds.
	
	(self allNodes select: [:node | rectangle containsRect: node absoluteBounds ]) 
		do: [:v | v announce: (MOElementSelection new element: v; setAsMultiple ) ]! !

!MORoot methodsFor: 'selection' stamp: 'tg 4/26/2008 00:18'!
selections
	^selections! !

!MORoot methodsFor: 'configuration' stamp: 'AlexandreBergel 9/6/2010 10:16'!
setDefaultHandlers

	self interaction 
		on: MOMouseDown do: [ :ann | 
			self expandToIncludePoint: (ann position * 1.3) asIntegerPoint.
			self hasSelectedNodes ifFalse: [
				selectionBoxCorner1 isNil 
					ifTrue: [ selectionBoxCorner1 := ann position ]
					ifFalse: [ selectionBoxCorner2 isNil
								ifTrue: [ selectionBoxCorner2 := ann position ]
								ifFalse: [ self selectElementsFromBox. 
										 selectionBoxCorner2 := selectionBoxCorner1 := nil ]
								].
				self updateWindow ]
			 ];
			
		on: MOMouseMove do: [ :ann |
			selectionBoxCorner1 notNil ifTrue: [
				self expandToIncludePoint: (ann position * 1.3) asIntegerPoint .
				selectionBoxCorner2 :=  ann position.
				self updateWindow ] 
			]
! !

!MORoot methodsFor: 'testing cache' stamp: 'Alexandre Bergel 7/15/2010 21:10'!
shouldCache
	^ false! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 9/6/2010 09:53'!
shouldDeselect
	selectionBoxUsage ifNil: [ ^ true ].
	^ (Time now asSeconds - selectionBoxUsage asSeconds) > 1! !

!MORoot methodsFor: 'translation and bounds' stamp: 'Alexandre.Bergel 3/16/2009 22:23'!
translateBy: aPoint 

	self nodes do: [:node | node translateBy: aPoint ]! !

!MORoot methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 7/26/2010 13:03'!
updateBounds
	| maxWidth maxHeight origin bounds |
	self nodes ifEmpty: [self error: 'This method cannot be called since there is no children, something is going wrong'].
	maxWidth := 0.
	maxHeight := 0.
	self nodes do: [:figure|
		origin := figure origin.
		maxWidth := maxWidth max: (figure width + origin x).
		maxHeight := maxHeight max: (figure height + origin y).
	].

	bounds := self bounds.
	bounds width: maxWidth.
	bounds height: maxHeight.

	
"	minX := self children inject: 10000 into: [:min :figure | min min: (figure origin x)].
	minY := self children inject: 10000 into: [:min :figure | min min: (figure origin y)].
	bounds origin: minX @ minY"
	
	canvas ifNotNil: [ canvas updateBounds ]! !

!MORoot methodsFor: 'cache' stamp: 'Alexandre Bergel 7/15/2010 16:57'!
updateOwner
	"nothing to do here"! !

!MORoot methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 7/13/2010 23:14'!
updateWindow
	"Refresh the content of the window. This happens when some shape change for example"
"	self resetFormCacheResursively."
	
	"We notify the morphic framework that the canvas needs to be redrawn"
	self canvas changed.
"	self announcer announce: MOContentChanged new.
"! !

!MORoot methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/26/2010 22:02'!
zOrder
	^ 1! !

!MORoot methodsFor: 'zoom' stamp: 'simondenier 10/27/2009 17:13'!
zoomDecLabel

	^ '-'! !

!MORoot methodsFor: 'zoom' stamp: 'simondenier 10/27/2009 17:13'!
zoomIncLabel

	^ '+'! !

Object subclass: #MOHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

MOHelp subclass: #MOEaselHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!MOEaselHelp class methodsFor: 'helpers' stamp: 'AlexandreBergel 9/5/2010 09:33'!
umlShape
	| builder |
	builder := MOFormsBuilder new.
	builder
		column;
		fill.
	builder
		row;
		fill;
		row;
		fill.
	builder x: 1 y: 1 add: MORectangleShape new.
	builder
		x: 1
		y: 1
		add:
			(((MORectangleShape new)
				withoutBorder;
				withText) text: [ :cls | cls name ]).
	builder x: 1 y: 2 add: MORectangleShape new.
	builder
		x: 1
		y: 2
		add:
			(((MORectangleShape new)
				withoutBorder;
				withText)
				text: [ :cls | cls methodDict keys inject: '' into: [ :sum :el | sum , el , (String with: Character cr) ] ]).
	^ builder shape! !

!MOEaselHelp methodsFor: 'normalizer' stamp: 'Alexandre Bergel 7/26/2010 15:24'!
numberLinearNormalizer
	<title: 'number linear'>
	
^
'| normalizer |

normalizer := MONumberLinearNormalizer inContext: {1 . 2 . 3 . 4 . 3 . 2 . 1}. normalizer scale: 50.
view shape rectangle size: normalizer.
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}.

"The script above has the same effect than:
| maxPixel maxValue |
maxPixel := 50.
maxValue := 4.
view shape rectangle size: [:v | (v * maxPixel / maxValue) asInteger ].
view nodes: {1 . 2 . 3 . 4 . 3 . 2 . 1}
"'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'AlexandreBergel 9/16/2010 01:38'!
script10SelectionAndDeselection
	<title: 'Selecting multiple nodes'>
^
'view shape label.
view node: ''Click on inner nodes''.
view nodes: (1 to: 3) forEach: [:each |
	|nodes |
	nodes :=  (each * 100) to: (each * 110).
	view interaction 
		registerForEvent: MOElementSelection
		forNodes: [:v | nodes ]
		updateShape: [:shape | shape borderColor: Color red]
		updateLayout: false.
	view interaction 
		registerForEvent: MOElementDeselection
		forNodes: [:v | nodes ]
		updateShape: [:shape | shape borderColor: Color black]
		updateLayout: false.
	view nodes: nodes.
].
view verticalLineLayout'! !

!MOEaselHelp methodsFor: 'builder' stamp: 'AlexandreBergel 9/16/2010 01:35'!
script1Form
	<title: 'form: facility'>
^ '
"form: takes a one block argument. A forms builder is passed as argument"
view shape 
	form: [:b | 
					b column; fill; row; fill; row; fill; row; fill. 
					b x:1 y:1 add: (MORectangleShape new fillColor: Color lightGreen).
					b x:1 y:2 add: MORectangleShape new withText.
					b x:1 y:3 add: (MORectangleShape new fillColor: Color lightBlue).].
view node: ''hello world'''! !

!MOEaselHelp methodsFor: 'layout' stamp: 'JeanRemyFalleri 7/15/2010 19:35'!
script1ScatterplotLayout

^ '
| nodes mthNorm locNorm |
nodes := Collection withAllSubclasses.
mthNorm := MONumberLinearNormalizer inContext: nodes withCommand: [:c | c selectors size].
mthNorm scale: 10.
locNorm := MONumberLinearNormalizer inContext: nodes withCommand: [:c | c linesOfCode].
locNorm scale: 10.
view node: #plot forIt: [
	view nodes: (nodes collect: [:c| {c name. mthNorm moValue: c. locNorm moValue: c}]).
	view interaction popupText: [:n | n first].
	view layout: (MOScatterplotLayout new
							upSideDown;
							offset: 2;
							scaleFactor: 10;
							x: #third;
							y: #second)].
'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/17/2009 18:59'!
script1SimpleHighlight
	<title: 'simple highlight'>
^
'view shape rectangle size: 60.
view interaction 
	highlightWhenOver.

view nodes: (1 to: 20)'! !

!MOEaselHelp methodsFor: 'basic' stamp: 'Alexandre Bergel 12/17/2009 02:14'!
script1SimpleNodes
	<title: 'just 20 simple nodes'>
	^
 '
"Display 20 nodes using the default size (5x5)"
view nodes: (1 to: 20).
'! !

!MOEaselHelp methodsFor: 'subviews' stamp: 'Alexandre Bergel 12/17/2009 18:20'!
script1Subview
	<title: 'simple'>
^
'
view nodes: (1 to: 20) forEach: [:each |
	view nodes: (1 to: 100).
	view gridLayout
]
'! !

!MOEaselHelp methodsFor: 'shape' stamp: 'Alexandre Bergel 5/12/2010 08:46'!
script1Transparency
	<title: 'color transparency'>
	
^ 'view shape ellipse
	width: 100; height: 100; fillColor:(Color blue alpha:0.2).
view nodes: #((10 10) (10 20) (0 0) (40 20)).
view layout: (MOScatterplotLayout new
                      scaleFactor: 5;
                      x: #first;
                      y: #second).

view shape line
	fromPositions: #(#center);
	toPositions: #(#center).
view edge: #(10 10) from: #yourself to:  #(10 20).
view edge: #(40 20) from: #yourself to:  #(10 20).'! !

!MOEaselHelp methodsFor: 'software visualization' stamp: 'AlexandreBergel 9/16/2010 01:51'!
script1UML
	<title: 'UML'>
^
'"Resize the easel after generating"
view shape: UMLClassDiagram new umlShape.
view nodes: (MOShape withAllSubclasses).
	
view shape: (MOArrowedOrthoVerticalLineShape new).
view edgesFrom: #superclass.
view treeLayout'! !

!MOEaselHelp methodsFor: 'basic' stamp: 'Alexandre Bergel 12/17/2009 02:14'!
script2ColoredNodes
	<title: 'colored nodes'>
	^
'
view shape rectangle
	size: 30;
	linearFillColor: #yourself within: (1 to: 20).
	
view nodes: (1 to: 20).
	'! !

!MOEaselHelp methodsFor: 'shape' stamp: 'Alexandre Bergel 6/4/2010 17:38'!
script2Curve
	<title: 'simple curve mechanism'>
^ 'view shape: 
	(MOCurveShape new 
		width: 180; 
		height: 50; 
		colorWhenPositive:  Color lightGray; 
		colorWhenNegative: Color lightRed).

view nodes: 
	{((Float pi negated to: Float pi by: 0.3) collect: [:v | v cos * 10]) .
	 (-1 to: 4)}'! !

!MOEaselHelp methodsFor: 'builder' stamp: 'AlexandreBergel 9/16/2010 01:35'!
script2FormBuilder
	<title: 'example of MOFormsBuilder'>
^ '
| builder rectangleShape |
builder := MOFormsBuilder new.
builder column; left; pref.
builder row; left; row; left; row; left; pref.

rectangleShape := MORectangleShape new
		height: 10;
		width: 20.

builder x: 1 y: 1 add: (rectangleShape copy fillColor: Color red).
builder x: 1 y: 2 add: (rectangleShape copy fillColor: Color green).
builder x: 1 y: 3 add: (MORectangleShape new withText).

view shape: builder shape.
view nodes: (1 to: 5).
view treeLayout
'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/17/2009 19:49'!
script2HighlightSeveralNodes
	<title: 'highlight several nodes '>
^
'
view interaction highlightWhenOver: [:v | {v - 1 . v + 1. v + 4 . v - 4}].
view shape rectangle 
	width: 40;
	height: 30;
	withText.
view nodes: (1 to: 16).
view gridLayout gapSize: 2.'! !

!MOEaselHelp methodsFor: 'layout' stamp: 'Alexandre Bergel 3/2/2010 21:52'!
script2SimpleScatterplotLayout
	<title: 'simple scatterplotlayout'>

^ 'view nodes: #((10 5) (20 50) (2 4) (60 20)).
view layout: (MOScatterplotLayout new
						upSideDown;
						scaleFactor: 2;
						x: #first;
						y: #second).'! !

!MOEaselHelp methodsFor: 'subviews' stamp: 'Alexandre Bergel 12/17/2009 16:23'!
script2Subview
	<title: 'titled nodes + interaction forward'>
^
'
view shape rectangle withoutBorder.
view nodes: (1 to: 20) forEach: [:each |
	view shape label.
	view node: each.
	view interaction forward.
	view node: each forIt: [
		view node: each.
		view nodes: (1 to: 100).
		view gridLayout gapSize: 2].
	view verticalLineLayout center.
]
'! !

!MOEaselHelp methodsFor: 'software visualization' stamp: 'Alexandre Bergel 7/16/2010 13:24'!
script2SystemComplexity
	<title: 'System Complexity'>
^
'"Each node is a class, edges designate inheritance.
Height is linear to the number of method the class defines.
Width is linear to the number of variables the class defines.
Color color is linear to the number of lines of code of the class.
The darkest node designates the class that has the highest number of lines of code"

view shape rectangle
	width: [:cls | cls instVarNames size * 3];
	height: [:cls | cls methods size ];
	linearFillColor: [:cls | cls methods inject: 0 into: [:sum :el | sum + el getSourceFromFile lineCount]] within: Collection withAllSubclasses.
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout'! !

!MOEaselHelp methodsFor: 'basic' stamp: 'Alexandre Bergel 12/17/2009 02:26'!
script3ColoredNodes
	<title: 'ellipsoid nodes'>
	^
'
view shape ellipse
	height: [:each | each * 2];
	width: [:each | each * 3];
	linearFillColor: #yourself within: (1 to: 20).
	
view nodes: (1 to: 20).
'! !

!MOEaselHelp methodsFor: 'builder' stamp: 'AlexandreBergel 9/16/2010 01:38'!
script3FlagExample
	<title: 'flag example'>
^ '
| builder |
builder := MOFormsBuilder new.
"Assuming you want a grid made up of 3 columns and 2 rows"
builder 
	column; fill; 
	column; fill; center; 
	column; fill.
builder 
	row; fill; row; fill; row; fill;  "For the German flag"
	row; center; 							"The EU text"
	row; pref.	 "For the French flag"
"We draw a German flag"
builder x: 1 y: 1 w: 3 add: (MORectangleShape new width: 30; height: 7; fillColor: Color black).
builder x: 1 y: 2 w: 3 add: (MORectangleShape new width: 30; height: 7; fillColor: Color red).
builder x: 1 y: 3 w: 3 add: (MORectangleShape new width: 30; height: 7; fillColor: Color yellow).

builder x: 1 y: 4 w: 3 add: (MORectangleShape new text: [:aNumber |''EU '', aNumber printString]).

"We draw a French flag"
builder x: 1 y: 5 add: (MORectangleShape new width: 10; height: 20; fillColor: Color blue).
builder x: 2 y: 5 add: (MORectangleShape new width: 10; height: 20; fillColor: Color white).
builder x: 3 y: 5 add: (MORectangleShape new width: 10; height: 20; fillColor: Color red).



view interaction popupText: [:aNumber | ''my value is '', aNumber printString ].

view shape: (builder shape).
view nodes: (1 to: 27).
view edges: (1 to: 27) from: #yourself to: [:each | each * each].
view circleLayout.
'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/17/2009 19:57'!
script3HighlightSeveralNodes
	<title: 'strong highlight several nodes '>
^
'
view interaction strongHighlightWhenOver: [:v | {v - 1 . v + 1. v + 4 . v - 4}].
view shape rectangle 
	width: 40;
	height: 30;
	withText.
view nodes: (1 to: 16).
view gridLayout gapSize: 2.'! !

!MOEaselHelp methodsFor: 'layout' stamp: 'AlexandreBergel 9/16/2010 01:55'!
script3InteractiveSpringLayout
	<title: 'interactive springLayout'>

^ 'view interaction refreshLayoutEvery: 30.
view shape rectangle withText.
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view layout: (MOSpringLayout new maxSecondsToCompute: 0)'! !

!MOEaselHelp methodsFor: 'subviews' stamp: 'Alexandre Bergel 12/20/2009 13:01'!
script3InteractiveSubview
	<title: 'adding subview '>
^
'view shape rectangle size: 20.
view interaction
	on: MOMouseDown do: [:ann | view forNode: ann element model do: [ view nodes: (1 to: 5). view gridLayout ] ].
view nodes: ( 1 to: 16 ).
view gridLayout'! !

!MOEaselHelp methodsFor: 'basic' stamp: 'Alexandre Bergel 12/17/2009 16:17'!
script4EdgesAndTitledNodes
	<title: 'edges + titled nodes'>
	^
'
| nodes |
view shape rectangle
	width: 40;
	text: #yourself.
	
nodes := view nodes: (1 to: 20).

view shape arrowedLine.
view edges: (2 to: 20) from: 1 to: #yourself.
view layout: (MOCircleLayout forNodes: nodes allButFirst)
'! !

!MOEaselHelp methodsFor: 'layout' stamp: 'AlexandreBergel 9/16/2010 01:55'!
script4InteractiveSpringLayout2
	<title: 'interactive springLayout, small example'>

^ 'view interaction refreshLayoutEvery: 30.
view shape rectangle size: 15.
view nodes: (1 to: 30).
view edges: (1 to: 30) from: #yourself to: [:v | v \\ 5].
view layout: (MOSpringLayout new maxSecondsToCompute: 0)'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/17/2009 20:32'!
script4SizeUpdateNodes
	<title: 'variation in node size'>
^
'view shape rectangle size: 10.
view interaction
	forNodes: #yourself 
	whenEnteringUpdateShapes: [:shape | shape size: 30] 
	whenLeavingUpdateShapes: [:shape | shape size: 10]
	withLayoutUpdate: true.
view nodes: (1 to: 20).'! !

!MOEaselHelp methodsFor: 'subviews' stamp: 'Alexandre Bergel 4/1/2010 15:10'!
script4Zoom

^ 
'view shape rectangle size: 10.
view interaction popupView: [:el :v | 
	v nodes: (1 to: 9). v gridLayout
] zoomedInBy: 3.
view nodes: (1 to: 10) forEach: [:each | 
	view nodes: (1 to: 9). view gridLayout].

view gridLayout
'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/28/2009 11:26'!
script5ClickingOnBackground
	<title: 'Clicking on background'>
^
'view nodes: (1 to: 100).
view gridLayout.

view root interaction
	on: MOMouseDown do: [:ann | self inform: ''You clicked on the background, press ok!!'' ]'! !

!MOEaselHelp methodsFor: 'basic' stamp: 'Alexandre Bergel 4/26/2010 17:04'!
script5Labels
	<title: 'labels'>
	^
'view shape rectangle withoutBorder.
view node: ''example 1'' forIt: [
	view shape label fontSize: #yourself.
	view nodes: (1 to: 40).
].

view shape rectangle withoutBorder.
view node: ''example 2'' forIt: [
	view shape label smallFont.
	view node: ''small font''.

	view shape label normalFont.
	view node: ''normal font''.

	view shape label bigFont.
	view node: ''big font''.
].

view shape rectangle withoutBorder.
view node: ''example 3'' forIt: [
	view shape label 
		linearFontSize: #yourself within: (1 to: 40).
	view nodes: (1 to: 40).
].


view verticalLineLayout'! !

!MOEaselHelp methodsFor: 'layout' stamp: 'AlexandreBergel 9/16/2010 01:47'!
script5MinimumGridLayout
	<title: 'minimum grid layout'>
	
	^'(1 to: 50) do: [ :index |
		view shape rectangle size: (200 atRandom ) ; borderWidth: 1 ; fillColor: Color lightBlue.
		view node: (index asString).
	].

	view minimumGridLayout.'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 12/28/2009 13:13'!
script6ClickingOnBackgroundWithUpdate
	<title: 'Clicking on background with update'>
^
'view interaction action: [:v | (view nodeForDomainValue: v) inspect ].
view nodes: (1 to: 100).
view gridLayout gapSize: 10.

view root interaction
	on: MOMouseDouble do: [:ann | 
			| node txt |
			
			txt := UIManager default request: ''Enter a text''.
			view shape rectangle withText.
			node := view node: txt.
			node translateBy: ann position.
			view updateWindow
			]'! !

!MOEaselHelp methodsFor: 'basic' stamp: 'Alexandre Bergel 2/28/2010 22:08'!
script6EdgesToAll
	<title: 'edgesToAll:'>
	^
'
"link 1 to 2,3,4, link 2 to 3,4,5, ..."
view nodes: (1 to: 20).
view edgesToAll: [:v | {v + 1 . v + 2. v + 3}].
view treeLayout'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 6/19/2010 20:00'!
script7ComplexRendering
	<title: 'Mouse over and node expansion'>
^
'view shape rectangle size: 20.
view interaction action: #inspect.
view interaction 
	whenEnteringUpdateNode: [:node | 
		view interaction forwarder.
		view nodes: (Set allSubclasses).
			view interaction forwarder.
		view edgesFrom: #superclass..
		view treeLayout
		] 
	whenLeavingUpdateNode:  [:node | ]  
	withLayoutUpdate: true.
view nodes: (1 to: 3)'! !

!MOEaselHelp methodsFor: 'basic' stamp: 'Alexandre Bergel 4/14/2010 09:02'!
script7DashedEdge
	<title: 'Dashed edges'>
	^
'view shape rectangle size: 15.
view nodes: (1 to: 5).
view shape arrowedDashedLine width: 3.
view edges: {1 -> 2} from: #key to: #value.

view shape dashedLine.
view edges: {2 -> 3} from: #key to: #value.

view shape dashedLine dashLengths: {5 . 2}; width: 4.
view edges: {2 -> 4} from: #key to: #value.

view treeLayout'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 1/26/2010 21:23'!
script8PopupView
	<title: 'Popup view'>
^
'view shape rectangle size: 60.
view interaction 
	popupView: [:entity :myView | myView nodes: (1 to: 20) ] delay: 500;
	highlightWhenOver.

view nodes: (1 to: 20)'! !

!MOEaselHelp methodsFor: 'interaction' stamp: 'Alexandre Bergel 2/24/2010 00:03'!
script9WindowStatus
	<title: 'Window status'>
^
'view shape rectangle size: 30.
view interaction windowStatus: #yourself.
view nodes: (1 to: 5)'! !

!MOHelp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 9/6/2010 18:31'!
populateMenu: menuMorph
	| selectors title pragma |
	
	self organization categories do: [:catName |
		selectors := self organization listAtCategoryNamed: catName.
		selectors do: [:sel | 
			title := sel asString.
			pragma := ((self >> sel) pragmaAt: #title:).
			pragma ifNotNil: [ title := pragma arguments first ].
			
			title := catName asString, ' / ', title.
			menuMorph add:  title target: self selector: #setScript: argument: (self perform: sel) ].
	].



"	self organization categories do: [:catName |
		submenu := MenuMorph new.
		selectors := self organization listAtCategoryNamed: catName.
		selectors do: [:sel | 
			title := sel asString.
			pragma := ((self >> sel) pragmaAt: #title:).
			pragma ifNotNil: [ title := pragma arguments first ].
			submenu add:  title target: self selector: #openEaselFromSelector: argument: sel ].
		aMenu add: catName asString subMenu: submenu
	].
"! !

!MOHelp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 9/16/2010 18:06'!
populateMenu: menuMorph forEasel: easel
	"Return a menu filled with mondrian easel commands"

	| selectors title pragma help submenus aSubmenu |

	submenus := Dictionary new.

	help := self new.
	self organization categories do: [:catName |
		selectors := self organization listAtCategoryNamed: catName.
		selectors do: [:sel | 
			title := sel asString.
			pragma := ((self >> sel) pragmaAt: #title:).
			pragma ifNotNil: [ title := pragma arguments first ].
			
			aSubmenu := submenus at: catName asString ifAbsentPut: [ MenuMorph new ].
			aSubmenu add:  title target: easel selector: #setScript: argument: (help perform: sel) ].
	].

	submenus associationsDo: [ :ass | 
		menuMorph add: ass key subMenu: ass value ]
! !

Object subclass: #MOIdentityMatrix
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOIdentityMatrix class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
new
	"Answer a newly created and initialized instance."
	
	^super new initialize! !

!MOIdentityMatrix methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
at: u
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row keys! !

!MOIdentityMatrix methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
at: u at: v
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row
		at: v
		ifAbsent: [false]! !

!MOIdentityMatrix methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
at: u at: v put: aBoolean
	
	| row |
	"u -> v"
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	row at: v put: aBoolean.	"v -> u"
	row := rows
		at: v
		ifAbsentPut: [IdentityDictionary new].
	row at: u put: aBoolean! !

!MOIdentityMatrix methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	rows := IdentityDictionary new! !

Object subclass: #MOLayout
	instanceVariableNames: 'edges userDefinedEdges affectedNodes fromPositions toPositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

MOLayout subclass: #MOAbstractFlowLayout
	instanceVariableNames: 'maxWidth gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractFlowLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withMaxWidth: anInteger
	
	^(self new)
		maxWidth: anInteger;
		yourself! !

!MOAbstractFlowLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withMaxWidth: anInteger withGap: anotherInteger
	
	^(self new)
		maxWidth: anInteger;
		gapSize: anotherInteger;
		yourself! !

!MOAbstractFlowLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize
	
	^gapSize! !

!MOAbstractFlowLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize: anObject
	
	gapSize := anObject! !

!MOAbstractFlowLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 4/2/2009 00:41'!
initialize
	
	super initialize.
	maxWidth := 100.
	gapSize := 5! !

!MOAbstractFlowLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
maxWidth
	
	^maxWidth! !

!MOAbstractFlowLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
maxWidth: anObject
	
	maxWidth := anObject! !

MOAbstractFlowLayout subclass: #MOBottomFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOBottomFlowLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:14'!
isAbstract
	^ false! !

!MOBottomFlowLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doExecute: aGraph 
	| x y maxLastLineHeight lineHeights lineNumber |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	lineHeights := OrderedCollection new.
	lineNumber := 1.
	aGraph nodes do: 
		[ :aNodeFigure | 
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ lineHeights addLast: maxLastLineHeight.
			x := self gapSize.
			maxLastLineHeight := 0 ] ].
	lineHeights addLast: maxLastLineHeight.
	x := self gapSize.
	aGraph nodes do: 
		[ :aNodeFigure | 
		| lineHeight |
		lineHeight := lineHeights at: lineNumber.
		aNodeFigure translateTo: x @ (y + lineHeight - aNodeFigure height).
		x := x + aNodeFigure width + (2 * self gapSize).
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + lineHeight.
			lineNumber := lineNumber + 1 ] ]! !

MOAbstractFlowLayout subclass: #MOFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOFlowLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:14'!
isAbstract
	^ false! !

!MOFlowLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doExecute: aGraph 
	| x y maxLastLineHeight |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	aGraph nodes do: 
		[ :aNodeFigure | 
		aNodeFigure translateTo: x @ y.
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + maxLastLineHeight.
			maxLastLineHeight := 0 ] ]! !

MOLayout subclass: #MOAbstractGraphLayout
	instanceVariableNames: 'verticalGap horizontalGap cachedChildren cachedParents cachedParentsWithHighestNestings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractGraphLayout class methodsFor: 'constants' stamp: ' 24/4/08 15:59'!
horizontalGap
	
	^3.0! !

!MOAbstractGraphLayout class methodsFor: 'constants' stamp: ' 24/4/08 15:59'!
verticalGap
	
	^20.0! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cachedChildren
	
	cachedChildren ifNil: [cachedChildren := IdentityDictionary new: 1000].
	^cachedChildren! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cachedParents
	
	cachedParents ifNil: [cachedParents := IdentityDictionary new: 1000].
	^cachedParents! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cachedParentsWithHighestNestings
	
	cachedParentsWithHighestNestings
		ifNil: [cachedParentsWithHighestNestings := IdentityDictionary new: 1000].
	^cachedParentsWithHighestNestings! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'tg 4/24/2008 16:13'!
childrenFor: aNode
	
	^self cachedChildren
		at: aNode
		ifAbsentPut:
			[| nodes |
			nodes := OrderedCollection new.
			self edges
				do:
					[:edge | 
					(edge source == aNode and: [edge target ~= aNode])
						ifTrue:
							[(nodes includes: edge target) ifFalse: [nodes add: edge target]]].
			nodes]! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'tg 4/24/2008 16:15'!
childrenFor: aNode except: aNodeCollection
	
	^(self childrenFor: aNode) difference: aNodeCollection! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
childrenWithHighestNestingLevelFor: aNode
	
	^(self childrenFor: aNode)
		select: [:eachChild | (self highestNestingParentFor: eachChild) == aNode]! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'Alexandre.Bergel 3/26/2009 10:59'!
clear
	
	cachedParents := nil.
	cachedChildren := nil.
	cachedParentsWithHighestNestings := nil! !

!MOAbstractGraphLayout methodsFor: 'default values' stamp: ' 24/4/08 15:59'!
defaultFromPositions
	
	^#(#bottomCenter)! !

!MOAbstractGraphLayout methodsFor: 'default values' stamp: ' 24/4/08 15:59'!
defaultToPositions
	
	^#(#topCenter)! !

!MOAbstractGraphLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doInitialize: aGraph 
	super doInitialize: aGraph.
	self clear.
	self greedyCycleRemoval: aGraph nodes! !

!MOAbstractGraphLayout methodsFor: 'battista' stamp: 'tg 4/24/2008 16:14'!
greedyCycleRemoval: aCollection
	"Di Battista Greedy-Cycle-Removal algorithm. Chapter 9.4, page 297. The last part is not like in the book. The original algorithm only takes
	 local optimas into account. This will break ordinary trees sometimes. This version also takes global optimas into account."
	
	| g sl sr s indeg outdeg degrees vertex |
	g := aCollection copy.
	sl := OrderedCollection new.
	sr := OrderedCollection new.	"While g contains a sink (aka leaf)"
	g copy
		do:
			[:node | 
			(self childrenFor: node) isEmpty
				ifTrue:
					[sr addFirst: node.
					g remove: node]	"self edges detect: [:edge | edge fromFigure == node] ifNone: [sr addFirst: node. g remove: node]"].	"While g contains a source (aka root)"
	g copy
		do:
			[:node | 
			(self parentsFor: node) isEmpty
				ifTrue:
					[sl addLast: node.
					g remove: node]	"self edges detect: [:edge | edge toFigure == node] ifNone: [sl addLast: node. g remove: node]"].	"Calculate deg for all remaining vertices"
	degrees := IdentityDictionary new.
	g
		do:
			[:node | 
			indeg := (self parentsFor: node) size.
			outdeg := (self childrenFor: node) size.	"indeg := self edges inject: 0 into: [:sum :edge | (edge toFigure == node) ifTrue: [sum + 1] ifFalse: [sum]].
		outdeg := self edges inject: 0 into: [:sum :edge | (edge fromFigure == node) ifTrue: [sum + 1] ifFalse: [sum]]."
			degrees
				at: node
				put: outdeg - indeg].	"While g not empty"
	g := g asSortedCollection: [:a :b | (degrees at: a) >= (degrees at: b)].
	[g isEmpty]
		whileFalse:
			[vertex := g
				detect: [:v | (self parentsFor: v) anySatisfy: [:w | sl includes: w]]
				ifNone: [g first].	"Corner case: Closed cycle with not root at all. Eg 1 -> 2 -> 3 -> 1"
			sl addLast: vertex.
			g remove: vertex].	"Remove all leftward edges"
	s := sl , sr.
	self edges copy
		do:
			[:edge | 
			(s indexOf: edge source) > (s indexOf: edge target)
				ifTrue: [self edges remove: edge]].	"Reset the cache"
	self clear! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
highestNestingParentFor: aNodeFigure
	
	| parents |
	^self cachedParentsWithHighestNestings
		at: aNodeFigure
		ifAbsentPut:
			[parents := self parentsFor: aNodeFigure.
			parents isEmpty
				ifTrue: [0]
				ifFalse:
					[parents detectMax: [:eachParent | self nestingLevelFor: eachParent]]]! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalGap
	
	^horizontalGap ifNil: [self class horizontalGap]! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: 'simon.denier 3/5/2009 11:57'!
horizontalGap: anInteger
	
	horizontalGap := anInteger! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'simon.denier 3/5/2009 16:37'!
nestingLevelFor: aNodeFigure
	
	| parents parentsNesting |
	parents := self parentsFor: aNodeFigure.
	parentsNesting := parents
		collect: [:eachParent | self nestingLevelFor: eachParent].
	^parentsNesting isEmpty
		ifTrue: [0]
		ifFalse: [parentsNesting max + 1]
! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'Alexandre Bergel 7/26/2010 12:26'!
parentsFor: aNode
	"MOGraphElement knows its outgoing edges, getting the parent of a node should be faster than this method"
	^ self cachedParents
		at: aNode
		ifAbsentPut:
			[| nodes |
			nodes := OrderedCollection new.
			self edges
				do:
					[:edge | edge target == aNode ifTrue: [nodes add: edge source]].
			nodes]! !

!MOAbstractGraphLayout methodsFor: 'private' stamp: 'Alexandre.Bergel 8/30/2009 15:42'!
rootNodesFor: aCollection
	^ aCollection select: [:node | (self parentsFor: node) isEmpty ].
	
	"| nodes |
	nodes := OrderedCollection new.
	aCollection
		do:
			[:node | (self parentsFor: node) isEmpty ifTrue: [nodes add: node]].
	^nodes"! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalGap
	
	^verticalGap ifNil: [self class verticalGap]! !

!MOAbstractGraphLayout methodsFor: 'accessing' stamp: 'simon.denier 3/5/2009 11:57'!
verticalGap: anInteger
	
	verticalGap := anInteger! !

MOAbstractGraphLayout subclass: #MOAbstractRegularTreeLayout
	instanceVariableNames: 'alreadyLayoutedNodes topGap leftGap nodesByLayer isLayered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

MOAbstractRegularTreeLayout subclass: #MOAbstractHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/15/2010 00:47'!
computeChildrenFor: aNode
	self subclassResponsibility! !

!MOAbstractHorizontalTreeLayout methodsFor: 'default values' stamp: 'tg 8/14/2010 22:50'!
defaultFromPositions
	
	^#(#rightCenter)! !

!MOAbstractHorizontalTreeLayout methodsFor: 'default values' stamp: 'tg 8/14/2010 22:50'!
defaultToPositions
	
	^#(#leftCenter)! !

!MOAbstractHorizontalTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/14/2010 23:04'!
initialize
	super initialize.
	verticalGap := 3.
	horizontalGap := 20! !

!MOAbstractHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 23:03'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := x + each width + self horizontalGap.
		treeSize := each height
			max: (self layout: (self computeChildrenFor: each) atPoint: childrenPosition @ y atLayer: aNumber + 1).
		middleOfTree := y + (treeSize / 2.0) - (each height / 2.0).
		each translateTo: x @ middleOfTree.
		y := y + treeSize + self verticalGap ].
	^ y - aPoint y - self verticalGap! !

!MOAbstractHorizontalTreeLayout methodsFor: 'private' stamp: 'tg 8/15/2010 00:38'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self leftGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			eachNode translateTo: (cursor @ eachNode absoluteBounds top).
			max max: eachNode width ].
		cursor := cursor + layerDepthSize + self horizontalGap ]! !

MOAbstractHorizontalTreeLayout subclass: #MOBulletTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOBulletTreeLayout class methodsFor: 'default values' stamp: 'Alexandre Bergel 12/20/2009 15:31'!
defaultFromPositions
	
	^#(#bottomLeft)! !

!MOBulletTreeLayout class methodsFor: 'default values' stamp: 'Alexandre Bergel 12/20/2009 15:31'!
defaultToPositions
	
	^#(#leftCenter)! !

!MOBulletTreeLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:14'!
isAbstract
	^ false! !

!MOBulletTreeLayout methodsFor: 'hook-private' stamp: 'AlexandreBergel 8/31/2010 18:03'!
computeChildrenFor: aNode! !

!MOBulletTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/15/2010 00:45'!
initialize
	
	super initialize.
	verticalGap := 3.
	horizontalGap := 10! !

!MOBulletTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/15/2010 00:45'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeHeight childrenX x y |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenX := x + self horizontalGap.
		y := y + each height.
		treeHeight := self
			layout: (self childrenFor: each)
			atPoint: childrenX @ y
			atLayer: aNumber + 1.
		each translateTo: x @ y.
		y := y + treeHeight + self verticalGap ].
	^ y - aPoint y - self verticalGap! !

MOAbstractHorizontalTreeLayout subclass: #MOHorizontalDominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalDominanceTreeLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOHorizontalDominanceTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:51'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

MOHorizontalDominanceTreeLayout subclass: #MOHorizontalDominanceTreeWithTimelineLayout
	instanceVariableNames: 'timeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalDominanceTreeWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:32'!
doExecute: aGraph
	super doExecute: aGraph.
	aGraph nodes do: [ :aNodeFigure | aNodeFigure translateTo: (timeBlock value: aNodeFigure model) @ (aNodeFigure bounds origin y ) ]! !

!MOHorizontalDominanceTreeWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:26'!
timeBlock
	^ timeBlock! !

!MOHorizontalDominanceTreeWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:26'!
timeBlock: anObject
	timeBlock := anObject! !

MOAbstractHorizontalTreeLayout subclass: #MOHorizontalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalTreeLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOHorizontalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:51'!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

!MOAbstractRegularTreeLayout methodsFor: 'private' stamp: 'tg 2/12/2010 15:31'!
atLayer: aNumber add: aNodeCollection
	| collection |
	collection := nodesByLayer at: aNumber ifAbsentPut: [OrderedCollection new].
	collection addAll: aNodeCollection! !

!MOAbstractRegularTreeLayout methodsFor: 'hook' stamp: 'tg 8/16/2010 16:58'!
doExecute: aGraph
	| rootNodes |
	alreadyLayoutedNodes := OrderedCollection new.
	rootNodes := self rootNodesFor: aGraph nodes.
	nodesByLayer := OrderedCollection new.
	self
		layout: rootNodes
		atPoint: self leftGap @ self topGap
		atLayer: 1.
	self isLayered ifTrue: [
		self rearrangeByLayers: aGraph ]! !

!MOAbstractRegularTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/16/2010 16:58'!
initialize
	super initialize.
	topGap := 5.
	leftGap := 5.
	isLayered := false! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 8/16/2010 16:58'!
isLayered
	^ isLayered! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 8/16/2010 16:58'!
isLayered: anObject
	isLayered := anObject! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 8/16/2010 16:58'!
layered
	self isLayered: true! !

!MOAbstractRegularTreeLayout methodsFor: 'hook-private' stamp: 'tg 2/12/2010 07:45'!
layout: aNodeCollection atPoint: aPoint atLayer: anObject
	self subclassResponsibility! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 1/20/2010 02:59'!
leftGap
	^ leftGap! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 1/20/2010 02:59'!
leftGap: anInteger
	leftGap := anInteger! !

!MOAbstractRegularTreeLayout methodsFor: 'private' stamp: 'tg 8/14/2010 23:14'!
rearrangeByLayers: aGraph
	self subclassResponsibility! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 1/20/2010 02:58'!
topGap
	^ topGap! !

!MOAbstractRegularTreeLayout methodsFor: 'accessing' stamp: 'tg 1/20/2010 02:59'!
topGap: anInteger
	topGap := anInteger! !

MOAbstractRegularTreeLayout subclass: #MOAbstractVerticalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:39'!
computeChildrenFor: aNode
	self subclassResponsibility! !

!MOAbstractVerticalTreeLayout methodsFor: 'initialize-release' stamp: 'tg 8/14/2010 23:04'!
initialize
	super initialize.
	verticalGap := 20.
	horizontalGap := 3! !

!MOAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 23:03'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := y + each height + self verticalGap.
		treeSize := each width
			max: (self layout: (self computeChildrenFor: each) atPoint: x @ childrenPosition atLayer: aNumber + 1).
		middleOfTree := x + (treeSize / 2.0) - (each width / 2.0).
		each translateTo: middleOfTree @ y.
		x := x + treeSize + self horizontalGap ].
	^ x - aPoint x - self horizontalGap! !

!MOAbstractVerticalTreeLayout methodsFor: 'private' stamp: 'tg 8/15/2010 00:38'!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self topGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			eachNode translateTo: (eachNode absoluteBounds left @ cursor ).
			max max: eachNode height ].
		cursor := cursor + layerDepthSize + self verticalGap ]! !

MOAbstractVerticalTreeLayout subclass: #MODominanceTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MODominanceTreeLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:15'!
isAbstract
	^ false! !

!MODominanceTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:40'!
computeChildrenFor: aNode
	^ self childrenWithHighestNestingLevelFor: aNode! !

MOAbstractVerticalTreeLayout subclass: #MOTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOTreeLayout class methodsFor: 'default' stamp: 'Alexandre.Bergel 4/12/2009 19:26'!
defaultFromPositions
	^ #(#bottomCenter)! !

!MOTreeLayout class methodsFor: 'default' stamp: 'Alexandre.Bergel 4/12/2009 19:27'!
defaultToPositions
	^ #(#topCenter)! !

!MOTreeLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOTreeLayout methodsFor: 'hook-private' stamp: 'tg 8/14/2010 22:40'!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

MOAbstractGraphLayout subclass: #MONarrowTreeLayout
	instanceVariableNames: 'layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MONarrowTreeLayout commentStamp: '<historical>' prior: 0!
Classical Code Crawler vertical tree layout.

Instance Variables:
	layers	<Dictionary>	Contains a TreeLayerWrapper for every layer

!

MONarrowTreeLayout subclass: #MOHorizontalNarrowTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalNarrowTreeLayout methodsFor: 'default values' stamp: 'tg 7/25/2010 14:40'!
defaultFromPositions
	
	^#(#rightCenter)! !

!MOHorizontalNarrowTreeLayout methodsFor: 'default values' stamp: 'tg 7/25/2010 14:40'!
defaultToPositions
	
	^#(#leftCenter)! !

!MOHorizontalNarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:30'!
shapeTree: aRoot position: xOffset
	
	| treeHeight layerKeys layer layerHeight horizontalPosition verticalPosition |
	self buildLayers: aRoot.
	treeHeight := self currentTreeSize.
	horizontalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection.
	layerKeys do: [:aKey | 
		layer := layers at: aKey.
		layerHeight := layer width: self horizontalGap.
		verticalPosition := treeHeight / 2.0 + xOffset - (layerHeight / 2.0).
		layer do: [:aFigure | 
			aFigure translateTo: horizontalPosition @ verticalPosition.
			verticalPosition := verticalPosition + aFigure width + self horizontalGap].
		horizontalPosition := horizontalPosition + layer height + self verticalGap].
	^treeHeight! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:15'!
atLayer: aLayer add: aFigure
	"Associates the figure aFigure with the layer aLayer"
	
	| layer |
	layer := layers
		at: aLayer
		ifAbsent:
			[layers
				at: aLayer
				put: MOTreeLayerWrapper new.
			layers at: aLayer].
	layer add: aFigure! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:20'!
buildLayers: aRoot
	layers := Dictionary new.
	self buildLayers: aRoot layer: 0! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:20'!
buildLayers: aRoot layer: aLayer
	self atLayer: aLayer add: aRoot.
	(self childrenFor: aRoot) do: [:aChild | 
		self
			buildLayers: aChild
			layer: aLayer + 1 ]! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:31'!
currentTreeSize
	| maximum |
	maximum := 0.
	layers values do: [:aLayer | 
		maximum := maximum max: (aLayer width: self horizontalGap)].
	^maximum! !

!MONarrowTreeLayout methodsFor: 'hook' stamp: 'tg 7/25/2010 14:18'!
doExecute: aGraph 
	| roots offset treeWidth |
	roots := self rootNodesFor: aGraph nodes.
	offset := self horizontalGap.
	roots do: 
		[ :aRoot | 
		treeWidth := self 
			shapeTree: aRoot
			position: offset.
		offset := offset + treeWidth + (2 * self horizontalGap) ]! !

!MONarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:29'!
shapeTree: aRoot position: xOffset
	self subclassResponsibility! !

MONarrowTreeLayout subclass: #MOVerticalNarrowTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOVerticalNarrowTreeLayout commentStamp: '<historical>' prior: 0!
Classical Code Crawler vertical tree layout.

Instance Variables:
	layers	<Dictionary>	Contains a TreeLayerWrapper for every layer

!

!MOVerticalNarrowTreeLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOVerticalNarrowTreeLayout methodsFor: 'private' stamp: 'tg 7/25/2010 14:22'!
shapeTree: aRoot position: xOffset
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition |
	self buildLayers: aRoot.
	treeWidth := self currentTreeSize.
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection.
	layerKeys do: [:aKey | 
		layer := layers at: aKey.
		layerWidth := layer width: self horizontalGap.
		horizontalPosition := treeWidth / 2.0 + xOffset - (layerWidth / 2.0).
		layer do: [:aFigure | 
			aFigure translateTo: horizontalPosition @ verticalPosition.
			horizontalPosition := horizontalPosition + aFigure width + self horizontalGap].
		verticalPosition := verticalPosition + layer height + self verticalGap].
	^treeWidth! !

MOAbstractGraphLayout subclass: #MORadialTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MORadialTreeLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MORadialTreeLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/6/2010 11:21'!
doExecute: aGraph 
	"	| rootNodes top left |
	top := left := Unlimited positive.
	rootNodes := self rootNodesFor: aGraph nodeFigures.
	self layoutLayer: rootNodes radius: 5 from: 0 to: (2 * Double pi).
	aGraph nodeFigures do: [:each | 
		top := top min: each bounds top. 
		left := left min: each bounds left.].
	aGraph nodeFigures do: [:each | 
		each translateBy: ((0 - left)) @ ((0 - top)).
	].


"
	| rootNodes maximumRadius xOffset |

	rootNodes := self rootNodesFor: aGraph nodes.
	xOffset := 0.
	rootNodes do: 
		[ :node | 
		node translateTo: 0 @ 0.	"Move the node to the origin of the coordinate system"
		maximumRadius := self 
			layoutLayer: (self childrenFor: node)
			radius: node radius
			from: 0
			to: 2 * Float pi.
		self 
			shiftTree: node
			by: (maximumRadius + xOffset) @ maximumRadius.
		xOffset := xOffset + (2 * maximumRadius) ]! !

!MORadialTreeLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
gap
	
	^self verticalGap! !

!MORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 9/6/2010 11:21'!
layoutLayer: aCollection radius: oldRadius from: aFromAngle to: aToAngle
	
	| delta childRadius maximumRadius myRadius fromAngle toAngle |
	"Initialize with default value"
	maximumRadius := oldRadius.
	aCollection isEmpty
		ifFalse:
			[myRadius := oldRadius + self gap + (self maximumRadius: aCollection).
			childRadius := oldRadius + self gap + (self maximumDiameter: aCollection).	"This is a purely optical tweak"
			(aCollection size = 1 and: [aToAngle - aFromAngle = (2 * Float pi)])
				ifTrue:
					[delta := 0.4 * Float pi.
					fromAngle := 0.8 * Float pi.
					toAngle := fromAngle + delta]
				ifFalse:
					[delta := (aToAngle - aFromAngle) / aCollection size.
					fromAngle := aFromAngle.
					toAngle := aFromAngle + delta].
			aCollection
				do:
					[:child | 
					child
						translateTo:
							(Point
								r: myRadius
								theta: toAngle - (delta / 2.0)).
					maximumRadius := maximumRadius
						max:
							(self
								layoutLayer: (self childrenFor: child)
								radius: childRadius
								from: fromAngle
								to: toAngle).
					fromAngle := toAngle.
					toAngle := toAngle + delta]].
	^maximumRadius! !

!MORadialTreeLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
maximumDiameter: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: node diameter]! !

!MORadialTreeLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
maximumRadius: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: node radius]! !

!MORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 2/12/2009 10:31'!
shiftTree: aNode by: aPoint
	
	aNode translateBy: aPoint.
	(self childrenFor: aNode) do: [:child | self shiftTree: child by: aPoint]! !

MOAbstractGraphLayout subclass: #MOSugiyamaLayout
	instanceVariableNames: 'sortBlock labels layers layerNrs connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOSugiyamaLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOSugiyamaLayout class methodsFor: 'utils' stamp: ' 24/4/08 15:59'!
sortBlock
	
	^MOSortBlock new! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'Alexandre Bergel 2/17/2010 18:11'!
addDummyNodes
	
	| layer layerNr |
	connections := MOIdentityMatrix new.
	self edges
		do:
			[:edge | 
			| a b span fromNode toNode |
			"edge hints removeAll."
			a := layerNrs at: edge source.
			b := layerNrs at: edge target.
			span := (a - b) abs.
			span = 1
				ifTrue:
					[connections
						at: edge source
						at: edge target
						put: true].	"Normal case where nodes are in adjacent layers"
			fromNode := edge source.
			[span > 1]
				whileTrue:
					[span := span - 1.
					layerNr := b + span.
					layer := layers at: layerNr.
					toNode := MODummyNode
						on: edge
						slot: a - span.
					layer add: toNode.
					layerNrs at: toNode put: layerNr.
					connections at: fromNode at: toNode put: true.
					fromNode := toNode].
			(a - b) abs > 1
				ifTrue:
					[connections
						at: fromNode
						at: edge target
						put: true]]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'simon.denier 4/30/2009 13:24'!
assignLabels: aGraph 
	"Initialize label dictionary"
	| label vertices parentLabels |
	labels := IdentityDictionary new.
	label := 1.	"Assign labels to the roots"
	(self rootNodesFor: aGraph nodes) do: 
		[ :node | 
		labels 
			at: node
			put: label.
		label := label + 1 ].	"Assign labels to the rest"
	[ labels keys size < aGraph nodes size ] whileTrue: 
		[ vertices := SortedCollection sortBlock: self sortBlock.
		aGraph nodes do: 
			[ :node | 
			(labels includesKey: node) ifFalse: 
				[ parentLabels := ((self parentsFor: node) collect: 
					[ :pn | 
					labels 
						at: pn
						ifAbsent: [ Float infinity ] ]) asSortedCollection.
				parentLabels last ~= Float infinity ifTrue: [ vertices add: node -> parentLabels ] ] ].
		labels 
			at: vertices first key
			put: label.
		label := label + 1 ]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'simon.denier 4/30/2009 13:26'!
buildLayers: g
	
	| w layerNr u vertices vertex layer done |
	w := Float infinity.
	u := OrderedCollection new.
	layers := IdentityDictionary new.
	layerNrs := IdentityDictionary new.	"Assign all nodes to layers"
	[g isEmpty]
		whileFalse:
			[vertices := g
				select:
					[:e | (self childrenFor: e) allSatisfy: [:node | u includes: node]].
			vertex := vertices detectMax: [:e | labels at: e].
			done := false.
			layerNr := 1.
			[done]
				whileFalse:
					[layer := layers
						at: layerNr
						ifAbsentPut: [OrderedCollection new].
					(layer size >= w
						or:
							[(self childrenFor: vertex) anySatisfy: [:n | (layerNrs at: n) >= layerNr]])
						ifTrue: [layerNr := layerNr + 1]
						ifFalse: [done := true]].
			layer add: vertex.
			layerNrs at: vertex put: layerNr.
			u add: vertex.
			g remove: vertex]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
cl: layer u: u v: v
	"Calculates cuv. Di Battista, chapter 9.2.2, page 283"
	
	| partnersOfU partnersOfV c partnersOfUIndex partnersOfVIndex layerNr |
	layerNr := layerNrs at: u.	":= layerNrs at: v"
	partnersOfU := (connections at: u)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	partnersOfV := (connections at: v)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	c := 0.
	partnersOfUIndex := partnersOfU collect: [:node | layer indexOf: node].
	partnersOfVIndex := partnersOfV collect: [:node | layer indexOf: node].
	partnersOfUIndex
		do:
			[:uIndex | partnersOfVIndex do: [:vIndex | vIndex < uIndex ifTrue: [c := c + 1]]].
	^c! !

!MOSugiyamaLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/6/2010 11:26'!
cleanUp
	"no idea what this #hints does
	There is no test in the VW version of Mondrian about hints
	
	self edges do: [:edge | edge hints clear]"! !

!MOSugiyamaLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doExecute: aFigure 
	"Coffman-Graham-Layering. Di Battista Book, page 275, chapter, 9.2.1"
	self assignLabels: aFigure.
	self buildLayers: aFigure nodes copy.
	self addDummyNodes.
	self reduceCrossing.
	self layoutAt: self verticalGap @ self horizontalGap! !

!MOSugiyamaLayout methodsFor: 'private' stamp: 'Alexandre Bergel 7/26/2010 14:59'!
layoutAt: aPoint
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition layerHeight |
	treeWidth := layers values
		inject: Float infinity negated
		into:
			[:max :e | max max: (e sum: #width) + ((e size - 1) * self horizontalGap)].
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection reverse.
	layerKeys
		do:
			[:aKey | 
			layer := layers at: aKey.
			layerWidth := (layer sum: #width)
				+ ((layer size - 1) * self horizontalGap).
			layerHeight := (layer detectMax: #height) height.
			horizontalPosition := treeWidth / 2.0 + aPoint x - (layerWidth / 2.0).
			layer
				do:
					[:node | 
					node translateTo: horizontalPosition @ verticalPosition.
					horizontalPosition := horizontalPosition + node width
						+ self horizontalGap].
			verticalPosition := verticalPosition + layerHeight + self verticalGap]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
reduceCrossing
	"Crossing reduction"
	
	| layer2 u v c1 c2 layer1 done |
	2
		to: layers keys size
		do:
			[:index | 
			layer1 := layers at: index - 1.
			layer2 := layers at: index.
			done := false.
			[done]
				whileFalse:
					[done := true.
					2
						to: layer2 size
						do:
							[:i | 
							u := layer2 at: i - 1.
							v := layer2 at: i.
							c1 := self cl: layer1 u: u v: v.
							c2 := self cl: layer1 u: v v: u.
							c1 > c2
								ifTrue:
									[layer2 swapElement: u withElement: v.
									done := false]]]]! !

!MOSugiyamaLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
sortBlock
	
	sortBlock isNil ifTrue: [sortBlock := self class sortBlock].
	^sortBlock! !

MOAbstractGraphLayout subclass: #MOTreeMapLayout
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOTreeMapLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'Alexandre.Bergel 4/10/2009 20:43'!
bringToFront: aFigure 
	aFigure owner isNil 
		ifTrue: 
			[ | index |
			index := graph nodes indexOf: aFigure.
			index 
				to: graph nodes size - 1
				do: 
					[ :i | 
					graph nodes 
						at: i
						put: (graph nodes at: i + 1) ].
			graph nodes 
				at: graph nodes size
				put: aFigure ]
		ifFalse: [ aFigure owner bringToFront: aFigure ]! !

!MOTreeMapLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
cleanUp
	
	self showEdges! !

!MOTreeMapLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
deepCountChildrenFor: aNode
	
	| children |
	children := 0.
	(self childrenFor: aNode)
		do:
			[:child | children := children + 1 + (self deepCountChildrenFor: child)].
	^children! !

!MOTreeMapLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:08'!
doExecute: aGraph 
	| offset |
	graph := aGraph.
	self hideEdges.
	offset := self horizontalGap.
	(self rootNodesFor: aGraph nodes) do: 
		[ :aRoot | 
		self 
			verticalLayout: aRoot
			at: offset @ 5
			width: aRoot width
			height: aRoot height.
		offset := offset + aRoot width + self horizontalGap ]! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'tg 4/24/2008 16:08'!
hideEdges
	graph edges do: [ :edge | edge visible: false ]! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'Alexandre.Bergel 4/10/2009 20:47'!
horizontalLayout: node at: aPosition width: width height: aHeight
	
	| numberOfChildren position |
	node translateTo: aPosition.
"	node width: width.
	node height: aHeight.
	self bringToFront: node.
"
	node copyShapeAndDo: [:shape | shape width: width; height: aHeight].
	
	numberOfChildren := self deepCountChildrenFor: node.
	position := aPosition.
	(self childrenFor: node)
		do:
			[:child | 
			| height |
			height := (1 + (self deepCountChildrenFor: child)) * aHeight /
					numberOfChildren.
			self verticalLayout: child at: position width: width height: height.
			position := position + (0 @ height)]! !

!MOTreeMapLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	super initialize.
	horizontalGap := 10! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'tg 4/24/2008 16:08'!
showEdges
	graph edges do: [ :edge | edge visible: true ]! !

!MOTreeMapLayout methodsFor: 'private' stamp: 'AlexandreBergel 9/6/2010 11:25'!
verticalLayout: node at: aPosition width: aWidth height: height
	
	| numberOfChildren position |
	node translateTo: aPosition.
	node copyShapeAndDo: [:shape | shape width: aWidth; height: height].
	
	numberOfChildren := self deepCountChildrenFor: node.
	position := aPosition.
	(self childrenFor: node)
		do:
			[:child | 
			| width |
			width := (1 + (self deepCountChildrenFor: child)) * aWidth /
					numberOfChildren.
			self horizontalLayout: child at: position width: width height: height.
			position := position + (width @ 0)]! !

MOLayout subclass: #MOAbstractLineLayout
	instanceVariableNames: 'gapSize horizontalGap verticalGap horizontalOutGap verticalOutGap alignment horizontallyStretchable verticallyStretchable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOAbstractLineLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withGap: anInteger
	
	^(self new)
		gapSize: anInteger;
		yourself! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignBottom
	
	alignment := #bottom! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignCenter
	
	alignment := #center! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignLeft
	
	alignment := #left! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignRight
	
	alignment := #right! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignTop
	
	alignment := #top! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
alignment
	
	^alignment! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 10:50'!
alignment: anObject
	
	alignment := anObject! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre.Bergel 8/30/2009 11:17'!
center
	self alignment: #center! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
deltaFor: aNodeFigure
	
	^self subclassResponsibility! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 8/30/2009 10:46'!
doCenter: aGraph
	self subclassResponsibility ! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 2/28/2010 21:47'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	aGraph nodes do: 
		[ :aNodeFigure | 
		delta := self deltaFor: aNodeFigure.
		aNodeFigure translateTo: pointer - delta.
		self 
			movePointer: pointer
			accordingToFigure: aNodeFigure ].	

	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/1/2010 17:57'!
doStretchHorizontal: aGraph 
	"this method is executed after translating nodes"
	
 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds width ].

	((parentBounds width >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds width: (parentBounds width - (2 * horizontalOutGap)).
						(node layout isLineLayout and: [ node layout horizontallyStretchable ])
							ifTrue: [ node layout doStretchHorizontal: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds width: max ] ]
	 
! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/1/2010 17:57'!
doStretchVertical: aGraph 
	"this method is executed after translating nodes"

 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds height ].

	((parentBounds height >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds height: (parentBounds height - (2 * verticalOutGap) ).
						(node layout isLineLayout and: [ node layout verticallyStretchable])
							ifTrue: [ node layout doStretchVertical: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds height: max ] ]! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize
	
	^gapSize! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 14:17'!
gapSize: aNumber
	gapSize := aNumber. " This value is never used actually "
	
	verticalGap := 2 * aNumber.
	horizontalGap := 2 * aNumber.
	verticalOutGap := aNumber.
	horizontalOutGap := aNumber! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalGap
	
	^horizontalGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalGap: anObject
	
	horizontalGap := anObject! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalOutGap
	
	^horizontalOutGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
horizontalOutGap: anObject
	
	horizontalOutGap := anObject! !

!MOAbstractLineLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 2/23/2010 18:58'!
horizontallyStretchable
	^ horizontallyStretchable! !

!MOAbstractLineLayout methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 1/6/2010 17:01'!
initialize
	
	super initialize.
	verticalGap := 10.
	horizontalGap := 10.
	horizontalOutGap := 5.
	verticalOutGap := 5.
	horizontallyStretchable := verticallyStretchable := false! !

!MOAbstractLineLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 3/1/2010 17:55'!
isLineLayout
	^ true! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
movePointer: pointer accordingToFigure: aNodeFigure
	
	self subclassResponsibility! !

!MOAbstractLineLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
positionOriginalPointer: aGraph
	
	^self subclassResponsibility! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 1/6/2010 17:01'!
stretch
	horizontallyStretchable := verticallyStretchable := true! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 1/6/2010 17:15'!
stretchHorizontally
	horizontallyStretchable := true! !

!MOAbstractLineLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 1/6/2010 17:15'!
stretchVertically
	verticallyStretchable := true! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalGap
	
	^verticalGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalGap: anObject
	
	verticalGap := anObject! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalOutGap
	
	^verticalOutGap! !

!MOAbstractLineLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
verticalOutGap: anObject
	
	verticalOutGap := anObject! !

!MOAbstractLineLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 2/23/2010 18:58'!
verticallyStretchable
	^ verticallyStretchable! !

MOAbstractLineLayout subclass: #MOHorizontalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOHorizontalLineLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 11:32'!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #bottom ifTrue: [delta := aNodeFigure height].
	self alignment == #center ifTrue: [delta := aNodeFigure height / 2.0].
	^0 @ delta! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 4/24/2009 18:34'!
doCenter: aGraph 

 	| midTallest step |
	midTallest := 0.
	midTallest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds height )].
	midTallest := midTallest / 2.
	aGraph nodes do: [ :node | 
		step := 0@ (midTallest - (node bounds height /2)) asInteger.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 1/7/2010 08:12'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	aGraph nodes do: 
		[ :aNodeFigure | 
		delta := self deltaFor: aNodeFigure.
		aNodeFigure translateTo: pointer - delta.
		self 
			movePointer: pointer
			accordingToFigure: aNodeFigure ].	

	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/6/2010 18:31'!
doStretchHorizontal: aGraph 

 	| parentBounds addedWidth parentBoundsWidth runningIndex newWidth origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedWidth := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el width ].

	parentBoundsWidth := parentBounds width.
	parentBoundsWidth := parentBoundsWidth - (aGraph nodes size - 1 * horizontalGap) - (2 * horizontalOutGap).
	
	runningIndex := horizontalOutGap.
	((parentBounds width > addedWidth) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newWidth := (node width * parentBoundsWidth / addedWidth) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (runningIndex @ origin y) ;
								width: newWidth.
						runningIndex := runningIndex + newWidth + horizontalGap ] ]
! !

!MOHorizontalLineLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	super initialize.
	self alignTop! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'tg 4/24/2008 16:06'!
movePointer: pointer accordingToFigure: aNodeFigure
	
	^pointer moX: pointer x + aNodeFigure bounds width + self horizontalGap! !

!MOHorizontalLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 2/23/2010 19:39'!
positionOriginalPointer: aGraph 
	| maxHeight delta |
	delta := 0.
	self alignment == #bottom ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight ].
	self alignment == #center ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight / 2.0 ].
	^ self horizontalOutGap @ (self verticalOutGap + delta)! !

MOAbstractLineLayout subclass: #MOVerticalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOVerticalLineLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 11:28'!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #right ifTrue: [delta := aNodeFigure width].
	self alignment == #center ifTrue: [delta := aNodeFigure width / 2.0].
	^delta @ 0! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 4/24/2009 18:35'!
doCenter: aGraph 

 	| midWidest step |
	midWidest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds width )].
	midWidest := midWidest / 2.
	aGraph nodes do: [ :node | 
		step := (midWidest - (node bounds width /2)) asInteger @ 0.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 2/23/2010 21:41'!
doStretchVertical: aGraph 

 	| parentBounds addedHeight parentBoundsHeight runningIndex newHeight origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedHeight := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el height ].

	parentBoundsHeight := parentBounds height.
	parentBoundsHeight := parentBoundsHeight - (aGraph nodes size - 1 * verticalGap) - (2 * verticalOutGap).
	
	runningIndex := verticalOutGap.
	((parentBounds height > addedHeight) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newHeight := (node height * parentBoundsHeight / addedHeight) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (origin x @ runningIndex) ;
								height: newHeight.
						runningIndex := runningIndex + newHeight + verticalGap ] ]
! !

!MOVerticalLineLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	super initialize.
	self alignLeft! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 10:24'!
movePointer: pointer accordingToFigure: aNodeFigure
	
	^pointer setX: pointer x setY: pointer y + aNodeFigure height + self verticalGap! !

!MOVerticalLineLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 11:27'!
positionOriginalPointer: aGraph 
	| maxWidth delta |
	delta := 0.
	self alignment == #right ifTrue: 
		[ maxWidth := aGraph nodes maxValue: #width.
		delta := maxWidth ].
	self alignment == #center ifTrue: 
		[ maxWidth := aGraph nodes maxValue: #width.
		delta := maxWidth / 2.0 ].
	^ (self horizontalOutGap + delta) @ self verticalOutGap! !

MOVerticalLineLayout subclass: #MOVerticalLineWithTimelineLayout
	instanceVariableNames: 'timeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOVerticalLineWithTimelineLayout methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/18/2010 21:33'!
doExecute: aGraph 
	super doExecute: aGraph .
	

	aGraph nodes do: [ :aNodeFigure | aNodeFigure translateTo: (timeBlock value: aNodeFigure model) @ (aNodeFigure bounds origin y ) ]! !

!MOVerticalLineWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:16'!
timeBlock
	^ timeBlock! !

!MOVerticalLineWithTimelineLayout methodsFor: 'accessing' stamp: 'MirceaLungu 8/18/2010 21:16'!
timeBlock: anObject
	timeBlock := anObject! !

MOLayout subclass: #MOCircleLayout
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOCircleLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOCircleLayout class methodsFor: 'instance creation' stamp: 'Alexandre Bergel 12/17/2009 00:00'!
scaleBy: aNumber
	
	^self new scaleBy: aNumber! !

!MOCircleLayout methodsFor: 'hook' stamp: 'AlexandreBergel 2/17/2009 17:11'!
doExecute: aGraph
	
	| angleTemp angle rad center |
	(self affectedNodesOf: aGraph) isEmpty ifTrue: [^self].
	rad := (self affectedNodesOf: aGraph) size * self scaleFactor.
	center := Point x: rad y: rad.
	angleTemp := 2 * Float pi / (self affectedNodesOf: aGraph) size.
	angle := 0.
	(self affectedNodesOf: aGraph)
		do:
			[:each | 
			| point |
			point := center + (Point r: rad theta: angle).
			angle := angle + angleTemp.
			each translateTo: point]! !

!MOCircleLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self scaleBy: 11! !

!MOCircleLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
scaleBy: aNumber
	
	factor := aNumber! !

!MOCircleLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
scaleFactor
	
	^factor! !

MOLayout subclass: #MOFillInFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOFillInFlowLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOFillInFlowLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 1/26/2010 21:30'!
doExecute: aGraph 
	| x y maxLastLineHeight |
	x := 5.
	y := 5.
	maxLastLineHeight := 0.
	aGraph nodes do: 
		[ :aNodeFigure | 
		aNodeFigure translateTo: x @ y.
		x := x + aNodeFigure width + 10.
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > aGraph width ifTrue: 
			[ x := 5.
			y := y + 10 + maxLastLineHeight.
			maxLastLineHeight := 0 ] ]! !

MOLayout subclass: #MOForceBasedLayout
	instanceVariableNames: 'iterations repellingForce attractingForce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOForceBasedLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOForceBasedLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:47'!
attractingForce: aBlock
	"Attracting force between edges."
	
	attractingForce := aBlock! !

!MOForceBasedLayout methodsFor: 'private' stamp: 'tg 10/5/2008 23:33'!
attractingForceFor: aFigure
	
	^attractingForce moValue: aFigure! !

!MOForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/5/2010 09:34'!
doExecute: aFigure
	| nodes nodeCenterA nodeCenterB deltaX deltaY distance xForces yForces xForce yForce force random edgesIndices nodeCenter nodeRadius nodeRadiusA nodeRadiusB nodeOrigin minX minY delta radial |
	"Start by placing the nodes at random"
	radial := MORadialTreeLayout new.
	radial fromPositions: self fromPositions.
	radial toPositions: self toPositions.
	radial executeOnNode: aFigure.
	self initializeConnectionPositions: aFigure.	"Init variables"
	random := Random new.	"Create array with the node center and radius. Like this we don't need to move the actual nodes"
	nodes := aFigure nodes asArray.
	nodeCenter := Array new: nodes size.
	nodeRadius := Array new: nodes size.
	1 to: nodes size do: [ :index | 
		nodeCenter at: index put: (nodes at: index) center.
		nodeRadius at: index put: (nodes at: index) radius ].	"Create array with the indices of the edge nodes"
	edgesIndices := Array new: self edges size.
	1 to: self edges size do: [ :index | 
		| edge |
		edge := self edges at: index.
		edgesIndices at: index put: (Array with: (nodes indexOf: edge source) with: (nodes indexOf: edge target)) ].
	1 to: (self iterationsFor: aFigure) do: [ :iteration | 
		xForces := (Array new: nodes size) atAllPut: 0.
		yForces := (Array new: nodes size) atAllPut: 0.	"Node forces"
		1 to: nodes size do: [ :i | 
			i + 1 to: nodes size do: [ :j | 
				nodeCenterA := nodeCenter at: i.
				nodeCenterB := nodeCenter at: j.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance < 100
					ifTrue: [ 
						nodeRadiusA := nodeRadius at: i.
						nodeRadiusB := nodeRadius at: j.
						force := (self repellingForceFor: aFigure) * nodeRadiusA * nodeRadiusB / distance / distance.
						xForce := force * deltaX / distance.
						yForce := force * deltaY / distance.
						xForces at: i put: (xForces at: i) - xForce.
						yForces at: i put: (yForces at: i) - yForce.
						xForces at: j put: (xForces at: j) + xForce.
						yForces at: j put: (yForces at: j) + yForce ] ] ].	"Edge forces"
		edgesIndices
			do: [ :indices | 
				nodeCenterA := nodeCenter at: indices first.
				nodeCenterB := nodeCenter at: indices last.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance := distance min: 15.
				force := (self attractingForceFor: aFigure) * distance.
				xForce := force * deltaX / distance.
				yForce := force * deltaY / distance.
				xForces at: indices first put: (xForces at: indices first) + xForce.
				yForces at: indices first put: (yForces at: indices first) + yForce.
				xForces at: indices last put: (xForces at: indices last) - xForce.
				yForces at: indices last put: (yForces at: indices last) - yForce ].	"Move centers"
		1 to: nodes size do: [ :index | 
			deltaX := xForces at: index.
			deltaY := yForces at: index.
			deltaX := deltaX min: 30.
			deltaX := deltaX max: -30.
			deltaY := deltaY min: 30.
			deltaY := deltaY max: -30.
			nodeCenter at: index put: ((nodeCenter at: index) translatedBy: deltaX @ deltaY) ] ].	"Node origins"
	nodeOrigin := Array new: nodes size.
	minX := 10000000.	"minX := Unlimited positive."
	minY := 10000000.	"minY := Unlimited positive."
	1 to: nodes size do: [ :index | 
		| origin node |
		node := nodes at: index.
		origin := (nodeCenter at: index) - ((node width / 2.0) @ (node height / 2.0)).
		nodeOrigin at: index put: origin.
		minX := minX min: origin x.
		minY := minY min: origin y ].	"Move nodes"
	minX := -1 * minX.
	minY := -1 * minY.
	delta := minX @ minY + (5 @ 5).
	1 to: nodes size do: [ :index | (nodes at: index) translateTo: (nodeOrigin at: index) + delta ]! !

!MOForceBasedLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 2/2/2009 15:47'!
initialize
	
	super initialize.
	iterations := 300.
	repellingForce := 10.
	attractingForce := 0.02! !

!MOForceBasedLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:47'!
iterations: aBlock
	
	iterations := aBlock! !

!MOForceBasedLayout methodsFor: 'private' stamp: 'tg 10/5/2008 23:33'!
iterationsFor: aFigure
	
	^iterations moValue: aFigure! !

!MOForceBasedLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:48'!
repellingForce: aBlock
	"Repelling force between nodes."
	
	repellingForce := aBlock! !

!MOForceBasedLayout methodsFor: 'private' stamp: 'tg 10/5/2008 23:33'!
repellingForceFor: aFigure
	
	^repellingForce moValue: aFigure! !

MOLayout subclass: #MOFormsLayout
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOFormsLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOFormsLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
on: aBuilder
	
	^(self new)
		builder: aBuilder;
		yourself! !

!MOFormsLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
builder
	
	^builder! !

!MOFormsLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
builder: aBuilder
	
	builder := aBuilder! !

!MOFormsLayout methodsFor: 'private - utils' stamp: ' 24/4/08 15:59'!
builderAt: aX and: aY
	"Utility method that makes other methods easier to read."
	
	^self builder at: aX and: aY! !

!MOFormsLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
doExecute: aFigure
	
	| myWidths myHeights |
	"Calculate the grid"
	myWidths := self builder widthsFor: aFigure.
	myHeights := self builder heightsFor: aFigure.	"Position and resize the components"
	self builder runWithWidths: myWidths heights: myHeights.	"Move the figures to the calculated positions"
	self builder figures do: [:figure | figure install]! !

MOLayout subclass: #MOGridLayout
	instanceVariableNames: 'gapSize lineItemsCountBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOGridLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOGridLayout class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 4/4/2009 13:24'!
new
	
	^self withGap: 5! !

!MOGridLayout class methodsFor: 'instance creation' stamp: 'tg 4/24/2008 16:08'!
withGap: anInteger 
	^ self 
		withGap: anInteger
		withLineItemsCount: 
			[ :graph | 
			| height width |
			(graph nodes size < 3 
				ifTrue: [ (graph nodes size max: 1) @ 1 ]
				ifFalse: 
					[ height := (graph nodes size * 0.618034) sqrt ceiling truncated.
					width := (graph nodes size / height) ceiling truncated.
					width @ height ]) x ]! !

!MOGridLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withGap: anInteger withLineItemsCount: aBlock
	
	^(super new)
		gapSize: anInteger;
		lineItemsCount: aBlock;
		yourself! !

!MOGridLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withLineItemsCount: aBlock
	
	^(super new)
		gapSize: 2;
		lineItemsCount: aBlock;
		yourself! !

!MOGridLayout methodsFor: 'hook' stamp: 'tg 4/25/2008 10:19'!
doExecute: aGraph 
	| pointer lineItemCount lineItemSize maxLastLineHeight |
	pointer := self gapSize @ self gapSize.
	lineItemSize := self lineItemsCountBlock value: aGraph.
	lineItemCount := 0.
	maxLastLineHeight := 0.
	aGraph nodes do: 
		[ :aNodeFigure | 
		aNodeFigure translateTo: pointer.
		pointer := (pointer x + aNodeFigure width + (self gapSize * 2)) @ pointer y.
		lineItemCount := lineItemCount + 1.
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		lineItemCount >= lineItemSize ifTrue: 
			[ pointer := self gapSize @ (pointer y + (self gapSize * 2) + maxLastLineHeight).
			maxLastLineHeight := 0.
			lineItemCount := 0 ] ]! !

!MOGridLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
gapSize
	
	^gapSize! !

!MOGridLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/10/2009 12:40'!
gapSize: anObject
	
	gapSize := anObject! !

!MOGridLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 2/10/2009 12:40'!
initialize
	
	super initialize.
	gapSize := 5! !

!MOGridLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/10/2009 12:41'!
lineItemsCount: aBlock
	
	lineItemsCountBlock := aBlock! !

!MOGridLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/10/2009 12:41'!
lineItemsCountBlock
	
	^ lineItemsCountBlock! !

!MOLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
forNodes: aCollection
	
	^self new affectedNodes: aCollection! !

!MOLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:13'!
isAbstract
	^ true! !

!MOLayout class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withEdges: aCollection
	
	^self new initialize userDefinedEdges: aCollection! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
affectedNodes
	
	^affectedNodes! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
affectedNodes: anObject
	
	affectedNodes := anObject! !

!MOLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:39'!
affectedNodesOf:  aNode 
	^ affectedNodes ifNil: [ aNode nodes ]! !

!MOLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/7/2010 13:43'!
applyOn: aNode
	
	self executeOnNode: aNode! !

!MOLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
cleanUp
	"Put any clean up code in to this method"
	
	! !

!MOLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + (2 * deltaY)! !

!MOLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + (2 * deltaX)! !

!MOLayout methodsFor: 'default values' stamp: 'Alexandre Bergel 2/17/2010 20:45'!
defaultFromPositions
	^ #()
	"^#(#rightCenter #bottomCenter)"! !

!MOLayout methodsFor: 'default values' stamp: 'Alexandre Bergel 2/17/2010 20:45'!
defaultToPositions
	^ #()
	"^#(#topCenter #leftCenter)"! !

!MOLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
doExecute: aFigure
	
	self subclassResponsibility! !

!MOLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/21/2010 12:50'!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doExecute: anElementNode! !

!MOLayout methodsFor: 'hook' stamp: ' 24/4/08 15:59'!
doInitialize: aGraph
	
	! !

!MOLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 1/23/2010 12:58'!
doPostOnGraph: aGraph
	"Hook method"
! !

!MOLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
edges
	
	^edges! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
edges: aCollection
	
	edges := aCollection! !

!MOLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:40'!
executeOnGraph: aGraphElement 
	self deprecated: 'Use executeOnNode: instead'.
	self executeOnNode: aGraphElement! !

!MOLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:40'!
executeOnNode: aGraphElement 
	self initializeConnectionPositions: aGraphElement.
"	self registerAdjustor: aFigure."
	self userDefinedEdges isNil 
		ifTrue: [ self edges: aGraphElement edges copy ]
		ifFalse: 
			[ | flat |
			flat := OrderedCollection new.
			self userDefinedEdges do: 
				[ :each | 
				each value isCollection 
					ifTrue: [ flat addAll: each value ]
					ifFalse: [ flat add: each value ] ].
			self edges: flat ].
	self doInitialize: aGraphElement.
	self doExecute: aGraphElement! !

!MOLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
fromPositions
	
	^fromPositions ifNil: [fromPositions := self defaultFromPositions]! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
fromPositions: anArray
	
	fromPositions := anArray! !

!MOLayout methodsFor: 'initialize-release' stamp: ' 24/4/08 15:59'!
initialize
	
	edges := nil! !

!MOLayout methodsFor: 'private' stamp: 'Alexandre.Bergel 6/6/2009 13:02'!
initializeConnectionPositions: aGraph 
	aGraph edges do: 
		[ :aFigure | 
		aFigure setIfNilFromPositions: self fromPositions.
		aFigure setIfNilToPositions: self toPositions ]! !

!MOLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 3/1/2010 17:55'!
isLineLayout
	^ false! !

!MOLayout methodsFor: 'private' stamp: 'tg 9/20/2009 19:44'!
toPositions
	
	^toPositions ifNil: [toPositions := self defaultToPositions]! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
toPositions: anArray
	
	toPositions := anArray! !

!MOLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
userDefinedEdges
	
	^userDefinedEdges! !

!MOLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 3/29/2009 03:19'!
userDefinedEdges: aCollection
	
	userDefinedEdges := aCollection! !

MOLayout subclass: #MOLocalSpringLayout
	instanceVariableNames: 'treeRoots nodesToLayoutsOrders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOLocalSpringLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOLocalSpringLayout methodsFor: 'hook' stamp: 'RomainRobbes 4/6/2010 14:59'!
doExecute: aGraphElement
	| springLayout domainNodes mass nodes index |
	springLayout := MOSpringLayout new.
	treeRoots ifNotNil: [
		springLayout affectedNodes: (aGraphElement nodeForDomainValues: treeRoots).
		springLayout doExecute: nil.
	].


	nodesToLayoutsOrders ifNotNil: [
		nodesToLayoutsOrders do: [ :massAndNodes |
			domainNodes := massAndNodes second.
			mass := massAndNodes first.
			nodes := aGraphElement nodeForDomainValues: domainNodes.
			" nodes := nodes reject: [:n | n hasAttribute: #fixed ]."
			index := 1@2.
			nodes do: [:n | 
				n incomingEdges ifNotEmpty: [
					n translateTo: (n incomingEdges first source position + index ).
					index := index + (1@2) ] 
								ifEmpty: [n translateTo: 1000 @ 1000]].
			
			springLayout affectedNodes: nodes.
			springLayout mass: mass.
			springLayout doExecute: nil.
			nodes do: [:n | n attributeAt: #fixed put: nil ] ].
		
	]! !

!MOLocalSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 4/2/2010 19:56'!
doIncrementalStep: aGraphElement
	| springLayout |
	springLayout := MOSpringLayout new.
	treeRoots ifNotNil: [
		springLayout affectedNodes: (aGraphElement nodeForDomainValues: treeRoots).
		springLayout doIncrementalStep: nil.
	].


	nodesToLayoutsOrders ifNotNil: [
		nodesToLayoutsOrders do: [ :massAndNodes |
			springLayout affectedNodes: (aGraphElement nodeForDomainValues: massAndNodes second).
			springLayout mass: massAndNodes first.
			springLayout doIncrementalStep: nil ].
		
	]! !

!MOLocalSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 4/2/2010 20:06'!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doIncrementalStep: anElementNode! !

!MOLocalSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 4/2/2010 19:21'!
doInitialize: aGraphElement
	| springLayout |
	springLayout := MOSpringLayout new.
	treeRoots ifNotNil: [
		springLayout affectedNodes: (aGraphElement nodeForDomainValues: treeRoots).
		springLayout doInitialize: nil.
	].

	nodesToLayoutsOrders ifNotNil: [
		nodesToLayoutsOrders do: [:massAndNodes |
			springLayout affectedNodes: (aGraphElement nodeForDomainValues: massAndNodes second).
			springLayout mass: massAndNodes first.
			springLayout doInitialize: nil ].
		
	]! !

!MOLocalSpringLayout methodsFor: 'initialization' stamp: 'jannik.laval 6/2/2010 10:30'!
initialize
	super initialize.
	nodesToLayoutsOrders := OrderedCollection new! !

!MOLocalSpringLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 4/2/2010 19:26'!
layout: values

	self layout: values mass: 1500! !

!MOLocalSpringLayout methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 4/2/2010 19:28'!
layout: values mass: mass
	nodesToLayoutsOrders ifNil: [ nodesToLayoutsOrders := OrderedCollection new ].
	nodesToLayoutsOrders add: {mass . values}! !

!MOLocalSpringLayout methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/6/2010 14:22'!
layout: values root: r mass: mass
	| nodes |
	nodes := values, {r}.
	nodesToLayoutsOrders ifNil: [ nodesToLayoutsOrders := OrderedCollection new ].
	nodesToLayoutsOrders add: {mass . nodes}! !

!MOLocalSpringLayout methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/6/2010 15:07'!
theScript: view
	| classes packages ls |
view shape rectangle fillColor: Color green.
view node: #root.
packages := {PackageInfo named: 'Bogus' . PackageInfo named: 'Announcements'}.  "PackageInfo named: 'Gofer'. PackageInfo named: 'SUnit' }."
packages do: [:pak |
	view shape rectangle fillColor: Color red. 
	view node: pak. 
	view edge: #root -> pak from: #key to: #value.
	
	classes := pak classes.
	view shape rectangle fillColor: Color blue; size: #numberOfMethods.
	view nodes: classes.

	view edges: (classes collect: [:c | c -> pak]) from: #key to: #value.

	classes do: [:cls | | t |
		t := cls methods collect: #methodReference.
		view interaction action: #inspect.
		view shape ellipse size: [:mr | mr compiledMethod linesOfCode].
		view nodes: t.
		view edges: (t collect: [:cm | cls -> cm ]) from: #key to: #value.] ].

ls := view localSpringLayout.
ls
	layout: packages, {#root} mass: 4000.
packages do: [:e |
	ls layout: (e classes), {e}  mass: 1500.
	].

packages do: [:e |
	e classes do: [:c |
		ls layout: (c methods collect: #methodReference), {c} mass: 1000.]].! !

!MOLocalSpringLayout methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 4/2/2010 18:26'!
treeRoot: aValue
	treeRoots ifNil: [ treeRoots := OrderedCollection new ].
	treeRoots add: aValue! !

MOLocalSpringLayout subclass: #MORootedSprintLayout
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MORootedSprintLayout methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/6/2010 14:34'!
doInitialize: aGraphElement
	| springLayout runningPosition|
	springLayout := MOSpringLayout new.
	nodesToLayoutsOrders ifNotNil: [
		nodesToLayoutsOrders do: [:massAndNodes |
			springLayout affectedNodes: (aGraphElement nodeForDomainValues: massAndNodes second).
			springLayout mass: massAndNodes first.
			"instead of the doInitialize of springLayout"
			runningPosition := (aGraphElement nodeForDomainValue: root) position.
			massAndNodes second do: [:n | | node |
			node := aGraphElement nodeForDomainValue: n.
			node attributeAt: #velocity put: 0@0.
		
			"make sure no 2 nodes are in exactly the same position"
			node translateTo: runningPosition.
			runningPosition := runningPosition + (10@12)		
				].
		
	]]! !

!MORootedSprintLayout methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/6/2010 14:32'!
layout: values root: r mass: mass
	| nodes |
	nodes := {r}, values.
	root := r.
	nodesToLayoutsOrders ifNil: [ nodesToLayoutsOrders := OrderedCollection new ].
	nodesToLayoutsOrders add: {mass . nodes}! !

MOLayout subclass: #MOMinimumGridLayout
	instanceVariableNames: 'horizontalMode gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOMinimumGridLayout class methodsFor: 'hooks' stamp: 'JeanRemyFalleri 6/10/2010 13:27'!
isAbstract 
	^ false! !

!MOMinimumGridLayout class methodsFor: 'instance creation' stamp: 'JeanRemyFalleri 6/10/2010 13:27'!
new
	
	^self withGap: 5! !

!MOMinimumGridLayout class methodsFor: 'instance creation' stamp: 'JeanRemyFalleri 6/10/2010 15:15'!
withGap: anInteger 

	^(super new) gapSize: anInteger ; yourself.! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'simon.denier 7/7/2010 11:08'!
beHorizontal

	horizontalMode := true! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'simon.denier 7/7/2010 11:08'!
beVertical

	horizontalMode := false! !

!MOMinimumGridLayout methodsFor: 'hook' stamp: 'simon.denier 7/7/2010 11:09'!
doExecute: aGraph 

	horizontalMode
		ifTrue: [ self doHorizontalLayout: aGraph ]
		ifFalse: [ self doVerticalLayout: aGraph ]! !

!MOMinimumGridLayout methodsFor: 'hook' stamp: 'simondenier 8/20/2010 20:55'!
doHorizontalLayout: aGraph 
	| pointer sortedNodes newColumn columnMaxHeight columnMaxWidth |
	
	sortedNodes := aGraph nodes sorted: [ :a :b | 
		(a height > b height) or: 
		[ (a height = b height) & (a width >= b width) ] ].
	
	pointer := 0 @ 0.
	
	columnMaxWidth := 0.
	columnMaxHeight := (sortedNodes at: 1) height.
	
	newColumn := true.
	
	[ sortedNodes isEmpty ] whileFalse: [ | h next |
		newColumn ifTrue: [
			pointer := (pointer x + columnMaxWidth + (self gapSize * 2)) @ self gapSize.
			columnMaxWidth := sortedNodes first width.
			h := columnMaxHeight.
			newColumn := false.
		].
	
		next := self nextFit: sortedNodes toHeight: h andWidth: columnMaxWidth.
		
		next isNil
			ifTrue:  [
				newColumn := true ]
			ifFalse: [
				next translateTo: pointer.
				pointer := pointer x @ (pointer y + next height + (2 * self gapSize)).
				h := h - next height ]
	].! !

!MOMinimumGridLayout methodsFor: 'hook' stamp: 'simondenier 8/20/2010 20:59'!
doVerticalLayout: aGraph 
	| pointer sortedNodes newRow columnMaxHeight columnMaxWidth |
	
	sortedNodes := aGraph nodes sorted: [ :a :b | 
		(a width > b width) or:
		[ (a width = b width) & (a height >= b height) ]].
	
	pointer := 0 @ 0.
	
	columnMaxWidth := (sortedNodes at: 1) width..
	columnMaxHeight := 0.
	
	newRow := true.
	
	[ sortedNodes isEmpty ] whileFalse: [ | w next |
		newRow ifTrue: [
			pointer := self gapSize @ (pointer y + columnMaxHeight + (self gapSize * 2)).
			columnMaxHeight := sortedNodes first height.
			w := columnMaxWidth .
			newRow := false ].
	
		next := self nextFit: sortedNodes toHeight: columnMaxHeight andWidth: w.
		
		next isNil
			ifTrue:  [
				newRow := true ]
			ifFalse: [
				next translateTo: pointer.
				pointer := (pointer x + next width + (2 * self gapSize)) @ pointer y.
				w := w - next width ]
	].! !

!MOMinimumGridLayout methodsFor: 'as yet unclassified' stamp: 'JeanRemyFalleri 6/10/2010 17:02'!
fit: aNode inWidth: aWidth andHeight: aHeight

	^( aNode width <= aWidth) & (aNode height <= aHeight ).
	 ! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'JeanRemyFalleri 6/10/2010 13:27'!
gapSize
	
	^gapSize! !

!MOMinimumGridLayout methodsFor: 'accessing' stamp: 'JeanRemyFalleri 6/10/2010 13:27'!
gapSize: anObject
	
	gapSize := anObject! !

!MOMinimumGridLayout methodsFor: 'initialize-release' stamp: 'simon.denier 7/7/2010 11:07'!
initialize
	
	super initialize.
	horizontalMode := true.
	gapSize := 5! !

!MOMinimumGridLayout methodsFor: 'as yet unclassified' stamp: 'JeanRemyFalleri 6/10/2010 16:41'!
nextFit: aNodeList toHeight: aHeight andWidth: aWidth
	
	1 to: aNodeList size do: [ :index |
		| node |
		node := aNodeList at: index.
		( self fit: node inWidth: aWidth   andHeight: aHeight  ) ifTrue: [
			^aNodeList removeAt: index.
		].
	].
	^nil.

	! !

!MOMinimumGridLayout methodsFor: 'as yet unclassified' stamp: 'JeanRemyFalleri 6/10/2010 15:37'!
surface: aNode

	^aNode height * aNode width! !

MOLayout subclass: #MOScatterplotLayout
	instanceVariableNames: 'horizontalPadding verticalPadding xBlock yBlock xOffset yOffset upSideDown scaleFactorX scaleFactorY scaledToWidth scaledToHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOScatterplotLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOScatterplotLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + deltaY + self yOutGap! !

!MOScatterplotLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + deltaX + self xOutGap! !

!MOScatterplotLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/6/2010 18:43'!
doExecute: aGraphElement

	| maxWidth maxHeight nodesToLayout x y origin newX newY |
	maxWidth := 0.
	maxHeight := 0.
	nodesToLayout := affectedNodes ifNil: [ aGraphElement nodes ] ifNotNil: [ :arg | affectedNodes ].
	nodesToLayout
		do: [ :node | 
			x := (xBlock value: node model) * scaleFactorX.
			y := (yBlock value: node model) * scaleFactorY.
			maxWidth := maxWidth max: x.
			maxHeight := maxHeight max: y.	"x = #centered ifTrue: [ x := 0 ]."
			x := x + xOffset.
			y := upSideDown
				ifTrue: [ y - yOffset ]
				ifFalse: [ y + yOffset ].
			node translateTo: x @ y ].	"We scale them to the width and height"
	aGraphElement
		nodesDo: [ :node | 
			origin := node bounds origin.
			newX := origin x.
			newY := origin y.
			scaledToWidth ifNotNil: [ :arg | newX := (origin x / maxWidth * scaledToWidth) asInteger ].
			scaledToHeight ifNotNil: [ :arg | newY := (origin y / maxHeight * scaledToHeight) asInteger ].
			node translateTo: newX @ newY ].
	scaledToHeight ifNotNil: [ :arg | maxHeight := scaledToHeight ].
	upSideDown
		ifFalse: [ ^ self ].	"We need to inverse the plots"
	nodesToLayout
		do: [ :node | 
			y := node bounds origin y.
			node translateBy: 0 @ (maxHeight - (2 * y)) ]! !

!MOScatterplotLayout methodsFor: 'hook' stamp: 'Alexandre.Bergel 4/29/2009 15:56'!
doPostOnGraph: aFigure 
	^ super doPostOnGraph: aFigure.
	

	"Position the centered nodes"
"	| x y |
	aFigure nodes do: 
		[ :node | 
		x := node preferredX.
		y := node preferredY.
		x = #centered ifTrue: 
			[ x := aFigure childArea width / 2.0 - (node width / 2.0).
			x := x + node xOffset.
			node translateTo: x @ y ] ]"! !

!MOScatterplotLayout methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 10/14/2009 17:56'!
initialize
	super initialize.

	horizontalPadding := 5.
	verticalPadding := 5.
	xOffset := 0.
	yOffset := 0.
	scaleFactorX := 1.
	scaleFactorY := 1.
	upSideDown := false.
	xBlock := yBlock := [:aNode | aNode ]! !

!MOScatterplotLayout methodsFor: 'as yet unclassified' stamp: 'JeanRemyFalleri 7/13/2010 14:51'!
offset: anInt

	xOffset := anInt.
	yOffset := anInt.! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:57'!
outGap
	
	^ self xOutGap @ self yOutGap! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
outGap: anObject
	
	self xOutGap: anObject.
	self yOutGap: anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 10/14/2009 17:56'!
scaleFactor: aValue
	scaleFactorX := aValue.
	scaleFactorY := aValue! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 10/14/2009 17:57'!
scaleFactorX: aValue
	scaleFactorX := aValue.! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 10/14/2009 17:57'!
scaleFactorY: aValue
	scaleFactorY := aValue.! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:11'!
scaledToHeight
	^ scaledToHeight! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:11'!
scaledToHeight: anObject
	scaledToHeight := anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:12'!
scaledToWidth
	^ scaledToWidth! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:12'!
scaledToWidth: anObject
	scaledToWidth := anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/29/2009 15:46'!
upSideDown
	upSideDown := upSideDown not! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/29/2009 15:34'!
x: aBlock
	xBlock := aBlock! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
xOutGap
	
	^horizontalPadding! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
xOutGap: anObject
	
	horizontalPadding := anObject! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/29/2009 15:35'!
y: aBlock
	yBlock := aBlock! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
yOutGap
	
	^verticalPadding! !

!MOScatterplotLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
yOutGap: anObject
	
	verticalPadding := anObject! !

MOLayout subclass: #MOSpringLayout
	instanceVariableNames: 'maxSecondsToCompute mass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOSpringLayout commentStamp: 'Alexandre Bergel 3/15/2010 12:58' prior: 0!
Based on the algorithm described on http://en.wikipedia.org/wiki/Force-based_algorithms!

!MOSpringLayout class methodsFor: 'hooks' stamp: 'Alexandre Bergel 4/5/2010 19:19'!
isAbstract 
	^ false! !

!MOSpringLayout methodsFor: 'physic' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
coulombRepulsion: node and: otherNode
	"mass of node times mass of other Nodes, divided by their squared distance"
	| d v |
	v := node position - otherNode position.
	d := v r.
	d = 0.0 ifTrue: [ ^ v * 15 / (1) ].
	^ v * self mass / (d  * d * d)
	"^ 15 / (d * d)"! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 3/15/2010 14:46'!
damping
	^ 0.5! !

!MOSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/31/2010 18:51'!
doExecute: aGraphElement
	| firstTotalKineticEnergy totalKineticEnergy initialTime |
	firstTotalKineticEnergy := self doIncrementalStep: aGraphElement.
	
	initialTime := Time now asSeconds.
	UIManager default
		displayProgress: 'Layouting'
		at: Sensor cursorPoint
		from: self lowThresholdEnergy 
		to: (firstTotalKineticEnergy r asInteger)
		during: [ :bar | [ totalKineticEnergy := self doIncrementalStep: aGraphElement.
								((Time now asSeconds - initialTime) > self maxSecondsToCompute)
									ifTrue: [ ^ self ].
								bar value: (firstTotalKineticEnergy - totalKineticEnergy) r ] 
								doWhileTrue:  [ (totalKineticEnergy r >= self lowThresholdEnergy) or:
														[ (Time now asSeconds - initialTime) > self maxSecondsToCompute] ]].


! !

!MOSpringLayout methodsFor: 'hook' stamp: 'AlexandreBergel 9/16/2010 01:43'!
doIncrementalStep: aGraphElement
	"Return the total energy "

	| totalKineticEnergy netForce velocity nodesToLayout |
	totalKineticEnergy := 0 @ 0.
	nodesToLayout := affectedNodes ifNil: [ aGraphElement nodes ] ifNotNil: [ affectedNodes ].
	
	nodesToLayout do: [ :node |
		"running sum of total force on this particular node"
		netForce := 0@0.
		nodesToLayout do: [ :otherNode |
			(node ~~ otherNode)
				ifTrue: [ netForce := netForce + (self coulombRepulsion: node and: otherNode) ] ].

		node incomingAndOutgoingEdgesDo: [ :edge |
			(nodesToLayout includesAll: { edge source . edge target}) 
				ifTrue: 
					[ netForce := netForce + (self hookeAttractionFor: node and: edge).]].
				
		velocity := ((node attributeAt: #velocity ifAbsentPut: [0]) +  netForce) * self damping.
		node attributeAt: #velocity put: velocity.
		(((node position + velocity) x > 0) and: [(node position + velocity) y > 0])
			ifTrue: [  (node isSelected and: [ (node hasAttribute: #fixed) not ]) ifFalse: [ node translateBy: velocity  ]].

		"We may need to multiply by the node mass"
		totalKineticEnergy := totalKineticEnergy +  (velocity * velocity). 
	].

	^ totalKineticEnergy! !

!MOSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/21/2010 12:53'!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doIncrementalStep: anElementNode! !

!MOSpringLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 4/2/2010 18:38'!
doInitialize: aGraphElement
	
	| runningPosition nodesToLayout |
	runningPosition := 20@20.
	nodesToLayout := affectedNodes ifNil: [ aGraphElement nodes ] ifNotNil: [ affectedNodes ].
	nodesToLayout do: [ :node | 
		node attributeAt: #velocity put: 0@0.
		
		"make sure no 2 nodes are in exactly the same position"
		node translateTo: runningPosition.
		runningPosition := runningPosition + (10@12) ].
	! !

!MOSpringLayout methodsFor: 'physic' stamp: 'Alexandre Bergel 3/15/2010 18:11'!
hookeAttractionFor: node and: edge
	| f r v vector |
	r := edge length.
	r = 0.0 ifTrue: [ ^ 1@1 ].
	f := 30.
	vector := (edge target position - edge source position) / r.
	v := vector * r  / f.
	^ edge source == node
		ifTrue: [ v ]
		ifFalse: [ v negated ]
! !

!MOSpringLayout methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
initialize
	super initialize.
	maxSecondsToCompute := 10.
	mass := 1500! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 4/2/2010 09:26'!
lowThresholdEnergy
	^ 2! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
mass
	^ mass! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 4/2/2010 18:42'!
mass: aValue
	mass := aValue! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'Alexandre Bergel 3/31/2010 18:52'!
maxSecondsToCompute
	^ maxSecondsToCompute! !

!MOSpringLayout methodsFor: 'configuration' stamp: 'AlexandreBergel 9/16/2010 01:54'!
maxSecondsToCompute: v
	maxSecondsToCompute := v! !

Object subclass: #MOMatrixRenderer
	instanceVariableNames: 'rows columns cellFunction cellSize cellPadding cellShape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
cellFunction
	^ cellFunction! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
cellFunction: anObject
	cellFunction := anObject! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'Alexandre Bergel 3/2/2010 14:12'!
cellNodeIn: aViewRenderer row: rowElem column: colElem

	| cellObj n |
	cellObj := self cellFunction valueWithArguments: {rowElem. colElem}.
	^ cellObj
		ifNil: [
			aViewRenderer node: #nil using: self enclosingShape ]
		ifNotNil: [
			n := aViewRenderer node: #cell using: (self enclosingShape) forIt: [
				aViewRenderer shape: self cellShape.
				aViewRenderer node: cellObj.
			aViewRenderer layout: (MOHorizontalLineLayout new gapSize: (self cellPadding // 2)).
			n ]]! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 16:18'!
cellPadding
	^ cellPadding! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 16:18'!
cellPadding: anObject
	cellPadding := anObject! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 16:20'!
cellShape
	^ cellShape size: cellSize! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 15:12'!
cellShape: anObject
	cellShape := anObject! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 14:06'!
cellSize
	^ cellSize! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 14:06'!
cellSize: anObject
	cellSize := anObject! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
columns
	^ columns! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
columns: anObject
	columns := anObject! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'simon.denier 11/4/2009 16:19'!
enclosingShape
	^ MOFixedRectangleShape new
			borderColor: Color lightGray;
			size: cellSize + cellPadding! !

!MOMatrixRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 3/2/2010 14:14'!
initialize 

	super initialize.
	cellSize := 20.
	cellPadding := 10.
	cellFunction := [:rowEl :colEl | {rowEl. colEl}].
	cellShape := MOFixedRectangleShape new borderColor: Color white; fillColor: Color black.! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'simon.denier 11/4/2009 13:56'!
render

	| view |
	view := MOViewRenderer new.
	self renderOn: view.
	view open! !

!MOMatrixRenderer methodsFor: 'drawing' stamp: 'simon.denier 11/4/2009 15:56'!
renderOn: aViewRenderer 
	| builder x y |
	builder := MOFormsBuilder new.
	self rows size + 1 timesRepeat: [ builder row; pref ].
	self columns size + 1 timesRepeat: [ builder column; pref ].

	aViewRenderer shape: (self enclosingShape text: [ :el | el asString ]).
	builder x: 1 	y: 1 add: (aViewRenderer node: #matrix using: self enclosingShape).
	
	x := 1. y := 1.
	columns do: 
		[ :colElem | 
		x := x + 1.
		aViewRenderer shape: (self enclosingShape text: [ :el | el asString ]).
		builder 
			x: x
			y: y
			add: (aViewRenderer node: colElem) ].

	x := 1. y := 1.
	rows do: 
		[ :rowElem | 
		y := y + 1.
		aViewRenderer shape: (self enclosingShape text: [ :el | el asString ]).
		builder 
			x: x
			y: y
			add: (aViewRenderer node: rowElem) ].
	
	y := 1.
	rows do: 
		[ :rowElem | 
		y := y + 1.
		x := 1. 
		columns do: 
			[ :colElem | 
			x := x + 1.
			builder 
				x: x
				y: y
				add: (self cellNodeIn: aViewRenderer row: rowElem column: colElem) ]].
	aViewRenderer layout: builder asLayout.
! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
rows
	^ rows! !

!MOMatrixRenderer methodsFor: 'accessing' stamp: 'simon.denier 11/4/2009 13:57'!
rows: anObject
	rows := anObject! !

!MOMatrixRenderer methodsFor: 'initialize-release' stamp: 'simon.denier 11/4/2009 16:48'!
sampleDeadlock
	"
	self new sampleDeadlock
	"
	
	| acq |
	self cellSize: 40.
	self cellPadding: 20.
	self cellShape fillColor: [:cell ||lock|
			lock := cell second.
			(#(lock2 lock3) includes: lock)
				ifTrue: [Color red]
				ifFalse: [Color black]].
	self columns: #(lock1 lock2 lock3 lock4).
	self rows: #(thread1 thread2 thread3 thread4 thread5).
	acq := #(	(thread1 lock1)
				(thread2 lock1)
				(thread3 lock2) (thread3 lock3)
				(thread4 lock2) (thread4 lock3)
				(thread5 lock2) (thread5 lock4)).
	self cellFunction: [:row :col | |tuples|
		tuples := (acq select: [:tuple| tuple first = row]).
		tuples detect: [:tup| tup second = col]	ifNone: [nil] ].
	self render! !

Object subclass: #MONAbstractNormalizer
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

MONAbstractNormalizer subclass: #MOMultipleColorLinearNormalizer
	instanceVariableNames: 'normalizers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

!MOMultipleColorLinearNormalizer class methodsFor: 'instance creation' stamp: 'simon_denier 9/24/2009 16:10'!
valueRange: anArrayOfNumbers colorRange: anArrayOfColors

	^ self new valueRange: anArrayOfNumbers colorRange: anArrayOfColors! !

!MOMultipleColorLinearNormalizer methodsFor: 'private-accessing' stamp: 'simon_denier 9/24/2009 16:08'!
detectNormalizerFor: aValue

	normalizers keysAndValuesDo: [:range :norm |
		(range rangeIncludes: aValue)
			ifTrue: [^ norm] ].
	self error: aValue asString, ' not in declared ranges'! !

!MOMultipleColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'simon_denier 9/24/2009 17:48'!
initialize

	command := #yourself! !

!MOMultipleColorLinearNormalizer methodsFor: 'accessing' stamp: 'simon_denier 9/24/2009 16:09'!
moValue: anEntity

	| value |
	value := self command value: anEntity.
	"detect range for the value, retrieve and call corresponding normalizers"
	^ (self detectNormalizerFor: value) moValue: value! !

!MOMultipleColorLinearNormalizer methodsFor: 'initialize-release' stamp: 'simon_denier 9/24/2009 16:09'!
valueRange: anArrayOfNumbers colorRange: anArrayOfColors
	" {1. 2. 3} {Color red. Color yellow. Color green}"
	
	| size start end |
	normalizers := SmallDictionary new.
	self assert: anArrayOfNumbers size = anArrayOfColors size.
	size := anArrayOfNumbers size.
	1 to: size - 1 do: [:i|
		start := anArrayOfNumbers at: i.
		end :=  anArrayOfNumbers at: i + 1.
		normalizers
			at: (start to: end)
			put: (MONColorLinearNormalizer
						inContext: {start. end}
						lowColor: (anArrayOfColors at: i)
						highColor: (anArrayOfColors at: i + 1))
	].
! !

!MONAbstractNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
new
	"Answer a newly created and initialized instance."
	
	^super new initialize! !

!MONAbstractNormalizer methodsFor: 'accessing' stamp: 'simon_denier 9/24/2009 17:47'!
command
	
	^command! !

!MONAbstractNormalizer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 13:44'!
command: aBlock
	
	command := aBlock! !

!MONAbstractNormalizer methodsFor: 'accessing' stamp: 'tg 10/5/2008 23:35'!
moValue: anEntity
	
	self subclassResponsibility! !

MONAbstractNormalizer subclass: #MONIdentityNormalizer
	instanceVariableNames: 'dictionary colorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

MONIdentityNormalizer subclass: #MONExplicitIdentityNormalizer
	instanceVariableNames: 'colors defaultColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

!MONExplicitIdentityNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
withCommand: aBlock withColors: aCollection withDefaultColor: aColor
	
	^(self withCommand: aBlock)
		colors: aCollection;
		defaultColor: aColor;
		yourself! !

!MONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
colors
	
	^colors! !

!MONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
colors: anObject
	
	colors := anObject! !

!MONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
defaultColor
	
	^defaultColor! !

!MONExplicitIdentityNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
defaultColor: anObject
	
	defaultColor := anObject! !

!MONExplicitIdentityNormalizer methodsFor: 'private' stamp: ' 5/10/08 23:16'!
nextColor
	
	colorIndex := colorIndex + 1.
	^colorIndex > self colors size
		ifTrue: [self defaultColor asColor]
		ifFalse: [(self colors at: colorIndex) asColor]! !

!MONIdentityNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
withCommand: aBlock
	
	^(self new)
		command: aBlock;
		yourself! !

!MONIdentityNormalizer methodsFor: 'initialize-release' stamp: ' 5/10/08 23:16'!
initialize
	
	super initialize.
	colorIndex := 0.
	dictionary := IdentityDictionary new.
	command := #yourself! !

!MONIdentityNormalizer methodsFor: 'accessing' stamp: 'tg 10/5/2008 23:35'!
moValue: anEntity
	
	^dictionary
		at: (command moValue: anEntity)
		ifAbsentPut: [self nextColor]! !

!MONIdentityNormalizer methodsFor: 'private' stamp: 'Alexandre.Bergel 2/22/2009 20:37'!
nextColor
	
	colorIndex := colorIndex \\ Color colorNames size + 1.
	^Color perform: (Color colorNames at: colorIndex)! !

MONAbstractNormalizer subclass: #MONLinearNormalizer
	instanceVariableNames: 'maximumValue context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

MONLinearNormalizer subclass: #MONColorLinearNormalizer
	instanceVariableNames: 'minBrightness maxBrightness lowColor highColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

!MONColorLinearNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
inContext: aCollection lowColor: lowColor highColor: highColor
	
	| normalizer |
	normalizer := self inContext: aCollection.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	^normalizer! !

!MONColorLinearNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
inContext: aCollection lowColor: lowColor lowThreshold: lowThreshold highColor: highColor highThreshold: highThreshold
	
	| normalizer |
	normalizer := self inContext: aCollection.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	normalizer minBrightness: lowThreshold.
	normalizer maxBrightness: highThreshold.
	^normalizer! !

!MONColorLinearNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
inContext: aCollection withCommand: aBlock lowColor: lowColor highColor: highColor
	
	| normalizer |
	normalizer := self inContext: aCollection withCommand: aBlock.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	^normalizer! !

!MONColorLinearNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
inContext: aCollection withCommand: aBlock lowColor: lowColor lowThreshold: lowThreshold highColor: highColor highThreshold: highThreshold
	
	| normalizer |
	normalizer := self inContext: aCollection withCommand: aBlock.
	normalizer lowColor: lowColor.
	normalizer highColor: highColor.
	normalizer minBrightness: lowThreshold.
	normalizer maxBrightness: highThreshold.
	^normalizer! !

!MONColorLinearNormalizer methodsFor: 'private' stamp: 'tg 10/5/2008 23:51'!
blend: aColor with: aColorValue weight: wt
	"Answer a new ColorValue which is a weighted blend of the receiver and the
	supplied ColorValue."
	"Simply interpolates in RGB space."

	| rv gv bv invWt |
	
	invWt := 1-wt.
	rv := ((aColor red * invWt) + ((aColorValue red)*wt)) "rounded".
	gv := ((aColor green  * invWt) + ((aColorValue green)*wt)) "rounded".
	bv := ((aColor blue *invWt)+ ((aColorValue blue)*wt)) "rounded".
	^Color r: rv g: gv b: bv! !

!MONColorLinearNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
highColor: aBlock
	
	highColor := aBlock! !

!MONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'tg 10/5/2008 23:32'!
highColorFor: anEntity
	
	^highColor moValue: anEntity! !

!MONColorLinearNormalizer methodsFor: 'initialize-release' stamp: ' 5/10/08 23:16'!
initialize
	
	super initialize.
	lowColor := Color white.
	highColor := Color black! !

!MONColorLinearNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
lowColor: aBlock
	
	lowColor := aBlock! !

!MONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'tg 10/5/2008 23:32'!
lowColorFor: anEntity
	
	^lowColor moValue: anEntity! !

!MONColorLinearNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
maxBrightness: aBlock
	
	maxBrightness := aBlock! !

!MONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'tg 10/5/2008 23:32'!
maxBrightnessFor: anEntity
	
	^maxBrightness isNil
		ifTrue: [1.0]
		ifFalse: [maxBrightness moValue: anEntity]! !

!MONColorLinearNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
minBrightness: aBlock
	
	minBrightness := aBlock! !

!MONColorLinearNormalizer methodsFor: 'translator protocol' stamp: 'tg 10/5/2008 23:32'!
minBrightnessFor: anEntity
	
	^minBrightness isNil
		ifTrue: [0.0]
		ifFalse: [minBrightness moValue: anEntity]! !

!MONColorLinearNormalizer methodsFor: 'accessing' stamp: 'tg 10/5/2008 23:38'!
moValue: anEntity
	"Calculates the color of the entity based on the context."
	
	| myValue myHighColor myLowColor myMinBrightness myMaxBrightness weight |
	"Get color specific data"
	myMinBrightness := self minBrightnessFor: anEntity.
	myMaxBrightness := self maxBrightnessFor: anEntity.
	myHighColor := self highColorFor: anEntity.
	myLowColor := self lowColorFor: anEntity.	"Get data"
	myValue := self command value: anEntity.
	weight := myMinBrightness
		+
			(myValue abs / (self maximumValue: anEntity)
				* (myMaxBrightness - myMinBrightness)).
	^self blend: myLowColor with: myHighColor weight: weight! !

MONLinearNormalizer subclass: #MONFontLinearNormalizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

!MONFontLinearNormalizer methodsFor: 'accessing' stamp: 'tg 4/26/2010 22:17'!
moValue: anEntity
	"Calculates the color of the entity based on the context."
	
	| value |
	value := self command moValue: anEntity.
	^5 + (38 * (value abs / (self maximumValue: anEntity))) asInteger! !

!MONLinearNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
inContext: aCollection
	
	^self inContext: aCollection withCommand: #yourself! !

!MONLinearNormalizer class methodsFor: 'instance creation' stamp: ' 5/10/08 23:16'!
inContext: aCollection withCommand: aBlock
	
	^(self new)
		context: aCollection;
		command: aBlock;
		yourself! !

!MONLinearNormalizer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/22/2009 17:19'!
command: aBlock
	
	super command: aBlock.
	self flushCache! !

!MONLinearNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
context
	
	^context! !

!MONLinearNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
context: aContext
	
	context := aContext.
	self flushCache! !

!MONLinearNormalizer methodsFor: 'accessing' stamp: ' 5/10/08 23:16'!
flushCache
	
	maximumValue := nil! !

!MONLinearNormalizer methodsFor: 'initialize-release' stamp: ' 5/10/08 23:16'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	maximumValue := nil! !

!MONLinearNormalizer methodsFor: 'private' stamp: 'tg 10/5/2008 23:33'!
maximumValue: anEntity
	"Returns the largest value that the color metric provides"
	
	maximumValue isNil
		ifTrue:
			[maximumValue := (self context moValue: anEntity)
				inject: 1
				into:
					[:maximum :entity | maximum max: (self command moValue: entity)]].
	^maximumValue! !

MONLinearNormalizer subclass: #MONumberLinearNormalizer
	instanceVariableNames: 'scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Normalizers'!

!MONumberLinearNormalizer methodsFor: 'initialization' stamp: 'Alexandre.Bergel 8/30/2009 13:53'!
initialize
	super initialize.
	scale := 1! !

!MONumberLinearNormalizer methodsFor: 'accessing' stamp: 'simon.denier 5/15/2009 00:35'!
moValue: anEntity
	"Normalize value based on maximum value."
	
	| value |
	value := self command moValue: anEntity.
	^ ((value abs / (self maximumValue: anEntity)) asFloat * self scale) asInteger! !

!MONumberLinearNormalizer methodsFor: 'accessing' stamp: 'simon.denier 5/15/2009 00:35'!
scale
	^ scale! !

!MONumberLinearNormalizer methodsFor: 'accessing' stamp: 'simon.denier 5/15/2009 00:35'!
scale: anObject
	scale := anObject! !

Object subclass: #MOPopup
	instanceVariableNames: ''
	classVariableNames: 'TooltipBalloon'
	poolDictionaries: ''
	category: 'Mondrian-Morphic'!

!MOPopup class methodsFor: 'instance creation' stamp: 'Alexandre Bergel 4/6/2010 09:14'!
remove
	TooltipBalloon ifNotNil: [ TooltipBalloon delete ].
	MOPopupViewCanvas allInstances do: [:canv| canv delete].! !

!MOPopup class methodsFor: 'instance creation' stamp: 'tg 4/1/2010 20:21'!
show: msgString

	self remove.
	TooltipBalloon := (UITheme builder newBalloonHelp: msgString for: World activeHand)
		popUpFor: (Morph new) hand:  World activeHand.

	^ TooltipBalloon
! !

!MOPopup class methodsFor: 'instance creation' stamp: 'Alexandre Bergel 4/1/2010 14:57'!
showView: view
	^ self showView: view zoomedInBy: 1! !

!MOPopup class methodsFor: 'instance creation' stamp: 'VeronicaUquillas 6/15/2010 18:25'!
showView: view zoomedInBy: aValue
	| morph mouseOrigin deltaX deltaY newMorphBounds |
	self remove.
	morph := MOCanvas on: view root.
	aValue ~= 1 
		ifTrue: [ view root increaseZoomBy: aValue ].
	morph openInWorld.
	mouseOrigin := ActiveHand bounds origin.
	deltaX := 10.
	deltaY := 0.
	(mouseOrigin x + morph bounds width > World bounds width)
		ifTrue: [ deltaX := deltaX negated -  morph bounds width ].
	(mouseOrigin y + morph bounds height > World bounds height)
		ifTrue: [ deltaY := deltaY -  morph bounds height ].

	newMorphBounds := (morph bounds origin translatedBy: mouseOrigin) extent: (morph bounds extent +(15@15)).
	newMorphBounds := newMorphBounds translateBy: (deltaX @ deltaY).
	
	newMorphBounds origin x < 0
	ifTrue:[ newMorphBounds:= newMorphBounds translateBy: (newMorphBounds origin x negated @ 0) ].
	newMorphBounds origin y < 0
	ifTrue:[ newMorphBounds:= newMorphBounds translateBy: (0 @ newMorphBounds origin y negated) ].
	
	morph bounds: newMorphBounds.
	TooltipBalloon := morph.
	^ morph! !

Object subclass: #MOPort
	instanceVariableNames: 'portName value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Interaction'!

!MOPort commentStamp: 'Alexandre Bergel 3/2/2010 21:13' prior: 0!
MOPort represents port. Any port has a name. !

!MOPort methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:23'!
name
	^ portName! !

!MOPort methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:23'!
name: anObject
	portName := anObject! !

!MOPort methodsFor: 'printing' stamp: 'Alexandre Bergel 3/2/2010 21:24'!
printOn: aStream 
	 
	aStream 
		nextPutAll: 'Port (name='; 
		nextPutAll: self name printString; 
		nextPutAll: ' value='; 
		nextPutAll: self value printString; 
		nextPut: $)! !

!MOPort methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:25'!
receive: aTransmission 
	self receive: aTransmission in: MOTransmissionContext new! !

!MOPort methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:11'!
receive: aTransmission in: aContext
	self value: aTransmission value in: aContext! !

!MOPort methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:11'!
value 
	 
	^value! !

!MOPort methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:24'!
value: anObject 
	self value: anObject in: MOTransmissionContext new! !

!MOPort methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:11'!
value: anObject in: aContext
	aContext addPort: self.
	value := anObject! !

Object subclass: #MOQuadTree
	instanceVariableNames: 'elements quadrants bounds count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Util'!

MOQuadTree class
	instanceVariableNames: 'minExtent maxCount'!

MOQuadTree class
	instanceVariableNames: 'minExtent maxCount'!

!MOQuadTree class methodsFor: 'class initialization' stamp: 'simon.denier 6/25/2009 20:26'!
initialize
	super initialize.
	maxCount := 8.
	minExtent := 10 @ 10! !

!MOQuadTree class methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 14:59'!
maxCount

	^ maxCount! !

!MOQuadTree class methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 16:20'!
maxCount: anInteger

	maxCount := anInteger! !

!MOQuadTree class methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 16:38'!
minExtent
	^ minExtent! !

!MOQuadTree class methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 20:26'!
minExtent: aPoint 
	minExtent := aPoint! !

!MOQuadTree class methodsFor: 'accessing' stamp: 'simon.denier 6/24/2009 22:56'!
with: aRectangle

	^ self new bounds: aRectangle! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/25/2009 16:18'!
addElement: aMOGraphElement 

	self incCount.
	self isComposite ifTrue: [
		(self selectQuadrantsIntersecting: aMOGraphElement bounds) do: [:q | q addElement: aMOGraphElement ]
	] ifFalse: [
		self shouldSplit ifTrue: [
			self splitAdd: aMOGraphElement
		] ifFalse: [
			elements add: aMOGraphElement
		]
	].
	^ aMOGraphElement! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:17'!
basicAdd: aMOGraphElement

	self incCount.
	^ elements add: aMOGraphElement! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:17'!
basicRemove: aMOGraphElement

	self decCount.
	^ elements remove: aMOGraphElement! !

!MOQuadTree methodsFor: 'initialization' stamp: 'simon.denier 6/24/2009 22:55'!
bounds: aRectangle

	bounds := aRectangle  ! !

!MOQuadTree methodsFor: 'geometry' stamp: 'simon.denier 6/24/2009 11:47'!
contains: aPoint

	^ bounds containsPoint: aPoint! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:16'!
count

	^ count
! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:17'!
decCount

	count := count - 1! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 21:23'!
detectQuadrantContaining: aPoint 
	^ quadrants detect: [ :q | q contains: aPoint ]! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 15:52'!
elements

	^ elements! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/24/2009 13:38'!
findElementsAt: aPoint
	
	^ self isComposite ifTrue: [
		(self detectQuadrantContaining: aPoint) findElementsAt: aPoint
	] ifFalse: [
		elements select: [:e | e bounds containsPoint: aPoint]
	]! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/25/2009 15:18'!
findElementsIntersecting: aRectangle

	^ self isComposite ifTrue: [
		(self selectQuadrantsIntersecting: aRectangle) flatCollectAsSet: [:q | q findElementsIntersecting: aRectangle ]
	] ifFalse: [
		elements select: [:e | e bounds intersects: aRectangle ]
	].
! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:17'!
incCount

	count := count + 1! !

!MOQuadTree methodsFor: 'initialization' stamp: 'simon.denier 6/25/2009 16:11'!
initialize

	elements := OrderedCollection new.
	count := 0.! !

!MOQuadTree methodsFor: 'geometry' stamp: 'simon.denier 6/24/2009 11:34'!
intersects: aRectangle

	^ bounds intersects: aRectangle ! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/24/2009 23:28'!
isComposite

	^ quadrants notNil! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 15:56'!
mergeQuadrants

	elements := quadrants flatCollectAsSet: [:q | q elements	].
	quadrants := nil.! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/25/2009 16:17'!
removeElement: aMOGraphElement
	"remove elements from quadrants, merge them if necessary"
	
	self decCount.
	self isComposite ifTrue: [
		(self selectQuadrantsIntersecting: aMOGraphElement bounds) do:
			[:q | q removeElement: aMOGraphElement ].
		self shouldMerge ifTrue: [
			self mergeQuadrants
		]
	] ifFalse: [
		elements remove: aMOGraphElement 
	].
	^ aMOGraphElement ! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/24/2009 13:27'!
selectQuadrantsIntersecting: aRectangle 
	^ quadrants select: [ :q | q intersects: aRectangle ]! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 15:09'!
shouldMerge

	^ self count <= self class maxCount! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 20:25'!
shouldSplit
	"Split a leaf Quadtree only if the quadtree has reached its maximum capacity
	and it is big enough to be split"
	^ self count > self class maxCount and: [ bounds extent > self class minExtent ]! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'Alexandre.Bergel 8/30/2009 15:59'!
splitAdd: aMOGraphElement

	| topleft topright bottomright bottomleft |
	"create the four quadrants"
	topleft := self class with: (bounds origin corner: bounds center).
	topright := self class with: (bounds topCenter corner: bounds rightCenter).
	bottomright := self class with: (bounds center corner: bounds corner).
	bottomleft := self class with: (bounds leftCenter corner: bounds bottomCenter).
	quadrants := {topleft. topright. bottomright. bottomleft}.
	
	"dispatch all elements in the four quadrants"
	elements do: [:e |
		"since each quadrant is fresh, we can safely add each element without testing for capacity"
		(self selectQuadrantsIntersecting: e bounds) do: [:q | q basicAdd: e]
	].
	elements := elements copyEmpty. "remove all elements"
	
	"we have now created a composite Quadtree, we can add the new element, 	eventually splitting quadrants if necessary."
	(self selectQuadrantsIntersecting: aMOGraphElement bounds) do: [:q | q addElement: aMOGraphElement ]! !

Object subclass: #MOShape
	instanceVariableNames: 'isCached'
	classVariableNames: 'DefaultLineShape DefaultNodeShape'
	poolDictionaries: ''
	category: 'Mondrian-Core'!

MOShape subclass: #MOLineShape
	instanceVariableNames: 'color width fromPositions toPositions isAliased'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOLineShape commentStamp: 'Alexandre.Bergel 8/30/2009 13:59' prior: 0!
Maybe fromPositions and toPositions are positioned to high in the hierarchy. 
Wondering whether these variables may be safely moved down into MOStraightLineShape

A MOLineShape is xxxxxxxxx.

Instance Variables
	color:		<Object>
	fromPositions:		<Object>
	toPositions:		<Object>
	width:		<Object>

color
	- xxxxx

fromPositions
	- xxxxx

toPositions
	- xxxxx

width
	- xxxxx
!

MOLineShape subclass: #MOBezierLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOBezierLineShape methodsFor: 'drawing' stamp: 'Alexandre Bergel 12/1/2009 12:16'!
display: anEdgeElement on: aCanvas

	| fromPoint toPoint t b |
	t := self getAttachPointsFor: anEdgeElement.
	fromPoint := t first.
	toPoint := t second.
			
	b := fromPoint rect: toPoint.
	aCanvas
		drawBezierShape: (Array
			with: b origin
			with: b leftCenter
			with: b center
			with: b center
			with: b rightCenter
			with: b corner)
		color: Color transparent
		borderWidth: (self widthFor: anEdgeElement) 
		borderColor: (self colorFor: anEdgeElement).
! !

MOLineShape subclass: #MOCurveFitterShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOCurveFitterShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/6/2010 18:40'!
display: anEdgeElement on: aCanvas
	| fromPoint toPoint t yUnit curve size newForm curveOrigin w |	
		
	t := self getAttachPointsFor: anEdgeElement.
	fromPoint := t first.
	toPoint := t second.
			
	"Check if the figure to be rendered is not too small. If this is the case, 
	then no need to draw"
	(fromPoint - toPoint) abs < (anEdgeElement threadholdSize @ anEdgeElement threadholdSize)
		ifTrue: [^ self ].

	curve := CurveFitter new.
	size := self widthFor: anEdgeElement.
	w := self widthFor: anEdgeElement.
	curve form: ((Form extent: w @ w depth: Display depth) fillWithColor: (self colorFor: anEdgeElement); yourself).
	
	"xUnit := ((toPoint - fromPoint) x / 4) asInteger."
	yUnit := ((toPoint - fromPoint) y / 3) asInteger. 

	curveOrigin := (Rectangle encompassing: {fromPoint . toPoint}) origin.
	curve firstPoint: fromPoint - curveOrigin.
	curve secondPoint: (0 @ yUnit) + fromPoint - curveOrigin.
	curve thirdPoint: toPoint - curveOrigin.
"
	curve firstPoint: 0@0.
	curve secondPoint: (0 @ yUnit).
	curve thirdPoint: toPoint - fromPoint.
"
	newForm := Form extent: ((toPoint - fromPoint) abs + (2@2)) depth: Display depth.
	curve displayOn: newForm.	
	aCanvas paintImage: newForm at: curveOrigin
! !

!MOCurveFitterShape methodsFor: 'public' stamp: 'AlexandreBergel 9/6/2010 18:40'!
lineSegmentsFor: anEdgeElement

	| yUnit toPoint fromPoint running path tmp t |
	t := self getAttachPointsFor: anEdgeElement.
	fromPoint := t first.
	toPoint := t second.

	yUnit := ((toPoint - fromPoint) y / 3) asInteger. 

	running := fromPoint.
	path := Array
				with: ((0 @ yUnit) + fromPoint)
				with: toPoint.
	^ path collect: [:p | tmp := LineSegment from: running to: p. running := p. tmp]
! !

!MOLineShape class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 3/29/2009 15:38'!
color: aColor
	^ self new color: aColor; yourself! !

!MOLineShape methodsFor: 'public' stamp: 'AlexandreBergel 8/29/2010 17:18'!
absoluteBoundsFor: edgeElement
	"Answer the bounds in absolute terms (relative to the entire Canvas, not just the parent)."
		
	^ edgeElement owner isNil 
			ifTrue: [ self boundsFor: edgeElement ] 
			ifFalse: [ (self boundsFor: edgeElement ) translateBy: edgeElement owner absoluteBounds origin ]! !

!MOLineShape methodsFor: 'public' stamp: 'Alexandre.Bergel 8/30/2009 13:15'!
apply: anElement bounds: aBounds
	self error: 'Not appropriate'! !

!MOLineShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
color
	^ color! !

!MOLineShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
color: anObject
	"The color of the line."

	color := anObject! !

!MOLineShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/17/2010 11:56'!
colorFor: anElement
	^ anElement 
		cachedNamed: #cachecolorFor:
		ifAbsentInitializeWith: [ self computeColorFor: anElement ]

! !

!MOLineShape methodsFor: 'public' stamp: 'tg 5/7/2010 21:40'!
computeAttachPointsFor: fromNode and: toNode
	| fromPoint toPoint b1 b2 |
	b1 := fromNode absoluteBounds.
	b2 := toNode absoluteBounds.
	((fromPositions isNil not and: [ toPositions isNil not ])
		and: [ fromPositions isEmpty not and: [ toPositions isEmpty not ] ])
		ifTrue:
			[ 
			fromPositions first == #center
				ifTrue: [ fromPoint := b1 center ].
			fromPositions first == #leftCenter
				ifTrue: [ fromPoint := b1 leftCenter ].
			fromPositions first == #rightCenter
				ifTrue: [ fromPoint := b1 rightCenter ].
			fromPositions first == #topRight
				ifTrue: [ fromPoint := b1 topRight ].
			fromPositions first == #bottomRight
				ifTrue: [ fromPoint := b1 bottomRight ].
			fromPositions first == #bottomCenter
				ifTrue: [ fromPoint := b1 bottomCenter ].
			fromPositions first == #topCenter
				ifTrue: [ fromPoint := b1 topCenter ].
			toPositions first == #center
				ifTrue: [ toPoint := b2 center ].
			toPositions first == #leftCenter
				ifTrue: [ toPoint := b2 leftCenter ].
			toPositions first == #rightCenter
				ifTrue: [ toPoint := b2 rightCenter ].
			toPositions first == #topRight
				ifTrue: [ toPoint := b2 topRight ].
			toPositions first == #bottomRight
				ifTrue: [ toPoint := b2 bottomRight ].
			toPositions first == #bottomCenter
				ifTrue: [ toPoint := b2 bottomCenter ].
			toPositions first == #topCenter
				ifTrue: [ toPoint := b2 topCenter ].
			^ {fromPoint.
			toPoint} ].
	fromPoint := nil.
	toPoint := nil.
	(b1 right < b2 left and: [ b1 top > b2 bottom ])
		ifTrue:
			[ fromPoint := b1 topCenter.
			toPoint := b2 bottomCenter ].
	(b1 right < b2 left and: [ b1 bottom <= b2 top ])
		ifTrue:
			[ fromPoint := b1 bottomCenter.
			toPoint := b2 topCenter ].
	(b2 right < b1 left and: [ b2 top > b1 bottom ])
		ifTrue:
			[ fromPoint := b2 topCenter.
			toPoint := b1 bottomCenter ].
	(b2 right < b1 left and: [ b2 bottom <= b1 top ])
		ifTrue:
			[ fromPoint := b1 topCenter.
			toPoint := b2 bottomCenter ].	"---"
	(b1 right <= b2 left and: [ b1 top between: b2 top and: b2 bottom ])
		ifTrue:
			[ fromPoint := b1 rightCenter.
			toPoint := b2 leftCenter ].
	(b2 right < b1 left and: [ b2 top > b1 top and: [ b2 top > b1 bottom ] ])
		ifTrue:
			[ fromPoint := b1 leftCenter.
			toPoint := b2 rightCenter ].
	(b1 left >= b2 right and: [ b2 top between: b1 top and: b1 bottom ])
		ifTrue:
			[ fromPoint := b1 leftCenter.
			toPoint := b2 rightCenter ].
	(b1 left > b2 right and: [ b1 top > b2 top and: [ b1 top < b2 bottom ] ])
		ifTrue:
			[ fromPoint := b1 leftCenter.
			toPoint := b2 rightCenter ].
	(b1 right < b2 left and: [ b1 top < b2 top and: [ b1 bottom > b2 top ] ])
		ifTrue:
			[ fromPoint := b1 rightCenter.
			toPoint := b2 leftCenter ].
	(b1 top >= b2 bottom and: [ b1 left between: b2 left and: b2 right ])
		ifTrue:
			[ fromPoint := b1 topCenter.
			toPoint := b2 bottomCenter ].
	(b1 top > b2 bottom and: [ b1 right > b2 left and: [ b1 right < b2 right ] ])
		ifTrue:
			[ fromPoint := b1 topCenter.
			toPoint := b2 bottomCenter ].
	fromPoint ifNil: [ fromPoint := b1 bottomCenter ].
	toPoint ifNil: [ toPoint := b2 topCenter ].
	^ {fromPoint.
	toPoint}! !

!MOLineShape methodsFor: 'public' stamp: 'Alexandre Bergel 8/9/2010 18:17'!
computeBoundsFor: anEdge
	| t |
	t := self getAttachPointsFor: anEdge.
	^ Rectangle encompassing: t

! !

!MOLineShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/10/2010 17:48'!
computeColorFor: anElement
	^ color moValue: anElement model! !

!MOLineShape methodsFor: 'public' stamp: 'Alexandre.Bergel 8/30/2009 13:18'!
computeExtentFor: anElement 
	^ (anElement source bounds bottomCenter corner:
		anElement target bounds topCenter) extent! !

!MOLineShape methodsFor: 'public' stamp: 'Alexandre Bergel 8/2/2010 09:22'!
computeWidthFor: anElement
	^ (width moValue: anElement model) asInteger! !

!MOLineShape methodsFor: 'testing' stamp: 'AlexandreBergel 9/6/2010 18:40'!
containsPoint: aPoint for: anElement
	self lineSegmentsFor: anElement  do:
		[:p1 :p2 |
		(aPoint onLineFrom: p1 to: p2 within: (3 max: (self widthFor: anElement)+1//2) asFloat)
				ifTrue: [^ true]].
	^ false! !

!MOLineShape methodsFor: 'configuration' stamp: 'Alexandre.Bergel 6/27/2009 11:16'!
defaultColor
	^ Color lightGray! !

!MOLineShape methodsFor: 'configuration' stamp: 'lr 2/3/2008 13:39'!
defaultWidth
	^ 1! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:14'!
fromPositions
	^ fromPositions! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:14'!
fromPositions: anObject
	fromPositions := anObject! !

!MOLineShape methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 7/17/2010 08:26'!
getAttachPointsFor: anEdge
	| fromPoint  toPoint t |
	(anEdge source isNotSelected
		and: [ anEdge target isNotSelected and: [ anEdge isCacheLoaded ] ])
			ifTrue: [ fromPoint := anEdge cacheFromPoint. toPoint := anEdge cacheToPoint]
			ifFalse: 
				[ t := self computeAttachPointsFor: anEdge source and: anEdge target.
				fromPoint := t first.
				toPoint := t second.
				anEdge cacheFromPoint: fromPoint.
				anEdge cacheToPoint: toPoint ].
	^ {fromPoint . toPoint}
! !

!MOLineShape methodsFor: 'accessing-computed' stamp: 'Alexandre.Bergel 8/30/2009 13:14'!
heightFor: anElement
	self error: 'Not appropriate'! !

!MOLineShape methodsFor: 'initialization' stamp: 'Alexandre.Bergel 5/14/2009 00:55'!
initialize
	super initialize.
	self color: self defaultColor.
	self width: self defaultWidth.
	self isAliased: false! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 5/14/2009 00:57'!
isAliased
	^ isAliased ! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 5/14/2009 00:56'!
isAliased: aBlock
	isAliased := aBlock! !

!MOLineShape methodsFor: 'public' stamp: 'Alexandre.Bergel 5/14/2009 01:27'!
isAliasedFor: anElement
	^ self isAliased moValue: anElement model! !

!MOLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 4/14/2010 08:58'!
isArrowed
	^ false! !

!MOLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 4/14/2010 08:47'!
isDashed
	^ false! !

!MOLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 10/15/2009 19:48'!
isLineShape
	^ true! !

!MOLineShape methodsFor: 'public' stamp: 'AlexandreBergel 9/6/2010 18:40'!
lineSegmentsFor: anEdgeElement
	"return instances of LineSegment that describes the segment of myself"
	"coordinate are relatives to the parent object (owner)"
	
	| attach |
	attach := self getAttachPointsFor: anEdgeElement.
	^ {LineSegment from: (attach first) to: (attach second)}

"	fromOrigin := anEdgeElement owner bounds.
	attach := self getAttachPointsFor: anEdgeElement.
	^ {LineSegment from: (attach first - fromOrigin topLeft) to: (attach second - fromOrigin topLeft)}"! !

!MOLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 12/1/2009 11:35'!
lineSegmentsFor: anElement  do: aTwoArgBlock
	(self lineSegmentsFor: anElement)
		do: [:seg | seg lineSegmentsDo: aTwoArgBlock ]! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 6/6/2009 13:13'!
setIfNilFromPositions: symbols
	self fromPositions ifNil: [ self fromPositions: symbols ]! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 6/6/2009 13:12'!
setIfNilToPositions: symbols
	self toPositions ifNil: [ self toPositions: symbols ]! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
toPositions
	^ toPositions! !

!MOLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
toPositions: anObject
	toPositions := anObject! !

!MOLineShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
width
	^ width! !

!MOLineShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
width: anObject
	"The width of the line."

	width := anObject! !

!MOLineShape methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/16/2010 01:44'!
widthFor: anElement
	^ self isCached 
		ifTrue: [ anElement attributeAt: #cachewidthFor: ifAbsentPut: [ self computeWidthFor: anElement ] ]
		ifFalse: [ self computeWidthFor: anElement ].

! !

MOLineShape subclass: #MOOrthoHorizontalLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

MOOrthoHorizontalLineShape subclass: #MOArrowedOrthoHorizontalLineShape
	instanceVariableNames: 'arrowSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOArrowedOrthoHorizontalLineShape methodsFor: 'initialization' stamp: 'Alexandre.Bergel 3/11/2009 11:07'!
arrowSize
	^ arrowSize! !

!MOArrowedOrthoHorizontalLineShape methodsFor: 'initialization' stamp: 'Alexandre.Bergel 4/12/2009 11:00'!
arrowSize: anInteger
	arrowSize := anInteger! !

!MOArrowedOrthoHorizontalLineShape methodsFor: 'drawing' stamp: 'Alexandre.Bergel 4/12/2009 10:54'!
display: aFigure on: aCanvas
	| arrowMiddle fromNode fromPoint toNode toPoint edgeBound midx w c arrowTop arrowBottom |
	"There is code duplication between this method and the display:on: in MOArrowedLineShape"
		
	w := self widthFor: aFigure.
	c := self colorFor: aFigure.

	fromNode := aFigure source.
	toNode := aFigure target.
	fromPoint := (fromNode bounds) rightCenter.
	toPoint := (toNode bounds) leftCenter.

"	u := self direction normal.
	arrowHead := fromPoint + (1.5@2.5).
	arrowBase := arrowHead - (self direction * self arrowSize).
	arrowMiddle := arrowHead - (0 @ (self direction y * (self arrowSize + 1))).	
	arrow := Array with: arrowHead with: arrowBase + (u * self arrowSize) with: arrowBase - (u * self arrowSize) with: arrowHead.
"
	arrowMiddle := fromPoint + (self arrowSize @0).
	arrowTop := arrowMiddle - (0 @ (self arrowSize)).
	arrowBottom := arrowMiddle + (0 @ (self arrowSize )).
	aCanvas line: fromPoint to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: fromPoint width: w color: c.
	
	"draw head of arrow"
"	aCanvas drawArrowHead: arrow fill: (self colorFor: aFigure) borderWidth: 1 borderColor: (self colorFor: aFigure).
"
	"draw line from element to middle of arrow head"
	edgeBound := arrowMiddle corner: toPoint.
	
	midx := (((edgeBound corner x - edgeBound origin x) / 2) + edgeBound origin x) asInteger.

	aCanvas line: arrowMiddle to: (midx @ edgeBound origin y) width: w color: c.
	aCanvas line: (midx @ edgeBound origin y) to: (midx @ edgeBound corner y) width: w color: c.
	aCanvas line: (midx @ edgeBound corner y) to: toPoint width: w color: c.


"	aCanvas 
		drawPath: (Array
			with: arrowMiddle
			with: midx @ edgeBound origin y 
			with: midx @ edgeBound corner y 
			with: toPoint)
		borderWidth: (self widthFor: aFigure) 
		borderColor: (self colorFor: aFigure).
""	aFigure display: aFigure on: aCanvas"! !

!MOArrowedOrthoHorizontalLineShape methodsFor: 'initialization' stamp: 'Alexandre.Bergel 4/12/2009 11:00'!
initialize
	super initialize.
	self arrowSize: 6.! !

!MOOrthoHorizontalLineShape methodsFor: 'drawing' stamp: 'Alexandre.Bergel 4/12/2009 10:54'!
display: aFigure on: aCanvas
	| edgeBound fromNode toNode fromPoint toPoint midx w c |
	
	fromNode := aFigure source.
	toNode := aFigure target.
	fromPoint := (fromNode bounds) rightCenter.
	toPoint := (toNode bounds) leftCenter.

	edgeBound := fromPoint corner: toPoint.
	
	midx := ((edgeBound corner x - edgeBound origin x) / 2) asInteger + edgeBound origin x.
	
	w := self widthFor: aFigure.
	c := self colorFor: aFigure.
	aCanvas line: fromPoint to: (midx @ edgeBound origin y) width: w color: c.
	aCanvas line: (midx @ edgeBound origin y) to: (midx @ edgeBound corner y) width: w color: c.
	aCanvas line: (midx @ edgeBound corner y) to: toPoint width: w color: c.

"	aCanvas 
		drawPath: (Array
			with: fromPoint
			with: midx @ edgeBound origin y
			with: midx @ edgeBound corner y
			with: toPoint)
		borderWidth: (self widthFor: aFigure) 
		borderColor: (self colorFor: aFigure).
"	
"	aFigure display: aFigure on: aCanvas"! !

MOLineShape subclass: #MOOrthoVerticalLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

MOOrthoVerticalLineShape subclass: #MOArrowedOrthoVerticalLineShape
	instanceVariableNames: 'arrowSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOArrowedOrthoVerticalLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 11:00'!
arrowSize
	^ arrowSize! !

!MOArrowedOrthoVerticalLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 11:00'!
arrowSize: anInteger
	arrowSize := anInteger! !

!MOArrowedOrthoVerticalLineShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/6/2010 18:40'!
display: edge on: aCanvas
	| t arrowMiddle fromPoint toPoint edgeBound w c arrowTop arrowBottom midy |
	"There is code duplication between this method and the display:on: in MOArrowedLineShape"

	w := self widthFor: edge.
	c := self colorFor: edge.

	t := self getAttachPointsFor: edge..
	fromPoint := t first.
	toPoint := t second.

	arrowMiddle := fromPoint + (0@self arrowSize).
	arrowTop := arrowMiddle - (self arrowSize@0).
	arrowBottom := arrowMiddle + (self arrowSize@0).
	aCanvas line: fromPoint to: arrowTop width: w color: c.
	aCanvas line: arrowTop to: arrowBottom width: w color: c.
	aCanvas line: arrowBottom to: fromPoint width: w color: c.
	
	"draw line from element to middle of arrow head"
	edgeBound := fromPoint corner: toPoint.
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.
	w := self widthFor: edge.
	c := self colorFor: edge.

	aCanvas line: arrowMiddle to: (edgeBound origin x @ midy) width: w color: c.
	aCanvas line: (edgeBound origin x @ midy) to: (edgeBound corner x @ midy) width: w color: c.
	aCanvas line: (edgeBound corner x @ midy) to: toPoint width: w color: c.
! !

!MOArrowedOrthoVerticalLineShape methodsFor: 'initialization' stamp: 'Alexandre.Bergel 4/12/2009 11:01'!
initialize
	super initialize.
	self arrowSize: 6.! !

!MOOrthoVerticalLineShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/6/2010 18:40'!
display: edge on: aCanvas
	| edgeBound toNode fromPoint toPoint midy w c t |

	t := self getAttachPointsFor: edge..
	fromPoint := t first.
	toPoint := t second.

	edgeBound := fromPoint corner: toPoint.
	
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.
	w := self widthFor: edge.
	c := self colorFor: edge.

	aCanvas line: fromPoint to: (edgeBound origin x @ midy) width: w color: c.
	aCanvas line: (edgeBound origin x @ midy) to: (edgeBound corner x @ midy) width: w color: c.
	aCanvas line: (edgeBound corner x @ midy) to: toPoint width: w color: c.
! !

!MOOrthoVerticalLineShape methodsFor: 'public' stamp: 'Alexandre Bergel 12/1/2009 11:47'!
lineSegmentsFor: anEdgeElement
	| running path tmp fromNode toNode fromPoint toPoint edgeBound midy |
	
	fromNode := anEdgeElement source.
	toNode := anEdgeElement target.
	fromPoint := (fromNode bounds) bottomCenter.
	toPoint := (toNode bounds) topCenter.

	edgeBound := fromPoint corner: toPoint.
	
	midy := ((edgeBound corner y - edgeBound origin y) / 2) asInteger + edgeBound origin y.

	running := fromPoint.
	path := Array
				with: (edgeBound origin x @ midy)
				with: (edgeBound corner x @ midy)
				with: toPoint.
	^ path collect: [:p | tmp := LineSegment from: running to: p. running := p. tmp]! !

MOLineShape subclass: #MOSplineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOSplineShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/6/2010 18:41'!
display: anElement on: aCanvas
	| fromPoint toPoint t spline xUnit yUnit w splineOrigin newForm encompassingRectangle |	
	t := self getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.
			
	"Check if the figure to be rendered is not too small. If this is the case, 
	then no need to draw"
	(fromPoint - toPoint) abs < (anElement threadholdSize @ anElement threadholdSize)
		ifTrue: [^ self ].

	spline := Spline new.
	w := self widthFor: anElement.
	spline form: ((Form extent: w @ w depth: Display depth) fillWithColor: (self colorFor: anElement); yourself).
	
	xUnit := ((toPoint - fromPoint) x / 4) asInteger.
	yUnit := ((toPoint - fromPoint) y / 3) asInteger. 

	encompassingRectangle := (Rectangle 
							encompassing: {	fromPoint . 
												toPoint }).
	encompassingRectangle := encompassingRectangle extendBy: (encompassingRectangle extent * 3).
	encompassingRectangle := encompassingRectangle translateBy: ( encompassingRectangle extent / 2) negated.
	
	splineOrigin := encompassingRectangle origin.



	spline add: fromPoint - splineOrigin. 
	spline add: (0 @ yUnit) + fromPoint - splineOrigin.
	spline add: ((4 * xUnit) @ ( 2 * yUnit)) + fromPoint - splineOrigin.
	spline add: toPoint - splineOrigin.
	
	spline computeCurve.
	spline isEmpty ifTrue: [ ^ self ].
	newForm := Form extent: (encompassingRectangle extent + (2@2)) depth: Display depth.
	spline displayOn: newForm.	
	aCanvas paintImage: newForm at: splineOrigin.
	
"for anti-aliasing"
"	aCanvas 
		drawPath: (Array
			with: (fromPoint)
			with: (toPoint))
		borderWidth: (self widthFor: aFigure) 
		borderColor: (self colorFor: aFigure).
"
"	next display: anElement on: aCanvas"! !

!MOSplineShape methodsFor: 'public' stamp: 'Alexandre Bergel 12/1/2009 12:28'!
lineSegmentsFor: anElement
	| t fromPoint toPoint xUnit yUnit running path tmp |
	
	t := self getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.

	xUnit := ((toPoint - fromPoint) x / 4) asInteger.
	yUnit := ((toPoint - fromPoint) y / 3) asInteger. 

	running := fromPoint.
	path := Array 
		with: (0 @ yUnit) + fromPoint 
		with: ((4 * xUnit) @ ( 2 * yUnit)) + fromPoint 
		with: toPoint .

	^ path collect: [ :p | tmp := LineSegment from: running to: p. running := p. tmp ]! !

MOLineShape subclass: #MOStraightLineShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

MOStraightLineShape subclass: #MOArrowedLineShape
	instanceVariableNames: 'arrowSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOArrowedLineShape class methodsFor: 'testing' stamp: 'AlexandreBergel 7/9/2010 16:11'!
isDefaultLineShape
	^ false! !

!MOArrowedLineShape methodsFor: 'accessing' stamp: 'dr 7/3/2007 11:25'!
arrowSize
	^arrowSize! !

!MOArrowedLineShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 10:59'!
arrowSize: anInteger
	arrowSize := anInteger! !

!MOArrowedLineShape methodsFor: 'drawing' stamp: 'Alexandre Bergel 4/14/2010 08:41'!
display: anElement on: aCanvas
	| fromPoint toPoint t u vector unit arrowLeft arrowRight arrowMiddle w c |	
		
	t := self getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.
			
	"Draw head"
	vector := toPoint - fromPoint.
	u := vector normal.
	unit := vector / vector r.
	arrowMiddle := toPoint - (unit * self arrowSize). 
	arrowLeft :=  arrowMiddle- (u * self arrowSize).
	arrowRight := arrowMiddle + (u * self arrowSize).

	w := self widthFor: anElement.
	c := self colorFor: anElement.
	aCanvas line: toPoint to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPoint width: w color: c.

	"draw line"
	aCanvas line: fromPoint to: arrowMiddle width: w color: c.
! !

!MOArrowedLineShape methodsFor: 'initialization' stamp: 'Alexandre.Bergel 4/12/2009 10:59'!
initialize
	super initialize.
	self arrowSize: 6.! !

!MOArrowedLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 4/14/2010 08:58'!
isArrowed
	^ true! !

MOStraightLineShape subclass: #MODashedLineShape
	instanceVariableNames: 'secondaryColor dashLengths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

MODashedLineShape subclass: #MOArrowedDashedLineShape
	instanceVariableNames: 'towardsTo arrowSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOArrowedDashedLineShape class methodsFor: 'testing' stamp: 'AlexandreBergel 7/9/2010 16:11'!
isDefaultLineShape
	^ false! !

!MOArrowedDashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/14/2010 10:19'!
arrowSize
	^arrowSize! !

!MOArrowedDashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/14/2010 10:19'!
arrowSize: anInteger
	arrowSize := anInteger! !

!MOArrowedDashedLineShape methodsFor: 'drawing' stamp: 'VeronicaUquillas 4/8/2010 16:19'!
display: anElement on: aCanvas
	| fromPoint toPoint t u vector unit arrowLeft arrowRight arrowMiddle w c |	
		
	t := self getAttachPointsFor: anElement.
	self towardsTo 
	ifTrue:[ fromPoint := t first.
			  toPoint := t second ]
	ifFalse:[ fromPoint := t second. 
				toPoint := t first ].
			
	"Draw head"
	vector := toPoint - fromPoint.
	u := vector normal.
	unit := vector / vector r.
	arrowMiddle := toPoint - (unit * self arrowSize). 
	arrowLeft :=  arrowMiddle - (u * self arrowSize).
	arrowRight := arrowMiddle + (u * self arrowSize).

	w := self widthFor: anElement.
	c := self colorFor: anElement.
	aCanvas line: toPoint to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPoint width: w color: c.

	"draw line"
	aCanvas line: fromPoint to: arrowMiddle width: w colors: {c. self secondaryColor} dashes: self dashLengths startingOffset: 0. ! !

!MOArrowedDashedLineShape methodsFor: 'initialization' stamp: 'VeronicaUquillas 4/14/2010 10:21'!
initialize 

	super initialize.
	self arrowSize: 6.
	self towardsTo: true.! !

!MOArrowedDashedLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 4/14/2010 08:59'!
isArrowed
	^ true! !

!MOArrowedDashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/8/2010 13:09'!
towardsTo

	^towardsTo! !

!MOArrowedDashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/8/2010 13:08'!
towardsTo: aBoolean

	towardsTo:= aBoolean ! !

!MODashedLineShape class methodsFor: 'testing' stamp: 'AlexandreBergel 7/9/2010 16:11'!
isDefaultLineShape
	^ false! !

!MODashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/12/2010 11:25'!
dashLengths

	^dashLengths ! !

!MODashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/8/2010 13:03'!
dashLengths: twoLengths

	dashLengths:= twoLengths ! !

!MODashedLineShape methodsFor: 'drawing' stamp: 'VeronicaUquillas 4/12/2010 11:26'!
display: anElement on: aCanvas
	| fromPoint toPoint t w c |	
		
	t := self getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.

	w := self widthFor: anElement.
	c := self colorFor: anElement.

	aCanvas line: fromPoint to: toPoint width: w colors: { c. self secondaryColor } dashes: self dashLengths startingOffset: 0. ! !

!MODashedLineShape methodsFor: 'initialization' stamp: 'VeronicaUquillas 4/14/2010 10:21'!
initialize 

	super initialize.
	self dashLengths: #(3 3).
	self secondaryColor: Color white.! !

!MODashedLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 4/14/2010 08:53'!
isDashed
	self dashLengths ifNil: [ ^ false ]. "Something strange here, it should not be"
	
	^ self dashLengths second > 0! !

!MODashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/12/2010 11:25'!
secondaryColor

	^secondaryColor ! !

!MODashedLineShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 4/8/2010 13:03'!
secondaryColor: aColor

	secondaryColor:= aColor ! !

!MOStraightLineShape class methodsFor: 'testing' stamp: 'Alexandre Bergel 6/17/2010 12:10'!
isDefaultLineShape
	^ true! !

!MOStraightLineShape methodsFor: 'testing' stamp: 'Alexandre Bergel 4/22/2010 15:23'!
containsPoint: aPoint for: anEdgeElement
	| attachPoints min max |
	"We do here a special treatment when the line is horizontal or vertical"
	attachPoints := self getAttachPointsFor: anEdgeElement.
	((attachPoints first y = attachPoints second y) and: [ attachPoints first y = aPoint y ])
		ifTrue: [ 
				min := attachPoints first x min: (attachPoints second x). 
				max := attachPoints first x min: (attachPoints second x). 
					^ (min <= aPoint x) and: [ max <= aPoint x] ].

	((attachPoints first x = attachPoints second x) and: [ attachPoints first x = aPoint x ])
		ifTrue: [ 
				min := attachPoints first y min: (attachPoints second y). 
				max := attachPoints first y min: (attachPoints second y). 
					^ (min <= aPoint y) and: [ max <= aPoint y] ].

	^ super containsPoint: aPoint for: anEdgeElement! !

!MOStraightLineShape methodsFor: 'drawing' stamp: 'Alexandre Bergel 4/14/2010 08:42'!
display: anElement on: aCanvas
	| fromPoint toPoint t |	

	t := self getAttachPointsFor: anElement.
	fromPoint := t first.
	toPoint := t second.


	"Check if the figure to be rendered is not too small. If this is the case, 
	then no need to draw"
	(fromPoint - toPoint) abs < (anElement threadholdSize @ anElement threadholdSize)
		ifTrue: [^ self ].

	self isAliased 
		ifTrue:
			[	aCanvas 
					drawPath: { fromPoint . toPoint}
				borderWidth: (self widthFor: anElement) 
				borderColor: (self colorFor: anElement) ]
		ifFalse: 
			[ aCanvas 
				line: fromPoint
				to: toPoint
				width: (self widthFor: anElement) 
				color: (self colorFor: anElement) ]
		

"for anti-aliasing"
"	aCanvas 
		drawPath: (Array
			with: (fromPoint)
			with: (toPoint))
		borderWidth: (self widthFor: aFigure) 
		borderColor: (self colorFor: aFigure).
"
"	next display: anElement on: aCanvas"! !

MOShape subclass: #MONodeShape
	instanceVariableNames: 'parent'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

MONodeShape subclass: #MOFilledShape
	instanceVariableNames: 'fillColor borderColor borderWidth borderStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

MOFilledShape subclass: #MOBoundedShape
	instanceVariableNames: 'width height hasBorder text fontSize fontColor fontFamily logicalFont textAlignment textHorizontalPadding textVerticalPadding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

MOBoundedShape class
	instanceVariableNames: 'fontCache'!

MOBoundedShape class
	instanceVariableNames: 'fontCache'!

!MOBoundedShape class methodsFor: 'defaults' stamp: 'Alexandre.Bergel 4/17/2009 13:28'!
defaultColor
	^ Color black! !

!MOBoundedShape class methodsFor: 'defaults' stamp: 'Alexandre.Bergel 4/17/2009 13:28'!
defaultFont
	^ TextStyle defaultFont! !

!MOBoundedShape class methodsFor: 'defaults' stamp: 'Alexandre.Bergel 3/28/2009 12:28'!
defaultHeight
	^ 5! !

!MOBoundedShape class methodsFor: 'defaults' stamp: 'tg 4/26/2010 21:36'!
defaultSize
	^ 5! !

!MOBoundedShape class methodsFor: 'defaults' stamp: 'Alexandre.Bergel 3/28/2009 12:28'!
defaultWidth
	^ 5! !

!MOBoundedShape class methodsFor: 'instance creation' stamp: 'jlr 10/23/2008 10:04'!
fillColor: aColor 
	^self width: self defaultWidth height: self defaultHeight fillColor: aColor ! !

!MOBoundedShape class methodsFor: 'defaults' stamp: 'Alexandre.Bergel 4/17/2009 13:29'!
fontCache

	^ fontCache ifNil: [ fontCache := Dictionary new]! !

!MOBoundedShape class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 3/28/2009 12:25'!
width: aSmallIntegerOrABlock height: anotherSmallIntegerOrABlock fillColor: aBlock 
	^self new 
		width: aSmallIntegerOrABlock;
		height: anotherSmallIntegerOrABlock;
		fillColor: aBlock! !

!MOBoundedShape class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 2/20/2009 19:03'!
withBorder
	^ self new withBorder! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 12/22/2009 00:39'!
bigFont
	^ self fontSize: 15! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/25/2010 23:34'!
computeExtentHavingChildrenFor: aNodeElement 
	| compoundWidth compoundHeight idealExtentX idealExtentY minX minY bounds |
	"This method is compute the size of the provided element. It therefore has children"
	self assert: [ aNodeElement hasChildren ].

	aNodeElement resetMetricCaches.

	compoundWidth := 0.
	compoundHeight := 0.
	minX := 10000000.
	minY := 10000000.

	aNodeElement nodesDo: 
			[ :node | 
				bounds := node bounds.
				compoundWidth := compoundWidth max: (node shape widthFor: node) + bounds origin x.
				compoundHeight := compoundHeight max: (node shape heightFor: node) + bounds origin y.
				minX := minX min: bounds origin x. minY := minY min: bounds origin y].
			
	idealExtentX := self width moValue: aNodeElement model.
	idealExtentY := self height moValue: aNodeElement model.

	^ (compoundWidth + minX max: idealExtentX) @ (compoundHeight + minY max: idealExtentY)! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 6/16/2010 22:10'!
computeFontColorFor: anElement
	^ fontColor moValue: anElement model! !

!MOBoundedShape methodsFor: 'convenient' stamp: 'Alexandre Bergel 6/16/2010 22:09'!
computeFontFamilyFor: anElement
	^ self fontFamily moValue: anElement model! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 6/16/2010 22:06'!
computeFontSizeFor: anElement
	^fontSize moValue: anElement model
! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 8/2/2010 09:21'!
computeHeightFor: aNodeElement
	| h |
	h := 5.
	"Note that we do not consider multilines label for now"
	text isNil ifFalse: [ h := self textHeightFor: aNodeElement].

	aNodeElement hasChildren ifFalse: [ ^ (self height moValue: aNodeElement model) asInteger max: h ].
	^ (self computeExtentHavingChildrenFor: aNodeElement) y asInteger max: h! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/16/2010 22:05'!
computeTextFor: anElement
	^ (text moValue: anElement model) asString! !

!MOBoundedShape methodsFor: 'public' stamp: 'AlexandreBergel 9/13/2010 00:25'!
computeTextHeightFor: anElement
	| lineCount size |
	lineCount := (self textFor: anElement) lineCount.
	size := (self fontSizeFor: anElement) max: ((self fontFor: anElement) height).
	^ (( size + (self interlineSpace)) * lineCount) + (2 * textVerticalPadding)
		"+ (2 * (self borderWidthFor: anElement) )"
"	^ ((((self fontFor: anElement) height) + (self interlineSpace))* lineCount) + (2 * textVerticalPadding)"
	
"	^ (((self fontSizeFor: anElement) + (self interlineSpace))* lineCount) + (2 * textVerticalPadding)"! !

!MOBoundedShape methodsFor: 'public' stamp: 'AlexandreBergel 9/13/2010 00:23'!
computeTextWidthFor: anElement
	| longestLine |
	longestLine := ''.	
	(self textFor: anElement) linesDo: [:line | 
		longestLine := line size > longestLine size ifTrue: [line] ifFalse: [longestLine]].	
	^ ((self fontFor: anElement) widthOfString: longestLine) + (2 * textHorizontalPadding) 
				+ (2 * (self borderWidthFor: anElement) )! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 8/2/2010 09:21'!
computeWidthFor: aNodeElement
	| w |
	w := 5.
	"Note that we do not consider multilines label for now"
	text isNil ifFalse: [ w := self textWidthFor: aNodeElement ].


	aNodeElement hasChildren ifFalse: [ ^ (self width moValue: aNodeElement model) asInteger max: w ].
	^ (self computeExtentHavingChildrenFor: aNodeElement) x asInteger max: w! !

!MOBoundedShape methodsFor: 'default values' stamp: 'Alexandre.Bergel 2/21/2009 13:21'!
defaultBounds

	^ Rectangle left: 0 top: 0 width: 10 height: 10! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre.Bergel 4/17/2009 13:32'!
defaultColor
	^ self class defaultColor! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre.Bergel 4/17/2009 13:21'!
defaultFont
	^ self class defaultFont! !

!MOBoundedShape methodsFor: 'default values' stamp: 'jannik.laval 5/15/2009 11:56'!
defaultFontFamily
	^ self class defaultFont familyName! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre.Bergel 4/17/2009 13:39'!
defaultSize
	^ self class defaultSize! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre.Bergel 4/17/2009 13:21'!
defaultText
	^ #asString! !

!MOBoundedShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/5/2010 10:22'!
display: node on: aCanvas
	| bounds borderWidthValue textExtent c textToDisplay font borderColorValue borderStyleValue textToDisplayBounds |

"	bounds := 0@0 extent: ((node shapeBoundsAt: self) extent)."
	bounds := (0@0 extent: (self boundsFor: node) extent).
	
	c := self fillColorFor: node.
	borderWidthValue := self borderWidthFor: node.
	borderColorValue := self borderColorFor: node.
	borderStyleValue := self borderStyleFor: node.

	"We render the rectangle"
	c ifNotNil: 
	[hasBorder
		ifTrue: 
			[aCanvas 
				frameAndFillRectangle: bounds
					fillColor: c
					borderWidth: borderWidthValue
					borderColor: borderColorValue.
			 borderStyleValue ifNotNil:[	
				(borderStyleValue width: borderWidthValue) frameRectangle: bounds on: aCanvas 
				]]
		ifFalse:
			[aCanvas 
				frameAndFillRectangle: bounds
					fillColor: c
					borderWidth: 0
					borderColor: c ]].

	"Using balloon (anti-aliasing)"
"	aCanvas 
			drawRectangle: bounds
			color: (self fillColorFor: aFigure)
			borderWidth: borderWidthValue
			borderColor: (self borderColorFor: aFigure).
"
	text isNil ifFalse: [
		| textColor textBounds |
		font := self fontFor: node.
		textToDisplay := self textFor: node.
		textColor := (self fontColorFor: node).
		textBounds := (bounds origin + (textHorizontalPadding @ textVerticalPadding)) 
							extent: (((self textWidthFor: node) + (textHorizontalPadding)) @ 
										((self textHeightFor: node) + (textVerticalPadding))). 
		textToDisplay linesDo: [:line |
			textToDisplayBounds := (textBounds insetBy: ((self borderWidthFor: node))).
			(self textAlignment == #center) ifTrue: [
					textExtent := textToDisplayBounds extent.
					textToDisplayBounds := 
							(textBounds origin  + ((bounds width - textExtent x / 2) asInteger
											@ (bounds height - textExtent y / 2) asInteger)) extent: 
							textExtent ].
			(self textAlignment == #right) ifTrue: [
					textExtent := textToDisplayBounds extent.
					textToDisplayBounds := 
							(textBounds origin  + ((bounds width - textExtent x) asInteger
											@ (bounds height - textExtent y) asInteger)) extent: 
							textExtent ].
			aCanvas 
				drawString: line
				in: textToDisplayBounds
				font:  font
				color: textColor.
			textBounds origin: (textBounds origin + (0 @ (self interlineSpace)) + 
													(0 @ (self fontSizeFor: node))). 
			textBounds corner: (textBounds corner + (0 @ (self interlineSpace)) + (0 @ (self fontSizeFor: node))). 

		].
	].

	self displaySelection: node on: aCanvas.
! !

!MOBoundedShape methodsFor: 'public' stamp: 'AlexandreBergel 8/22/2010 20:23'!
extentFor: anElement 
	^ (self boundsFor: anElement) extent
"	^ (anElement hasChildren) 
		ifFalse: [ (self widthFor: anElement) @ (self heightFor: anElement) ]
		ifTrue: [ self computeExtentHavingChildrenFor: anElement]"! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre.Bergel 4/17/2009 13:33'!
fontColor: anObjet
	fontColor := anObjet! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 6/17/2010 11:52'!
fontColorFor: anElement
	^ anElement cachedNamed: #cachefontColorFor: ifAbsentInitializeWith: [ self computeFontColorFor: anElement ] ! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 5/14/2009 01:15'!
fontFamily
	^fontFamily! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 5/14/2009 01:14'!
fontFamily: aBlock
	fontFamily := aBlock! !

!MOBoundedShape methodsFor: 'convenient' stamp: 'Alexandre Bergel 6/17/2010 11:52'!
fontFamilyFor: anElement
	^ anElement 
		cachedNamed: #cachefontFamilyFor: 
		ifAbsentInitializeWith: [ self computeFontFamilyFor: anElement ]! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 6/18/2010 09:40'!
fontFor: anElement


	| size family lf |
	^ self logicalFont isNil 
		ifTrue: [
			size := self fontSizeFor: anElement.
			family := self fontFamilyFor: anElement.
			lf := LogicalFont familyName: family pointSize: size.
			self class fontCache 
				at: (family, size asString) 
				ifAbsentPut: [ lf ] ]
		ifFalse: [self logicalFont moValue: anElement]
	! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre.Bergel 4/17/2009 13:22'!
fontSize
	^fontSize! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre.Bergel 4/17/2009 13:23'!
fontSize: anObject
	"The size of the font to be used. anObject could be a 1-arg block or a numerical value"

	fontSize := anObject! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 6/17/2010 11:53'!
fontSizeFor: anElement
	^ anElement 
		cachedNamed: #cachefontSizeFor: 
		ifAbsentInitializeWith: [ self computeFontSizeFor: anElement ]
	! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'jlr 10/22/2008 15:11'!
height
	^height! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'jlr 10/22/2008 15:11'!
height: aBlock
	height := aBlock! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/17/2010 11:53'!
heightFor: anElement
	^ anElement 
		cachedNamed: #cacheheightFor: 
		ifAbsentInitializeWith: [ self computeHeightFor: anElement ]
	! !

!MOBoundedShape methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 1/7/2010 17:38'!
initialize
	super initialize.
	width := 5.
	height := 5.
	hasBorder := true.
	text := nil.
	self fontFamily: self defaultFontFamily.
	self fontSize: self defaultSize.
	self fontColor: self defaultColor.
	textAlignment := #center.
	textHorizontalPadding := textVerticalPadding := 0 
! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre.Bergel 4/17/2009 13:23'!
interlineSpace
	^ 3! !

!MOBoundedShape methodsFor: '*Mondrian-Utils' stamp: 'tg 4/26/2010 22:08'!
linearFontSize: aBlock within: aCollection
	fontSize := MONFontLinearNormalizer inContext: aCollection withCommand: aBlock! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 5/14/2009 01:32'!
logicalFont
	^ logicalFont! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 5/14/2009 01:32'!
logicalFont: anObject
	logicalFont := anObject! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 12/22/2009 00:40'!
normalFont
	^ self fontSize: 10! !

!MOBoundedShape methodsFor: 'convenient' stamp: 'AlexandreBergel 8/22/2010 20:53'!
size: aValueOrABlock
	self width: aValueOrABlock.
	self height: aValueOrABlock.
	! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 12/22/2009 00:40'!
smallFont
	^ self fontSize: 5! !

!MOBoundedShape methodsFor: 'convenient' stamp: 'Alexandre.Bergel 6/8/2009 11:06'!
square: aValue
	^ self size: aValue! !

!MOBoundedShape methodsFor: 'convenient' stamp: 'Alexandre.Bergel 3/11/2009 10:08'!
squareSize: aValueOrABlock
	self width: aValueOrABlock.
	^ self height: aValueOrABlock! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 13:56'!
text: aOneArgumentBlock
	"Rectangle may have a text."
	text := aOneArgumentBlock! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/28/2009 16:48'!
textAlignment 
	^ textAlignment! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/28/2009 16:46'!
textAlignment: aSymbol
	"aSymbol = #left, #right, #center"
	textAlignment := aSymbol! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/17/2010 11:53'!
textFor: anElement
	^ anElement 
		cachedNamed: #cachetextFor: 
		ifAbsentInitializeWith: [ self computeTextFor: anElement ]
! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/17/2010 11:53'!
textHeightFor: anElement
	^ anElement 
		cachedNamed: #cachetextHeightFor: 
		ifAbsentInitializeWith: [ self computeTextHeightFor: anElement ]
! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 1/7/2010 17:44'!
textHorizontalPadding: anInteger
	textHorizontalPadding := anInteger ! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 1/7/2010 17:36'!
textPadding: anInteger
	textHorizontalPadding := textVerticalPadding := anInteger ! !

!MOBoundedShape methodsFor: 'accessing text' stamp: 'Alexandre Bergel 1/7/2010 17:44'!
textVerticalPadding: anInteger
	textVerticalPadding := anInteger ! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/17/2010 12:30'!
textWidthFor: anElement
	^ anElement 
		cachedNamed: #cachetextWidthFor:
		ifAbsentInitializeWith: [ self computeTextWidthFor: anElement ]
! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'jlr 10/22/2008 15:11'!
width
	^width! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'jlr 10/22/2008 15:11'!
width: aBlock
	width := aBlock! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/17/2010 11:54'!
widthFor: anElement
	^ anElement 
		cachedNamed: #cachewidthFor: 
		ifAbsentInitializeWith: [ self computeWidthFor: anElement ]
! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 19:04'!
withBorder
	hasBorder := true! !

!MOBoundedShape methodsFor: 'public' stamp: 'Alexandre.Bergel 8/30/2009 14:06'!
withLabel
	text := #yourself! !

!MOBoundedShape methodsFor: 'convenient' stamp: 'Alexandre Bergel 12/17/2009 19:32'!
withText
	self text: #yourself! !

!MOBoundedShape methodsFor: 'convenient' stamp: 'Alexandre Bergel 6/18/2010 09:32'!
withoutBackground
	fillColor := nil! !

!MOBoundedShape methodsFor: 'accessing' stamp: 'tg 3/23/2009 21:58'!
withoutBorder
	hasBorder := false.
	self borderWidth: 0.! !

MOBoundedShape subclass: #MOChildrenShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOChildrenShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/6/2010 18:42'!
display: anElement on: aCanvas
	"The element to display can only have a formshape as a shape"
	| builder |

	self assert: [ anElement shape isFormsShape ].
	self assert: [ anElement shape isFormsShape ].
	builder := anElement shape builder.
	self assert: [ builder notNil ].

	aCanvas 
		translateBy: (anElement shape builder boundsOf: self) origin negated
						+ anElement bounds origin negated
		during: [:tmpCanvas | anElement elementsToDisplay do: [ :each | each displayOn: tmpCanvas ] ].

"	anElement elementsToDisplay do: [ :each | each displayOn: aCanvas ]
"	
	
"	aCanvas translateBy: bounds origin negated during: [ :myCanvas | 
		anElement elementsToDisplay do: [ :each | each displayOn: myCanvas ] ].
"! !

!MOChildrenShape methodsFor: 'testing' stamp: 'Alexandre Bergel 8/9/2010 17:52'!
isChildShape
	^ true ! !

MOBoundedShape subclass: #MOCurveShape
	instanceVariableNames: 'values colorWhenPositive colorWhenNegative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 08:58'!
color: aBlockOrSelector
	 colorWhenPositive := colorWhenNegative := aBlockOrSelector! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 08:58'!
colorFor: anElement
	^ anElement model moValue: self colorWhenPositive! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 08:58'!
colorWhenNegative
	^ colorWhenNegative! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 17:18'!
colorWhenNegative: aBlockOrSymbol
	colorWhenNegative := aBlockOrSymbol! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 17:31'!
colorWhenNegativeFor: anElement
	^ self colorWhenNegative moValue: anElement model! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 08:58'!
colorWhenPositive
	^ colorWhenPositive! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 17:18'!
colorWhenPositive: aBlockOrSymbol
	colorWhenPositive := aBlockOrSymbol! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/4/2010 17:31'!
colorWhenPositiveFor: anElement
	^ self colorWhenPositive moValue: anElement model ! !

!MOCurveShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/6/2010 18:42'!
display: anElement on: aCanvas

	| bounds c colorForPositive colorForNegative borderWidthValue borderColorValue borderStyleValue valuesToRender maxValue minValue barWidth sizeForNegativePart step running heightBar |
	bounds := (0@0 extent: (self extentFor: anElement)). 

	c := self fillColorFor: anElement.
	
	colorForPositive := self colorWhenPositiveFor: anElement.
	colorForNegative := self colorWhenNegativeFor: anElement.

	borderWidthValue := self borderWidthFor: anElement.
	borderColorValue := self borderColorFor: anElement.
	borderStyleValue := self borderStyleFor: anElement.
	
	valuesToRender := self valuesFor: anElement.
	maxValue := valuesToRender max.
	minValue := valuesToRender min min: 0.
	barWidth := bounds width / valuesToRender size.
	
	sizeForNegativePart := (bounds height * (minValue abs) / (maxValue abs + minValue abs)) asFloat.
	step := bounds width / valuesToRender size.
	running := bounds topLeft.

	valuesToRender do: [ :v |
		(v > 0)  
			ifTrue: [
"			  heightBar := bounds height - ((v abs * ratioForPositiveValues) asInteger).
"			 heightBar := (bounds height * v abs / (maxValue abs + minValue abs )) asInteger.  
		 	  aCanvas 
				drawPolygon: { 
					(running + (0 @ (bounds height - heightBar - sizeForNegativePart))) asIntegerPoint .
					(running + (barWidth@( bounds height - heightBar - sizeForNegativePart))) asIntegerPoint. 
					(running + (barWidth@(bounds height - sizeForNegativePart))) asIntegerPoint . 
					(running + (0 @ (bounds height - sizeForNegativePart))) asIntegerPoint
					} 
				color: colorForPositive 
				borderWidth: borderWidthValue 
				borderColor: borderColorValue ]
			ifFalse: [
			  heightBar := (bounds height * v abs / (maxValue abs + minValue abs )) asInteger.  
		 	  aCanvas 
				drawPolygon: { 
					(running + (0 @ (bounds height - sizeForNegativePart))) asIntegerPoint .
					(running + (barWidth @ (bounds height - sizeForNegativePart))) asIntegerPoint. 
					(running + (barWidth @ (bounds height - sizeForNegativePart + heightBar))) asIntegerPoint . 
					(running + (0 @ (bounds height - sizeForNegativePart + heightBar))) asIntegerPoint
					} 
				color: colorForNegative
				borderWidth: borderWidthValue 
				borderColor: borderColorValue 
				].
		running := running + (step @ 0).
	].

	self displaySelection: anElement on: aCanvas.! !

!MOCurveShape methodsFor: 'initialization' stamp: 'Alexandre Bergel 6/4/2010 17:30'!
initialize 
	super initialize.
	values := #yourself.
	colorWhenNegative := Color white.
	colorWhenPositive := Color lightGray.! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/3/2010 20:07'!
values
	^ values! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/3/2010 20:07'!
values: aBlockOrSelector
	values := aBlockOrSelector ! !

!MOCurveShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/3/2010 20:23'!
valuesFor: anGraphElement

	^ (self values moValue: anGraphElement model) ! !

MOBoundedShape subclass: #MODiamondShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MODiamondShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/6/2010 18:42'!
display: anElement on: aCanvas
	| bounds borderWidthValue c textToDisplay font borderColorValue borderStyleValue textToDisplayBounds |
	bounds := (0@0 extent: (self extentFor: anElement)). 

	c := self fillColorFor: anElement.
	borderWidthValue := self borderWidthFor: anElement.
	borderColorValue := self borderColorFor: anElement.
	borderStyleValue := self borderStyleFor: anElement.
	
	aCanvas 
		drawPolygon: { bounds topCenter. bounds rightCenter . bounds bottomCenter . bounds leftCenter } 
		color: c 
		borderWidth: borderWidthValue 
		borderColor: borderColorValue! !

MOBoundedShape subclass: #MOEllipseShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOEllipseShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/16/2010 01:49'!
display: anElement on: aCanvas

	| bounds |
	bounds := (0@0 extent: (self extentFor: anElement)). 
	aCanvas 
		fillOval: (Rectangle
			origin: bounds origin
			extent: bounds extent)
 		fillStyle: (self fillColorFor: anElement)
		borderWidth: (self borderWidthFor: anElement)
		borderColor: (self borderColorFor: anElement).
		
	self displaySelection: anElement on: aCanvas.

! !

MOBoundedShape subclass: #MOFixedRectangleShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOFixedRectangleShape methodsFor: 'public' stamp: 'Alexandre Bergel 8/2/2010 09:22'!
computeHeightFor: anElement
	| h |
	h := 5.
	^ (self height moValue: anElement model) asInteger max: h! !

!MOFixedRectangleShape methodsFor: 'public' stamp: 'Alexandre Bergel 8/2/2010 09:22'!
computeWidthFor: anElement
	| w |
	w := 5.
	^ (self width moValue: anElement model) asInteger max: w! !

MOBoundedShape subclass: #MORectangleShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MORectangleShape class methodsFor: 'testing' stamp: 'Alexandre Bergel 6/17/2010 12:10'!
isDefaultNodeShape
	^ true! !

!MORectangleShape methodsFor: '*Mondrian-Legend' stamp: 'Alexandre Bergel 7/26/2010 15:01'!
viewLegend
	| view |
	view := MOViewRenderer title: 'legend' translated.
	view shape rectangle withoutBorder.
	view
		node: #foo
		forIt: [ 
			view shape label fontSize: 10.
			self height isSymbol
				ifTrue: [ view node: self height ].
			(self height isKindOf: BlockClosure)
				ifTrue: [ view node: (Decompiler new decompileBlock: self height) ].
			view shape rectangle withoutBorder.
			view
				node: #bar
				forIt: [ 
					view shape label fontSize: 10.
					self width isSymbol
						ifTrue: [ view node: self width ].
					(self width isKindOf: BlockClosure)
						ifTrue: [ view node: (Decompiler new decompileBlock: self width) ].
					(view shape rectangle)
						width: 30;
						height: 50;
						fillColor: Color lightGray;
						withText;
						fontSize: 5.
					self fillColor isSymbol
						ifTrue: [ view node: self fillColor ]
						ifFalse: [ 
							(self fillColor isKindOf: BlockClosure)
								ifTrue: [ view node: (Decompiler new decompileBlock: self fillColor) ]
								ifFalse: [ view node: self fillColor printString ] ].
					view verticalLineLayout center ].
			view horizontalLineLayout center ].
	view open! !

MOBoundedShape subclass: #MORoundedRectangleShape
	instanceVariableNames: 'radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MORoundedRectangleShape methodsFor: 'drawing' stamp: 'Alexandre Bergel 3/10/2010 12:08'!
display: anElement on: aCanvas
	| bounds borderWidthValue runningPoint increment alpha lastPoint x |
	bounds := self boundsFor: anElement. 
	"bounds := bounds scaleBy: anElement zoom."
	borderWidthValue := self borderWidthFor: anElement.

	aCanvas
		line: bounds origin + (self radius @ 0)
		to: bounds topRight - (self radius @ 0)
		width: borderWidthValue
		color: (self borderColorFor: anElement).

	aCanvas
		line: bounds bottomLeft + (self radius @ 0)
		to: bounds bottomRight - (self radius @ 0)
		width: borderWidthValue
		color: (self borderColorFor: anElement).

	aCanvas
		line: bounds origin + (0 @ self radius)
		to: bounds bottomLeft - (0 @ self radius)
		width: borderWidthValue
		color: (self borderColorFor: anElement).

	aCanvas
		line: bounds topRight + (0 @ self radius)
		to: bounds bottomRight - (0 @ self radius)
		width: borderWidthValue
		color: (self borderColorFor: anElement).

	runningPoint := bounds origin + (0 @ self radius).
	lastPoint := runningPoint.
	0 to: self radius do: [:i |
		alpha := (self radius - i / self radius) asFloat arcCos .
		increment := alpha sin * self radius. 
		aCanvas line: runningPoint + (i@ increment negated) to: lastPoint width: (self borderWidthFor: anElement) color: (self borderColorFor: anElement).
		lastPoint := runningPoint + (i@ increment negated).
	].

	runningPoint := bounds topRight - (self radius @ 0).
	lastPoint := runningPoint.
	0 to: self radius do: [:i |
		x := (i / self radius) asFloat.
		alpha :=  x arcCos .
		increment := alpha sin * self radius. 
		aCanvas line: runningPoint + (i@ (self radius - increment)) to: lastPoint width: (self borderWidthFor: anElement) color: (self borderColorFor: anElement).
		lastPoint := runningPoint + (i@ (self radius - increment)).
	].

	runningPoint := bounds bottomLeft - (0 @ self radius).
	lastPoint := runningPoint.
	0 to: self radius do: [:i |
		x := (self radius - i / self radius) negated asFloat.
		alpha :=  x arcCos .
		increment := alpha sin * self radius. 
		aCanvas line: runningPoint + (i@ ( increment)) to: lastPoint width: (self borderWidthFor: anElement) color: (self borderColorFor: anElement).
		lastPoint := runningPoint + (i@ ( increment)).
	].

	runningPoint := bounds bottomRight - (self radius @ self radius).
	lastPoint := bounds bottomRight - (self radius @ 0).
	0 to: self radius do: [:i |
		x := (i / self radius) asFloat.
		alpha :=  x arcCos .
		increment := alpha sin * self radius. 
		aCanvas line: runningPoint + (i@ (increment)) to: lastPoint width: (self borderWidthFor: anElement) color: (self borderColorFor: anElement).
		lastPoint := runningPoint + (i@ ( increment)).
	].


! !

!MORoundedRectangleShape methodsFor: 'initialization' stamp: 'Alexandre.Bergel 3/19/2009 11:04'!
initialize
	super initialize.
	self radius: 10! !

!MORoundedRectangleShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 3/19/2009 10:09'!
radius
	^ radius! !

!MORoundedRectangleShape methodsFor: 'accessing' stamp: 'Alexandre.Bergel 3/19/2009 10:10'!
radius: integer
	radius := integer! !

MOBoundedShape subclass: #MOTriangleShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOTriangleShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/16/2010 01:49'!
display: aNodeElement on: aCanvas
	| bounds borderWidthValue c textToDisplay font borderColorValue borderStyleValue textToDisplayBounds |
	bounds := (0@0 extent: (self extentFor: aNodeElement)). 

	c := self fillColorFor: aNodeElement.
	borderWidthValue := self borderWidthFor: aNodeElement.
	borderColorValue := self borderColorFor: aNodeElement.
	borderStyleValue := self borderStyleFor: aNodeElement.
	
	aCanvas 
		drawPolygon: { bounds topCenter. bounds bottomLeft . bounds bottomRight } 
		color: c 
		borderWidth: borderWidthValue 
		borderColor: borderColorValue.
		
	self displaySelection: aNodeElement on: aCanvas.! !

!MOFilledShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
borderColor
	^ borderColor! !

!MOFilledShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
borderColor: anObject
	"The border color of the outline."

	borderColor := anObject! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/17/2010 11:54'!
borderColorFor: anElement
	^ anElement 
		cachedNamed: #cacheborderColorFor:
		ifAbsentInitializeWith: [ self computeBorderColorFor: anElement ]
! !

!MOFilledShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/18/2009 13:16'!
borderStyle 
	^ borderStyle! !

!MOFilledShape methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/18/2009 13:17'!
borderStyle: anObject
	"The border style of the outline."

	borderStyle := anObject! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/17/2010 11:55'!
borderStyleFor: anElement
	^ anElement 
		cachedNamed: #cacheborderStyleFor:
		ifAbsentInitializeWith: [ self computeBorderStyleFor: anElement ]
! !

!MOFilledShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
borderWidth
	^ borderWidth! !

!MOFilledShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
borderWidth: anObject
	"The border width of the outline."

	borderWidth := anObject! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/17/2010 11:55'!
borderWidthFor: anElement
	^ anElement 
		cachedNamed: #cacheborderWidthFor:
		ifAbsentInitializeWith: [ self computeBorderWidthFor: anElement ]
! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/16/2010 21:58'!
computeBorderColorFor: anElement
	^ borderColor moValue: anElement model! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/16/2010 22:00'!
computeBorderStyleFor: anElement
	^ borderStyle moValue: anElement model! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/16/2010 22:01'!
computeBorderWidthFor: anElement
	^ borderWidth moValue: anElement model! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/16/2010 22:03'!
computeFillColorFor: anElement
	^ fillColor moValue: anElement model! !

!MOFilledShape methodsFor: 'configuration' stamp: 'VeronicaUquillas 11/18/2009 13:54'!
dashedBorder

	self borderStyle: BorderStyle dashed! !

!MOFilledShape methodsFor: 'configuration' stamp: 'lr 2/3/2008 13:39'!
defaultBorderColor
	^ Color black! !

!MOFilledShape methodsFor: 'configuration' stamp: 'lr 2/3/2008 13:39'!
defaultBorderWidth
	^ 1! !

!MOFilledShape methodsFor: 'configuration' stamp: 'lr 2/3/2008 13:39'!
defaultFillColor
	^ Color white! !

!MOFilledShape methodsFor: 'accessing' stamp: 'lr 2/3/2008 13:39'!
fillColor
	^ fillColor! !

!MOFilledShape methodsFor: 'accessing' stamp: 'ab 12/26/2008 11:45'!
fillColor: anObjectOrABlock
	"Any object may be provided to this method. It could be: 
		- a color (e.g., 'Color blue')
		- a block (e.g., [:each | each size > 10 ifTrue: [Color blue] ifFalse: [Color red]]
		- an instance of MONColorLinearNormalizer (e.g., linearFillColor:within:)"

	fillColor := anObjectOrABlock! !

!MOFilledShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/17/2010 11:55'!
fillColorFor: anElement
	^ anElement 
		cachedNamed: #cachefillColorFor:
		ifAbsentInitializeWith: [ self computeFillColorFor: anElement ]
! !

!MOFilledShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/8/2010 15:51'!
if: conditionBlock fillColor: colorBlock
	| oldBlockOrValue |
	oldBlockOrValue := self fillColor ifNil: [ self defaultFillColor ].
	^self fillColor: [ :each | (conditionBlock moValue: each)
								ifTrue: [ colorBlock moValue: each ] ifFalse: [ oldBlockOrValue moValue: each ]].! !

!MOFilledShape methodsFor: 'initialize-release' stamp: 'lr 2/3/2008 13:39'!
initialize
	super initialize.
	self fillColor: self defaultFillColor.
	self borderColor: self defaultBorderColor.
	self borderWidth: self defaultBorderWidth! !

!MOFilledShape methodsFor: '*Mondrian-Utils' stamp: 'Alexandre.Bergel 3/3/2009 12:29'!
linearBlueFillColor: anObject within: aGroup
	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: Color white
						highColor: Color blue! !

!MOFilledShape methodsFor: '*Mondrian-Utils' stamp: 'tg 10/5/2008 23:28'!
linearFillColor: anObject within: aGroup
	fillColor := MONColorLinearNormalizer inContext: aGroup withCommand: anObject! !

!MOFilledShape methodsFor: '*Mondrian-Utils' stamp: 'Alexandre.Bergel 3/3/2009 12:20'!
linearRedFillColor: anObject within: aGroup
	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: Color white
						highColor: Color red! !

!MOFilledShape methodsFor: '*Mondrian-Utils' stamp: 'Alexandre.Bergel 3/3/2009 12:29'!
linearYellowFillColor: anObject within: aGroup
	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: Color white
						highColor: Color yellow! !

!MOFilledShape methodsFor: 'configuration' stamp: 'VeronicaUquillas 11/18/2009 13:54'!
simpleBorder

	self borderStyle: BorderStyle simple! !

MONodeShape subclass: #MOFormsShape
	instanceVariableNames: 'builder isChildrenShape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-ComplexShape'!

!MOFormsShape commentStamp: 'Alexandre.Bergel 2/4/2009 10:54' prior: 0!
A MOFormsShape is the shape created by a FormsBuilder.

Instance Variables
	builder:		<Object>
	debug:		<Object>
	isChildrenShape:		<Object>

builder
	- xxxxx

debug
	- xxxxx

isChildrenShape
	- xxxxx
!

!MOFormsShape class methodsFor: 'instance creation' stamp: ' 23/10/08 11:55'!
on: aBuilder
	
	^(self new)
		builder: aBuilder;
		yourself! !

!MOFormsShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 8/11/2010 08:56'!
builder
	
	^builder ifNil: [ builder := MOFormsBuilder new ]! !

!MOFormsShape methodsFor: 'initialize-release' stamp: ' 23/10/08 11:55'!
builder: aBuilder
	
	builder := aBuilder! !

!MOFormsShape methodsFor: 'private' stamp: ' 23/10/08 11:55'!
builderAt: aX and: aY
	"Utility method that makes other methods easier to read."
	
	^self builder at: aX and: aY! !

!MOFormsShape methodsFor: 'testing' stamp: 'Alexandre Bergel 8/9/2010 17:52'!
canHandleChildren
	
	^ self collectAllShapes anySatisfy: [:s | s isChildShape ]! !

!MOFormsShape methodsFor: 'accessing-computed' stamp: ' 23/10/08 11:55'!
collectAllShapes
	
	| allShapes |
	allShapes := OrderedCollection new.
	allShapes add: self.
	self builder shapes
		do: [:shape | allShapes addAll: shape collectAllShapes].	"We also need the decorations"
	^allShapes! !

!MOFormsShape methodsFor: 'public' stamp: 'AlexandreBergel 9/5/2010 09:53'!
computeBoundsFor: anElement
	
	| myWidth myHeight myWidths myHeights v positionsX positionsY |
	"Calculate the grid"
	myWidths := self builder widthsFor: anElement.
	myHeights := self builder heightsFor: anElement.	"Position and resize the components"

	myWidth := myWidths
		inject: 0
		into: [:sum :nextElement | sum + nextElement].
	myHeight := myHeights
		inject: 0
		into: [:sum :nextElement | sum + nextElement].
		
	v := 0.
	positionsX := myWidths copy.
	1 to: positionsX size do: [:i | positionsX at: i put: v. v := v + (myWidths at: i) ].

	v := 0.
	positionsY := myHeights copy.
	1 to: positionsY size do: [:i | positionsY at: i put: v. v := v + (myHeights at: i) ].

	self builder shapes do: [:shape | 
		shape parent: self.

		anElement shapeBoundsAt: shape shape put:
			(self builder boundsOf: shape shape)].
	
	"I am not sure about this value (0@0), before it was 'aFigure origin'"
	^Rectangle
			origin: (0@0)
			extent: (myWidth@myHeight) asIntegerPoint 
! !

!MOFormsShape methodsFor: 'public' stamp: 'Alexandre.Bergel 8/30/2009 13:18'!
computeExtentFor: anElement 
	^ self extentFor: anElement! !

!MOFormsShape methodsFor: 'public' stamp: 'AlexandreBergel 2/18/2009 18:13'!
computeOriginRelativeToMeOf: aShape

	^builder originOf: aShape! !

!MOFormsShape methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 2/21/2009 14:01'!
defaultBounds

	^ Rectangle left: 0 top: 0 width: 10 height: 10! !

!MOFormsShape methodsFor: 'drawing' stamp: 'AlexandreBergel 9/5/2010 10:10'!
display: anElement on: aCanvas
	| shape |

	self builder shapes do: [:adaptor | 
		shape := adaptor shape.

		aCanvas 
			"translateBy: 0@0"
			translateBy: (anElement shapeBoundsAt: shape) origin + anElement absoluteBounds origin negated
			"translateBy: (shape boundsFor: anElement) origin"
			"translateBy: (anElement shape builder boundsOf: shape) origin"
			during: [:tmpCanvas | shape display: anElement on: tmpCanvas ] ]! !

!MOFormsShape methodsFor: 'private' stamp: 'Alexandre Bergel 6/17/2010 11:46'!
extentFor: anElement
	^ (self boundsFor: anElement) extent! !

!MOFormsShape methodsFor: 'public' stamp: 'Alexandre Bergel 2/18/2010 01:31'!
heightFor: anElement
	^ (self boundsFor: anElement) height
! !

!MOFormsShape methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 2/21/2009 14:01'!
initialize
	
	super initialize.
	isChildrenShape := false! !

!MOFormsShape methodsFor: 'testing' stamp: 'Alexandre Bergel 6/9/2010 19:31'!
isCached 
	^ false! !

!MOFormsShape methodsFor: 'testing' stamp: 'Alexandre Bergel 8/10/2010 10:05'!
isFormsShape
	^ true! !

!MOFormsShape methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 8/28/2010 16:21'!
positionOfChildrenForOwner: aGraphElement

	^ aGraphElement shape == self
		ifTrue: [ aGraphElement owner absoluteBounds origin ]
		ifFalse: [ self halt ]! !

!MOFormsShape methodsFor: 'bounds' stamp: 'AlexandreBergel 2/19/2009 00:46'!
relativeBoundsOf: aShape
	^ builder boundsOf: aShape! !

!MOFormsShape methodsFor: 'accessing' stamp: ' 23/10/08 11:55'!
setIsChildrenShape
	
	isChildrenShape := true! !

!MOFormsShape methodsFor: 'public' stamp: 'AlexandreBergel 9/5/2010 11:33'!
translateBoundsForFigure: anElement by: aPoint context: aDictionary
	
	aDictionary
		at: self
		put: ((aDictionary at: self) translatedBy: aPoint).
	self builder shapes
		do:
			[:adaptor | 
			adaptor component translateBoundsForFigure: anElement by: aPoint context:
					aDictionary ].	"Move the nested figures"

! !

!MOFormsShape methodsFor: 'public' stamp: 'Alexandre Bergel 2/18/2010 01:31'!
widthFor: anElement
	^ (self boundsFor: anElement) width
! !

!MONodeShape class methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 6/17/2010 12:07'!
default
	^ Default ifNil: [ Default := MORectangleShape new ]! !

!MONodeShape methodsFor: 'accessing' stamp: 'AlexandreBergel 8/29/2010 12:51'!
computeAssociatedBuiderFor: aGraphElement

	self assert: [self hasParentShapeFor: aGraphElement ].
	^  aGraphElement owner shape builder! !

!MONodeShape methodsFor: 'public' stamp: 'Alexandre Bergel 3/13/2010 14:52'!
computeOriginRelativeToMeOf: aShape

	^0@0! !

!MONodeShape methodsFor: 'accessing' stamp: 'AlexandreBergel 8/29/2010 12:55'!
computeParentShapeBoundsFor: aGraphElement
	| builder childrenShape |

	self 
		assert: [ aGraphElement owner notNil ] 
		description: 'Not an inner node'.	
	self 
		assert: [ aGraphElement owner shape isFormsShape ] 
		description: 'The shape of the owner is not a form shape'.

	builder := self computeAssociatedBuiderFor: aGraphElement.
	childrenShape := self computeParentShapeFor: aGraphElement.
	^ builder boundsOf: childrenShape! !

!MONodeShape methodsFor: 'accessing' stamp: 'AlexandreBergel 8/29/2010 12:49'!
computeParentShapeFor: aGraphElement
	| builder childrenShape |

	self 
		assert: [ aGraphElement owner notNil ] 
		description: 'Not an inner node'.	
	self 
		assert: [ aGraphElement owner shape isFormsShape ] 
		description: 'The shape of the owner is not a form shape'.

	builder := aGraphElement owner shape builder.
	childrenShape := builder shapes detect: [ :s | s shape isChildShape ].
	
	^ childrenShape shape! !

!MONodeShape methodsFor: 'accessing' stamp: 'AlexandreBergel 9/6/2010 18:41'!
hasParentShapeFor: aGraphElement
	| builder |

	"Must be inner node"
	aGraphElement owner notNil ifFalse: [ ^ false ].
	
	"shape of the owner is not a form shape"
	 aGraphElement owner shape isFormsShape ifFalse: [ ^ false ].
	
	"the builder must contain at least one child shape"
	builder := aGraphElement owner shape builder.
	^ builder shapes anySatisfy: [ :s | s shape isChildShape ].	
! !

!MONodeShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/13/2010 14:53'!
parent
	^parent! !

!MONodeShape methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/13/2010 14:53'!
parent: aParentShape
	parent := aParentShape! !

!MONodeShape methodsFor: 'public' stamp: 'Alexandre Bergel 3/13/2010 14:51'!
translateBoundsForFigure: aFigure by: aDelta context: aDictionary
	"Move the shape"
	
	aDelta = (0 @ 0) ifTrue: [^self].
	aFigure translateBy: aDelta.
	self changed! !

!MOShape class methodsFor: 'default' stamp: 'Alexandre Bergel 6/26/2010 13:11'!
defaultLineShapeClass
	| classes |

	classes := (self allSubclasses select: #isDefaultLineShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ classes anyOne! !

!MOShape class methodsFor: 'default' stamp: 'Alexandre Bergel 6/17/2010 17:18'!
defaultLineShapeInstance
	| classes |
	DefaultLineShape ifNotNil: [ ^ DefaultLineShape ].

	classes := (self allSubclasses select: #isDefaultLineShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ DefaultLineShape := classes anyOne new! !

!MOShape class methodsFor: 'default' stamp: 'Alexandre Bergel 6/26/2010 13:13'!
defaultNodeShapeClass
	| classes |

	classes := (self allSubclasses select: #isDefaultNodeShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ classes anyOne! !

!MOShape class methodsFor: 'default' stamp: 'Alexandre Bergel 6/17/2010 17:18'!
defaultNodeShapeInstance
	| classes |
	DefaultNodeShape ifNotNil: [ ^ DefaultNodeShape ].

	classes := (self allSubclasses select: #isDefaultNodeShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ DefaultNodeShape := classes anyOne new! !

!MOShape class methodsFor: 'testing' stamp: 'Alexandre Bergel 6/17/2010 12:16'!
isDefaultLineShape
	^ false! !

!MOShape class methodsFor: 'testing' stamp: 'Alexandre Bergel 6/17/2010 12:16'!
isDefaultNodeShape
	^ false! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 8/31/2010 09:14'!
absoluteBoundsFor: aGraphElement
	"Answer the bounds in absolute terms (relative to the entire Canvas, not just the parent)."

	| b |
	b :=  self boundsFor: aGraphElement.
	^ aGraphElement owner isNil
		ifTrue: [ b ]
		ifFalse: [ b translateBy: (self positionOfChildrenForOwner: aGraphElement) ]
"		ifFalse: [ b translateBy: (aGraphElement owner absoluteBounds origin) ]
"! !

!MOShape methodsFor: 'public' stamp: 'Alexandre.Bergel 8/30/2009 12:48'!
apply: anElement bounds: aBounds
	aBounds extent: (self computeExtentFor: anElement).
	^ aBounds! !

!MOShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/14/2010 22:59'!
boundsFor: aGraphElement
	aGraphElement shapeBoundsAt: self ifPresent: [ :b | ^ b ].
	^ self computeBoundsFor: aGraphElement! !

!MOShape methodsFor: 'testing' stamp: 'Alexandre Bergel 8/9/2010 17:43'!
canHandleChildren
	^false! !

!MOShape methodsFor: 'accessing-computed' stamp: 'jlr 10/23/2008 11:40'!
collectAllShapes

	 ^OrderedCollection with: self! !

!MOShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/25/2010 23:01'!
computeBoundsFor: anElement 
	"Return the bounds with a relative origin"
	
	^ 0@0 corner: (self computeExtentFor: anElement) asNonFractionalPoint
! !

!MOShape methodsFor: 'public' stamp: 'Alexandre.Bergel 8/30/2009 12:48'!
computeExtentFor: anElement 
	
	^ (self widthFor: anElement) @ (self heightFor: anElement)! !

!MOShape methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/5/2010 09:36'!
computeParentShapeBoundsFor: aGraphElement
	self subclassResponsibility ! !

!MOShape methodsFor: 'testing' stamp: 'Alexandre Bergel 4/24/2010 17:28'!
containsPoint: aPoint for: anElement
	^ anElement absoluteBounds containsPoint: aPoint! !

!MOShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/9/2010 19:02'!
disableCache
	isCached := false! !

!MOShape methodsFor: 'drawing' stamp: 'Alexandre Bergel 3/13/2010 14:31'!
display: anElement on: aCanvas
	self subclassResponsibility! !

!MOShape methodsFor: 'selection' stamp: 'Alexandre Bergel 8/15/2010 12:10'!
displaySelection: aGraphElement on: aCanvas
	| s borderWidthValue c bounds |
	aGraphElement isSelected ifFalse: [ ^ self ].
	s := 4. "Size of handler"
	borderWidthValue := 2.
	c := Color red.
	bounds := (0@0 extent: (self extentFor: aGraphElement)). 
	
	aCanvas line: bounds origin to: (bounds origin + (s@0)) width: borderWidthValue color: c.
	aCanvas line: bounds origin to: (bounds origin + (0@s)) width: borderWidthValue color: c.

	aCanvas line: bounds topRight to: (bounds topRight - (s@0)) width: borderWidthValue color: c.
	aCanvas line: bounds topRight to: (bounds topRight + (0@s)) width: borderWidthValue color: c.

	aCanvas line: bounds bottomRight to: (bounds bottomRight - (s@0)) width: borderWidthValue color: c.
	aCanvas line: bounds bottomRight to: (bounds bottomRight - (0@s)) width: borderWidthValue color: c.

	aCanvas line: bounds bottomLeft to: (bounds bottomLeft + (s@0)) width: borderWidthValue color: c.
	aCanvas line: bounds bottomLeft to: (bounds bottomLeft - (0@s)) width: borderWidthValue color: c.
! !

!MOShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/9/2010 19:03'!
enableCache
	isCached := true! !

!MOShape methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 9/5/2010 09:35'!
extentFor: anElement 
	self subclassResponsibility ! !

!MOShape methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 7/26/2010 11:43'!
heightFor: element
	self subclassResponsibility ! !

!MOShape methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 6/9/2010 19:02'!
initialize
	super initialize.
	isCached := true! !

!MOShape methodsFor: 'testing' stamp: 'Alexandre Bergel 6/9/2010 19:02'!
isCached
	^ isCached! !

!MOShape methodsFor: 'testing' stamp: 'Alexandre Bergel 8/9/2010 17:52'!
isChildShape
	^ false ! !

!MOShape methodsFor: 'testing' stamp: 'Alexandre Bergel 8/10/2010 10:04'!
isFormsShape
	^ false! !

!MOShape methodsFor: 'testing' stamp: 'Alexandre Bergel 10/15/2009 19:48'!
isLineShape
	^ false! !

!MOShape methodsFor: 'testing' stamp: 'Alexandre Bergel 10/15/2009 19:48'!
isNodeShape
	^ self isLineShape not! !

!MOShape methodsFor: 'testing' stamp: 'jlr 10/23/2008 10:39'!
isShape
	^true! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 8/31/2010 09:16'!
positionOfChildrenForOwner: aGraphElement
	^ (self hasParentShapeFor: aGraphElement)
		ifTrue: [ (self computeParentShapeBoundsFor: aGraphElement) origin +
				 aGraphElement owner absoluteBounds origin ]
		ifFalse: [ aGraphElement owner absoluteBounds origin ]! !

!MOShape methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 7/26/2010 11:43'!
widthFor: element
	self subclassResponsibility ! !

Object subclass: #MOShapeSelector
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Shapes'!

!MOShapeSelector methodsFor: '*Mondrian-ComplexShape-composite' stamp: 'Alexandre Bergel 6/16/2010 22:20'!
a: shape withNameOnLeft: aBlock
	| builder |
	builder := MOFormsBuilder new.
	builder column; fill; column; fill.
	builder row; fill.
	builder x: 1 y: 1 add: ((MORectangleShape new withoutBorder; withText) new text: aBlock).
	builder x: 2 y: 1 add: shape.
	^ view shape: builder shape! !

!MOShapeSelector methodsFor: '*Mondrian-ComplexShape-composite' stamp: 'Alexandre Bergel 6/16/2010 22:20'!
a: shape withNameOnTop: aBlock
	| builder |
	builder := MOFormsBuilder new.
	builder column; fill.
	builder row; fill; row; fill.
	builder x: 1 y: 1 add: ((MORectangleShape new withoutBorder; withText) new text: aBlock).
	builder x: 1 y: 2 add: shape.
	^ view shape: builder shape! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'VeronicaUquillas 4/8/2010 10:16'!
arrowedDashedLine
	^ view shape: MOArrowedDashedLineShape new! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'Alexandre.Bergel 5/14/2009 00:44'!
arrowedLine
	^ view shape: MOArrowedLineShape new! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'Alexandre.Bergel 5/14/2009 00:44'!
curvedLine
	^ view shape: MOCurveFitterShape new! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'VeronicaUquillas 4/2/2010 15:34'!
dashedLine
	^ view shape: MODashedLineShape new! !

!MOShapeSelector methodsFor: 'basic shape node' stamp: 'Alexandre Bergel 4/1/2010 15:51'!
diamond
	^ view shape: MODiamondShape new! !

!MOShapeSelector methodsFor: 'basic shape node' stamp: 'Alexandre Bergel 12/17/2009 02:31'!
ellipse
	^ view shape: MOEllipseShape new! !

!MOShapeSelector methodsFor: '*Mondrian-ComplexShape' stamp: 'Alexandre Bergel 2/28/2010 23:30'!
form: aOneArgBlock

	| builder |
	builder := MOFormsBuilder new.
	aOneArgBlock value: builder.
	^ view shape: builder asShape! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'tg 12/9/2009 12:50'!
horizontalOrthogonalLine
	^ view shape: MOOrthoHorizontalLineShape new! !

!MOShapeSelector methodsFor: 'basic shape node' stamp: 'Alexandre Bergel 12/22/2009 00:37'!
label
	^ view shape: (MORectangleShape new withoutBorder; withText)! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'Alexandre.Bergel 5/14/2009 00:44'!
line
	^ view shape: MOStraightLineShape new! !

!MOShapeSelector methodsFor: 'basic shape node' stamp: 'Alexandre.Bergel 5/14/2009 00:44'!
rectangle
	^ view shape: MORectangleShape new! !

!MOShapeSelector methodsFor: 'basic shape node' stamp: 'Alexandre Bergel 3/10/2010 12:07'!
roundedRectangle
	^ view shape: MORoundedRectangleShape new! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'Alexandre.Bergel 5/14/2009 00:44'!
splineLine
	^ view shape: MOSplineShape new! !

!MOShapeSelector methodsFor: 'basic shape node' stamp: 'Alexandre Bergel 4/1/2010 15:48'!
triangle
	^ view shape: MOTriangleShape new! !

!MOShapeSelector methodsFor: '*Mondrian-ComplexShape-composite' stamp: 'AlexandreBergel 9/5/2010 09:33'!
umlClass
	| builder |
	builder := MOFormsBuilder new.
	builder
		column;
		fill.
	builder
		row;
		fill;
		row;
		fill.
	builder x: 1 y: 1 add: MORectangleShape new.
	builder
		x: 1
		y: 1
		add:
			((MORectangleShape new withText)
				text: [ :cls | cls name ];
				fontSize: 12).
	builder x: 1 y: 2 add: MORectangleShape new.
	builder
		x: 1
		y: 2
		add:
			((MORectangleShape new withText)
				text: [ :cls | cls methods asArray inject: '' into: [ :sum :el | sum , el name , (String with: Character cr) ] ];
				fontSize: 8).
	^ view shape: builder shape! !

!MOShapeSelector methodsFor: 'basic shape edge' stamp: 'tg 10/31/2009 11:00'!
verticalOrthogonalLine
	^ view shape: MOOrthoVerticalLineShape new! !

!MOShapeSelector methodsFor: 'accessing' stamp: 'Alexandre.Bergel 5/14/2009 00:45'!
view: aView
	view := aView! !

Object subclass: #MOSortBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOSortBlock class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
new
	"Answer a newly created and initialized instance."
	
	^super new initialize! !

!MOSortBlock methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/10/2009 20:21'!
fixTemps! !

!MOSortBlock methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 16:10'!
value: assocA value: assocB
	"Return false if assocA is bigger than assocB.
	Return true if assocA is smaller than assocB.
	-> Inverted list with biggest elements first"
	
	| a b offset |
	offset := 0.
	a := assocA value.
	b := assocB value.
	[(a size > offset)
		and: [(b size > offset) and: [(a at: a size - offset) = (b at: b size - offset)]]]
		whileTrue: [offset := offset + 1].	"Corner cases"
	(a size = b size and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3], [3, 3]"
	(a size > offset and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3, 6], [3, 3]"
	(b size > offset and: [a size = offset]) ifTrue: [ ^ false ].	"[3, 3], [3, 3, 6]"	"Normal case"
	^(a at: a size - offset) >= (b at: b size - offset)! !

Object subclass: #MOTestModel
	instanceVariableNames: 'a1 b1 b2 c1 c2 c3 c4 d1 d2 d3 nodes edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Tests'!

!MOTestModel class methodsFor: 'instance creation' stamp: ' 29/3/09 10:48'!
new
	
	^super new initialize! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
a1
	
	^a1! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
allEdges
	
	^edges! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
allNodes
	
	^nodes! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
b1
	
	^b1! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
b2
	
	^b2! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
c1
	
	^c1! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
d1
	
	^d1! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
d2
	
	^d2! !

!MOTestModel methodsFor: 'accessing' stamp: ' 29/3/09 10:48'!
d3
	
	^d3! !

!MOTestModel methodsFor: 'initialize-release' stamp: ' 29/3/09 10:48'!
initialize
	
	self initializeNodes.
	self initializeEdges! !

!MOTestModel methodsFor: 'initialize-release' stamp: ' 29/3/09 10:48'!
initializeEdges
	
	edges := OrderedCollection new.
	edges add: (Array with: a1 with: b1).
	edges add: (Array with: a1 with: b2).
	edges add: (Array with: b1 with: c1).
	edges add: (Array with: b1 with: c2).
	edges add: (Array with: b2 with: c3).
	edges add: (Array with: b2 with: c4).
	edges add: (Array with: c1 with: d1).
	edges add: (Array with: c1 with: d2).
	edges add: (Array with: c1 with: d3)! !

!MOTestModel methodsFor: 'initialize-release' stamp: ' 29/3/09 10:48'!
initializeNodes
	
	a1 := (OrderedCollection new)
		add: #a1;
		add: 3;
		add: 6;
		add: 3;
		add: self;
		yourself.
	b1 := (OrderedCollection new)
		add: #b1;
		add: 1;
		add: 5;
		add: 0;
		add: self;
		yourself.
	b2 := (OrderedCollection new)
		add: #b2;
		add: 0;
		add: 2;
		add: 9;
		add: self;
		yourself.
	c1 := (OrderedCollection new)
		add: #c1;
		add: 5;
		add: 0;
		add: 15;
		add: self;
		yourself.
	c2 := (OrderedCollection new)
		add: #c2;
		add: 6;
		add: 0;
		add: 18;
		add: self;
		yourself.
	c3 := (OrderedCollection new)
		add: #c3;
		add: 9;
		add: 9;
		add: 22;
		add: self;
		yourself.
	c4 := (OrderedCollection new)
		add: #c4;
		add: 8;
		add: 7;
		add: 0;
		add: self;
		yourself.
	d1 := (OrderedCollection new)
		add: #d1;
		add: 12;
		add: 4;
		add: 4;
		add: self;
		yourself.
	d2 := (OrderedCollection new)
		add: #d2;
		add: 2;
		add: 13;
		add: 19;
		add: self;
		yourself.
	d3 := (OrderedCollection new)
		add: #d3;
		add: 15;
		add: 8;
		add: 12;
		add: self;
		yourself.
	nodes := (OrderedCollection new)
		add: a1;
		add: b1;
		add: b2;
		add: c1;
		add: c2;
		add: c3;
		add: c4;
		add: d1;
		add: d2;
		add: d3;
		yourself! !

!MOTestModel methodsFor: 'shapes' stamp: 'Alexandre.Bergel 3/29/2009 15:49'!
shapeForEdge
	
	^ MOStraightLineShape color: [:entity | Color lightGray]! !

!MOTestModel methodsFor: 'shapes' stamp: 'Alexandre.Bergel 3/29/2009 15:37'!
shapeForNode
	
	^ (MORectangleShape
						width: [:anEntity | 5 + (anEntity at: 2)]
						height: [:anEntity | 5 + (anEntity at: 3)]
						fillColor:
							(MONColorLinearNormalizer
								inContext: self allNodes
								withCommand: [:entity | entity at: 4]))
	! !

Object subclass: #MOTextWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Morphic'!

!MOTextWindow class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 2/24/2009 17:20'!
openWithContent: aContent
	self openWithContent: aContent labeled: 'Mondrian'! !

!MOTextWindow class methodsFor: 'instance creation' stamp: 'Alexandre.Bergel 2/24/2009 17:19'!
openWithContent: aContent labeled: aLabel
	Workspace new contents: aContent; openLabel: aLabel! !

!MOTextWindow class methodsFor: 'instance creation' stamp: 'AlexandreBergel 9/6/2010 18:43'!
openWithContentFromFileName: aFilename
	"self openWithContentFromFileName: 'PharoDebug.log' "
	
	| content stream |
	(FileDirectory default fileExists: aFilename)
		ifFalse: [ ^ self ].

	stream := (FileStream fileNamed: aFilename) readStream.
	
	"The fact that we use Latin1TextConverter is arbitrary"
	"It simply works for the situation I am encountering"
	"Alexandre Bergel Feb 24, 2009"
	stream converter: Latin1TextConverter new.
	
	content := stream contents.
	self openWithContent: content labeled: aFilename
! !

Object subclass: #MOTransmission
	instanceVariableNames: 'context origin destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Interaction'!

!MOTransmission commentStamp: 'Alexandre Bergel 3/2/2010 21:14' prior: 0!
A MOTransmission models the connection between pane ports. Whenever a port changes the value, the corresponding transmissions are triggered.

transmission takes place in a context. The context is started every time a new value is set from outside. Afterwards, the context is preserved internally. This is important for braking possible loops of propagation of transmissions.!

!MOTransmission methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:15'!
context
	 context ifNil: [context := OrderedCollection new].
	^context! !

!MOTransmission methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:15'!
context: aContext
	 context := aContext! !

!MOTransmission methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:16'!
destination 
	 
	^destination! !

!MOTransmission methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:16'!
destination: aPort 
	 
	destination := aPort! !

!MOTransmission methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:16'!
origin 
	 
	^origin! !

!MOTransmission methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:16'!
origin: aPort 
	 
	origin := aPort! !

!MOTransmission methodsFor: 'testing' stamp: 'Alexandre Bergel 3/2/2010 21:16'!
originatesAt: aPort 
	 
	^self origin = aPort! !

!MOTransmission methodsFor: 'transmitting' stamp: 'Alexandre Bergel 3/2/2010 21:21'!
transmit
	self transmitIn: MOTransmissionContext new! !

!MOTransmission methodsFor: 'transmitting' stamp: 'Alexandre Bergel 3/2/2010 21:16'!
transmitIn: aContext
	 
	self destination receive: self in: aContext! !

!MOTransmission methodsFor: 'transmitting' stamp: 'Alexandre Bergel 3/2/2010 21:16'!
value 
	 
	^self origin value! !

Object subclass: #MOTransmissionContext
	instanceVariableNames: 'ports'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Interaction'!

!MOTransmissionContext methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:21'!
addPort: aPort
	self ports add: aPort! !

!MOTransmissionContext methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:21'!
ports
	^ ports ifNil: [ports := OrderedCollection new]! !

!MOTransmissionContext methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 21:21'!
ports: anObject
	ports := anObject! !

Object subclass: #MOTreeLayerWrapper
	instanceVariableNames: 'figures cachedHeight cachedWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Layouts'!

!MOTreeLayerWrapper commentStamp: '<historical>' prior: 0!
This class holds all figures that belong to the same layer. The class also contains auxiliary information
like width and height of the layer.

Instance Variables:
	cachedHeight	<ArithmeticValue>	The height of the layer
	cachedWidth	<ArithmeticValue>	The widht of the layer
	figures	<Collection of: AtlantisFigure>	All figures that belong to this layer

!

!MOTreeLayerWrapper class methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
new
	"Answer a newly created and initialized instance."
	
	^super new initialize! !

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
add: aFigure
	
	figures add: aFigure! !

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
do: aBlock
	
	figures do: aBlock! !

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
height
	
	cachedHeight isNil
		ifTrue:
			[cachedHeight := 0.
			figures do: [:aFigure | cachedHeight := cachedHeight max: aFigure height]].
	^cachedHeight! !

!MOTreeLayerWrapper methodsFor: 'initialize-release' stamp: 'tg 7/25/2010 14:25'!
initialize
	figures := OrderedCollection new.
	cachedWidth := nil.
	cachedHeight := nil! !

!MOTreeLayerWrapper methodsFor: 'accessing' stamp: 'tg 7/25/2010 14:23'!
width: gapSize	
	^ cachedWidth ifNil: [
		cachedWidth := 0.
		figures do: [ :aFigure | cachedWidth := cachedWidth + aFigure width].
		cachedWidth := cachedWidth + ((figures size - 1) * gapSize) ].! !

Object subclass: #MOViewRenderer
	instanceVariableNames: 'announcer layout root shape title defaultNodeShapeInstance defaultLineShapeInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOViewRenderer commentStamp: 'tg 4/24/2008 01:30' prior: 0!
TODO:
- bounds should be computed by Shape
- Make the edge dependent on the Nodes.


Instance Variables
	announcer:		<Object>
	edgeShape:		<Object>
	element:		<Object>
	graph:		<Object>
	layout:		<Object>
	nodeShape:		<Object>

announcer
	- xxxxx

edgeShape
	- xxxxx

element
	- xxxxx

graph
	- xxxxx

layout
	- xxxxx

nodeShape
	- xxxxx
!

!MOViewRenderer class methodsFor: 'public' stamp: 'Alexandre Bergel 3/15/2010 18:58'!
title: aTitle
	^ self new title: aTitle; yourself! !

!MOViewRenderer methodsFor: 'private' stamp: 'Alexandre Bergel 11/30/2009 23:55'!
addEdgeIn: aCollection from: source to: target model: model shape: aShape

	| edge |		
	(source notNil and: [ target notNil ]) ifTrue: 
		[ (source ~= target) ifTrue: [ "An edge is between two different nodes "
			edge := MOEdge from: source to: target.
			edge model: model.
			edge shape: aShape.
			edge setAnnouncer: announcer.
			self root addEdge: edge.
			aCollection addLast: edge ] ]! !

!MOViewRenderer methodsFor: 'announce' stamp: 'Alexandre.Bergel 2/3/2009 23:50'!
announce: ann
	"^ self announcer announce: ann"
	ann element announcer announce: ann! !

!MOViewRenderer methodsFor: 'announce' stamp: 'Alexandre.Bergel 2/2/2009 09:00'!
announcer
	^ announcer ifNil: [ announcer := self defaultAnnouncer ]! !

!MOViewRenderer methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 2/25/2010 10:12'!
asMorph

	| pane canvas |
	pane := ScrollPane new.
	canvas := MOCanvas on: self root.
	pane scroller addMorph: canvas.
	^ (MOCanvas on: self root) updateBounds; yourself.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 4/26/2010 23:12'!
bottomFlowLayout
	^self layout: MOBottomFlowLayout new.! !

!MOViewRenderer methodsFor: '*Mondrian-Morphic' stamp: 'Alexandre Bergel 3/29/2010 09:30'!
browserClass
	^ MOBrowser! !

!MOViewRenderer methodsFor: '*Mondrian-Morphic' stamp: 'tg 5/15/2009 14:55'!
canvas

	| canvas |
	canvas := MOCanvas new root: root.
	canvas initializeHanders.
	^ canvas! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 4/30/2009 14:55'!
circleLayout
	^self layout: MOCircleLayout new.! !

!MOViewRenderer methodsFor: 'announce' stamp: 'Alexandre Bergel 12/17/2009 18:53'!
defaultAnnouncer
	^ MOAnnouncer new viewRenderer: self! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 10/15/2009 20:05'!
defaultLineShapeClass 
	^ MOEdge defaultLineShapeClass
! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:07'!
defaultLineShapeInstance
	^ defaultLineShapeInstance! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:07'!
defaultLineShapeInstance: anObject
	defaultLineShapeInstance := anObject! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 10/15/2009 20:05'!
defaultNodeShapeClass 
	^ MONode defaultNodeShapeClass
! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:08'!
defaultNodeShapeInstance
	^ defaultNodeShapeInstance! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:08'!
defaultNodeShapeInstance: anObject
	defaultNodeShapeInstance := anObject! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre.Bergel 2/25/2009 21:44'!
domain
	^ self root nodes collect: [ :each | each model ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 00:47'!
dominanceTreeLayout
	^self layout: MODominanceTreeLayout new.! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 4/10/2009 19:45'!
edge: anObject from: aFromBlock to: aToBlock
	
	^ (self edges: (OrderedCollection with: anObject) from: aFromBlock to: aToBlock) first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 4/10/2009 19:20'!
edge: anObject from: aFromBlock to: aToBlock using: aShape
	
	^self edges: (OrderedCollection with: anObject) from: aFromBlock to: aToBlock using: aShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 2/25/2009 21:45'!
edgeFrom: aFromBlock to: aToBlock
	
	^self edges: self domain from: aFromBlock to: aToBlock! !

!MOViewRenderer methodsFor: 'rendering shape' stamp: 'Alexandre Bergel 6/26/2010 13:27'!
edgeShape
	(shape isNil or: [ shape isNodeShape ]) 
		ifTrue: [ 
			self defaultLineShapeInstance ifNotNilDo: [ :s | ^ shape := s ].
			shape := self defaultLineShapeClass new ].
	^ shape! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/25/2009 22:12'!
edgeShape: aShape
	^ self shape: aShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 9/28/2009 23:45'!
edges: aCollection from: aFromBlock
	
	^ self edges: aCollection from: aFromBlock to: [ :anObject | anObject ]! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 3/24/2009 21:43'!
edges: aCollection from: aFromBlock to: aToBlock
	
	^ self edges: aCollection from: aFromBlock to: aToBlock using: self edgeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 4/8/2009 16:47'!
edges: aCollection from: aFromBlock to: aToBlock fromGlobal: fromGlobal toGlobal: toGlobal 
	^ self edges: aCollection from: aFromBlock to: aToBlock using: self edgeShape fromGlobal: fromGlobal toGlobal: toGlobal ! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 3/24/2009 21:43'!
edges: aCollection from: aFromBlock to: aToBlock using: aShape 

	^ self edges: aCollection from: aFromBlock to: aToBlock using: aShape fromGlobal: false toGlobal: true! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 1/26/2010 22:40'!
edges: aCollection from: aFromBlock to: aToBlock using: aShape fromGlobal: fromGlobal toGlobal: toGlobal 

	| source target edges |
	edges := OrderedCollection new.
	aCollection do: 
		[ :each |
			source := self lookupNode: (aFromBlock moValue: each) globally: fromGlobal.
			target := self lookupNode: (aToBlock moValue: each) globally: toGlobal.
			self addEdgeIn: edges from: source to: target model: each shape: aShape].
	self resetInteraction.
	self root resetElementsToDisplayCacheRecursively.
	^ edges! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'ab 12/26/2008 16:48'!
edges: aCollection from: aFromBlock toAll: aToBlock
	"aToBlock should return a collection, edges will be drawn from the element returned by aFromBlock to this collection"
	
	^self edges: aCollection from: aFromBlock toAll: aToBlock using: self edgeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'ab 12/26/2008 16:36'!
edges: aCollection from: aFromBlock toAll: aToBlock using: aShape 
	^self edges: aCollection from: aFromBlock toAll: aToBlock using: aShape fromGlobal: false toGlobal: true! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 1/26/2010 22:41'!
edges: aCollection from: aFromBlock toAll: aToBlock using: aShape fromGlobal: fromGlobal toGlobal: toGlobal 

	| source target edges targetModels |
	edges := OrderedCollection new.
	aCollection do: 
		[ :each | 
			source := self lookupNode: (aFromBlock moValue: each) globally: fromGlobal.		
	
			targetModels := aToBlock moValue: each.
			self 
				assert: [targetModels isCollection or: [targetModels isNil]]
				description: 'destination nodes is not a collection'.
			targetModels ifNotNil: [
				targetModels do: [ :targetModel | 
					target := self lookupNode: targetModel globally: toGlobal.
					self addEdgeIn: edges from: source to: target model: each shape: aShape ]]].
	self resetInteraction.
	self root resetElementsToDisplayCacheRecursively.
	^ edges! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 5/8/2010 17:39'!
edges: aCollection fromAll: aFromBlock to: aToBlock
	"aFromBlock should return a collection, edges will be drawn from this collection to the element returned by aToBlock"
	
	^self edges: aCollection fromAll: aFromBlock to: aToBlock using: self edgeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 5/8/2010 17:40'!
edges: aCollection fromAll: aFromBlock to: aToBlock using: aShape 
	^self edges: aCollection fromAll: aFromBlock to: aToBlock using: aShape fromGlobal: false toGlobal: true! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 5/8/2010 17:38'!
edges: aCollection fromAll: aFromBlock to: aToBlock using: aShape fromGlobal: fromGlobal toGlobal: toGlobal 

	| source target edges sourceModels |
	edges := OrderedCollection new.
	aCollection do: 
		[ :each | 
			target := self lookupNode: (aToBlock moValue: each) globally: toGlobal.		
	
			sourceModels := aFromBlock moValue: each.
			self 
				assert: [sourceModels isCollection or: [sourceModels isNil]]
				description: 'destination nodes is not a collection'.
			sourceModels ifNotNil: [
				sourceModels do: [ :sourceModel | 
					source := self lookupNode: sourceModel globally: fromGlobal.
					self addEdgeIn: edges from: source to: target model: each shape: aShape ]]].
	self resetInteraction.
	self root resetElementsToDisplayCacheRecursively.
	^ edges! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 9/28/2009 23:46'!
edges: aCollection to: aToBlock
	
	^ self edges: aCollection from: [ :anObject | anObject ] to: aToBlock ! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'Alexandre.Bergel 5/2/2009 09:17'!
edgesFrom: aBlockOrSelector 

	^ self 
		edges: self domain
		from: aBlockOrSelector
		to: #yourself! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'tg 2/26/2010 19:23'!
edgesToAll: aBlockOrSelector 

	^ self 
		edges: self domain
		from: #yourself
		toAll: aBlockOrSelector! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 9/28/2009 23:34'!
flowLayout
	^self layout: MOFlowLayout new.! !

!MOViewRenderer methodsFor: '*Mondrian-Animation' stamp: 'Alexandre Bergel 3/1/2010 12:17'!
forFramedNode: aFramedNode do: aBlock
	"Enable one to add a subview for a given node"
	
	| oldPos|
	"For some strange reason, doing an applyLayout reset to 0@0 the origin of the node, it should not"
	
	aFramedNode allEdgesDo: #resetCache. 
	aFramedNode owner updateBounds.
	aFramedNode nodes copy do: #remove.

	oldPos := aFramedNode bounds origin.
	self with: aFramedNode during: [ 
		self resetInteraction. 
		aBlock value: aFramedNode currentValue. 
		aFramedNode applyLayout.].
	aFramedNode bounds origin: oldPos. 

	aFramedNode bounds extent: (aFramedNode shape computeExtentFor: aFramedNode).
	self resetInteraction.
	^ aFramedNode! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 7/20/2010 11:38'!
forNode: aValue do: aBlock
	"Enable one to add a subview for a given node"
	
	| node oldPos|
	"For some strange reason, doing an applyLayout reset to 0@0 the origin of the node, it should not"
	
"	node := self nodeForDomainValue: aValue."
	node := self lookupNode: aValue globally: true.
	node allEdgesDo: #resetCache. 
	node owner updateBounds.
	node nodes copy do: #remove.

	oldPos := node bounds origin.
	self with: node during: [ self resetInteraction. aBlock value. node applyLayout ].
	node bounds origin: oldPos. 

	node bounds extent: (node shape computeExtentFor: node).
	node resetFormCache.
	node owner ifNotNil: [ node owner resetFormCache ].
	
	"We might have to update the bounds of the root"
	(node owner isRoot and: [( node owner absoluteBounds containsRect: node absoluteBounds) not])
		ifTrue: [ node owner updateBounds ].
		
	self root resetElementsToDisplayCacheRecursively.
	self root resetElementsToLookup.
	self resetInteraction.
	^ node! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 1/12/2010 14:20'!
forNodes: values do: oneBlockArg
	"Enable one to add a subview for a given nodes"

	^ values collect: [:v | self forNode: v do: [ oneBlockArg value: v ] ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 00:48'!
forceBasedLayout
	^self layout: MOForceBasedLayout new.! !

!MOViewRenderer methodsFor: '*Mondrian-Animation' stamp: 'Alexandre Bergel 3/1/2010 08:15'!
framedNode: modelValues
	^ self framedNode: modelValues using: self nodeShape! !

!MOViewRenderer methodsFor: '*Mondrian-Animation' stamp: 'Alexandre Bergel 3/1/2010 11:29'!
framedNode: modelValues forEach: anOneArgBlock
	^ self framedNode: modelValues using: self nodeShape forEach: anOneArgBlock! !

!MOViewRenderer methodsFor: '*Mondrian-Animation' stamp: 'Alexandre Bergel 3/1/2010 11:31'!
framedNode: modelValues using: aShape
	^ self framedNode: modelValues using: aShape forEach: nil! !

!MOViewRenderer methodsFor: '*Mondrian-Animation' stamp: 'Alexandre Bergel 3/1/2010 12:51'!
framedNode: modelValues using: aShape forEach: anOneArgBlockOrNil
	| node |
	self assert: [ modelValues isCollection ] description: 'A collection should be provided, else use #node: instead'.

	node := MOFramedNode for: modelValues.
	node view: self. "Not sure if this is conceptually necessary, but currently it is"
	node shape: aShape.
	node setAnnouncer: announcer.
	self root addNode: node.
	node frameBlock: anOneArgBlockOrNil.
	node generateFrame.


	self resetDefaults.
	^ node
	! !

!MOViewRenderer methodsFor: 'debugging' stamp: 'Alexandre Bergel 7/18/2010 15:50'!
getRenderedForm
	"Simulate the graphical morph rendering"
	"Nodes need to be layouted before calling this method"

	| bounds form canvas |
	bounds := self root bounds.	
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	self root displayOn: canvas.
	
	^ form
! !

!MOViewRenderer methodsFor: 'private' stamp: 'simon.denier 7/3/2009 18:47'!
globalLookupNode: aModel

	^ self root root 
			nodeWith: aModel
			ifAbsent: [ self root root 
					firstSubnodeThat: [:aNode | aNode model = aModel] ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 4/1/2009 17:33'!
gridLayout
	| l |
	l := MOGridLayout new.
	self layout: l.
	^ l
! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 00:48'!
horizontalDominanceTreeLayout
	^self layout: MOHorizontalDominanceTreeLayout new.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 5/22/2008 12:22'!
horizontalLineLayout
	^self layout: MOHorizontalLineLayout new.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 7/25/2010 14:44'!
horizontalNarrowTreeLayout

	^ self layout: MOHorizontalNarrowTreeLayout new! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 9/23/2009 14:43'!
horizontalTreeLayout
	^self layout: MOHorizontalTreeLayout new.! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 7/26/2010 15:01'!
initialize
	root := MORoot new.
	self resetInteraction.
	self title: 'Mondrian Renderer' translated! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'jannik.laval 3/6/2009 16:24'!
interaction
	^ self announcer! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 14:21'!
layout
	^ self root layout ifNil: [ self root layout: MOHorizontalLineLayout new ]! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/26/2009 14:17'!
layout: anObject 

	self root layout: anObject.
	^ anObject! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:39'!
localEdges: aCollection from: aFromBlock to: aToBlock using: aShape 
	^self edges: aCollection from: aFromBlock to: aToBlock using: aShape fromGlobal: false toGlobal: false.! !

!MOViewRenderer methodsFor: 'private' stamp: 'AlexandreBergel 9/12/2010 18:08'!
localLookupNode: aModel

	^ self root 
			nodeWith: aModel	
			ifAbsent: [ self root 
					firstSubnodeThat: [:aNode | aNode model = aModel] 
					ifAbsent: [ self globalLookupNode: aModel] ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre Bergel 4/2/2010 18:15'!
localSpringLayout
	^self layout: MOLocalSpringLayout new.! !

!MOViewRenderer methodsFor: 'private' stamp: 'simon.denier 7/3/2009 18:45'!
lookupNode: aModel globally: aBoolean

	^ aBoolean
			ifTrue: [ self globalLookupNode: aModel ]
			ifFalse: [ self localLookupNode: aModel ].! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre Bergel 6/14/2010 15:23'!
minimumGridLayout
	^ self layout: MOMinimumGridLayout new.

! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 7/25/2010 14:44'!
narrowTreeLayout

	^ self layout: MOVerticalNarrowTreeLayout new.! !

!MOViewRenderer methodsFor: 'events' stamp: 'Alexandre.Bergel 9/26/2009 13:58'!
noInteraction
	announcer := nil! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:33'!
node: anObject

	| coll |
	coll := self nodes: (OrderedCollection with: anObject).
	^ coll first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 20:48'!
node: anObject forIt: aZeroArgBlock

	^ (self nodes: (OrderedCollection with: anObject) forEach: [:each | aZeroArgBlock value]) first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 11/30/2009 23:54'!
node: anObject using: aShape
	| collection |
	collection := self nodes: (OrderedCollection with: anObject) using: aShape.
	^collection first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:32'!
node: anObject using: aShape forIt: aZeroArgBlock
	| collection |
	collection := self nodes: (OrderedCollection with: anObject) using: aShape forEach: [:each | aZeroArgBlock value].
	^collection first! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject
	"Returns the MONode corresponding to the value anObject"
	
	^ self root nodeForDomainValue: anObject! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject ifAbsent: aBlock
	"Returns the MONode corresponding to the value anObject"
	
	^ self root nodeForDomainValue: anObject ifAbsent: aBlock! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 4/2/2010 19:01'!
nodeForDomainValues: aCollection
	"Returns the MONode corresponding to the values contained in aCollection"
	^ self root nodeForDomainValues: aCollection! !

!MOViewRenderer methodsFor: 'rendering shape' stamp: 'Alexandre Bergel 6/26/2010 13:19'!
nodeShape
	(shape isNil or: [ shape isLineShape ]) 
		ifTrue: [ 
			self defaultNodeShapeInstance ifNotNilDo: [ :s | ^ shape := s ].
			shape := self defaultNodeShapeClass new ].
	^ shape
! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/25/2009 20:19'!
nodeShape: aShape
	self shape: aShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:33'!
nodes: aCollection

	^ self nodes: aCollection using: self nodeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 4/24/2008 14:34'!
nodes: aCollection forEach: aBlock


	^self nodes: aCollection using: self nodeShape forEach: aBlock! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 2/26/2010 15:10'!
nodes: aCollection using: aShape 
	| nodes newNode |

	self assert: [ aCollection isCollection ] description: 'A collection should be provided, else use #node: instead'.

	nodes := aCollection collect: 
		[ :anEntity | 
		newNode := MONode new.
		newNode model: anEntity.
		newNode shape: aShape.
		newNode setAnnouncer: announcer.
		self root addNode: newNode.
		newNode ].

	self resetDefaults.
	^ nodes! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 8/18/2009 21:35'!
nodes: aCollection using: aShape forEach: aBlock

	| newNodes |
	newNodes := self nodes: aCollection using: aShape.
	
	newNodes do: [ :eachNode |
		self with: eachNode during: [self resetInteraction. aBlock value: eachNode model]
	].
	self resetInteraction.
	^newNodes! !

!MOViewRenderer methodsFor: '*Mondrian-Morphic-public' stamp: 'AlexandreBergel 9/6/2010 18:43'!
open
	self getRenderedForm.
	self root resetFormCacheResursively; resetElementsToDisplayCache.
	^ self open: self browserClass new! !

!MOViewRenderer methodsFor: '*Mondrian-Morphic' stamp: 'AlexandreBergel 9/5/2010 17:21'!
open: browserInstance
	"this subscription is triggered by updateWindow"
	| browser systemWindow |

	browser := browserInstance root: root.
	systemWindow := browser open.
	self setDefaultHandlers.
	self setDefaultHandlerForWindow: systemWindow.
	browser canvas initializeHanders.
	browser canvas updateBounds.
	systemWindow setLabel: self title.

	^ systemWindow! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 01:42'!
radialTreeLayout
	^self layout: MORadialTreeLayout new.! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 3/21/2010 20:14'!
resetDefaults

	self shape: nil.
	self resetInteraction.! !

!MOViewRenderer methodsFor: 'events' stamp: 'Alexandre.Bergel 3/31/2009 19:36'!
resetInteraction
	announcer := nil.
	self setUsefulHandlersForNodes.! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 20:22'!
root
	^ root! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 20:38'!
root:  aMORoot 
	root := aMORoot! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'RomainRobbes 4/6/2010 14:32'!
rootSpringLayout
	^self layout: MORootedSprintLayout new.! !

!MOViewRenderer methodsFor: 'events' stamp: 'AlexandreBergel 9/6/2010 18:43'!
setDefaultHandlerForWindow: systemWindow
	self root announcer 
		on: MOWindowStatusChanged
		do: [ :ann | | rootLabel |
				rootLabel := 
					(systemWindow label includes: $:)
						ifTrue: [ systemWindow label copyUpTo: $: ]
						ifFalse: [ systemWindow label ].
				ann newLabel 
					ifNotEmpty: [systemWindow setLabel: (rootLabel, ': ', ann newLabel)]
					ifEmpty: [ systemWindow setLabel: rootLabel ].
				 ]! !

!MOViewRenderer methodsFor: 'events' stamp: 'AlexandreBergel 9/6/2010 09:53'!
setDefaultHandlers
	"This method is called when the nodes have been added to the view"

	"@@WHY this handlers are set here? And not in MORoot"
	self root announcer 
		subscribe: MOMouseDown
		do: 
			[ :ann | 
			self root shouldDeselect ifTrue:
				[ self root allSelectedNodes do: [ :node | node deselect ] ].
			self updateWindow ].

	"this subscription is triggered by updateWindow"
	self root announcer 
		subscribe: MOContentChanged
		do: [ :ann | self root canvas changed ].
! !

!MOViewRenderer methodsFor: 'events' stamp: 'AlexandreBergel 9/6/2010 09:42'!
setUsefulHandlersForNodes
	"Set a number of useful handlers for nodes"
	self interaction draggable.
	self interaction popupText.
	self interaction on: MOElementSelection 
		do: [:ann |
				ann isUnique  
					ifTrue: [ self root allSelectedNodes 
								do: [ :node | 
										self haltOnce.
										node 
											resetFormCacheUpToTheRoot; 
											deselect;
											announce: (MOElementDeselection new) ] ].
				ann element resetFormCacheUpToTheRoot; select.
				self updateWindow ].
! !

!MOViewRenderer methodsFor: '*Mondrian-Shapes' stamp: 'Alexandre.Bergel 5/14/2009 00:44'!
shape
	^ MOShapeSelector new view: self! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:29'!
shape: anObject
	shape := anObject.
	^ anObject! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre Bergel 3/15/2010 18:54'!
springLayout
	^self layout: MOSpringLayout new.! !

!MOViewRenderer methodsFor: '*Mondrian-Animation' stamp: 'Alexandre Bergel 6/20/2010 23:41'!
stopAllProcesses
	self root allNodesDo: [ :n | n interaction stopProcesses ].
	(Process allInstances select: [:p | p name = 'mondrian process' ])
		do: #terminate.! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/15/2010 18:55'!
title
	^ title! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/15/2010 18:55'!
title: anObject
	title := anObject! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 5/22/2008 12:22'!
treeLayout
	^self layout: MOTreeLayout new.! !

!MOViewRenderer methodsFor: 'events' stamp: 'Alexandre.Bergel 9/23/2009 17:09'!
updateWindow
	"Refresh the content of the window. This happens when some shape change for example"
	self root updateWindow! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 5/22/2008 12:22'!
verticalLineLayout
	^self layout: MOVerticalLineLayout new.! !

!MOViewRenderer methodsFor: '*Mondrian-Legend' stamp: 'Alexandre Bergel 5/9/2010 20:30'!
viewLegendFor: aValue
	| node nodeShape |
	node := self nodeForDomainValue: aValue.
	nodeShape := node shape.
	nodeShape viewLegend.
	 ! !

!MOViewRenderer methodsFor: 'private' stamp: 'Alexandre Bergel 3/15/2010 10:43'!
with: anElement during: aBlock
	| state |
	state := self shallowCopy.
	self root: anElement.
	aBlock ensure: [ self copyFrom: state ]
! !

Object subclass: #MOVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Visitor'!

!MOVisitor methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/2/2010 11:33'!
visitEdge: anEdge! !

!MOVisitor methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/2/2010 11:33'!
visitNode: aNode! !

!MOVisitor methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/4/2010 19:27'!
visitRoot: aRoot
! !

MOVisitor subclass: #MOXMLVisitor
	instanceVariableNames: 'stream mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Visitor'!

!MOXMLVisitor class methodsFor: 'instance creation' stamp: 'Alexandre Bergel 7/4/2010 17:35'!
stream: aStream
	^ self new stream: aStream; yourself! !

!MOXMLVisitor methodsFor: 'accessing' stamp: 'Alexandre Bergel 7/4/2010 19:19'!
idOfNode: aMONode
	mapping at: aMONode ifAbsentPut: [ mapping size + 1 ].
	^ mapping at: aMONode! !

!MOXMLVisitor methodsFor: 'initialization' stamp: 'Alexandre Bergel 7/4/2010 19:17'!
initialize 
	super initialize.
	mapping := Dictionary new! !

!MOXMLVisitor methodsFor: 'accessing' stamp: 'Alexandre Bergel 7/4/2010 17:36'!
stream: aStream
	stream := aStream ! !

!MOXMLVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 9/5/2010 09:34'!
visitEdge: anEdge
	| idSource idTarget |
	idSource := self idOfNode: anEdge source.
	idTarget := self idOfNode: anEdge target.
	stream nextPutAll: (String with: Character tab).
	stream
		nextPutAll: '<edge source="' , idSource printString , '" target= "' , idTarget printString;
		nextPutAll: '"/>'.	"	stream nextPutAll: '<edge>'.
	stream nextPutAll: '<source>', idSource printString, '</source>'.
	stream nextPutAll: '<target>', idSource printString, '</target>'.
	stream nextPutAll: '</edge>'.	
"
	stream nextPut: Character cr! !

!MOXMLVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 9/5/2010 09:34'!
visitNode: aNode
	| id |
	id := self idOfNode: aNode.
	stream nextPutAll: (String with: Character tab).
	stream
		nextPutAll:
				'<node id="' , id printString , '" name="' , aNode model printString
						, (' width ="<1p>"' expandMacrosWith: aNode bounds width)
						, (' height ="<1p>"' expandMacrosWith: aNode bounds height);
		nextPutAll: '"/>'.
	stream nextPut: Character cr! !

!MOXMLVisitor methodsFor: 'visiting' stamp: 'Alexandre Bergel 7/4/2010 19:27'!
visitRoot: aRoot
	aRoot nodes do: [:n | n acceptVisitor: self ].
	aRoot edges do: [:n | n acceptVisitor: self ]! !

!MOXMLVisitor methodsFor: 'public' stamp: 'Alexandre Bergel 7/4/2010 19:15'!
writeContent! !

!MOXMLVisitor methodsFor: 'public' stamp: 'Alexandre Bergel 7/4/2010 19:14'!
writePreamble
	stream nextPutAll: '<graph>'; cr! !

!MOXMLVisitor methodsFor: 'public' stamp: 'Alexandre Bergel 7/4/2010 19:14'!
writeTail 
	stream nextPutAll: '</graph>'; cr! !

!Object methodsFor: '*mondrian' stamp: 'Alexandre.Bergel 2/1/2009 10:09'!
isShape
	^ false! !

!Object methodsFor: '*mondrian' stamp: 'lr 2/3/2008 13:34'!
moValue: anArgument 
	^ self! !

Object subclass: #UMLClassDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!UMLClassDiagram class methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 12/16/2009 23:44'!
render: classes
	"self render: (Collection withAllSubclasses)"
	^ self new render: classes! !

!UMLClassDiagram methodsFor: 'public-view rendering' stamp: 'Alexandre Bergel 12/17/2009 00:26'!
render: classes
	"(self render: Collection withAllSubclasses) open"
	| view edges |
	view := MOViewRenderer new.
	view shape: self umlShape.

	view interaction
		popupText; nodraggable.
	
	view nodes: classes.
	
	view shape: (MOArrowedOrthoVerticalLineShape new).
	edges := view edgesFrom: #superclass.
	view layout: (MOTreeLayout new horizontalGap: 20; userDefinedEdges: edges).
	
"	self furtherDrawingOn: view classes: classes."
	^ view! !

!UMLClassDiagram methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2010 09:33'!
umlShape
	| builder |
	builder := MOFormsBuilder new.
	builder
		column;
		fill.
	builder
		row;
		fill;
		row;
		fill.
	builder x: 1 y: 1 add: (MORectangleShape new text: [ :cls | cls name ]).
	builder
		x: 1
		y: 2
		add:
			(MORectangleShape new
				text: [ :cls | 
					cls methodDict keys asSortedCollection
						inject: (String with: Character cr)
						into: [ :sum :el | sum , ' ' , el , ' ' , (String with: Character cr) ] ]).
	^ builder shape! !

UMLClassDiagram subclass: #UMLEnhClassDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Example'!

!UMLEnhClassDiagram methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 6/16/2010 22:19'!
fillClassMethods
		
	^(MORectangleShape new withoutBorder; withText) new text: 
			[ :cls | | stream categories |
			stream := WriteStream on: String new.
			categories := cls class organization categories.
			categories = #(#'no messages')
				ifFalse: [
					(categories copyWithout: #accessing)
						do: [:cat | 
							stream 
								nextPutAll:  ' ('; nextPutAll: cat; nextPutAll: ') '.
							(cls class organization listAtCategoryNamed: cat) 
								do: [:sel |
									stream
										cr;space: 3 ;
										nextPutAll: sel asString;
										space]]
						separatedBy: [stream cr]].
			stream contents]! !

!UMLEnhClassDiagram methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 6/16/2010 22:18'!
fillClassVars
		
	^(MORectangleShape new withoutBorder; withText) new text: 
			[ :cls | | stream |
			stream := WriteStream on: String new.
			cls class instVarNames 
									do: [:ivar | 
										stream 
											space;
											nextPutAll:  ivar asString]
									separatedBy: [stream cr].
			stream contents]! !

!UMLEnhClassDiagram methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 6/16/2010 22:20'!
fillInstanceMethods
		
	^(MORectangleShape new withoutBorder; withText) new text: 
			[ :cls | | stream categories |
			stream := WriteStream on: String new.
			categories := cls organization categories.
			categories = #(#'no messages')
				ifFalse: [
					(categories copyWithout: #accessing)
						do: [:cat | 
							stream 
								nextPutAll:  ' ('; nextPutAll: cat; nextPutAll: ') '.
							(cls organization listAtCategoryNamed: cat) 
								do: [:sel |
									stream
										cr;space: 3 ;
										nextPutAll: sel asString;
										space]]
						separatedBy: [stream cr]].
			stream contents]! !

!UMLEnhClassDiagram methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 6/16/2010 22:20'!
fillInstanceVars
		
	^(MORectangleShape new withoutBorder; withText) new text: 
			[ :cls | | stream |
			stream := WriteStream on: String new.
			cls instVarNames do: [:ivar | 
							stream 
									space;
									nextPutAll:  ivar asString]
								separatedBy: [stream cr].
			stream contents]! !

!UMLEnhClassDiagram methodsFor: 'accessing' stamp: 'CB 4/30/2009 11:54'!
umlShape
	| builder|
	builder := MOFormsBuilder new.
	builder
		column;fill.
	builder
		row;fill;row;fill;row;fill;row;fill;row;fill.
	builder 
		x: 1
		y: 1
		add: (MORectangleShape new text: [ :cls | cls name ]).
	#(2 3 4 5) do: [:row | builder 
		x: 1
		y: row
		add: MORectangleShape new].
	
	builder 
		x: 1
		y: 2
		add: self fillInstanceVars.	
	builder 
		x: 1
		y: 3
		add: self fillInstanceMethods.
	
	builder 
		x: 1
		y: 4
		add: self fillClassVars.	
	builder 
		x: 1
		y: 5
		add: self fillClassMethods.
		
	^ builder shape! !

!ClassDescription methodsFor: '*mondrian-accessing' stamp: 'Alexandre Bergel 7/26/2010 11:35'!
numberOfLinesOfCode
	^ self methods inject: 5 into: [ :sum :compiledMethod |
			(compiledMethod propertyValueAt: #numberOfLinesOfCode)
				ifNil: [ compiledMethod 
									propertyValueAt: #numberOfLinesOfCode 
									put: compiledMethod getSource lineCount ].
			sum + (compiledMethod propertyValueAt: #numberOfLinesOfCode) ]! !
MOEasel initialize!
MOQuadTree initialize!
